<?php

/**
* @copyright	Copyright (C) 2009 - 2015 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		PayPlans
* @subpackage	Activateafterpayment
* @contact		support+payplans@readybytes.in
*/
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

/**
 * Payplans Registration Plugin
 *
 * @package		Payplans
 * @subpackage	Plugin
 */
class  plgPayplansregistrationactivateAfterPayment extends XiPluginRegistration
{
	protected $_registrationUrl = 'index.php?option=com_payplans&view=plan&task=login';

	function _isRegistrationUrl()
	{
		$vars = $this->_getVars();
		if($vars['option'] == 'com_payplans' && $vars['view'] == 'plan' && $vars['task'] == 'login'){
			return true;
		}
		
		return false;
	}


	public function onPayplansGetPlugin()
	    {
	        $xml = dirname(__FILE__).DS.'activateafterpayment.xml';
	        if (file_exists($xml)) {
	                    $xmlContent = simplexml_load_file($xml);
	                }
	                else {
	                    $xmlContent = null;
	                }
	         return array('name'   => 'activateafterpayment', 
	                	  'value' =>$xmlContent);
	    }
	
	function _isRegistrationCompleteUrl()
	{
		return true;
	}
	
	/** 
	 * @see XiPluginRegistration::_doStartRegistration()
	 * 
	 */
	protected function _doStartRegistration()
	{
		$planId = $this->_getPlan();

		$app 		= PayplansFactory::getApplication();
		$email 		= $app->input->get('payplansRegisterAutoEmail', false, '@');
		$username 	= $app->input->get('payplansRegisterAutoUsername', false, '@');
		$password 	= $app->input->getString('payplansRegisterAutoPassword', false);
        $captcha  	= $app->input->get('recaptcha',false);
		
		// if $username is not post then redirect to login page again
		if(!$username){
			$this->_app->redirect(XiRoute::_('index.php?option=com_payplans&view=plan&task=login&plan_id='.$planId));
		}
		
		// if email is not post then redirect to login page again
		if(!$email){
			$this->_app->redirect(XiRoute::_('index.php?option=com_payplans&view=plan&task=login&plan_id='.$planId));
		}
		
		// if password is not post then redirect to login page again
		if(!$password || JString::strlen(Jstring::trim($password)) === 0) {
			$this->_app->redirect(XiRoute::_('index.php?option=com_payplans&view=plan&task=login&plan_id='.$planId));
		}

        //if captcha code not matched then redirect to login page again
		 $state  = XiHelperPlugin::getStatus('recaptcha','captcha');
		 if($state){
			if($this->params->get('show_captcha', 0)){
		       $check = $this->_checkCaptchacode($captcha);
		       if($check == false){
		          $this->_app->enqueueMessage(XiText::_('PLG_PAYPLANSREGISTRATION_AUTO_REGISTRATION_SAVE_FAILED_16'));	
		          $this->_app->redirect(XiRoute::_('index.php?option=com_payplans&view=plan&task=login&plan_id='.$planId));
		      }
		   }
        }
		
		$userId = $this->_autoRegister($username, $email, $password);
		
		if($userId){
			// registration is completed here so call afterRegistrationComplete
			$this->_setUser($userId);
			return $this->_doCompleteRegistration();
		}
		
		return true;
	}
	
	function _autoRegister($username, $email, $password)
	{
		require_once  JPATH_ROOT.DS.'components'.DS.PAYPLANS_COM_USER.DS.'models'.DS.'registration.php';
		
		$model = new UsersModelRegistration();
		JFactory::getLanguage()->load(PAYPLANS_COM_USER);
		
		jimport('joomla.mail.helper');
		if(!JMailHelper::isEmailAddress($email)){
			$this->_app->enqueueMessage(XiText::_('COM_PAYPLANS_INVALID_EMAIL_ADDRESS'));
			return false;
		}
		
		if(PayplansHelperUser::exists('email', $email)){
			$this->_app->enqueueMessage(XiText::_('COM_PAYPLANS_EMAIL_ALREADY_REGISTERED'));
			return false;
		}
		
		if(PayplansHelperUser::exists('username', $username)){
			$this->_app->enqueueMessage(XiText::_('PLG_PAYPLANSREGISTRATION_AUTO_USERNAME_ALREADY_REGISTERED'));
			return false;
		}
		
		// load user helper
		jimport('joomla.user.helper');

		$temp = array(	'username'=>$username,'name'=>$username,'email1'=>$email,
						'password1'=>$password, 'password2'=>$password, 'block'=>1 );
				
		$config = JFactory::getConfig();
		$params = JComponentHelper::getParams('com_users');

		// Initialise the table with JUser.
		$user = new JUser;
		
		$data = (array)$model->getData();
		// Merge in the registration data.
		foreach ($temp as $k => $v) {
			$data[$k] = $v;
		}

		// Prepare the data for the user object.
		$data['email']		= $data['email1'];
		$data['password']	= $data['password1'];
		
		jimport('joomla.user.helper');
		$data['block']		=	1;
		$data['activation'] = JApplication::getHash(JUserHelper::genRandomPassword());

		// Bind the data.
		if (!$user->bind($data)) {
			$this->_app->enqueueMessage(XiText::sprintf('PLG_PAYPLANSREGISTRATION_AUTO_BIND_FAILED', $user->getError()));
			return false;
		}

		// Load the users plugin group.
		JPluginHelper::importPlugin('user');

		// Store the data.
		if (!$user->save()) {
			$this->_app->enqueueMessage(XiText::sprintf('PLG_PAYPLANSREGISTRATION_AUTO_REGISTRATION_SAVE_FAILED', $user->getError()));
			return false;
		}
		$this->_app->enqueueMessage(XiText::_('PLG_PAYPLANSREGISTRATION_ACTIVATE_AFTER_PAYMENT_MSG_ON_INVOICE_CONFIRM'));
		return $user->id;
	}

	
	
	function onPayplansSubscriptionAfterSave($previous, $current)
	{

		if(PayplansFactory::getConfig()->registrationType != 'activateafterpayment')
			return true;
		
		if($current->getStatus() == PayplansStatus::SUBSCRIPTION_ACTIVE){
			$userid = $current->getBuyer();
			$user = XiFactory::getUser($userid);
			
			// Do nothing when email already sent to user
			if($user->getParam('payplans_activationmailsent', false)){
				return true;
			}

			if($user->get('block') == false){
			return true;
			}			
		
			// Compile the notification mail values.
			$config = JFactory::getConfig();

			$data = $user->getProperties();
	
			$data['fromname']	= $config->get('fromname');
			$data['mailfrom']	= $config->get('mailfrom');
			$data['sitename']	= $config->get('sitename');
			$data['siteurl']	= JUri::root();

			$emailSubject	= XiText::sprintf(
				'PLG_PAYPLANSREGISTRATION_ACTIVATE_AFTER_PAYMENT_EMAIL_ACTIVATE_SUBJECT',
				$data['sitename']
			);

			if (empty($data['activation']))
	   		{
	   			return true;
	   		}
			
			$emailBody = XiText::sprintf(
				'PLG_PAYPLANSREGISTRATION_ACTIVATE_AFTER_PAYMENT_SEND_MSG_ACTIVATE',
				$data['name'],
				$data['sitename'],
				$data['siteurl'].'index.php?option=com_payplans&view=user&task=activate_user_after_payment&activation='.$data['activation'],
				$data['siteurl']
			);
	

		// Send the registration email.
		$return = JFactory::getMailer()->setSender( array(
														$data['mailfrom'],
														$data['fromname']
													   ))
									   ->addRecipient($data['email'])
									   ->setSubject($emailSubject)
									   ->setBody($emailBody)
									   ->Send();
		
		// 	Send notification to all administrators
		$subject2 = sprintf ( XiText::_('PLG_PAYPLANSREGISTRATION_AUTO_ACCOUNT_DETAILS_FOR' ), $data['name'], $data['sitename']);
		$subject2 = html_entity_decode($subject2, ENT_QUOTES);

		// get superadministrators id
		$rows = XiHelperJoomla::getUsersToSendSystemEmail();
		foreach ( $rows as $row ){		
			$message2 = sprintf ( JText::_( 'PLG_PAYPLANSREGISTRATION_AUTO_SEND_MSG_ADMIN' ), $row->name, $data['sitename'], $data['name'], $data['email'], $data['username']);
			$message2 = html_entity_decode($message2, ENT_QUOTES);
			$mail     = JFactory::getMailer()->setSender( array(
														$data['mailfrom'],
														$data['fromname']
													   ))
										     ->addRecipient($row->email)
									         ->setSubject($subject2)
									         ->setBody($message2)
									         ->Send();	
		}
		
		// Check for an error.
		if ($return !== true) {
			$this->_app->enqueueMessage(XiText::_('COM_USERS_REGISTRATION_SEND_MAIL_FAILED'), 'error');

			// Send a system message to administrators receiving system mails
			if (count($rows) > 0) {
				$db		= XiFactory::getDBO();
				$jdate = new XiDate();
				// Build the query to add the messages
				$q = "INSERT INTO `#__messages` (`user_id_from`, `user_id_to`, `date_time`, `subject`, `message`)
					VALUES ";
				$messages = array();
				foreach ($rows as $emailUser) {
					$messages[] = "(".$emailUser->id.", ".$emailUser->id.",".$db->quote($jdate->toMySQL()).",".$db->quote(JText::_('COM_USERS_MAIL_SEND_FAILURE_SUBJECT')).",".$db->quote(JText::sprintf('COM_USERS_MAIL_SEND_FAILURE_BODY', $return, $data['username'])).")";
				}
				$q .= implode(',', $messages);
				$db->setQuery($q);
				$db->query();
			}
			return false;
			
		}
		$user->setParam('payplans_activationmailsent', true);
		$user->save();
		
		return true;
		}
	}
	
	function onAfterRoute()
	{
		
 		if(isset(XiFactory::getConfig()->registrationType) && $this->_name != XiFactory::getConfig()->registrationType){
                       return true;
        }


		// call parent's onAfterRoute
		parent::onAfterRoute(); 

		$vars = $this->_getVars(array('option','view', 'task', 'activation','afterPayment'));
		//if url is not same as given in the activation link then return
        if($vars['option'] != 'com_payplans' || $vars['view'] != 'user' || $vars['task'] != 'activate_user_after_payment'){
			return;
		}
					
		$mainframe = XiFactory::getApplication();
		// Initialize some variables
		$db			= XiFactory::getDBO();
		$user 		= XiFactory::getUser();
		$document   = XiFactory::getDocument();

	   	
		// Check to see if they're logged in, because they don't need activation!
		if ($user->get('id')) {
			// They're already logged in, so redirect them to the home page
			$mainframe->redirect( 'index.php' );
		}
				
		$activationRedirectUrl 	= $this->params->get('activation_redirect_url', 'index.php?option=com_payplans&view=dashboard');
		$siteURL	 			= JURI::base();
		$activationRedirectUrl 	= str_replace($siteURL,'',$activationRedirectUrl);
		
		$returl 				= XiRoute::_($activationRedirectUrl);
		
		// Do we even have an activation string?
		$activation = JRequest::getVar('activation', '', '', 'alnum' );
		$activation = $db->escape( $activation );
		
		if (empty( $activation )){
			$message = XiText::_( 'PLG_PAYPLANSREGISTRATION_AUTO_REG_ACTIVATE_NOT_FOUND' );
		    XiFactory::getApplication()->redirect($returl,$message); 
			return;
		}
		
		$user = $this->_getUserFromActivation($activation);
		$sitename 		= $mainframe->getCfg( 'sitename' );
		// Now activate this user
		jimport('joomla.user.helper');
		if (JUserHelper::activateUser($activation)){

				$message = XiText::_('PLG_PAYPLANSREGISTRATION_ACTIVATE_AFTER_PAYMENT_REG_ACTIVATE_COMPLETE' );
				$mainframe = PayplansFactory::getApplication();
				$mailfrom 		= $mainframe->getCfg( 'mailfrom' );
				$fromname 		= $mainframe->getCfg( 'fromname' );
				$sitename 		= $mainframe->getCfg( 'sitename' );
				$name 			=	$user->get('name');
				$mail_subject 	= XiText::sprintf('PLG_PAYPLANSREGISTRATION_ACTIVATE_AFTER_PAYMENT_EMAIL_SUBJECT', $sitename);
				$mail_subject 	= html_entity_decode($mail_subject, ENT_QUOTES);
				
				$mail_message    = XiText::sprintf('PLG_PAYPLANSREGISTRATION_ACTIVATE_AFTER_PAYMENT_EMAIL_BODY', $name, $sitename);
	
				$mail_message = html_entity_decode($mail_message, ENT_QUOTES);
				$mail = new JMail();
				$email 		= $user->get('email');
				JFactory::getMailer()->setSender( array(
														$mailfrom,
														$fromname
													   ))
										     ->addRecipient($email)
									         ->setSubject($mail_subject)
									         ->setBody($mail_message)
									         ->Send();	
		}

		
		// redirect user to $returl and display $message
		PayplansFactory::getApplication()->redirect($returl,$message); 		
	}
		
	function _getUserFromActivation($activation)
		{
			$db	= PayplansFactory::getDBO();
			$query = new XiQuery();
			$userId = $query->select('id')
						    ->from('#__users')
						    ->where('activation = "'.$activation.'"')
						    ->where('block = 1')
			 			    ->where('lastvisitDate = "'.$db->getNullDate().'"')
			 			    ->dbLoadQuery()
			 			    ->loadResult();
			
			// Check for a valid user id.
			if (!$userId) {
				$this->setError(JText::_('COM_USERS_ACTIVATION_TOKEN_NOT_FOUND'));
				return false;
			}
	
			$user = PayplansFactory::getUser($userId);
			return $user;
		}
	
    function _checkCaptchacode($captcha)
	{
		$check = JCaptcha::getInstance("recaptcha", array('namespace' => 'payplans'));
		$answer = $check->checkAnswer($captcha);
		return $answer;
	}
	
}

