<?php
/**
* @copyright	Copyright (C) 2009 - 2009 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		PayPlans
* @subpackage	Frontend
* @contact 		payplans@readybytes.in
*/

if(defined('_JEXEC')===false) die();
jimport( 'joomla.plugin.plugin' );

class plgPayplansregistrationAdagency extends XiPluginRegistration
{
	public function _isApplicable(Array $conditions= array())
	{
		return JFolder::exists(JPATH_SITE .DS.'components'.DS.'com_adagency');
	}
	
	protected $_registrationUrl = '';

	function __construct(& $subject, $config = array())
	{
		parent::__construct($subject, $config);
		$this->_registrationUrl = 'index.php?option=com_adagency&controller=adagencyAdvertisers&task=edit&fromPayplans=1';
	}
	
	function _isRegistrationUrl()
	{               
		$vars = $this->_getVars(array('option', 'controller', 'task'));

		if($vars['option'] == 'com_adagency' && $vars['controller'] == 'adagencyAdvertisers' && $vars['task'] == 'edit'){
			return true;
		}
		
		return false;	 
	}
	
	function _isRegistrationCompleteUrl()
	{
		return true;	 
	}

	public function onPayplansGetPlugin()
	    {
	        $xml = dirname(__FILE__).DS.'adagency.xml';
	        if (file_exists($xml)) {
	                    $xmlContent = simplexml_load_file($xml);
	                }
	                else {
	                    $xmlContent = null;
	                }
	         return array('name'   => 'adagency', 
	                	  'value' =>$xmlContent);
	    }
	    
	protected function _doStartRegistration()
  	{
			$compInfo =    XiAbstractHelperJoomla::getExtension('com_adagency');
				  
			if(empty($compInfo) || array_shift($compInfo)->enabled == 0){
      			XiFactory::getApplication()->enqueueMessage(sprintf(XiText::_("COM_PAYPLANS_COMPONENT_NOT_FOUND_OR_DISABLED"), 'AdAgency'));
      			return parent::_doStartRegistration();
	 	 	}
	 	                   
        	$planId = $this->_getPlan();
            $this->_setPlan($planId);
            $this->_session->set('fromPayplans', 1);
            $this->_app->redirect(XiRoute::_('index.php?option=com_adagency&controller=adagencyAdvertisers&task=edit'));
            return true;
     }
	
	function onPayplansAccessCheck()
	{
		$vars 		  = $this->_getVars(array('option', 'view','task','controller'));
		$fromPayplans = $this->_session->get('fromPayplans', 0);
		
		if( $vars['option'] == 'com_adagency' && 
		    $vars['task']   == 'edit' && 
		    $vars['controller'] == 'adagencyAdvertisers' && 
		    !$fromPayplans ){
				$this->_app->redirect(XiRoute::_("index.php?option=com_payplans&view=plan&task=subscribe", false));
		}
	}
}
