<?php
/**
* @copyright	Copyright (C) 2009 - 2009 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		PayPlans
* @subpackage	Frontend
* @contact 		payplans@readybytes.in
*/
if(defined('_JEXEC')===false) die();

class PayplansAppAlertpay extends PayplansAppPayment
{
	//inherited properties
	// IMP : store txn_id in txn_id for payment
	// and store subscr_id for recurring master payment
	
	protected $_location	= __FILE__;
	
	function isApplicable($refObject = null, $eventName='')
	{
		// return true for event onPayplansControllerCreation
		if($eventName == 'onPayplansControllerCreation'){
			return true;
		}
		
		return parent::isApplicable($refObject, $eventName);
	}
	
	function onPayplansControllerCreation(&$view, &$controller, &$task, &$format)
	{
		if($view != 'payment' || $task != 'notify'){
			return true;
		}
		
		if(JRequest::getVar('gateway', false) !== 'alertpay'){
			return true;
		}

		$token = JRequest::getVar('token', false);
		if(!$token){
			return true;
		}
		
		$respose = $this->_getResponse($token);
		if(!$respose){
			return true;
		}
		
		// we will get order and payment key from apc_2
		$paymentKey = $respose['apc_2'];
		
		if($paymentKey == false){
			return true;
		}
		// key is the combination of appId_orderKey
		$paymentKey = explode('_', $paymentKey);
		
		if($paymentKey[0] == $this->getId()){
			JRequest::setVar('payment_key', $paymentKey[1], 'POST');
		}
		
		foreach($respose as $key => $value){
			JRequest::setVar($key, $value, 'POST');
		}
		
		return true;
	}
	
	public function onPayplansPaymentForm(PayplansPayment $payment, $data = null)
	{
		if(is_object($data)){
			$data = (array)$data;
		}

		$invoice = $payment->getInvoice(PAYPLANS_INSTANCE_REQUIRE);
				
		$this->assign('post_url', "https://secure.payza.com/checkout");
		if($this->getAppParam('sandbox', false)){
			$this->assign('ap_test', '1');
			$this->assign('post_url', " https://sandbox.Payza.com/sandbox/payprocess.aspx "); 
		}

		$this->assign('ap_merchant', $this->getAppParam('merchant', ''));
		$this->assign('ap_itemname', $invoice->getTitle());
		$this->assign('ap_currency', $invoice->getcurrency('isocode'));
		
		$root = JURI::root();
    	if(XiFactory::getConfig()->https == true){
    		$root = JString::str_ireplace("http:", "https:", $root);
    	}
    	
		$this->assign('ap_returnurl', $root.'index.php?option=com_payplans&view=payment&task=complete&action=success&payment_key='.$payment->getKey());
		$this->assign('ap_cancelurl', $root.'index.php?option=com_payplans&view=payment&task=complete&action=cancel&payment_key='.$payment->getKey());
//		$this->assign('ap_alerturl',  $root.'index.php?option=com_payplans&view=order&task=notify&order_key='.$order->getKey().'&payment_key='.$payment->getKey());
		$this->assign('ap_description', $invoice->getTitle());	
	
		// custom data which store order key and payment key
		$this->assign('apc_1', $this->getId().'_'.$invoice->getKey());
		$this->assign('apc_2', $this->getId().'_'.$payment->getKey());
		//$this->assign('apc_3', $request->int_var['usage']);
		
		$recurring = $invoice->isRecurring();
		if($recurring == PAYPLANS_RECURRING_TRIAL_2){
			XiError::assert( $recurring != PAYPLANS_RECURRING_TRIAL_2, XiText::_('COM_PAYPLANS_APP_ALERTPAY_DO_NOT_SUPPORT_SECOND_TRIAL'), XiError::ERROR);
		}
			
		if($recurring) {			
			$this->assign('ap_purchasetype', 'Subscription');
			$regularTotal = $invoice->getTotal();
			
			$recurrence_count = $invoice->getRecurrenceCount();
        	if($recurring == PAYPLANS_RECURRING_TRIAL_1){
        		$expTime = $invoice->getExpiration(PAYPLANS_RECURRING_TRIAL_1);
        		$expTime = $this->getRecurrenceTime($expTime);
				$this->assign('ap_trialamount', $invoice->getTotal());
				$this->assign('ap_trialtimeunit', $expTime['unit']);
				$this->assign('ap_trialperiodlength', $expTime['period']);
				$regularTotal = $invoice->getTotal($invoice->getCounter()+1);
			}		
			
			$expTime = $invoice->getExpiration(PAYPLANS_RECURRING);
        	$expTime = $this->getRecurrenceTime($expTime);
			$this->assign('ap_amount', 		 $regularTotal);
			$this->assign('ap_timeunit', 	 $expTime['unit']);
			$this->assign('ap_periodlength', $expTime['period']);
			$this->assign('ap_periodcount',  $recurrence_count);
			return $this->_render('form_subscription');
		} 
		
		$this->assign('ap_purchasetype', 'Item');
		$this->assign('ap_amount', $invoice->getTotal());
		        
        return $this->_render('form_buynow');
	}
	
	public function getRecurrenceTime($expTime)
	{
		$expTime['year'] = isset($expTime['year']) ? intval($expTime['year']) : 0;
		$expTime['month'] = isset($expTime['month']) ? intval($expTime['month']) : 0;
		$expTime['day'] = isset($expTime['day']) ? intval($expTime['day']) : 0;;
		
		// years
		if(!empty($expTime['year'])){
			if($expTime['year'] >= 5){
				return array('period' => 5, 'unit' => 'Year', 'frequency' => XiText::_('COM_PAYPLANS_RECURRENCE_FREQUENCY_GREATER_THAN_ONE'),
																'message' => XiText::_('COM_PAYPLANS_PAYMENT_APP_ALERTPAY_RECURRING_MESSAGE'));
			}
			
			if($expTime['year'] >= 2){
				return array('period' => $expTime['year'], 'unit' => 'Year', 'frequency' => XiText::_('COM_PAYPLANS_RECURRENCE_FREQUENCY_GREATER_THAN_ONE'),
																		     'message' => XiText::_('COM_PAYPLANS_PAYMENT_APP_ALERTPAY_RECURRING_MESSAGE'));
			}
			
			// if months is not set then return years * 12 + months
			if(isset($expTime['month']) && $expTime['month']){
				return array('period' => $expTime['year'] * 12 + $expTime['month'], 'unit' => 'Month');
			}				
			
			return array('period' => $expTime['year'], 'unit' => 'Year', 'frequency' => XiText::_('COM_PAYPLANS_RECURRENCE_FREQUENCY_GREATER_THAN_ONE'),
																		 'message' => XiText::_('COM_PAYPLANS_PAYMENT_APP_ALERTPAY_RECURRING_MESSAGE'));
		}
		
		// if months are set
		if(!empty($expTime['month'])){
			// if days are empty
			if(empty($expTime['day'])){
				return array('period' => $expTime['month'], 'unit' => 'Month', 'frequency' => XiText::_('COM_PAYPLANS_RECURRENCE_FREQUENCY_GREATER_THAN_ONE'),
																				'message' => XiText::_('COM_PAYPLANS_PAYMENT_APP_ALERTPAY_RECURRING_MESSAGE'));
			}
			
			// if total days are less or equlas to 90, then return days
			//  IMP : ASSUMPTION : 1 month = 30 days
			$days = $expTime['month'] * 30;
			if(($days + $expTime['day']) <= 90){
				return array('period' => $days + $expTime['day'], 'unit' => 'Day', 'frequency' => XiText::_('COM_PAYPLANS_RECURRENCE_FREQUENCY_GREATER_THAN_ONE'),
																					'message' => XiText::_('COM_PAYPLANS_PAYMENT_APP_ALERTPAY_RECURRING_MESSAGE'));
			}
			
			// other wise convert it into weeks
			return array('period' => intval(($days + $expTime['day'])/7, 10), 'unit' => 'W', 'frequency' => XiText::_('COM_PAYPLANS_RECURRENCE_FREQUENCY_GREATER_THAN_ONE'),
																							 'message' => XiText::_('COM_PAYPLANS_PAYMENT_APP_ALERTPAY_RECURRING_MESSAGE'));
		}
		
		// if only days are set then return days as it is
		if(!empty($expTime['day'])){
			return array('period' => intval($expTime['day'], 10), 'unit' => 'Day', 'frequency' => XiText::_('COM_PAYPLANS_RECURRENCE_FREQUENCY_GREATER_THAN_ONE'),
																					'message' => XiText::_('COM_PAYPLANS_PAYMENT_APP_ALERTPAY_RECURRING_MESSAGE'));
		}
		
		// XITODO : what to do if not able to convert it
		return false;
	}

	public function onPayplansPaymentAfter(PayplansPayment $payment, &$action, &$data, $controller)
	{
		$logs	= PayplansHelperLogger::getLog($payment, XiLogger::LEVEL_ERROR);
		$record = array_pop($logs);		
		if($record && !empty($record)){
			$action = 'error';
		}
		
		return parent::onPayplansPaymentAfter($payment, $action, $data, $controller);
	}

	protected function _getResponse($token)
	{
		$response = '';
		if(empty($token)){
			return $response;
		}
		
		$url = "https://secure.payza.com/ipn2.ashx";
		if($this->getAppParam('sandbox', false)){
			$url = "https://sandbox.payza.com/sandbox/ipn2.ashx"; 
		}
		// get the token from Alertpay
		$token = urlencode($token);
	
		//preappend the identifier string "token=" 
		$token = 'token='.$token;
		
		/**
		 * 
		 * Sends the URL encoded TOKEN string to the Alertpay's IPN handler
		 * using cURL and retrieves the response.
		 * 
		 * variable $response holds the response string from the Alertpay's IPN V2.
		 */
		
		$response = '';
		
		$ch = curl_init();
	
		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_POST, true);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $token);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_HEADER, false);
		curl_setopt($ch, CURLOPT_TIMEOUT, 60);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
	
		$response = curl_exec($ch);
	
		curl_close($ch);
		
		
		if(strlen($response) <= 0){
			// log the error
			$message = XiText::_('COM_PAYPLANS_APP_ALERTPAY_LOGGER_ERROR_NO_RESPONSE');
			PayplansHelperLogger::log(XiLogger::LEVEL_ERROR, $message, $this, array($message), 'PayplansPaymentFormatter', '', true);
			return false;
		}
		
		if(urldecode($response) == "INVALID TOKEN")
		{
			//the token is not valid
			$message = XiText::_('COM_PAYPLANS_APP_ALERTPAY_LOGGER_ERROR_INVALID_TOKEN');
			PayplansHelperLogger::log(XiLogger::LEVEL_ERROR, $message, $this, array($message), 'PayplansPaymentFormatter', '', true);
			return false;
		}
		
		//urldecode the received response from Alertpay's IPN V2
		$response = urldecode($response);
		
		//split the response string by the delimeter "&"
		$aps = explode("&", $response);
			
		//create a file to save the response information from Alertpay's IPN V2	
//		$myFile = "IPNRes.txt";
//		$fh = fopen($myFile,'a') or die("can't open the file");
		
		//define an array to put the IPN information
		$info = array();
		
		foreach ($aps as $ap)
		{
			//put the IPN information into an associative array $info
			$ele = explode("=", $ap);
			$info[$ele[0]] = $ele[1];
			
//			//write the information to the file IPNRes.txt
//			fwrite($fh, "$ele[0] \t");
//			fwrite($fh, "=\t");
//			fwrite($fh, "$ele[1]\r\n");
		}
		
//		fclose($fh);
		return $info;
	}
	
	protected function _processNotification(&$payment, $data, $transaction)
	{	
		$errors = array();
		if(JString::strtolower($this->getAppParam('merchant')) !== JString::strtolower($data['ap_merchant'])){
			$errors['error_message'] = XiText::_('COM_PAYPLANS_APP_ALERTPAY_INVALID_MERCHANT');
		}
			
		// check for recurring ang non-recurring
		if('success' !== JString::strtolower($data['ap_status']) && 'subscription-payment-success' !== JString::strtolower($data['ap_status'])){
			$errors['error_message'] = XiText::_('COM_PAYPLANS_APP_ALERTPAY_PAYMENT_FAIL');
		}
	
		if(!empty($errors)){
			$message 			= 'COM_PAYPLANS_APP_ALERTPAY_LOGGER_ERROR_IN_PAYMENT';
			$errors['response']	= $data;
			PayplansHelperLogger::log(XiLogger::LEVEL_ERROR, XiText::_($message), $payment, $errors, 'PayplansPaymentFormatter', '', true);
			$amount = 0;
		}else{
			$message = 'COM_PAYPLANS_APP_PAYPAL_TRANSACTION_COMPLETED';
			$amount = $data['ap_totalamount'];
		}
			
		$transaction->set('message', $message)
					->set('amount', $amount);
		return true;
	}
	
	public function onPayplansPaymentNotify(PayplansPayment $payment, $data, $controller)
	{		
		$invoice = $payment->getInvoice(PAYPLANS_INSTANCE_REQUIRE);
		
		// if same notification came more than one time
    	// Check if transaction already exists then do nothing and return	
		$txn_id 	= isset($data['ap_referencenumber']) 				? $data['ap_referencenumber'] 				: 0;
    	$subscr_id  = isset($data['ap_subscriptionreferencenumber']) 	? $data['ap_subscriptionreferencenumber'] 	: 0;
    	$parent_txn = isset($data['parent_txn_id']) 					? $data['parent_txn_id'] 					: 0;
	    	
    	$transactions = $this->_getExistingTransaction($invoice->getId(), $txn_id, $subscr_id, $parent_txn);
    	if($transactions !== false){
    		foreach($transactions as $record){
    			$record = PayplansTransaction::getInstance($record->transaction_id, null, $record);
    			if($record->getParam('ap_status','') === JString::strtolower($data['ap_status'])){
    				return true;
    			}
    		}
    	}
		
		// get the transaction instace of lib
		$transaction = PayplansTransaction::getInstance();
		$transaction->set('user_id', 			$payment->getBuyer())
					->set('invoice_id', 		$invoice->getId())
					->set('payment_id', 		$payment->getId())
					->set('gateway_txn_id', 	$txn_id)
					->set('gateway_subscr_id', 	$subscr_id)
					->set('gateway_parent_txn', $parent_txn)
					->set('params', PayplansHelperParam::arrayToIni($data));
					
		if('item' === JString::strtolower($data['ap_purchasetype'])){
			// its a normal payment			
			$this->_processNotification($payment, $data, $transaction);
			return $transaction->save();
		}
		
		if('subscription' === JString::strtolower($data['ap_purchasetype'])){
//			$txnId = $data['ap_referencenumber'];
															
			if ($data['ap_status'] == "Subscription-Payment-Success") 
			{
					// The payment is for a recurring subscription.
					// Check if TEST MODE is on/off and apply the proper logic. 
					// If Test Mode is ON then no transaction reference number will be returned.
					// A subscription reference number will be returned.
					// Process the order here by cross referencing the received data with your database. 														
					// Check that the total amount paid was the expected amount.
					// Check that the amount paid was for the correct service.
					// Check that the currency is correct.
					// ie: if ($totalAmountReceived == 50) ... etc ...
					// After verification, update your database accordingly.
					
					$this->_processNotification($payment, $data, $transaction);	
			}
			elseif ($data['ap_status'] == "Subscription-Canceled")
			{
				$transaction->set('message', 'COM_PAYPLANS_APP_ALERTPAY_TRANSACTION_SUBSCR_CANCEL');
				//terminate the order
				$invoice = $payment->getInvoice(PAYPLANS_INSTANCE_REQUIRE);
				$invoice->terminate();
			}
			else{
				$transaction->set('message', 'COM_PAYPLANS_APP_ALERTPAY_TRANSACTION_'.JString::strtoupper($data['ap_subscriptionreferencenumber']));
			}
		}
		
		return $transaction->save();
	}
}
