<?php
/**
* @copyright	Copyright (C) 2009 - 2015 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		Payplans
* @subpackage	Akeeba Ticket System
* @contact		support+payplans@readybytes.in
*/
// no direct access

defined( '_JEXEC' ) or die( 'Restricted access' );

/**
 * Payplans Akeeba Ticket System Credit App
 *
 */
class PayplansAppAts extends PayplansApp
{
	public 		$_location  = __FILE__;

	public function isApplicable($refObject = NULL, $eventName = '')
	{
		return parent::isApplicable($refObject,$eventName);
	}

	public function onPayplansSubscriptionAfterSave($prev, PayplansSubscription $new)
	{
		
		$newstatus  = $new->getStatus();
		$userid			= $new->getBuyer();	
		
//		$applyOnRenwal = $this->getAppParam('applyOnRenewal', 1);
//		$applyOnUpgrade = $this->getAppParam('applyOnUpgrade', 1);
		
		$isRenewal = $this->isSubscriptionRenewal($new);
		$isUpgrade = $this->isSubscriptionUpgrade($new);
		
// 		//only retrun when app say do not apply on renew, but subcription is renewed
// 		if ( 0 == $applyOnRenwal && true === $isRenewal ) {
// 			return true;
// 		}

// 		//only retrun when app say do not apply on upgrade, but subcription is upgraded
// 		if ( 0 == $applyOnUpgrade && true === $isUpgrade ) {
// 			return true;
// 		}	
		
		
		//if subscription is active, credit the user's account
		if ( $newstatus == PayplansStatus::SUBSCRIPTION_ACTIVE ) {
			$creditAmount = $this->getAppParam('creditAmount', 0);
			
			//only retrun when app say do not apply on upgrade, but subcription is upgraded
			if ( true === $isUpgrade ) {
				$creditAmount = $this->getAppParam('creditUpgradeAmount', 0);
			}
			
			//only retrun when app say do not apply on renew, but subcription is renewed
			if ( true === $isRenewal ) {
				$creditAmount = $this->getAppParam('creditRenewalAmount', 0);
			}
					
			return $this->creditUserAccount($userid,$creditAmount,$new, false, false);
		}
		
		//if subscription is hold, debut the user's account
		if ( $newstatus == PayplansStatus::SUBSCRIPTION_HOLD ) {
			$debitAmount = $this->getAppParam('debitHoldAmount', 0);
			return $this->creditUserAccount($userid,$debitAmount,$new, true, false);

// 			$holdTheAmount = $this->getAppParam('holdTheAmount', 0);
// 			return $this->creditUserAccount($userid,$creditAmount,$new, false, $holdTheAmount);
		}
		
		// if subscription is expire, debut the user's account
		if ( $newstatus == PayplansStatus::SUBSCRIPTION_EXPIRED ) {
			$debitAmount = $this->getAppParam('debitExpireAmount', 0);
			return $this->creditUserAccount($userid,$debitAmount,$new, true, false);
		}

		return true;
	}
	
	/**
	 * Credit the akeebas ticket's user's account
	 * @param  integer              $userid       
	 * @param  integer              $amount       
	 * @param  PayplansSubscription $subscription 
	 * @param  boolean              $isDebit      
	 * @return boolean              is user's account credited or not
	 */
	protected function creditUserAccount($userid = null, $amount = 0, PayplansSubscription $subscription, $isDebit = false, $holdTheAmount = 0)
	{
		$amount = intval($amount);

// 		if(0 === $amount && 0 === $holdTheAmount) {
// 			return true;
// 		}

		if( 0 === $amount ) {
			return true;
		}

		$this->loadAtsLibrary();
		// This line loads the class autoloader for ATS
              $container = \FOF30\Container\Container::getInstance('com_ats');
		//$modal = $container->factory->model('CreditTransactions')->tmpInstance();
		$modal = FOFModel::getTmpInstance('CreditTransactions', 'AtsModel');

		//get avaialbe user balance then if avaialbe balance is less than debit amount then bebit the same amount
		if ( $isDebit ) {
			
			  $availableBalance = Akeeba\TicketSystem\Admin\Helper\Credits::creditsLeft($userid, true);
			
		  if ( $amount >= $availableBalance ) {
				$amount = $availableBalance;
			} 
			  
			 $amount = ( $isDebit ) ? - $amount : $amount;
		}

// 		if ( $holdTheAmount ) {
// 			$records = $modal->user_id($user_id)
// 											->type('payplans')
// 											->unique_id($subscription->getKey())
// 											->getList(true);
			
// 			foreach ( $records as $record ) {
// 				$record->enabled = 0;
// 				$modal->save($record);
// 			}
			
// 			return true;
// 		}
		
		//use current date cause subscription may be activate or on hold, so can't use subcription date. 
		$date = new XiDate('now');
		
		$data = array(	'ats_credittransaction_id' => 0,
						'user_id' 			=> $userid,
						'transaction_date'	=> $date->toFormat(XiDate::YYYY_MM_DD_HH_MM),
						'type'				=> 'payplans',
						'unique_id'			=> $subscription->getKey(),
						'value'				=> $amount,
					);

		return $modal->save($data);
		
	}
	
	public function isSubscriptionRenewal(PayplansSubscription $subcription)
	{
		$order = $subcription->getOrder(PAYPLANS_INSTANCE_REQUIRE);
		$firstInvoice = $order->getParam('first_invoice_id',0);
		$lastMasterInvoice = $order->getParam('last_master_invoice_id',0);

		if ( $firstInvoice != $lastMasterInvoice) {
			return true;
		}
		
		return false;
	}
	
	public function isSubscriptionUpgrade(PayplansSubscription $subcription)
	{
		$order = $subcription->getOrder(PAYPLANS_INSTANCE_REQUIRE);
		$upgrade = $order->getParam('upgrading_from',0);

		if ( 0 != $upgrade) {
			return true;
		}
	
		return false;
	}
	
	public function loadAtsLibrary() 
	{
		// Include FOF
		if(!defined('FOF30_INCLUDED')) {
			require_once JPATH_LIBRARIES.'/fof30/include.php';
		}
		return true;
	}
}

