<?php
/**
* @copyright	Copyright (C) 2009 - 2009 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		PayPlans
* @subpackage	Frontend
* @contact 		shyam@readybytes.in
*/
if(defined('_JEXEC')===false) die();

class PayplansAppBankaudi extends PayplansAppPayment
{
	//inherited properties
	protected $_location	= __FILE__;
	
	function onPayplansPaymentForm(PayplansPayment $payment, $data = null)
	{
		$invoice = $payment->getInvoice(PAYPLANS_INSTANCE_REQUIRE);
		
		$this->assign('post_url', 'https://gateway.netcash.co.za/vvonline/ccnetcash.asp');

		$post['accessCode'] = $this->getAppParam('access_code', '');
		$post['merchant']	= $this->getAppParam('merchant_id', '');
				
		// merchTxnRef is payment key
		$post['merchTxnRef'] = $payment->getKey();
		$post['orderInfo']   = $invoice->getTitle();
		
		// need to multiply by 100
		$post['amount']		 = intval($invoice->getTotal() * 100);
		
		$url  = JURI::root().'index.php?option=com_payplans&view=payment&task=complete';
		$url .= '&payment_key='.$payment->getKey();
		$post['returnURL'] = $url;
		
		$secretHash = $this->getAppParam('secret_hash', '');
		
		ksort($post);
		$md5HashData = $secretHash;
		
		$vpcURL = '';
		foreach($post as $key => $value) 
		{
		    // create the md5 input and URL leaving out any fields that have no value
		    if (strlen($value) > 0 && ($key == 'accessCode' || $key == 'merchTxnRef' || $key == 'merchant' || $key == 'orderInfo' || $key == 'amount' || $key == 'returnURL')) {
		        // this ensures the first paramter of the URL is preceded by the '?' char
		        if (!isset($appendAmp) || $appendAmp == 0) 
		        {
		            $vpcURL .= urlencode($key) . '=' . urlencode($value);
		            $appendAmp = 1;
		        } else {
		            $vpcURL .= '&' . urlencode($key) . "=" . urlencode($value);
		        }
		        $md5HashData .= $value;
		    }
		}	
		$newHash = $vpcURL."&vpc_SecureHash=" . strtoupper(md5($md5HashData));
		$this->assign('post_url', 'https://gw1.audicards.com/TPGWeb/payment/prepayment.action?'.$newHash);
		return $this->_render('form_buynow');
	}
		
	public function onPayplansPaymentAfter(PayplansPayment $payment, &$action, &$data, $controller)
	{
		$invoice = $payment->getInvoice(PAYPLANS_INSTANCE_REQUIRE);		
					
		$secretHash = $this->getAppParam('secret_hash', '');
		$errors 	= array();
		$status		= null;
			
		// needs GET data only		
		$data = JRequest::get('GET');
		$cookies = JRequest::get('COOKIE');
		foreach($cookies as $key => $value){
			if(isset($data[$key])) unset($data[$key]);
		}

		if(isset($data['Itemid'])) 		unset($data['Itemid']);
		if(isset($data['option'])) 		unset($data['option']);
		if(isset($data['view'])) 		unset($data['view']);
		if(isset($data['task'])) 		unset($data['task']);
		if(isset($data['order_key'])) 	unset($data['order_key']);
		if(isset($data['payment_key'])) unset($data['payment_key']);
		
		// if same notification came more than one time
		// Check if transaction already exists,if yes then do nothing and return
		$txn_id = isset($data['vpc_TransactionNo']) ? $data['vpc_TransactionNo'] :0; 
		$transactions 	= $this->_getExistingTransaction($invoice->getId(), $txn_id, 0, 0);
		if (!empty($transactions)) {
    		foreach ($transactions as $transaction) {
    			$transaction = PayplansTransaction::getInstance($transaction->transaction_id, null, $transaction);
    			if(strtolower($transaction->getParam('vpc_TxnResponseCode','')) == strtolower($data['vpc_TxnResponseCode'])){
					return true;
				}
    		}
	    }
		
		// get the transaction instace of lib
		$transaction = PayplansTransaction::getInstance();
		$transaction->set('user_id', $payment->getBuyer())
					->set('invoice_id', $invoice->getId())
					->set('payment_id', $payment->getId())
					->set('gateway_subscr_id', 0)
					->set('gateway_parent_txn', 0)
					->set('params', PayplansHelperParam::arrayToIni($data));
		
		//get secure hash value of merchant	
		//get the secure hash sent from payment client
		$vpc_Txn_Secure_Hash = addslashes($data["vpc_SecureHash"]);
		unset($data["vpc_SecureHash"]); 
		ksort($data);
		// set a flag to indicate if hash has been validated
		$errorExists = false;
		//check if the value of response code is valid
		if (strlen($secretHash) > 0 && addslashes($data["vpc_TxnResponseCode"]) != "7" 
				&& addslashes($data["vpc_TxnResponseCode"]) != "No Value Returned") {
					
			//creat an md5 variable to be compared with the passed transaction secure hash to check if url has been tampered with or not
		    $md5HashData = $secretHash;
	
			//creat an md5 variable to be compared with the passed transaction secure hash to check if url has been tampered with or not
		    $md5HashData_2 = $secretHash;
	
		    // sort all the incoming vpc response fields and leave out any with no value
		    foreach($data as $key => $value) 
		    {
		        if ($key != "vpc_SecureHash" && strlen($value) > 0 && $key != 'action' ) 
		        {
					$hash_value = str_replace(" ",'+',$value);
					$hash_value = str_replace("%20",'+',$hash_value);
					$md5HashData_2 .= $value;
		            $md5HashData .= $hash_value;
		            
		        }
	   		}

		    //if transaction secure hash is the same as the md5 variable created 
		    if (strtoupper($vpc_Txn_Secure_Hash) != strtoupper(md5($md5HashData)) 
		    	&& strtoupper($vpc_Txn_Secure_Hash) != strtoupper(md5($md5HashData_2))){
		        $error = XiText::_("COM_PAYPLANS_APP_BANKAUDI_INVALID_HASH");		        
		    }
		} 
		else 
		{
		   	$error = XiText::_("COM_PAYPLANS_APP_BANKAUDI_NO_SECURE_SECRET_PRESENT");
		}
		
		//the the fields passed from the url to be displayed
		$amount          = $this->null2unknown(addslashes($data["amount"])/100);
		
//		$locale          = $this->null2unknown(addslashes($data["vpc_Locale"]));
//		$batchNo         = $this->null2unknown(addslashes($data["vpc_BatchNo"]));
//		$command         = $this->null2unknown(addslashes($data["vpc_Command"]));
//		$message         = $this->null2unknown(addslashes($data["vpc_Message"]));
//		$version         = $this->null2unknown(addslashes($data["vpc_Version"]));
//		$cardType        = $this->null2unknown(addslashes($data["vpc_Card"]));
//		$orderInfo       = $this->null2unknown(addslashes($data["orderInfo"]));
//		$receiptNo       = $this->null2unknown(addslashes($data["vpc_ReceiptNo"]));
//		$merchantID      = $this->null2unknown(addslashes($data["merchant"]));
//		$authorizeID     = $this->null2unknown(addslashes($data["vpc_AuthorizeId"]));
//		$merchTxnRef     = $this->null2unknown(addslashes($data["merchTxnRef"]));
//		$transactionNo   = $this->null2unknown(addslashes($data["vpc_TransactionNo"]));
//		$acqResponseCode = $this->null2unknown(addslashes($data["vpc_AcqResponseCode"]));
		$txnResponseCode = $this->null2unknown(addslashes($data["vpc_TxnResponseCode"]));
			
		// if $txnResponseCode == 0, it means transaction successfull
		if(!is_numeric($txnResponseCode) ||  (int)$txnResponseCode !== 0){
			$errors[]	= $this->getResponseDescription($txnResponseCode);
		}
		
		//store the response in the payment AND save the payment
		$data["vpc_SecureHash"] = $vpc_Txn_Secure_Hash;
				
		if($error){
			$message 						= 'COM_PAYPLANS_APP_BANKAUDI_LOGGER_ERROR_IN_PAYMENT_PROCESS';		
			$response						= array();
			$response['error_message']   	= $error;
			$response['data']				= $data;	
			PayplansHelperLogger::log(XiLogger::LEVEL_ERROR, XiText::_($message), $payment, $response, 'PayplansPaymentFormatter', '', true);
			$action = "error";
			$amount = 0;
		}
		else{
			$message = 'COM_PAYPLANS_APP_BANKAUDI_LOGGER_SUCCESS_IN_PAYMENT_PROCESS';
		} 
		
		$transaction->set('message', $message)
					->set('amount', $amount)
					->set('gateway_txn_id', $data['vpc_TransactionNo'])
					->save();
		
		return parent::onPayplansPaymentAfter($payment, $action, $data, $controller);
	}
	
	function getResponseDescription($responseCode) 
	{
	    switch ($responseCode) {
	        case "0" : $result = XiText::_('COM_PAYPLANS_APP_BANKAUDI_TRANSACTION_MSG_TRANSACTION_SUCCESSFUL');"Transaction Successful"; break;
	        case "?" : $result = XiText::_('COM_PAYPLANS_APP_BANKAUDI_TRANSACTION_MSG_TRANSACTION_STATUS_IS_UNKNOWN');"Transaction status is unknown"; break;
	        case "1" : $result = XiText::_('COM_PAYPLANS_APP_BANKAUDI_TRANSACTION_MSG_UNKNOWN_ERROR');"Unknown Error"; break;
	        case "2" : $result = XiText::_('COM_PAYPLANS_APP_BANKAUDI_TRANSACTION_MSG_BANK_DECLINED_TRANSACTION');"Bank Declined Transaction"; break;
	        case "3" : $result = XiText::_('COM_PAYPLANS_APP_BANKAUDI_TRANSACTION_MSG_NO_REPLY_FROM_BANK');"No Reply from Bank"; break;
	        case "4" : $result = XiText::_('COM_PAYPLANS_APP_BANKAUDI_TRANSACTION_MSG_EXPIRED_CARD');"Expired Card"; break;
	        case "5" : $result = XiText::_('COM_PAYPLANS_APP_BANKAUDI_TRANSACTION_MSG_INSUFFICIENT_FUNDS');"Insufficient funds"; break;
	        case "6" : $result = XiText::_('COM_PAYPLANS_APP_BANKAUDI_TRANSACTION_MSG_ERROR_COMMUNICATING_WITH_BANK');"Error Communicating with Bank"; break;
	        case "7" : $result = XiText::_('COM_PAYPLANS_APP_BANKAUDI_TRANSACTION_MSG_PAYMENT_SERVER_SYSTEM_ERROR');"Payment Server System Error"; break;
	        case "8" : $result = XiText::_('COM_PAYPLANS_APP_BANKAUDI_TRANSACTION_MSG_TRANSACTION_TYPE_NOT_SUPPORTED');"Transaction Type Not Supported"; break;
	        case "9" : $result = XiText::_('COM_PAYPLANS_APP_BANKAUDI_TRANSACTION_MSG_BANK_DECLINED_TRANSACTION');"Bank declined transaction (Do not contact Bank)"; break;
	        case "A" : $result = XiText::_('COM_PAYPLANS_APP_BANKAUDI_TRANSACTION_MSG_TRANSACTION_ABORTED');"Transaction Aborted"; break;
	        case "C" : $result = XiText::_('COM_PAYPLANS_APP_BANKAUDI_TRANSACTION_MSG_TRANSACTION_CANCELLED');"Transaction Cancelled"; break;
	        case "D" : $result = XiText::_('COM_PAYPLANS_APP_BANKAUDI_TRANSACTION_MSG_DEFERRED_TRANSACTION');"Deferred transaction has been received and is awaiting processing"; break;
	        case "E" : $result = XiText::_('COM_PAYPLANS_APP_BANKAUDI_TRANSACTION_MSG_INVALID_CREDIT_CARD');"Invalid Credit Card"; break;
	        case "F" : $result = XiText::_('COM_PAYPLANS_APP_BANKAUDI_TRANSACTION_MSG_3D_SECURE_AUTHENTICATION_FAILED');"3D Secure Authentication failed"; break;
	        case "I" : $result = XiText::_('COM_PAYPLANS_APP_BANKAUDI_TRANSACTION_MSG_CARD_SECURITY_CODE_VERIFICATION_FAILED');"Card Security Code verification failed"; break;
	        case "G" : $result = XiText::_('COM_PAYPLANS_APP_BANKAUDI_TRANSACTION_MSG_INVALID_MERCHANT');"Invalid Merchant"; break;
	        case "L" : $result = XiText::_('COM_PAYPLANS_APP_BANKAUDI_TRANSACTION_MSG_SHOPPING_TRANSACTION_LOCKED');"Shopping Transaction Locked (Please try the transaction again later)"; break;
	        case "N" : $result = XiText::_('COM_PAYPLANS_APP_BANKAUDI_TRANSACTION_MSG_CARDHOLDER_IS_NOT_ENROLLED');"Cardholder is not enrolled in Authentication scheme"; break;
	        case "P" : $result = XiText::_('COM_PAYPLANS_APP_BANKAUDI_TRANSACTION_MSG_TRANSACTION_IS_BEING_PROCESSED');"Transaction has been received by the Payment Adaptor and is being processed"; break;
	        case "R" : $result = XiText::_('COM_PAYPLANS_APP_BANKAUDI_TRANSACTION_MSG_TRANSACTION_WAS_NOT_PROCESSED');"Transaction was not processed - Reached limit of retry attempts allowed"; break;
	        case "S" : $result = XiText::_('COM_PAYPLANS_APP_BANKAUDI_TRANSACTION_MSG_DUPLICATE_SESSIONID');"Duplicate SessionID (OrderInfo)"; break;
	        case "T" : $result = XiText::_('COM_PAYPLANS_APP_BANKAUDI_TRANSACTION_MSG_ADDRESS_VERIFICATION_FAILED');"Address Verification Failed"; break;
	        case "U" : $result = XiText::_('COM_PAYPLANS_APP_BANKAUDI_TRANSACTION_MSG_CARD_SECURITY_CODE_FAILED');"Card Security Code Failed"; break;
	        case "V" : $result = XiText::_('COM_PAYPLANS_APP_BANKAUDI_TRANSACTION_MSG_ADDRESS_VERIFICATION_AND_CARD_SECURITY_CODE_FAILED');"Address Verification and Card Security Code Failed"; break;
	        case "X" : $result = XiText::_('COM_PAYPLANS_APP_BANKAUDI_TRANSACTION_MSG_CREDIT_CARD_BLOCKED');"Credit Card Blocked"; break;
	        case "Y" : $result = XiText::_('COM_PAYPLANS_APP_BANKAUDI_TRANSACTION_MSG_INVALID_URL');"Invalid URL"; break;                
	        case "B" : $result = XiText::_('COM_PAYPLANS_APP_BANKAUDI_TRANSACTION_MSG_TRANSACTION_WAS_NOT_COMPLETED');"Transaction was not completed"; break;                
	        case "M" : $result = XiText::_('COM_PAYPLANS_APP_BANKAUDI_TRANSACTION_MSG_PLEASE_ENTER_ALL_REQUIRED_FIELDS');"Please enter all required fields"; break;                
	        case "J" : $result = XiText::_('COM_PAYPLANS_APP_BANKAUDI_TRANSACTION_MSG_TRANSACTION_ALREADY_IN_USE');"Transaction already in use"; break;
	        case "BL" : $result = XiText::_('COM_PAYPLANS_APP_BANKAUDI_TRANSACTION_MSG_CARD_BIN_LIMIT_REACHED');"Card Bin Limit Reached"; break;                
	        case "CL" : $result = XiText::_('COM_PAYPLANS_APP_BANKAUDI_TRANSACTION_MSG_CARD_LIMIT_REACHED');"Card Limit Reached"; break;                
	        case "LM" : $result = XiText::_('COM_PAYPLANS_APP_BANKAUDI_TRANSACTION_MSG_MERCHANT_AMOUNT_LIMIT_REACHED');"Merchant Amount Limit Reached"; break;                
	        case "Q" : $result = XiText::_('COM_PAYPLANS_APP_BANKAUDI_TRANSACTION_MSG_IP_BLOCKED');"IP Blocked"; break;                
	        case "R" : $result = XiText::_('COM_PAYPLANS_APP_BANKAUDI_TRANSACTION_MSG_TRANSACTION_WAS_NOT_PROCESSED');"Transaction was not processed - Reached limit of retry attempts allowed"; break;                
	        case "Z" : $result = XiText::_('COM_PAYPLANS_APP_BANKAUDI_TRANSACTION_MSG_BIN_BLOCKED');"Bin Blocked"; break;

	        default  : $result = XiText::_('COM_PAYPLANS_APP_BANKAUDI_TRANSACTION_MSG_UNABLE_TO_BE_DETERMINED');"Unable to be determined"; 
	    }
	    return $result;
	}
	
	//function to display a No Value Returned message if value of field is empty
	function null2unknown($data) 
	{
	    if ($data == "") 
	        return "No Value Returned";
	     else 
	        return $data;
	}
}
