<?php
/**
 * @copyright	Copyright (C) 2009 - 2015 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * @package		Payplans
 * @subpackage	Basic Tax
 * @contact 	support+payplans@readybytes.in
 */
if(defined('_JEXEC')===false) die();


/**
 * Discount System
 * @author shyam
 */
class PayplansAppBasictax extends PayplansApp
{
	//inherited properties
	protected $_location	= __FILE__;

	// 	Entry Function
	public function onPayplansApplyTax(PayplansInvoice $invoice, $countryCode, $purpose = 0, $vatno = false)
	{
		$applyTo = $this->getAppParam('tax_country', array());
		$applyTo = (is_array($applyTo)) ? $applyTo :array($applyTo);
		if(!in_array(PAYPLANS_CONST_ALL,$applyTo)){
			//When only one item is selected
			if(is_array($applyTo )==false){
				$applyTo = array($applyTo );
			}

			// not applicable
			if(in_array($countryCode,$applyTo) ==false){
				return NULL;

			}
		}

		$taxName  = array();
		$taxName[]= floatval($this->getAppParam('tax_rate', 0));
		$taxName[]= $this->title;
		// return tax rate to be used
		// MUST float cast it
		return $taxName;
	}
}

class PayplansAppBasictaxFormatter extends PayplansAppFormatter
{
	// get rules to apply
	function getVarFormatter()
	{
		$rules = array( '_appplans'       => array('formatter'=> 'PayplansAppFormatter',
										       'function' => 'getAppPlans'),
						'app_params'      => array('formatter'=> 'PayplansAppBasictaxFormatter',
										       	   'function' => 'getFormattedParams')
		);
		return $rules;
	}

	function getFormattedParams($key, $value, $data)
	{
		$items = XiFactory::getInstance('country', 'model')->loadRecords();
		if(is_array($value['tax_country']))
		{
			foreach ($value['tax_country'] as $param){
				$country[] = $items[$param]->title;
			}
			$value['tax_country']= $country;
		}
		else{
			$value['tax_country'] = $items[$value['tax_country']]->title;
		}
	}

}