<?php
/**
* @copyright	Copyright (C) 2009 - 2014 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		PayPlans
* @subpackage	Frontend
* @contact 		support+payplans@readybytes.in
*/
if(defined('_JEXEC')===false) die();

class PayplansAppCompay extends PayplansAppPayment
{
	protected $_location	= __FILE__;

   public function onPayplansPaymentForm(PayplansPayment $payment, $data = null)
   {
		if(is_object($data)){
			$data = (array)$data;
		}

		/*if(isset($data["initiate"])){
			return $this->initiatePaymentRequest($data);
		}*/

		$invoice 		= $payment->getInvoice(PAYPLANS_INSTANCE_REQUIRE);
		$merchantId 	= $this->getAppParam('client_id',false);
		$gatewaydata	= $this->initiatePaymentRequest($merchantId, $payment, $invoice);
    		if($this->getAppParam('sandbox',0)){
			$post_url  		= 'https://cptest.asseco-see.com.tr/fim/comPayGate';
		}else {
			$post_url  		= 'https://www.compayodeme.com/fim/comPayGate';
		}
    	
    	$this->assign('gatewaydata', 	$gatewaydata);
    	$this->assign('url',         	$post_url); 
	    	
		return $this->_render('postform');
  	}

    public function onPayplansPaymentAfter(PayplansPayment $payment, &$action, &$data, $controller)
	{
		if($action == 'cancel'){
				return true;
		}

		$invoice 	= $payment->getInvoice(PAYPLANS_INSTANCE_REQUIRE);
		$amount 	= number_format($invoice->getTotal(),2);
		
		$this->_processPayment($invoice, $payment, $_POST);
	
		return parent::onPayplansPaymentAfter($payment, $action, $data, $controller);
	}
	
	public function initiatePaymentRequest($merchantId, $payment, $invoice)
	{	
		$paymentKey = $payment->getKey();
		$buyer 		= $invoice->getBuyer(PAYPLANS_INSTANCE_REQUIRE);
		$root = JURI::root();
		if(XiFactory::getConfig()->https == true){
		    $root         = JString::str_ireplace("http:", "https:", $root);
		}
		
		$redirectURL     = $root.'index.php?option=com_payplans&gateway=compay&view=payment&task=complete&action=success&payment_key='.$paymentKey;
		$cancelURL       = $root.'index.php?option=com_payplans&gateway=compay&view=payment&task=complete&action=cancel&payment_key='.$paymentKey;
    	

		$gatewaydata						= array();
		$gatewaydata['clientid'] 			= $merchantId;
		$gatewaydata['amount'] 				= $invoice->getTotal();
		$gatewaydata['okurl'] 				= $redirectURL;
		$gatewaydata['failUrl'] 			= $cancelURL;
		$gatewaydata['TranType'] 			= "Auth";
		$gatewaydata['Instalment'] 			= "";
		$gatewaydata['callbackUrl'] 		= $redirectURL;
		$gatewaydata['shopurl'] 			= $redirectURL;
		$gatewaydata['currency'] 			= "949";
		$gatewaydata['rnd'] 				= microtime();
		$gatewaydata['orderId'] 			= $paymentKey;
		$gatewaydata['productType'] 		= "B";
		$gatewaydata['hashAlgorithm'] 		= "ver3";
		$gatewaydata['lang'] 				= "tr";
		$gatewaydata['BillToName'] 			= $buyer->getUsername();
		$gatewaydata['BillToCompany'] 		= $buyer->getUsername();

		//$merchant_data						= '';
		$postParams = array();
		foreach ($gatewaydata as $key => $value){
			array_push($postParams, $key);
			//$merchant_data .= $key.'='.urlencode($value).'&';
		}
			
		natcasesort($postParams);		
			
		$hashval = "";					
		foreach ($postParams as $param){				
			$paramValue 		= $gatewaydata[$param];
			$escapedParamValue 	= str_replace("|", "\\|", str_replace("\\", "\\\\", $paramValue));	
				
			$lowerParam 	= strtolower($param);
			if($lowerParam != "hash" && $lowerParam != "encoding" )	{
				$hashval 	= $hashval . $escapedParamValue . "|";
			}
		}
			
		$storeKey 				= $this->getAppParam('store_key',false);
		$escapedStoreKey 		= str_replace("|", "\\|", str_replace("\\", "\\\\", $storeKey));	
		$hashval 				= $hashval . $escapedStoreKey;
		
		$calculatedHashValue 	= hash('sha512', $hashval);  
		$hash 					= base64_encode (pack('H*',$calculatedHashValue));
		$gatewaydata['HASH']	= $hash;

		return $gatewaydata;
	}
	
	public function _processPayment($invoice, $payment, $response)
	{
		// if same notification came more than one time, check if transaction already exists if yes then do nothing and return
		$transactions = $this->_getExistingTransaction($invoice->getId(), $response['provisionTransactionId'], 0, 0);
    	    if($transactions !== false){
    		  foreach($transactions as $transaction){
    			$transaction = PayplansTransaction::getInstance($transaction->transaction_id, null, $transaction);
    			if($transaction->getParam('order_status', '') === $orderStatus)
    				return true;
    		 }
    	  }

		$postParams = array();
		foreach ($response as $key => $value){
			array_push($postParams, $key);				
		}
			
		natcasesort($postParams);		
			
		$hashval = "";					
		foreach ($postParams as $param){				
			$paramValue = $response[$param];
			$escapedParamValue = str_replace("|", "\\|", str_replace("\\", "\\\\", $paramValue));	
				
			$lowerParam = strtolower($param);
			if($lowerParam != "hash" && $lowerParam != "encoding" )	{
				$hashval = $hashval . $escapedParamValue . "|";
			}
		}
			
		$storeKey = $this->getAppParam('store_key',false);
		$escapedStoreKey = str_replace("|", "\\|", str_replace("\\", "\\\\", $storeKey));	
		$hashval = $hashval . $escapedStoreKey;
		
		$calculatedHashValue = hash('sha512', $hashval);  
		$actualHash = base64_encode (pack('H*',$calculatedHashValue));
		
		$retrievedHash = $response["HASH"];	

		$transaction = PayplansTransaction::getInstance();
		$transaction->set('user_id', 			$payment->getBuyer())
					->set('invoice_id', 		$invoice->getId())
					->set('payment_id', 		$payment->getId())
					->set('gateway_txn_id', 	isset($response['provisionTransactionId']) 		? $response['provisionTransactionId'] 			: 0)
					->set('gateway_subscr_id', 	0)
					->set('gateway_parent_txn', 0)
					->set('params', 			PayplansHelperParam::arrayToIni($response));

		$error	= '';

		if($retrievedHash == $response['HASH'])	{
				if($response['acqResponseDetail'] == 'Success') {
					$transaction->set('amount', 	$response['amount'])
							->set('message', 	XiText::_('COM_PAYPLANS_PAYMENT_APP_COMPAY_TRANSACTION_COMPLETED'));
				}else {
					$transaction->set('message', 	XiText::_('COM_PAYPLANS_PAYMENT_APP_COMPAY_TRANSACTION_FAILED'));
				}
					
			}else {
				$transaction->set('message', 	XiText::_('COM_PAYPLANS_PAYMENT_APP_COMPAY_TRANSACTION_INVALID_HASH'));
			}

		
		if($error){
				$message = XiText::_('COM_PAYPLANS_LOGGER_ERROR_IN_COMPAY_PAYMENT_PROCESS');
				PayplansHelperLogger::log(XiLogger::LEVEL_ERROR, $message, $payment, $response, 'PayplansPaymentFormatter', '', true);
		}
        
        //store the response in the payment AND save the payment
		if(!$transaction->save()){
			$message = XiText::_('COM_PAYPLANS_LOGGER_ERROR_TRANSACTION_SAVE_FAILD');
			PayplansHelperLogger::log(XiLogger::LEVEL_ERROR, $message, $payment, $response, 'PayplansPaymentFormatter', '', true);
		}
		
		$payment->save();
		return parent::onPayplansPaymentAfter($payment, $action, $data, $controller);
	}

}
