<?php

/**
* @copyright	Copyright (C) 2009 - 2009 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @contact		shyam@joomlaxi.com
*/
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

/**
 * Payplans Registration Comprofiler Plugin
 *
 * @package		Payplans
 * @subpackage	Plugin
 */

class  plgPayplansregistrationComprofiler extends XiPluginRegistration
{	
	protected $_registrationUrl = 'index.php?option=com_comprofiler&view=registers&fromPayplans=1';
	
	function _isRegistrationUrl()
	{   
		$vars = $this->_getVars();
		if($vars['option'] == 'com_comprofiler' && $vars['view'] == 'registers'){
			return true;
		}
		
		return false;	 
	}
	
	function _isRegistrationCompleteUrl()
	{
		return false;
	}
	
	function onAfterDispatch()
	{
		// do not run in admin panel
		if($this->_app->isAdmin()){
  			return true;
		}
		
		// must be on comprofile save screen
		$vars = $this->_getVars();
		if($vars['option'] != 'com_comprofiler' && $vars['view'] != 'saveregisters'){
			return true;
		}
		
		$registrationType = XiFactory::getConfig()->registrationType;	
		if($registrationType != $this->_name){
			return true;
		}
				
		// complete registration
		if($this->_getUser()){
			$this->_doCompleteRegistration();
		}
				
		return true;
	}


	public function onPayplansGetPlugin()
	    {
	        $xml = dirname(__FILE__).DS.'comprofiler.xml';
	        if (file_exists($xml)) {
	                    $xmlContent = simplexml_load_file($xml);
	                }
	                else {
	                    $xmlContent = null;
	                }
	         return array('name'   => 'comprofiler', 
	                	  'value' =>$xmlContent);
	    }
	    
	protected function _doStartRegistration()
  	{
			$compInfo =    XiAbstractHelperJoomla::getExtension('com_comprofiler');
				  
			if(empty($compInfo) || array_shift($compInfo)->enabled == 0){
      			XiFactory::getApplication()->enqueueMessage(sprintf(XiText::_("COM_PAYPLANS_COMPONENT_NOT_FOUND_OR_DISABLED"), 'Comprofiler'));
				return parent::_doStartRegistration();
	 	 	}
	 	 
                  
        	$planId = $this->_getPlan();
            $this->_setPlan($planId);
            $this->_session->set('fromPayplans', 1);
            $this->_app->redirect(XiRoute::_('index.php?option=com_comprofiler&task=registers'));
            return true;
     }
	
	function onPayplansAccessCheck()
	{
		$vars 			= $this->_getVars(array('option', 'view'));
		$fromPayplans 	= $this->_session->get('fromPayplans', 0);
		
		if($vars['option'] == 'com_comprofiler' && $vars['view'] == 'registers' && !($fromPayplans)){
			$this->_app->redirect(XiRoute::_("index.php?option=com_payplans&view=plan&task=subscribe", false));
		}
	}
}

