<?php
/**
* @copyright	Copyright (C) 2009 - 2009 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license	GNU/GPL, see LICENSE.php
* @contact	payplans@readybytes.in
*/
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );


/**
 * Payplans Content Hider on Subscription basis
 */

class plgPayplansContenthider extends XiPlugin
{	
	public function onPrepareContent( &$article, &$params, $limitstart = 0 )
	{
		// Check whether the plugin should process or not
		if ( JString::strpos( $article->text, 'payplans' ) === false )
		{
			return true;
		}
		
		// Search for this tag in the content
		$regex = "#{payplans(.*?)}(.*?){/payplans}#s";
		
		$article->text = preg_replace_callback( $regex, array($this, 'process'), $article->text );
	}
	
	public function onContentPrepare($context, &$row, &$params, $page = 0)
	{
		if(is_object($row)) {
			// Check whether the plugin should process or not
			if ( JString::strpos( $row->text, 'payplans' ) === false )
			{
				return true;
			}
			
			// Search for this tag in the content
			$regex = "#{payplans(.*?)}(.*?){/payplans}#s";
			
			$row->text = preg_replace_callback( $regex, array($this, 'process'), $row->text );
		} else {
			if ( JString::strpos( $row, 'payplans' ) === false ) {
				return true;
			}
			$regex = "#{payplans(.*?)}(.*?){/payplans}#s";
			$row = preg_replace_callback( $regex, array($this, 'process'), $row );
		}
		
		return true;
	}


	public function onPayplansGetPlugin()
	{
	        $xml = dirname(__FILE__).DS.'contenthider.xml';
	        if (file_exists($xml)) {
	                    $xmlContent = simplexml_load_file($xml);
	                }
	                else {
	                    $xmlContent = null;
	                }
	         return array('name'   => 'contenthider', 
	                	  'value' =>$xmlContent);
	 }
	
	/**
	 * preg_match callback to process each match
	 */
	public function process($match)
	{
		$ret = '';
		$content_show = 'SHOW';
		$content_hide = 'HIDE';
		
		if(!isset($match[2])){
			return $ret;
		}
		
		$user_id = (!isset($this->user_id)) ? XiFactory::getUser()->id : $this->user_id;
		$user = PayplansUser::getInstance($user_id);
		$user_plans = $user->getPlans(PayplansStatus::SUBSCRIPTION_ACTIVE);
		
		//For admin, Nothing will be hidden
		if($user->isAdmin()){
			return $match[2];
		}
		
		//For handling case of {payplans}{/payplans}
		if(empty($match[1])){
			if($user_id !== false){
				if(count($user_plans)>0){
					return $match[2];
				}
			}
			return $ret;
		}
		
		//Fetches Action: (HIDE or SHOW) from payplans tag 
		$restrictions = explode("=", $match[1]);
		$action = explode(" ", $restrictions[1]);

		//if action is HIDE then revert contents to show
		if(!empty($action[1]) && $action[1] === $content_hide){
			$temp = $match[2];
			$match[2] = $ret;
			$ret = $temp;
		}

		if(!$user_id){
			return $ret;
		}

		//Fetches plan ids from {payplans} tag
		$plan_ids = isset($action[0]) ? explode(',', $action[0]) : array();
		if(!count($plan_ids)){
			if(count($user_plans)>0){
				return $match[2];
			}
			
			return $ret;
		}
		
		//If user plan is in specified plans then show content
		if(count(array_intersect($user_plans, $plan_ids)) > 0){
			return $match[2];
		}
		
		return $ret;
	}
}