<?php

/**
* @copyright	Copyright (C) 2009 - 2012 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		Payplans
* @subpackage	donation
* @contact		payplans@readybytes.in
*/
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

/**
 * Payplans Donation Plugin
 *
 * @author 
 */
class plgPayplansDonation extends XiPlugin
{
	public function onPayplansSystemStart()
	{
	    $dir = dirname(__FILE__).DS.'donation';
	    PayplansHelperLoader::addAutoLoadFile($dir.DS.'lib.php', 'PayplansDonation');
	    
	    return true;
	
	}

   public function onPayplansGetPlugin()
	    {
	        $xml = dirname(__FILE__).DS.'donation.xml';
	        if (file_exists($xml)) {
	                    $xmlContent = simplexml_load_file($xml);
	                }
	                else {
	                    $xmlContent = null;
	                }
	         return array('name'   => 'donation', 
	                	  'value' =>$xmlContent);
	    }
	
   public function onPayplansViewBeforeRender(XiView $view, $task)
   {
		if(($view instanceof PayplanssiteViewDashboard) && $task == 'frontview')
		{
			// check user login or not
			 if(!XiFactory::getUser()->id){ 
			 	return true;
			 }
			
			return array('payplans-dashboard-right' => $this->_render('widgethtml'));
		}
	}	
		
	public function onPayplansDonateRequestDetails()
	{
		$userId = XiFactory::getUser()->id;
		
		if(!$userId){
	        $userId = $this->getDummyUserId();
		    // store current session to donation module
		    XiFactory::getSession()->set('REGISTRATION_NEW_USER_ID', $userId);
		}
		
		$this->_doDonateAction();
		
   	}

    function onPayplansRewriterReplaceTokens($refObject, $rewriter)
	{	
		if($refObject instanceof PayplansInvoice && $refObject->getObjectType() == 'PayplansDonation'){
			$rewriter->setMapping($refObject, false);
		}
		return ;
	}
	
   	protected function _doDonateAction()
   	{
   		$donate 	   = new stdClass();
		$donate->id    = 'payplans-donation-pay';
		$donate->click = 'payplans.donation.pay(0);';
		$donate->text  = XiText::_('COM_PAYPLANS_DONATION_APP_DONATE');
		$donate->classes = "btn btn-primary";
		
		$close 		   = new stdClass();
		$close->id     = 'payplans-donation-close';
		$close->click  = 'xi.ui.dialog.close();';
		$close->text   = XiText::_('COM_PAYPLANS_DONATION_APP_CLOSE');
		$close->classes = "btn";
		
		$html		 = $this->_render('default_donate');	
        $title 		 = XiText::_('PLG_PAYPLANS_DONATION');
		$domObject   = 'xiWindowBody';
		$domProperty = 'innerHTML';

		$response = XiFactory::getAjaxResponse();
		$response->addAssign( $domObject , $domProperty , $html );
		$response->addScriptCall('payplans.jQuery(\'#pp-donation-request\').show');
		$response->addScriptCall('xi.ui.dialog.title',$title);
		$response->addScriptCall('xi.ui.dialog.button', array($donate, $close));
		$response->sendResponse();	
	}
		
    public function onPayplansWalletUpdate($transaction, $amount)
	{ 
		$invoice 	 = $transaction->getInvoice(PAYPLANS_INSTANCE_REQUIRE);

		if(!$invoice || !$invoice->getId()){
		   return true;
		}
		
		$wallet = $invoice->getReferenceObject(PAYPLANS_INSTANCE_REQUIRE);

		if(!is_a($wallet, 'PayplansDonation')){
			return true;
		}

		$amount = $transaction->getAmount();
		$txn_id = $transaction->getId();
		$userId = $invoice->getBuyer();
		
		 //when refund is made externally then mark invoice as refunded       
//        if( floatval($amount) < floatval(0) ) {
//           if ($transaction instanceof PayplansTransaction){
//              //XITODO : handle partial refund case
//              $invoice->set('status', PayplansStatus::INVOICE_REFUNDED)->save();
//               return true;
//           }   
//        }

		//when there is amount difference then don't mark invoice as donation
		if(floatval($amount) != floatval($invoice->getTotal())){
			return true;
		}
		
		if($invoice->getStatus() != PayplansStatus::INVOICE_PAID){
			$invoice->set('status', PayplansStatus::INVOICE_PAID)->save();
			//PayplansHelperWallet::debit($userId, $txn_id, $amount , $message = 'COM_PAYPLANS_WALLET_AMOUNT_HAS_BEEN_DEBITED');
			
			 $wallet = PayplansWallet::getInstance();
		     $wallet->set('user_id', $userId)
				    ->set('amount', - $amount)  // this should be negative
				    ->set('message', 'COM_PAYPLANS_DONATION_MESSAGE_PAID_FOR_INVOICE')
				    ->set('invoice_id', $invoice->getId())
				    ->save();
				
			$message  =  XiText::_('COM_PAYPLANS_LOG_DONATION');
			$content  = array('user_id'=>$userId, 'invoice_id'=>$invoice->getId(), 'amount'=>$amount, 'detail'=>XiText::_('COM_PAYPLANS_DONATION_OTHER_INVOICES_TO_EQUATE_WALLET_BALANCE'));
			return PayplansHelperLogger::log(XiLogger::LEVEL_INFO, $message, $invoice, $content);
		}
		
		return true;
		
	}
	
	public function onPayplansCreateInvoice($userid ,$amount)
	{
	    $userid = ($userid == null)? XiFactory::getUser()->id : $userid;
		if(!$userid){
			$userid = $this->getDummyUserId();
		}
				
	    $rechargeAmount  = JRequest::getVar('recharge_amount', 0);
		
		$amount = ($amount == null) ? $rechargeAmount : $amount;
		$appId  = JRequest::getVar('payment_method', null);
		
		XiError::assert($appId,XiText::_('COM_PAYPLANS_WALLET_INVALID_APP_ID'));
		XiError::assert($amount,XiText::_('COM_PAYPLANS_WALLET_INVALID_AMOUNT'));
		
		$invoice = $this->createInvoice($userid, $amount);
		
		$invoice->confirm($appId);
		
		// get payment created
        $payment    = $invoice->getPayment();
        $paymentKey = $payment->getKey();
        PayplansFactory::redirect(XiRoute::_("index.php?option=com_payplans&view=payment&task=pay&payment_key=".$paymentKey), true);
		
        return false;

	}
	
	function createInvoice($userid, $amount)
	{
			$invoice = PayplansInvoice::getInstance();
			$invoice->set('object_type', 'PayplansDonation')
					->set('user_id', $userid)
					->set('subtotal', $amount)
					->set('total', $amount);
					
			$params 	= array('expirationtype' => 'fixed',
										 'expiration' => '000000000000', 
										 'recurrence_count' => 0, 
										 'price' => $amount,
										 'trial_price_1' => 0.00, 
										 'trial_time_1' => '000000000000', 
										 'trial_price_2' => 0.00, 
										 'trial_time_2' => '000000000000',
										 'title' => XiText::_('COM_PAYPLANS_DONATION_RECHARGE')
			                              );
				
			foreach($params as $param=>$value){
				$invoice->setParam($param, $value);
			}
			
			$invoice->save();
			
			return $invoice;
		}

    static $userId = null;
    static public function getDummyUserId()
    {   
        if(self::$userId != null){
            return $userId;
        }
       
        // find the dummy user
        $query = new XiQuery();
        self::$userId = $query->select(' `id`')
                     ->from('`#__users`')
                     ->where("`username`='donor_Registered'")
                     ->dbLoadQuery()
                     ->loadResult();

        // register a dummy user
        if(!self::$userId){
            jimport('joomla.user.helper');
            self::$userId = XiHelperPlugin::getPluginInstance('payplansregistration','auto')
                            ->_autoRegister(
                                'donor_Registered',
                                'donor@registered.com',
                                JUserHelper::genRandomPassword()
                            );
        }       
       
        return self::$userId;
    }
	
}

