<?php

/**
* @copyright	Copyright (C) 2009 - 2015 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		Payplans
* @subpackage	EASYBLOG
* @contact		support+payplans@readybytes.in
*/
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

/**
 * Payplans Easyblog Plugin
 *
 */
class plgPayplansEasyblog extends XiPlugin
{

	protected $total_allowed = 0;
	const BLOCKED 			 = 0;
	const ALLOWED 			 = 1;  
	protected $restrict		 = 0;
	const notexist 			 = 0;
	const exist 			 = 1;
	
	public function onPayplansSystemStart()
	{
		//add discount app path to app loader
		$appPath = dirname(__FILE__).DS.'easyblog'.DS.'app';
		PayplansHelperApp::addAppsPath($appPath);
	
		return true;
	}
	

	function onBeforeEasyBlogSave() {
		$pUser = XiFactory::getUser();
		$user  = PayplansUser::getInstance($pUser->id);
		$this->checkAccess($user);
	}
	

	private function checkAccess(PayplansUser $user)
	{
		$option		 = JRequest::getVar('option',      false);
		$category_id = JRequest::getVar('category_id', false);
		$ajax 		 = JRequest::getVar('format', false);
		$app_obj	 = new PayplansAppEasyblogsubmission;
		
		if($option==='com_easyblog' &&  $category_id!==false)
		{
			//if no user is logged in						
			if(!$user->getId()){
				$msg    = XiText::_('COM_PAYPLANS_APP_EASYBLOG_SUBMISSION_NOT_LOGIN');
				$returl = XiRoute::_('index.php?option=com_payplans&view=plan&task=subscribe');
				if($ajax === 'ajax'){
					require_once(JPATH_ADMINISTRATOR . '/components/com_easyblog/includes/easyblog.php');
					$msg = "<a href='$returl' target='_parent'>$msg</a>";
					EB::ajax()->reject(EB::exception($msg))->send();
				} else {
					XiFactory::getApplication()->redirect($returl, $msg);
					return true;	
				}
				return true;
			}
			
			//Is user Admin/SuperAdmin
			if($user->isAdmin()){
				return true;
			}
			
			$user_id	= PayplansFactory::getUser()->id;			
			$msg		= '';
			$allow		= $this->anyAllowed($user_id);
			
			//firstly check wheater user allowed in any or not. 
			//if yes then check further in paricular category
			if($allow == self::ALLOWED){
				$allow = $this->isAllowedInCategory($category_id,$user_id);
				
				if($allow == self::ALLOWED){
					$this->decreaseAll(0, $user_id);	
					$this->decreaseAll($category_id, $user_id);
					return true;
				}
			}
			else{
				$allow = self::BLOCKED;
			}
										
			if($allow == self::BLOCKED){	
				$msg    = XiText::_('COM_PAYPLANS_APP_EASYBLOG_SUBMISSION_NOT_ALLOWED_MORE_POST');
				$returl = XiRoute::_('index.php?option=com_payplans&view=plan&task=subscribe');
				if($ajax === 'ajax'){
					require_once(JPATH_ADMINISTRATOR . '/components/com_easyblog/includes/easyblog.php');
					$msg = "<a href='$returl' target='_parent'>$msg</a>";
					EB::ajax()->reject(EB::exception($msg))->send();	
				}else{
					XiFactory::getApplication()->redirect($returl, $msg);
					return true;
				}
			}
}	
		return true;
	}
	
	//check wheather total allowed in any category should not exausted. 
	function anyAllowed($user_id)
	{
		$resource_model		= PayplansApp::getResourceModel();
		$title		 	    = "com_easyblog.submission";
		$restrictedcategory = $resource_model->loadRecords(array('user_id'=>$user_id, 'title'=>$title, 'value'=>0));				
	
		if(empty($restrictedcategory)){		
				$apps=PayplansHelperApp::getAvailableApps('easyblogsubmission');
				foreach ($apps as $app){
					$addentryin=$app->getAppParam('add_entry_in');
					if ($addentryin == 'any_category'){
						return self::BLOCKED;
					}
				}
				return self::ALLOWED;
		}
			
		$res = array_shift($restrictedcategory);
		$res = $res->count;
		if($res!=0){
			return self::ALLOWED;
		}
		return self::BLOCKED;
	}
	
	//used to decrease the count of specified category
	function decrease($category,$user_id)
	{
		
		$query   = new XiQuery();
	
    	$count   = $query->select('`count`')
 	                	->from('`#__payplans_resource`')
 	               		->where('`value` = '.$category)
    	   	      		->where(' `title` = '."'com_easyblog.submission'")
    	   	      		->where('`user_id` = '.$user_id)
    	   	       		->dbLoadQuery()
    	   	       		->loadResult();
       
      	 $count = ($count!=0)?$count-1:0;
       	 
         $query   = $query->update('`#__payplans_resource`')
         					->set('`count` = '.$count)
    	    	    		->where('`value` = '.$category)
	    	   	      		->where(' `title` = '."'com_easyblog.submission'")
	    	   	      		->where('`user_id` = '.$user_id)
	    	   	      		->dbLoadQuery()
	    	   	      		->query();
        return true;
	}

	//used to decrease the counts of specified category and it's all parent.
	function decreaseAll($category,$user_id)
	{
		$this->decrease($category, $user_id);
		$parent = $this->gotParent($category);
		if($parent==0){
			//$this->decrease($parent, $user_id);
			return true;
		}
		$this->decreaseAll($parent, $user_id);
	}
	
	//collect the resource records 
	function collectResourceRecords($filter)
	{	
		$total_allowed		= 0;
		$resource_model		= PayplansApp::getResourceModel();
		return $resource_model->loadRecords($filter);
	}
	
	//used for fetching parent category for specified category
	function gotParent($category)
	{
		$query   = new XiQuery();
	
    	 return $query->select('`parent_id`')
    					->from('`#__easyblog_category`')
    					->where('`id` = '.$category)
    					->dbLoadQuery()
       					->loadResult();
       
	}
	
	//check whether the user allowed in particular category and it's parent category
	function isAllowedInCategory($category,$user_id)
	{
		$filter				= array('user_id'=>$user_id, 'title'=>"com_easyblog.submission", 'value'=>$category);
		$total_allowed		= $this->collectResourceRecords($filter);
		
		//if no app is applicable then no records in resource table.
		// but the app can be applied on parent may be
		if(empty($total_allowed)){
			 
			$solution = $this->appExistOnCategory($category); 
			if($solution == self::exist){
				return self::BLOCKED;
			}
			$parent = $this->gotParent($category);
			if($parent == 0){
				return self::ALLOWED;
			}
			return $this->isAllowedInCategory($parent, $user_id); 
		}		
		$total_allowed = array_shift($total_allowed);
		
		//if not allowed then it's resource counts are 0.
		if($total_allowed->count == 0){
			return self::BLOCKED;
		}
	
		$parent = $this->gotParent($category);
		
		//if reach to top category then allowed
		if($parent == 0)
		{	
			return self::ALLOWED;
		}
		
		$res=$this->isAllowedInCategory($parent, $user_id);
		return $res;
				
	}
	
	//to check out that an app exist on specified catefied.
	function appExistOnCategory($category)
	{
		$apps = PayplansHelperApp::getAvailableApps('easyblogsubmission'); 
					 
		foreach ($apps as $app){ 
			$addentryin = $app->getAppParam('add_entry_in'); 
			
			if ($addentryin != 'any_category'){ 
				$addentryincategory = $app->getAppParam('add_entry_in_category'); 
				if(!is_array($addentryincategory)){ 
					$addentryincategory = array($addentryincategory); 
				} 
				foreach ($addentryincategory as $appcategory){ 
					if($appcategory == $category){ 
						return self::exist;
					}
				}	 
			} 
		} 
		return self::notexist; 
	}	
}
