<?php
/**
* @copyright	Copyright (C) 2009 - 2009 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		PayPlans
* @subpackage	Easyblog
* @contact 		shyam@readybytes.in
* 
*/
if(defined('_JEXEC')===false) die();

class PayplansAppEasyblog extends PayplansApp
{
	protected $_location	= __FILE__;
	const DO_NOTHING = -1;
	const ALLOWED 	 =  1;
	const BLOCKED    =  0;
	
	public function isApplicable($refObject = null, $eventName='')
	{
		if($eventName === 'onPayplansAccessCheck'){
			return true;
		}
		return parent::isApplicable($refObject, $eventName);
	}
	
	function onPayplansAccessCheck(PayplansUser $user)
	{
		$option  = JRequest::getVar('option', false);
		$view 	 = JRequest::getVar('view', false);
		
		if($option!== 'com_easyblog'){
			return true;
		}

		if($user->isAdmin()){
			return true;
		}
		
		$msg        = '';	
		
		if($view == 'latest'){
			return true;
		}
		
		if($view== 'categories'){
			
			$id	 	 = JRequest::getVar('id',false);
			$format  = JRequest::getVar('format',false);
			$type    = JRequest::getVar('type', false);
			
			//if category is not false then do something
			if($id){
				
				//first check app is applicable on it or not
				//if yes then do something
				if($this->checkAppIsApplicableOrNot($id))
				{

					$this->checkuserlogin($user);		
						
					if($format =='feed' && $type == 'rss'){
					    $allCat    = $this->_getAllCategories($id);
					    $msg = XiText::_('COM_PAYPLANS_APP_EASYBLOG_UPGRADE_PLAN_TO_SUSCRIBE_FEED');
						$appResult = $this->_isAllowed($user,$allCat);
						if(in_array(self::BLOCKED, $appResult)){
							$this->_showMessage($msg, $view);
						}
					}
	
				    $easyblog_category = $this->_getAllowedCategories($user->getId());
				    if(!empty($easyblog_category)){
					    if(array_key_exists($id,$easyblog_category)){
					    	return true;
					    }
				    }
				    $path = XiRoute::_("index.php?option=com_payplans&view=plan&task=subscribe");
				    $msg  = XiText::_('COM_PAYPLANS_APP_EASYBLOG_CATEGORY_RESTRICTION');
				    $msg  = $msg.XiText::_('COM_PAYPLANS_APP_EASYBLOG_WANT_TO_SUBSCRIBE').'<a href='.$path.'>'.XiText::_('COM_PAYPLANS_APP_EASYBLOG_SUBSCRIBE_PLAN').'</a>';
					XiFactory::getApplication()->redirect(XiRoute::_('index.php?option=com_easyblog&view=categories&Itemid=496'), $msg);
					return true;
				}
			}
		}
		
		//when user tries to access a post
		if($view == 'entry'){
			 $blogId  = JRequest::getVar('id', 0);
			 
			 $db      = JFactory::getDBO();
	         $query 	 = 'SELECT `category_id`'
	                . ' FROM #__easyblog_post'
	                . ' WHERE `id` = '.$blogId;
	       	 $db->setQuery( $query );
	         $catId = $db->loadResult();

			if($this->checkAppIsApplicableOrNot($catId)){
			
				$this->checkuserlogin($user);
				$allCat = $this->_getAllCategories($catId);
				$appResult = $this->_isAllowed($user,$allCat);
				if(in_array(self::BLOCKED, $appResult)){
					$this->_showMessage($msg, $view);
				}
			}
		}
		

		
		//when user tries to subscribe to a category
		if($view == 'subscription'){
			//get category id
			$catId   = JRequest::getVar('value1', null);
			if($this->checkAppIsApplicableOrNot($catId)){
				$allCat  = $this->_getAllCategories($catId);	
				
				$this->checkuserlogin($user);

				$appResult = $this->_isAllowed($user,$allCat);
				if(in_array(self::BLOCKED, $appResult)){
					$this->_showMessage($msg, $view);
				}
			}
		}
		
		//when user access dashboard, the dashboard link show only when user is logged in 
		if($view == 'dashboard'){
			$layout	   = JRequest::getVar('layout', false);
				
			//when user is writing a blog
			if($layout == 'write'){
				$catId	   = JRequest::getVar('category_id', false);
				$allCat    = $this->_getAllCategories($catId);
	            
				$msg = XiText::_('COM_PAYPLANS_APP_EASYBLOG_UPGRADE_PLAN_TO_WRITE_BLOG_DESC');
				$appResult = $this->_isAllowed($user,$allCat);
				if(in_array(self::BLOCKED, $appResult)){
					$this->_showMessage($msg, $view);
				}
			}
			
			//if user is writing a blog through quick post
			if($layout == 'save'){
				$content   = JRequest::getVar('value0', false);
				$catId     = ltrim($content[1], "category_id=");
				$allCat    = $this->_getAllCategories($catId);
	            
				$msg = XiText::_('COM_PAYPLANS_APP_EASYBLOG_UPGRADE_PLAN_TO_WRITE_BLOG_DESC');
				$appResult = $this->_isAllowed($user,$allCat);
				if(in_array(self::BLOCKED, $appResult)){
					$this->_showMessage($msg, $view);
				}
			}
			
			else{
				return false;
			}
		}
		
		return true;
	}

	public function checkAppIsApplicableOrNot($catId)
	{
	    $allCat = $this->_getAllCategories($catId);
		$allowedCategoryByApp =  $this->getAppParam('addToCategoryOnActive', array());
		
		if(!is_array($allowedCategoryByApp)){
			$allowedCategoryByApp   = array($allowedCategoryByApp);
		}

		if(array_intersect($allowedCategoryByApp,$allCat)){
			return true;
		}
		
		return false;
	}

	public function checkuserlogin(PayplansUser $user)
	{
		
		//ask user to login first
		if(!$user->getId()){
			$msg = XiText::_('COM_PAYPLANS_APP_EASYBLOG_LOGIN_TO_ACCESS_DESC');
			XiFactory::getApplication()->redirect(XiRoute::_('index.php?option=com_payplans&view=plan&task=subscribe'), $msg);
		}		
		
		return false;
	}
	
	//render Widget
	public function renderWidgetHtml()
	{   
		//get user id
		$userid     = XiFactory::getUser()->id;
		if(!$userid){
			return '';
		}
		//get user's easyblog categories
	    $easyblog_category = $this->_getAllowedCategories($userid);
	    if(empty($easyblog_category)){
	    	return '';
	    }
	    $this->assign('easyblog_category',$easyblog_category);
        $data = $this->_render('widgethtml');
        return $data;
	}	
	
	//get user's easyblog category
	protected function _getAllowedCategories($userid)
	{
		$db         = XiFactory::getDBO();

		$db->setQuery(' SELECT `id`, `title` '
						.' FROM #__easyblog_category '
						.' WHERE `published` = "1" ');

		$categories = $db->loadObjectList('id');
      	$user = PayplansUser::getInstance($userid);
	  	//check which category is allowed to the user
        foreach($categories as $category){

        	$allCat    	  = $this->_getAllCategories($category->id);
	        $allowedOrNot = $this->_isAllowed($user, $allCat);
    	    $count = array_count_values($allowedOrNot);

			// if some one allows then its allowed
			if(in_array(self::ALLOWED, $allowedOrNot)) {
				 continue;
			}

			// if no one allows but some one blocks then its blocked
			if(in_array(self::BLOCKED, $allowedOrNot)) {
	     	   	 unset($categories[$category->id]);
    	    }
    	     
        }

        return $categories;
	}
	
	//traverse to parent = 0
	function _getAllCategories($catId)
	{            
		$allCat   = array();
		while($catId)
		{
			$allCat[] = $catId;
			
			$db 	= JFactory::getDBO();
			$query = 'SELECT `parent_id`'
				 	. ' FROM #__easyblog_category'
				 	. ' WHERE `published` = 1 AND `id` = '.$catId;
				 	;
		 	$db->setQuery( $query );
		 	$catId = $db->loadResult();
		}
		
		return $allCat;	
	}
	
    protected function _isAllowed($user, $category)
    {
    	$easyblogApps = PayplansHelperApp::getAvailableApps('easyblog');
   		$appResult  = array();
   		
        if(!is_array($category)){
            $category = array($category);
        }

	  	//check which app allow category, which not allow and which app do nothing
		foreach($easyblogApps as $app){

			$allowedCategoryByApp =  $app->getAppParam('addToCategoryOnActive', array());
	
			if(!is_array($allowedCategoryByApp)){
				$allowedCategoryByApp   = array($allowedCategoryByApp);
			}
	
		 	//if app is not applicable on that category 
		 	if(count(array_intersect($category, $allowedCategoryByApp)) == 0){
		 		$appResult[]    = self::DO_NOTHING;
		 		continue;
		 	}
	
	   	 	$subs       = $user->getPlans();
	   	 	//if user has no plans
	         if(empty($subs)){
	           	$appResult[]  = self::BLOCKED;
	           	continue;
	          }
	         
			// if user has plans and app is core app 
		 	if(!empty($subs) && $app->getParam('applyAll',false) != false){
		 		$appResult[]  = self::ALLOWED;
	           	continue;
		 	}
	
			//if user has app plans
			$appPlans = $app->getPlans();
			if(array_intersect($subs, $appPlans) != false){
				 $appResult[]  = self::ALLOWED;
	          	 continue;
			}
			else {
			   $appResult[]  = self::BLOCKED;
			}
     	}
     	
    	return $appResult;
    }
				
	protected function _showMessage($msg, $view)
	{
		if($view =='subscription')
			{   $layout  = JRequest::getVar('layout',false);
				$format  = JRequest::getVar('format',false);
				$content = JRequest::getVar('value0', false);
	            if($layout=='showForm' && $format=='ejax'&& $content=='category'){
					require_once( JPATH_ROOT . DS . 'components' . DS . 'com_easyblog' . DS . 'constants.php' );
					require_once( EBLOG_CLASSES . DS . 'ejax.php' );
					$ajax = new Ejax();
					$ajax->alert( JText::_('COM_PAYPLANS_APP_EASYBLOG_UPGRADE_PLAN_DESC') , JText::_('COM_PAYPLANS_APP_EASYBLOG_UPGRADE_PLAN') , '450' );
					return $ajax->send();
	            }
			}
			if(!$msg){
					$msg = XiText::_('COM_PAYPLANS_APP_EASYBLOG_UPGRADE_PLAN_DESC');
				}
				
			$returl = XiRoute::_('index.php?option=com_payplans&view=plan&task=subscribe');
			XiFactory::getApplication()->redirect($returl, $msg);
			return true;
	}
}