<?php
/**
* @copyright	Copyright (C) 2009 - 2015 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		PayPlans
* @subpackage	Easyblog
* @contact 		support+payplans@readybytes.in
* 
*/
if(defined('_JEXEC')===false) die();

class PayplansAppEasyblogsubmission extends PayplansApp
{
	protected $_location		= __FILE__;
	protected $allowed_to_post	= 0;
	protected $_resource		= 'com_easyblog.submission';
	
	function onPayplansSubscriptionAfterSave($prev,$new)
	{
		if($prev == null){
			return true;
		}		
		$newStatus  = $new->getStatus();
		$prevStatus = $prev->getStatus();
		if($prevStatus == $newStatus){
			return true;
		}
				
		$entryToAddIn 		= $this->getAppParam('add_entry_in', 'any_category');
		$restrictedcategory = $this->getAppParam('add_entry_in_category', 0);
		if(is_array($restrictedcategory)==false){
			$restrictedcategory=array($restrictedcategory);
		}
		$no_of_submisssion 	= $this->getAppParam('no_of_submisssion',  0);		
		$subid  			= $new->getId();
		$userid 			= $new->getBuyer();
		
		$buyer_name			= $new->getBuyerName();
		$plan_title			= $new->getTitle();
		
		if($newStatus == PayplansStatus::SUBSCRIPTION_ACTIVE){
			if($entryToAddIn != 'on_specific_category'){
				$this->_addToResource($subid, $userid,0, $this->_resource, $no_of_submisssion);
				return true;	
			}
				
			foreach ($restrictedcategory as $category){
					$this->_addToResource($subid, $userid, $category, $this->_resource, $no_of_submisssion);						
			}	
			
			return true;
		}
		
		if( $prevStatus == PayplansStatus::SUBSCRIPTION_ACTIVE  && $newStatus != PayplansStatus::SUBSCRIPTION_ACTIVE ){ 
			if($entryToAddIn != 'on_specific_category'){
					$this->_removeFromResource($subid, $userid, 0, $this->_resource, $no_of_submisssion);
			}
			else{		
				foreach ($restrictedcategory as $category){
						$this->_removeFromResource($subid, $userid, $category, $this->_resource, $no_of_submisssion);
		        }
			}				 	
		}
		
		return true;
	}
	
	//render Widget
	public function renderWidgetHtml()
	{   
		//get user id
		$userid     	 = XiFactory::getUser()->id;
		if(!$userid){
			return true;
		}

		$resourceRecords = $this->getallowedsubmission($userid);
	    if(empty($resourceRecords)){
	    	return true;
	    }

	    $categories		 = array();
	    foreach($resourceRecords as $resourceRecord){
	    	$cat_data 	 = $resourceRecord->value;
	    	if($cat_data==0){
	    		continue;
	    	}
	    	else{
	    		$categories[] = $cat_data;
	    	}
	    }
	    
	    $categoryRecords = $this->getcategory($categories);	
		
		$cat_id			= '';
		$total			= 0;
		$any_cat_count	= 0;
		$render_data	= array(array());
		$index			= 0;

		// first calculate the sum of all consumed post in total variable 
        // then subtract from consumed of additional category.
		foreach($resourceRecords as $resourceRecord){
			if($resourceRecord->value == 0){
				$any_cat_count	= $resourceRecord->count;
			}
			else{
				$cat_id								 = $resourceRecord->value;
	 			$blogRecords						 = $this->getAllSubmissions($userid,$cat_id);
	 			$render_data[$index]['title']	 	 = $categoryRecords[$cat_id]->title;
	 		 	$allowed						 	 = $resourceRecord->count; 
	 		 	$render_data[$index]['allowed']		 = $allowed;
				$render_data[$index]['consumed'] 	 = $blogRecords;
				$index++;
			}
		}
		
		
		$render_data[$index]['title']	 = XiText::_("COM_PAYPLANS_APP_EASYBLOG_SUBMISSION_ADDITIONAL_CAT");
		$render_data[$index]['allowed']	 = $any_cat_count;
		$value							 = $this->getAllSubmissions($userid,$cat_id,true); 
		$render_data[$index]['consumed'] = ($value);
	  
	    $this->assign('render_data', $render_data);		    
        $data = $this->_render('widgethtml');
        return $data;
	}
	
	//get category recoeds for categories in app
	function getcategory($catergories)
	{            
		if(empty($catergories)){
			return array();
		}
				
		$query 		     = new XiQuery();
		$cat_in			 = implode(",", $catergories);
		return $query->select('*')
						     ->from('`#__easyblog_category`')
						     ->where('`id` IN('.$cat_in.')')
						     ->dbLoadQuery()
						     ->loadObjectList('id');
	}

	//get all allowed submission of paricular user.
	function getallowedsubmission($user_id)
	{	
		$total_allowed		= 0;
		$resource_model		= PayplansApp::getResourceModel();
		$filter				= array('user_id'=>$user_id, 'title'=>'com_easyblog.submission');
		$resourceRecords	= $resource_model->loadRecords($filter);
		
		return $resourceRecords;
	}
	
	// To get # of posts by particular user	in all or in particular category
	function getAllSubmissions($userid,$cat_id,$need_all=false)
	{            
	   $query 		 = new XiQuery();
	   $query->select('count(*)')
		     ->from('`#__easyblog_post`')
		     ->where('`created_by`='.$userid)
		     ->where('`published`=1');

		if($need_all==false){
			 $query->where('`category_id`='.$cat_id);
		}
		
		return $query->dbLoadQuery()->loadResult();
		
	}
}

class PayplansAppEasyblogsubmissionFormatter extends PayplansAppFormatter
{
	//get Rules 
	function getVarFormatter()
	{
		$rules = array();		
		return $rules;
	}
}
