<?php

/**
* @copyright	Copyright (C) 2009 - 2012 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		Payplans
* @subpackage	easydiscuss
* @contact		payplans@readybytes.in
*/
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

/**
 * Payplans Easydiscuss Plugin
 *
 */
class PayplansAppEdcategory extends PayplansApp
{
	public $_location       = __FILE__;
	protected $_resource	= 'com_easydiscuss.acl';
	
    public function _isApplicable(PayplansIfaceApptriggerable $refObject, $eventname='')
	{
		return JFolder::exists(JPATH_SITE .DS.'components'.DS.'com_easydiscuss');
	}

	public function onPayplansSubscriptionAfterSave($prev, $new)
	{
		// no need to trigger if previous and current state is same
		if(($new->getStatus() == PayplansStatus::NONE) || ($prev != null && $prev->getStatus() == $new->getStatus())){
			return true;
	    }

		$newStatus  = $new->getStatus();
		
		$userid 			= $new->getBuyer();
		$subid  			= $new->getId();
		$buyer_name         = $new->getBuyerName();
		$plan               = $new->getTitle();
		$allowedCategories 	= $this->getAppParam('allowedcategories');
		$aclrules			= $this->getAppParam('aclrules', array());
	    $aclrules 		    = is_array($aclrules) ? $aclrules : array($aclrules);
		$allowedCategories 	= is_array($allowedCategories) ? $allowedCategories 
	    											: array($allowedCategories);
		
	    if($newStatus == PayplansStatus::SUBSCRIPTION_ACTIVE){
	    	if (!empty($aclrules)){
		    	$aclrule = $this->addIntoAcl($userid,$allowedCategories,$aclrules);
		     	foreach ($aclrule as $acl) {
		      		$this->_addToResource($subid, $userid, $acl, $this->_resource);		
		     	}
	    	}
	    }
	    else {
  
	    	$aclvalues = $this->_getAclValues($userid, $subid);
	    	$this->_deleteFromAcl($userid, $aclvalues);
	    	foreach ($aclvalues as $aclvalue){
	    		$this->_removeFromResource($subid, $userid, $aclvalue, $this->_resource); 	
	        } 
	    } 
		return true;
      }

    public function addIntoAcl($userid, $allowedCategories, $aclrules)
    {
    	$acl_ids = array();
		foreach ($aclrules as $aclrule){
			foreach ($allowedCategories as $category_id) {	
				$db    = PayplansFactory::getDBO();
				$query = 'insert into `#__discuss_category_acl_map` (`category_id`,`acl_id`,`type`,`content_id`,`status`) VALUES ('
						. $category_id.','.$aclrule.',"user",'.$userid.',1)';
			
				$db->setQuery($query);
				$db->query();
				$acl_ids[] = $db->insertid();
			}
		}
		return $acl_ids;
	}	
	
	protected function _getAclValues($userid, $subid)
	{
		$db    = PayplansFactory::getDbo();
		$query = 'SELECT `value`'
			 	. ' FROM #__payplans_resource'
			 	. ' WHERE `user_id`        = ' . $userid
			    . ' AND `subscription_ids` ='."'".','.$subid.','."'";
 
	    $db->setQuery( $query );
        return $db->loadColumn();         
	}
	
	protected function _deleteFromAcl($userid, $aclvalues)
	{
		$aclvalues = implode(',', $aclvalues);
		
		$db    = PayplansFactory::getDbo();
		$query = 'DELETE FROM #__discuss_category_acl_map'
			. ' WHERE `id` IN ('. $aclvalues .')' ;
		
		$db->setQuery( $query );
		return $db->query();
	}

	public function renderWidgetHtml()
	{	
	    $userid     = XiFactory::getUser()->id;
		if(!$userid){
			return '';
		}
		//get user's easydiscuss categories
	    $easydiscuss_category = $this->_getAllowedCategories($userid);
	    if(empty($easydiscuss_category)){
	    	return '';
	    }
	    $this->assign('easydiscuss_category',$easydiscuss_category);
        $data = $this->_render('widgethtml');
        return $data;	
	}	
	
	protected function _getAllowedCategories($userid)
	{
		 
	     $db    = PayplansFactory::getDbo();
		 $query = 'SELECT a.id, a.title '
			 	. ' FROM #__discuss_category AS a '
			 	. 'LEFT JOIN #__discuss_category_acl_map AS b '
			 	. 'ON a.id = b.category_id'
			 	. ' WHERE b.content_id = '. $userid ;
			 	 	
	     $db->setQuery( $query );
         return $db->loadObjectList();         	
	}
	

}	
class PayplansAppEdcategoryFormatter extends PayplansAppFormatter
{
	// get rules
	function getVarFormatter()
	{
		$rules = array('_appplans'    => array('formatter'=> 'PayplansAppFormatter',
										       'function' => 'getAppPlans'),
						'app_params'  => array('formatter'=> 'PayplansAppEdcategoryFormatter',
										       'function' => 'getEasydiscussCategory'));
		return $rules;
	}
	
	public function getEasydiscussCategory($key,$value,$data)
	{
		$value['allowedcategories'] 	= $this->getCategoryName($value['allowedcategories']);
		$value['xieasydiscussacl']   	= $this->getAclName($value['xieasydiscussacl']);
		
	}
	
	public function getCategoryName($values)
	{
		$allowedCategories = implode(',', $values);
		
		$db    = PayplansFactory::getDbo();
		$query = 'SELECT `title`'
			 	 .'FROM #__discuss_category'
			 	. ' WHERE `id` IN('.$allowedCategories.')';
			 	
	    $db->setQuery( $query );
       	$cateogries	=  $db->loadColumn();

		return implode(',', $cateogries); 
	}
	
	public function getAclName($values)
	{
		$acls = implode(',', $values);
		
		$db    = PayplansFactory::getDbo();
		$query = 'SELECT `alias`'
			 	 .'FROM #__discuss_category_acl_item'
			 	.' WHERE `id` IN('.$acls.')';
			 	
	    $db->setQuery( $query );
       	$aclvalues	=  $db->loadColumn();
       	
		return implode(',', $aclvalues); 
	}
}	

