<?php

/**
* @copyright	Copyright (C) 2009 - 2015 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		Payplans
* @subpackage	EasySocial
* @contact		support+payplans@readybytes.in
*/
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

/**
 * Payplans Easysocial Profiletype App
 *
 */
class PayplansAppEasysocialProfiletype extends PayplansApp
{
	public $_location       = __FILE__;
	protected $_resource	= 'com_easysocial.profile';
	
	public function onPayplansSubscriptionAfterSave($prev, $new)
	{
		// no need to trigger if previous and current state is same
		if($prev != null && $prev->getStatus() == $new->getStatus()){
			return true;
		}

		$newstatus  = $new->getStatus();
		$userid		= $new->getBuyer();
				
		//if subscription is active
		if($newstatus == PayplansStatus::SUBSCRIPTION_ACTIVE){
			$easysocialprofileId = $this->getAppParam('esprofiletypeOnactive', 0);
			return plgPayplansEasysocialProfiletype::_setEasysocialprofile($userid, $easysocialprofileId);
		}
		
		//if subscription is hold
		if($newstatus == PayplansStatus::SUBSCRIPTION_HOLD){
			$easysocialprofileId = $this->getAppParam('esprofiletypeOnHold', 0);
			return plgPayplansEasysocialProfiletype::_setEasysocialprofile($userid, $easysocialprofileId);
		}
		
		// if subscription is expire
		if($newstatus == PayplansStatus::SUBSCRIPTION_EXPIRED){
			$easysocialprofileId = $this->getAppParam('esprofiletypeOnExpire', 0);
			return plgPayplansEasysocialProfiletype::_setEasysocialprofile($userid, $easysocialprofileId);
		}

		return true;
	}


}	


class PayplansAppEasysocialProfiletypeFormatter extends PayplansAppFormatter
{
	// get rules
	function getVarFormatter()
	{
		$rules = array('_appplans'    => array('formatter'=> 'PayplansAppFormatter',
										       'function' => 'getAppPlans'),
						'app_params'  => array('formatter'=> 'PayplansAppEasysocialProfiletypeFormatter',
										       'function' => 'getEsProfiletypes'));
		return $rules;
	}
	
	// replace EasySocial profiletype ids with name
	function getEsProfiletypes($key,$value,$data)
	{
		$file = JPATH_ROOT.DS.'components'.DS.'com_xipt'.DS.'api.xipt.php';
		// do nothing if jspt is not installed
		if(!JFile::exists($file)){
			return false;
		}
		$value['esprofiletypeOnactive'] 	= $this->getProfileNames($value['esprofiletypeOnactive']);
		$value['esprofiletypeOnHold']   	= $this->getProfileNames($value['esprofiletypeOnHold']);
		$value['esprofiletypeOnExpire'] 	= $this->getProfileNames($value['esprofiletypeOnExpire']);
		
	}
	
	function getProfileNames($values)
	{
		$profiletypes 	= $this->getEasysocialProfiltypes();
		foreach ($values as $value){
			$profiletype[]  = $profiletypes[$value]->name;
		}
		
		return implode(',', $profiletype);
	}
	
	public function getEasysocialProfiltypes()
	{
		$db 	= PayplansFactory::getDBO();

		$query = 'SELECT *'
			 	. ' FROM #__social_profiles'
			 	. ' WHERE `state` = 1';

	 	$db->setQuery( $query );
	 	return $db->loadObjectList('id');
	} 
}