<?php
/**
* @copyright	Copyright (C) 2009 - 2015 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		PayPlans
* @subpackage	EasySocial Registration 
* @contact 		support+payplans@readybytes.in
*/

if(defined('_JEXEC')===false) die();
jimport( 'joomla.plugin.plugin' );

class plgPayplansregistrationEasysocialRegistration extends XiPluginRegistration
{
	public function _isApplicable(Array $conditions= array())
	{
		return JFolder::exists(JPATH_SITE .DS.'components'.DS.'com_easysocial');
	}
	
	protected $_registrationUrl = '';

	function __construct(& $subject, $config = array())
	{
		parent::__construct($subject, $config);
		$this->_registrationUrl = 'index.php?option=com_easysocial&view=registration';
	}
	
	function _isRegistrationUrl()
	{               
		$vars = $this->_getVars(array('option', 'view', 'layout', 'controller','plan_id', 'task'));

		if($vars['option'] == 'com_easysocial' && $vars['view'] == 'registration' && $vars['layout'] === 'BLANK' && $vars['controller'] === 'BLANK'){
			return true;
		}

		 // While using Auto login then set session variable
		if($vars['option'] == 'com_easysocial' && $vars['view'] == 'dashboard' && $vars['controller'] == 'registration' && $vars['task'] == 'saveStep')
		{
				require_once JPATH_ROOT . '/administrator/components/com_easysocial/includes/foundry.php';
			 	$session = JFactory::getSession();

				// Get necessary info about the current registration process.
				$registration = FD::table( 'Registration' );
				$state = $registration->load($session->getId());
				
		        // Load the profile object.
				$profile = FD::table('Profile');
				$profile->load($registration->get('profile_id'));

				// Get the sequence
				$sequence = $profile->getSequenceFromIndex($registration->get('step'), SOCIAL_PROFILES_VIEW_REGISTRATION);

				// Load the current step.
				$step 		= FD::table( 'FieldStep' );
				$step->loadBySequence( $profile->id , SOCIAL_TYPE_PROFILES , $sequence );
			
				$completed = $step->isFinalStep( SOCIAL_PROFILES_VIEW_REGISTRATION );
		        if($completed){
					if($profile->getRegistrationType() == 'auto'){	
						$this->_session->set('PP_EASYSOCIAL_LOGIN', 1);
					}
		        }
		 	}
		return false;	 
	}
	
	function _isRegistrationCompleteUrl()
	{	
		return true;
	}
	
	protected function _doStartRegistration()
  	{
			$compInfo =    XiAbstractHelperJoomla::getExtension('com_easysocial');
				  
			if(empty($compInfo) || array_shift($compInfo)->enabled == 0){
      			XiFactory::getApplication()->enqueueMessage(sprintf(XiText::_("COM_PAYPLANS_COMPONENT_NOT_FOUND_OR_DISABLED"), 'EasySocial'));
				return parent::_doStartRegistration();
	 	 	}
	 	 
	 	 	require_once JPATH_ROOT . '/administrator/components/com_easysocial/includes/foundry.php';
                  
        	$planId = $this->_getPlan();
            $this->_setPlan($planId);
            $this->_session->set('fromPayplans', 1);
            $this->_app->redirect(FRoute::registration( array( 'layout' => 'steps' , 'step' => 1) , false ));
            return true;
     }
	
	public function onPayplansGetPlugin()
	    {
	        $xml = dirname(__FILE__).DS.'easysocialregistration.xml';
	        if (file_exists($xml)) {
	                    $xmlContent = simplexml_load_file($xml);
	                }
	                else {
	                    $xmlContent = null;
	                }
	         return array('name'   => 'easysocialregistration', 
	                	  'value' =>$xmlContent);
	    }
	
	function onPayplansAccessCheck()
	{
		if(XiFactory::getUser()->id && $this->_session->get('PP_EASYSOCIAL_LOGIN') != 1 ){
			return true;
		}
		
		$vars = $this->_getVars(array('option', 'view', 'layout', 'controller', 'step'));
		$fromPayplans = $this->_session->get('fromPayplans', 0);
		if ($fromPayplans)
		{
			$this->_session->clear('fromPayplans');
		}

		// Set session variable if registration url comes from PayPlans (Issue with Community login page registration url is different)
		if($vars['option'] == 'com_easysocial' && $vars['view'] == 'registration' && $fromPayplans ){
			$this->_session->set('PP_EASYSOCIAL_REGISTRATION', 1);
		}
		
		// Redirect user to Plan selection page when user is redirected to Profile selection page during registration process (when easysocialprofiletype app is enabled)
		if($vars['option'] == 'com_easysocial' && $vars['view'] == 'registration' && $fromPayplans && $vars['layout'] === 'BLANK' && $vars['step'] === 'BLANK'){
			$easysocialProfileApp  = PayplansHelperApp::getAvailableApps('easysocialprofiletype');
			if(!empty($easysocialProfileApp)){
				$this->_app->redirect(XiRoute::_("index.php?option=com_payplans&view=plan&task=subscribe", false));
			}
		}
		

		if( $vars['option'] == 'com_easysocial' && $vars['view'] == 'registration' && $vars['layout'] === 'steps' && $vars['step'] == 1 && $this->_session->get('PP_EASYSOCIAL_REGISTRATION') == 1){
			$this->_session->clear('PP_EASYSOCIAL_REGISTRATION', 1);
		}

		if( $vars['option'] == 'com_easysocial' && $vars['view'] == 'registration' && $vars['layout'] === 'steps' && $vars['step'] == 1 && (!$fromPayplans && $this->_session->get('PP_EASYSOCIAL_REGISTRATION') != 1)){
			$this->_app->redirect(XiRoute::_("index.php?option=com_payplans&view=plan&task=subscribe", false));
		}

		if( $vars['option'] == 'com_easysocial' && $vars['view'] == 'registration' && !$fromPayplans && ($vars['layout'] === 'BLANK' && $vars['controller'] === 'BLANK')){	
			$this->_app->redirect(XiRoute::_("index.php?option=com_payplans&view=plan&task=subscribe", false));
		}

		// Redirect to Invoice confirm page in case of auto-login
		if($vars['option'] == 'com_easysocial' && $vars['view'] == 'dashboard' && $this->_session->get('PP_EASYSOCIAL_LOGIN') == 1){
				$this->_session->clear('PP_EASYSOCIAL_LOGIN');
				$this->_redirectToOrderConfirmPage();
		}
		
		// Set profile_id according to plan during user registration according to plan
		if($vars['option'] == 'com_easysocial' && $vars['view'] == 'registration' && $fromPayplans && $this->_session->get('PP_EASYSOCIAL_PROFLIE') == 1)
		{
			$this->_session->clear('PP_EASYSOCIAL_PROFLIE');

			require_once JPATH_ROOT . '/administrator/components/com_easysocial/includes/foundry.php';

			
			$session	= JFactory::getSession();
			$profile_id = $this->_session->get( 'profile_id' , '' , SOCIAL_SESSION_NAMESPACE);
			$session->set( 'profile_id' , $profile_id , SOCIAL_SESSION_NAMESPACE );
	
			// @task: Try to load more information about the current registration procedure.
			$registration				= Foundry::table( 'Registration' );
			$registration->set( 'session_id', 	$session->getId() );
			$registration->profile_id	= $profile_id;
	
			// When user accesses this page, the following will be the first page
			$registration->set( 'step' , 1 );

			// Add the first step into the accessible list.
			$registration->addStepAccess( 1 );
			$registration->store();
			$this->_session->set('fromPayplans', 1);
			return $this->_app->redirect(FRoute::registration( array( 'layout' => 'steps' , 'step' => 1) , false ));

		}
		
		return true;
	}
	
	protected function _redirectToOrderConfirmPage()
	{
		$userId  = $this->_getUser();
		if(empty($userId)){
		    $userId = XiFactory::getUser()->id; 
		}
		
		$order 		= PayplansPlan::getInstance( $this->_getPlan())
								->subscribe($userId);
		$invoice 	= $order->createInvoice();
		$invoiceKey = $invoice->getKey();	
			
		// now redirect to confirm action
		$this->_app->redirect(XiRoute::_("index.php?option=com_payplans&view=invoice&task=confirm&invoice_key=".$invoiceKey));
	}

}

