<?php
/**
* @copyright	Copyright (C) 2009 - 2015 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		PayPlans
* @subpackage	EBS
* @contact 		support+payplans@readybytes.in
*/
if(defined('_JEXEC')===false) die();

class PayplansAppEbs extends PayplansAppPayment
{
	protected $_location	= __FILE__;
	
    function onPayplansPaymentForm(PayplansPayment $payment, $data = null)
	{		
		
		$root = JURI::root();
    	if(XiFactory::getConfig()->https == true){
    		$root = JString::str_ireplace("http:", "https:", $root);
    	}
    	$invoice      = $payment->getInvoice(PAYPLANS_INSTANCE_REQUIRE);
		
    	$secret_key   = $this->getAppParam('secret_key');
    	$account_id   = $this->getAppParam('account_id');
    	$amount       = $invoice->getTotal();
    	$reference_no = $invoice->getKey();
    	$mode         = $this->getAppParam('mode');
    	$return_url   = $root.'index.php?option=com_payplans&view=payment&task=complete&payment_key='.$payment->getKey().'&DR={DR}';
    	$hash         = $secret_key."|".$account_id."|".$amount."|".$reference_no."|".$return_url."|".$mode;
		$secure_hash  = md5($hash);
		
		$this->assign('secret_key' ,$secret_key);
		$this->assign('account_id', $account_id);
		$this->assign('reference_no', $reference_no);
		$this->assign('mode', $mode);
		$this->assign('post_url', 'https://secure.ebs.in/pg/ma/sale/pay/');
		$this->assign('return_url',$return_url);
		$this->assign('payment', $payment);
		$this->assign('invoice', $invoice);
		$this->assign('amount', $amount);
		$this->assign('secure_hash', $secure_hash);
	  	return $this->_render('form');
	}
	
	function onPayplansPaymentAfter(PayplansPayment $payment, &$action, &$data, $controller)
	{		
		if($action == 'cancel'){
			return true;
		 }
	     // require once file for encryption and decryption of response
		 require_once 'Rc43.php';	
		 $secret_key = $this->getAppParam('secret_key');
		 $response = array();
		 
		 if(isset($data['DR'])) {
		
			 $DR 			= preg_replace("/\s/","+",$data['DR']);
		
			 $rc4 			= new XiCrypt_RC4($secret_key);
		 	 $QueryString 	= base64_decode($DR);
			 $rc4->decrypt($QueryString);
			 $QueryString 	= explode('&',$QueryString);
		
			 foreach($QueryString as $param){
			 	$param 					= explode('=',$param);
				$response[$param[0]] 	= urldecode($param[1]);
			 }
		 }
		$errors   = array();
		$this->_processResponse($payment, $response);

		$payment->save();
		
		return parent::onPayplansPaymentAfter($payment, $action, $data, $controller);
	}
	
	protected function _processResponse(PayplansPayment $payment, $response)
	{
		$invoice = $payment->getInvoice(PAYPLANS_INSTANCE_REQUIRE);
		
		//For Checking Existing Transactions
		$txn_id			= isset($response['transaction_id']) ? $response['transaction_id'] : 0;
		$transactions 	= $this->_getExistingTransaction($invoice->getId(), $txn_id, 0, 0);
	 	if(!empty($transactions)){
			return true;
	 	}
		
		//avoid dupication of transaction 
		if($response['MerchantRefNo']!= $invoice->getKey() || $response['Amount']!= $invoice->getTotal())
		{
			$message = XiText::_('COM_PAYPLANS_LOGGER_ERROR_IN_EBS_PAYMENT_PROCESS_RESPONSE');
			PayplansHelperLogger::log(XiLogger::LEVEL_ERROR, $message, $payment, $response, 'PayplansPaymentFormatter', '', true);
			return;
		}
		// get the transaction instace of lib
		$transaction = PayplansTransaction::getInstance();
		$transaction->set('user_id', $payment->getBuyer())
					->set('invoice_id', $invoice->getId())
					->set('payment_id', $payment->getId())
					->set('gateway_txn_id', isset($response['transaction_id']) ? $response['transaction_id'] : 0)
					->set('gateway_subscr_id', 0)
					->set('gateway_parent_txn', 0)
					->set('params', PayplansHelperParam::arrayToIni($response));

		
		// if response code is 0 then transaction is successful
	    if(!$response['ResponseCode']){
	    	$transaction->set('amount', $response['Amount'])
	    		->set('message', 'COM_PAYPLANS_APP_EBS_TRANSACTION_COMPLETED')
	    		->save();
		}		
		else
		{
			$transaction->set('amount',0)
						->set('message', 'COM_PAYPLANS_APP_EBS_TRANSACTION_NOT_COMPLETED')
	    				->save();
			
			$message = XiText::_('COM_PAYPLANS_LOGGER_ERROR_IN_EBS_PAYMENT_PROCESS');
			PayplansHelperLogger::log(XiLogger::LEVEL_ERROR, $message, $payment, $response, 'PayplansPaymentFormatter', '', true);
			$getApp = XiFactory::getApplication();
			$getApp->enqueueMessage(XiText::_($response['ResponseMessage'].' ('.$response['ResponseCode'].')'),'error');
		  	$getApp->redirect(XiRoute::_('index.php?option=com_payplans&view=payment&task=pay&payment_key='.$payment->getKey()));
		}
		
		
	}
}


