<?php
/**
* @copyright	Copyright (C) 2009 - 2009 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		PayPlans
* @subpackage	EventList
* @contact 		shyam@readybytes.in
* 
*/
if(defined('_JEXEC')===false) die();

class PayplansAppEventlist extends PayplansApp
{
	protected $_location	= __FILE__;
	protected $_resource	= 'com_eventlist.group';
	
	public function _isApplicable(PayplansIfaceApptriggerable $refObject, $eventname='')
	{
		return JFolder::exists(JPATH_SITE .DS.'components'.DS.'com_eventlist');
	}

	public function onPayplansSubscriptionAfterSave($prev, $new)
	{
		// no need to trigger if previous and current state is same
		if($prev != null && $prev->getStatus() == $new->getStatus()){
			return true;
		}
		
		$newStatus  = $new->getStatus();
		
		$active = $this->getAppParam('addToGroupOnActive');
		$active	= (is_array($active)) ? $active : array($active);
		
		$hold 	= $this->getAppParam('addToGroupOnHold');
		$hold	= (is_array($hold)) ? $hold : array($hold);
		
		$expire = $this->getAppParam('addToGroupOnExpire');
		$expire	= (is_array($expire)) ? $expire : array($expire);
			
		$subid  = $new->getId();
		$userid = $new->getBuyer();
		
		// if subscription is active
		if($newStatus == PayplansStatus::SUBSCRIPTION_ACTIVE){
			$this->_removeFromGroup($userid, $hold, $subid);
			$this->_removeFromGroup($userid, $expire, $subid);
			$this->_addToGroup($userid, $active, $subid);
			
			return true;
		}
		
		//if subscription is hold
		if($newStatus == PayplansStatus::SUBSCRIPTION_HOLD){
			$this->_removeFromGroup($userid, $active, $subid);
			$this->_removeFromGroup($userid, $expire, $subid);
			$this->_addToGroup($userid, $hold, $subid);
			
			return true;
		}
		// if subscription is active
		if($newStatus == PayplansStatus::SUBSCRIPTION_EXPIRED){
			$this->_removeFromGroup($userid, $active, $subid);
			$this->_removeFromGroup($userid, $hold, $subid);
			$this->_addToGroup($userid, $expire, $subid);
			
			return true;
		}
		
		return true;
	}
	
	protected function _addToGroup( $userid, $groupids, $subid )
	{
		if(!is_array($groupids)){
			return false;
		}		

		foreach($groupids as $groupid){
			if(empty($groupid)){
				continue;
			}
			
			$users = $this->_getGroupMembers($groupid);
			
			if(in_array($userid, $users)){
				$this->_addToResource($subid, $userid, $groupid, $this->_resource);
				continue;
			}
			
			
			if($this->_setGroupMember($groupid, $userid)){
				$this->_addToResource($subid, $userid, $groupid, $this->_resource);
			}
		}
		
		return true;
	}
	
	protected function _removeFromGroup( $userid, $groupids, $subid )
	{
		if(!is_array($groupids)){
			return false;
		}
		
		foreach($groupids as $groupid){
			if(empty($groupid)){
				continue;
			}
			
			$users = $this->_getGroupMembers($groupid);
			
			if(!in_array($userid,$users)){
				continue;
			}
					
			$this->_removeFromResource($subid, $userid, $groupid, $this->_resource); 
			$this->_removeGroupMember($groupid, $userid);
		}
		
		return true;
	}
	
	protected function _getGroupMembers($groupid)
	{
		$db = JFactory::getDBO();

		$query = 'SELECT `member`'
			. ' FROM #__eventlist_groupmembers'
			. ' WHERE `group_id` = \'' . $groupid . '\''
			;
		$db->setQuery( $query );
		$users = $db->loadColumn();
		
		return $users;
	}
	
	protected function _setGroupMember($groupid, $userid)
	{
		$db = JFactory::getDBO();
		
		$query = 'INSERT INTO `#__eventlist_groupmembers`'
			. ' (`group_id`, `member`)'
			. ' VALUES ( "' . $groupid. '", "'. $userid.'")';

		$db->setQuery( $query );
		return $db->query();
	}
	
	protected function _removeGroupMember($groupid, $userid)
	{
		$db = JFactory::getDBO();

		$user = XiFactory::getUser($userid);
		
		$query = 'DELETE FROM `#__eventlist_groupmembers` '
				.' WHERE `member` = "' . $userid.'" '
				.' AND `group_id` = "' . $groupid.'"';
		
		$db->setQuery( $query );
		return $db->query();
	}
	
	//render Widget
	public function renderWidgetHtml()
	{   
		//get user id
		$userid     = XiFactory::getUser()->id;
		if(!$userid){
			return '';
		}
		//get user's eventlist groups
	    $eventlist_groups = $this->_getUserEventlistGroup($userid);
	    if(empty($eventlist_groups)){
	    	return '';
	    }
	    $this->assign('eventlist_groups',$eventlist_groups);
        $data = $this->_render('widgethtml');
        return $data;
	}	
	
	//get eventlist user group
	protected function _getUserEventlistGroup($userid)
	{
		$db         = JFactory::getDBO();
		$jugaGroups = array();
		$query      = 'SELECT `name`'
			          . ' FROM #__eventlist_groupmembers, #__eventlist_groups'
			          . ' WHERE `member` = \'' . $userid . '\' AND `group_id` = `id`';
		$db->setQuery( $query );	
        $jugaGroups  = $db->loadColumn();
        return $jugaGroups;
	}
	
	function getNameFromResourceValue($resource, $value)
	{
		// if its a different resource
		if($resource != $this->_resource){
			return false;
		}
		$db         = XiFactory::getDBO();		
		$query      = 'SELECT `name`'
			          . ' FROM #__eventlist_groups'
			          . ' WHERE `id` = "'. $value.'"';
		$db->setQuery( $query );
		return $db->loadResult();	
	
	}
}
