<?php
/**
* @copyright	Copyright (C) 2009 - 2016 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		Payplans
* @subpackage	E-way Payment App
* @contact		support+payplans@readybytes.in
*/
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

define('EWAY_PAYMENT_TOKEN_PAYMENTS_LIVE_MODE', 'https://www.eway.com.au/gateway/ManagedPaymentService/managedCreditCardPayment.asmx?WSDL');
define('EWAY_PAYMENT_TOKEN_PAYMENTS_TESTING_MODE', 'https://www.eway.com.au/gateway/ManagedPaymentService/test/managedCreditCardPayment.asmx?WSDL');


/**
 * Payplans eway Plugin
 *
 * @author Puneet
 */
class plgPayplansEway extends XiPlugin
{
	public function onPayplansSystemStart()
	{
		$dir = dirname(__FILE__).DS.'eway'.DS.'app';
		PayplansHelperApp::addAppsPath($dir);
		return true;
	}

    /**
     * set plugin template for backend and front end
     */
    public function onPayplansViewBeforeRender(XiView $view, $task)
    {
    	if($view instanceof PayplanssiteViewSubscription && ($task == 'display' || $task == 'getDetails'))
        {
		   $subscriptionId     	= $view->getModel()->getId();
		   $subscription       	= PayplansSubscription::getInstance($subscriptionId);
		   $orderId            	= $subscription->getOrder();
		   $order              	= PayplansOrder::getInstance($orderId);
		   $invoice            	= $order->getInvoice();
		   $invoiceId			= $invoice->getId();
	   	   $payment             = $invoice->getPayment();
	   	   
		   if(!$payment){
		   		return true;
		   }
		   
		   $appId              	= $payment->getApp();
		   $ewayApp             = PayplansHelperApp::getAvailableApps('eway');
		   $appIds             	= array();
		   foreach ($ewayApp as $app) {
				 $appIds[]      = $app->getId();
		   }
	
			if($subscription->isRecurring() && in_array($appId, $appIds)){
				$this->_assign('invoice_id',    $invoiceId);
				return array('pp-subscription-display-action' => $this->_render('update_link'));
			}
    	}
  	}


  	
	/**	
	* This function handles the trigger when user click on update card widget.
	* @return boolean
	*/
	   	public function onPayplansUpdateLink()
		{
			$invoiceId	     = JFactory::getApplication()->input->get('invoice_id', false);
			$winHeight	     = JFactory::getApplication()->input->get('height');
			$invoice   	     = PayplansInvoice::getInstance($invoiceId);
			$update 	     = new stdClass();
			$update->id      = 'payplans-update-card';
			$update->click   = 'payplans.update.creditcard('.$invoiceId.');';
			$update->text    = XiText::_('COM_PAYPLANS_APP_EWAY_UPDATE');
			$update->classes = "btn btn-primary";
	
			$close 		     = new stdClass();
			$close->id       = 'payplans-update-close';
			$close->click    = 'xi.ui.dialog.close();';
			$close->text     = XiText::_('COM_PAYPLANS_APP_EWAY_CLOSE');
			$close->classes  = "btn";
	
			$order     		 = $invoice->getReferenceObject(PAYPLANS_INSTANCE_REQUIRE);
			$order     		 = PayplansOrder::getInstance($order->getId());
			$this->_assignFormValues($order->getInvoice());
	
			$html		 	 = $this->_render('update_form');	
			$title 		 	 = XiText::_('COM_PAYPLANS_APP_EWAY_UPDATE_CARD_DETAILS');
			$domObject   	 = 'xiWindowBody';
			$domProperty 	 = 'innerHTML';
			$response 		 = XiFactory::getAjaxResponse();
			$response->addAssign( $domObject , $domProperty , $html );
			$response->addScriptCall('xi.ui.dialog.title',$title);
			$response->addScriptCall('$("form#update_card_form").find("input,textarea,select").jqBootstrapValidation();');
			if(isset($winHeight)) {
				$response->addScriptCall('xi.ui.dialog.height',$winHeight);
			}		
			$response->addScriptCall('xi.ui.dialog.button', array($update, $close));
			$response->sendResponse();	
	
			return true;
		}

    private function _assignFormValues(PayplansInvoice $invoice)
    {
        $args   = array($invoice);
        $return = PayplansHelperEvent::trigger('queryCustomer', $args,'', $invoice);
        $info   = $return[0];

        if($info){      
            $this->_assign('CustomerTitle', $info->CustomerTitle);
            $this->_assign('CustomerFirstName', $info->CustomerFirstName);
            $this->_assign('CustomerLastName', $info->CustomerLastName);
            $this->_assign('CustomerCompany', $info->CustomerCompany);
            $this->_assign('CustomerJobDesc', $info->CustomerJobDesc);
            $this->_assign('CustomerEmail', $info->CustomerEmail);
            $this->_assign('CustomerAddress', $info->CustomerAddress);
            $this->_assign('CustomerSuburb', $info->CustomerSuburb);
            $this->_assign('CustomerState', $info->CustomerState);
            $this->_assign('CustomerPostCode', $info->CustomerPostCode);
            $this->_assign('CustomerCountry', $info->CustomerCountry);
            $this->_assign('CustomerPhone1', $info->CustomerPhone1);
            $this->_assign('CustomerPhone2', $info->CustomerPhone2);
            $this->_assign('CustomerFax', $info->CustomerFax);
            $this->_assign('CustomerURL', $info->CustomerURL);
            $this->_assign('CustomerComments', $info->CustomerComments);
            $this->_assign('CCName', $info->CCName);
            $this->_assign('CCNumber', $info->CCNumber);
            $this->_assign('CCExpiryMonth', $info->CCExpiryMonth);
            $this->_assign('CCExpiryYear', $info->CCExpiryYear);
        }else{
            return false;
        }
        return true;
    }
    
	/** Update Card Profile
		@param unknown_type $fields
	*/
	public function onPayplansUpdateCardProfile($fields)
	{
		$data 		 = array();
		foreach($fields as $field){
			$data[$field['name']]= $field['value'];
		}

		$invoiceId 	 = JFactory::getApplication()->input->get('invoice_id', false);
		$invoice     = PayplansInvoice::getInstance($invoiceId);
		$order	     = $invoice->getReferenceObject(PAYPLANS_INSTANCE_REQUIRE);
		$order       = PayplansOrder::getInstance($order->getId());
		$args   	 = array($order->getInvoice(), $data);	
		$is_updated  = PayplansHelperEvent::trigger('updateCustomer', $args);

		$html 		 = $this->_render('update_error');
		if($is_updated['0'] == true){
  			$html 	 = $this->_render('update_success');
		}
	  	
		$title 		 = XiText::_('COM_PAYPLANS_APP_EWAY_UPDATE_CARD_DETAILS');
	  	$domObject   = 'xiWindowBody';
		$domProperty = 'innerHTML';

		$response	 = XiFactory::getAjaxResponse();
		$response->addAssign( $domObject , $domProperty , $html );
		$response->addScriptCall('xi.ui.dialog.title',$title);
		$response->addScriptCall('xi.ui.dialog.height','auto');
		$response->addScriptCall('payplans.jQuery(\'#payplans-update-card\').hide');
		$response->sendResponse();
	}
}


