<?php

/**
* @copyright	Copyright (C) 2009 - 2016 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		Payplans
* @subpackage		Gift
* @contact		support+payplans@readybytes.in
*/
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

/**
 * Payplans Gift
 * Garima Agal
 */
 

class plgPayplansGift extends XiPlugin
{    
	
	public function onPayplansGetPlugin()
		    {
	        $xml = dirname(__FILE__).DS.'gift.xml';
	        if (file_exists($xml)) {
	                    $xmlContent = simplexml_load_file($xml);
	                }
	                else {
	                    $xmlContent = null;
	                }
	         return array('name'   => 'gift', 
	                	  'value' =>$xmlContent);
		    }
	
	public function onPayplansSubscriptionAfterSave($prev, $new)
	{
		
		// no need to trigger if previous and current state is same
		if($prev != null && $prev->getStatus() == $new->getStatus() ){
			return true;
		}
		
		// if subscription is activated
		if($new->getStatus() == PayplansStatus::SUBSCRIPTION_ACTIVE && !$new->isRecurring()){
			
			$plan 		= $new->getPlans(true);
			$plan 	= array_shift($plan);
			$planTitle = $plan->getTitle();
			$plan_id = $plan->getId();
			$user 		= $new->getBuyer(true);
			$subscription_id = $new->getId();
			$amount 	= 100.00000; // amount of discount to be given. As 100% discount is to be given, we have set it 100.
			$prefix = $this->params->get('prefix', 'GIFT_');
			
			$giftCount = $new->getParams()->get('gift_count' , 0);
			// if empty, then do nothing
			if(empty($giftCount)){
				return true;
			}
			$key =0;
			$discount = "";
			while($key < $giftCount)
			{
					//generate a 6 digit random code. Time is included so, no duplicate can exist.
					 $code = substr(number_format(time() * rand(), 0, '', ''), 0, 6); 
					 $code = $prefix.$code.$subscription_id;
					 $codes[] = $code;
					 
					 $db = XiFactory::getDBO();
					
					 $param = '{"extend_time_discount":"000000000000","coupon_amount_type":"percentage","allowed_quantity":"1","reusable":"no","allow_clubbing":"0"}';
		    		 $discount .= "( '$code', '$code', 'gift', 0, $amount , $plan_id , '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, '$param'),";
					 $key++;
			}
			
			 $discount = trim($discount,',');
    		 $discounts = 'INSERT INTO `#__payplans_prodiscount` (`title`, `coupon_code`, `coupon_type`, `core_discount`, `coupon_amount`, `plans`, `start_date`, `end_date`, `published`, `params`) VALUES'.$discount;

			 $db->setQuery($discounts);
			 $db->query();
			 
			 $data = $user->getProperties();
			 $config = JFactory::getConfig();
			
			 $codes = implode(",\n", $codes);
			 
			 $data['fromname']        = $config->get('fromname');
             $data['mailfrom']        = $config->get('mailfrom');
             $data['sitename']        = $config->get('sitename');
             $mail                    = JFactory::getMailer();
             $mail->IsHTML(true);
             
			 $subject 	= XiText::sprintf( 'PLG_PAYPLANS_GIFT_EMAIL_SUBJECT', $giftCount, $data['sitename']);
			 $body      = XiText::sprintf( 'PLG_PAYPLANS_GIFT_EMAIL_BODY',$planTitle,  $codes);
             $result    = $mail->sendMail($data['mailfrom'],$data['fromname'],$user->getEmail(),$subject,$body);

             if($this->params->get('sendMailTOAdmin', 0) == 1){
             	                         $mail                    = JFactory::getMailer();
					$rows 			= XiHelperJoomla::getUsersToSendSystemEmail();
					$subjectAdmin	= XiText::_("PLG_PAYPLANS_GIFT_ADMIN_SUBJECT");
					$bodyAdmin		= XiText::sprintf( 'PLG_PAYPLANS_GIFT_ADMIN_BODY', $user->getRealname(), $giftCount);
					
					foreach ( $rows as $row ){	
						$mail->sendMail($data['mailfrom'],$data['fromname'],$row->email,$subjectAdmin,$bodyAdmin);
					}
             }
			
             if($result === true) {                  
                      PayplansHelperLogger::log(XiLogger::LEVEL_INFO, XiText::_("PLG_PAYPLANS_GIFT_MESSAGE_SEND_SUCCESSFULLY"));
              }
              else {
                      PayplansHelperLogger::log(XiLogger::LEVEL_INFO, XiText::_("PLG_PAYPLANS_GIFT_MESSAGE_SEND_UNSUCCESSFULL"));
                   }
               
                   
              return $result;
			}	
			
		}
	
	public function onPayplansViewBeforeRender(XiView $view, $task)
	{
		// in view is not invoice or task is not confirm, then do nothing an return
		if(($view instanceof PayplanssiteViewInvoice) == false || $task != 'confirm'){
			return true;
		}
			
		$invoiceId  = $view->getModel()->getId();
		$invoice 	= PayplansInvoice::getInstance($invoiceId);
		
        if($invoice->isRecurring() || $invoice->getSubtotal() == 0)
        {
        	return true;
        }
        $plan 		  = $invoice->getPlans(true);
        $plan		  = array_shift($plan);
        
        if(!$this->params->get('applyPlan',0) || !in_array($plan->getId(), $this->params->get('applyPlan',0)))
        {
        	return true;
        }
        $subscription = $invoice->getReferenceObject(true)->getSubscription();
		$gift_count   = $subscription->getParams()->get('gift_count' , 0);
		
		$this->_assign('plan_id', $plan->getId());
		$this->_assign('invoice_id', $invoiceId);	
		$html         = "";
		
        $this->_assign('planTitle', $plan->getTitle());	
		$this->_assign('price', $invoice->getSubTotal());
		$this->_assign('quantity', $gift_count);		
		$html 	  = $this->_render('added_items');

		return array('pp-user-details' => $html);
	}
	
	/**
	 * Display all the gifts in pop-up 
	 */
	public function onPayplansShowItemsRequest()
	{	
		// add button
		$object1        	= new stdClass();
		$object1->id    	= "gift-add-item";
		$object1->click 	= 'payplans.apps.gift.add_item();';
		$object1->text 		= XiText::_('PLG_PAYPALNS_GIFT_SHOW_ITEMS_REQUEST_WINDOW_BUTTON_ADD');
		$object1->classes 	= "btn btn-primary";
		
		$object2        	= new stdClass();
		$object2->id    	= "gift-add-item-cancel";
		$object2->click 	= 'xi.ui.dialog.close();';
		$object2->text 		= XiText::_('PLG_PAYPLANS_GIFT_AJAX_CANCEL_BUTTON');
		$object2->classes 	= "btn";
		
		$plan_id = JRequest::getVar('plan_id', 0);
		$invoice_id = JRequest::getVar('invoice_id', 0);
		$this->_assign('plan_id', $plan_id);
		$this->_assign('invoice_id', $invoice_id);
		$html		 = $this->_render('show_items');

		// prepare window
        $title 		 = XiText::_('PLG_PAYPALNS_GIFT_SHOW_ITEMS_REQUEST_WINDOW_TITLE');
		$domObject   = 'xiWindowBody';
		$domProperty = 'innerHTML';
		
		// get ajax response object 
		$response	 = XiFactory::getAjaxResponse();
		
		// add window action
		$response->addAssign( $domObject , $domProperty , $html );
		$response->addScriptCall('xi.ui.dialog.height', 150);
		$response->addScriptCall('xi.ui.dialog.title',$title);
		
		$response->addScriptCall('xi.ui.dialog.button',array($object1,$object2));
		$response->sendResponse();
		
		return true;
	}
	
	public function onPayplansAddItemRequest($invoice_id, $item_id, $item_quantity)
	{
		// get ajax response object and send
		$response = XiFactory::getAjaxResponse();	
		$item_quantity = intval($item_quantity);
		if(!is_numeric($item_quantity) || $item_quantity == 0 || $item_quantity < 0)
		{
			$error = XiText::_('PLG_PAYPLANS_GIFT_INVALID_NUMBER');
			$response->addScriptCall('payplans.jQuery(".pp-gift-limit-err").html', $error);
			$response->sendResponse();
			return true;
		}
		
		if($item_quantity > $this->params->get('giftLimit',''))
		{
			$error = XiText::sprintf( 'PLG_PAYPLANS_GIFT_LIMIT_EXCEEDS', $this->params->get('giftLimit',''));
			$response->addScriptCall('payplans.jQuery(".pp-gift-limit-err").html', $error);
			$response->sendResponse();
			return true;
		}
		
		
		$invoice = PayplansInvoice::getInstance($invoice_id);
		$subscription = $invoice->getReferenceObject(true)->getSubscription();
		$subscription->setParam('gift_count' , $item_quantity);
		$subscription->save();	
		
	
		$plan = PayplansPlan::getInstance($item_id);
		$title = $plan->getTitle();
		$price = $plan->getPrice();
	
		$filter = array('type' => '"'.XiText::_("PLG_PAYPLANS_GIFT").'"', 
						'reference' => "'PLG_PAYPLANS_GIFT_ITEM:$item_id'",
						'invoice_id' => $invoice_id);		
		
		$modifier_model = XiFactory::getInstance('modifier', 'model');		
		$modifier_model->deleteMany($filter);
		
		
		// add modifier
		$invoice = $this->_addGiftModifier($invoice, $item_id, $item_quantity);

		$this->_assign('planTitle', $title);	
		$this->_assign('price', $price);
		$this->_assign('quantity', $item_quantity);	
		$this->_assign('invoice_id', $invoice_id);
		$this->_assign('plan_id', $item_id);		
		
		
		$html 	  = $this->_render('added_items');
		$response->addScriptCall('window.location.reload(true);');
		$response->sendResponse();
	}

	/**
	 * @param $invoice
	 * @param $plan_id
	 * @param $item_quantity
	 * @return mixed
     */
	protected function _addGiftModifier($invoice, $plan_id, $item_quantity)
		{
			    $price = 0;
				$plan = PayplansPlan::getInstance($plan_id);
				
				if(!$plan){
					return;
				}
				
				$price = $plan->getPrice() * $item_quantity;
				$applicability= $this->params->get('applicability');
				$applicability 	= constant("PayplansModifier::$applicability");
				// if modifier alreay exists, hen get its id
				$filter   = array('invoice_id' => $invoice->getId(), 
									'type'     => XiText::_("PLG_PAYPLANS_GIFT"), 
									'reference' => "'PLG_PAYPLANS_GIFT_ITEM:$plan_id'");
				
				$record = XiFactory::getInstance('modifier', 'model')->loadRecords($filter);
				
				$modifier = PayplansModifier::getInstance();
				if(!empty($record)){
					$record = array_shift($record);
					$modifier = PayplansModifier::getInstance($record->modifier_id, $record);
				}
				
				$modifier->set('user_id', $invoice->getBuyer())
						 ->set('amount', $price)
						 ->set('frequency', PayplansModifier::FREQUENCY_ONE_TIME)
						 ->set('invoice_id', $invoice->getId())
						 ->set('percentage', false)
						 ->set('message', XiText::_('PLG_PAYPLANS_GIFT_ADDITION_AMOUNT'))
						 ->set('serial', $applicability)
						 ->set('type', XiText::_("PLG_PAYPLANS_GIFT"))
						 ->set('reference', 'PLG_PAYPLANS_GIFT_ITEM:'.$plan_id);
						 
				$modifier->save();
			
			$invoice->refresh()->save();
			return $invoice;
		}


	/**
	 * @param $object
	 * @param $discountCode
	 * @return bool|string
     */
	public function onPayplansApplyDiscount($object, $discountCode)
		{
			//do nothing no discount coupon is entered
			if(empty($discountCode)){
				return false;
			}
			$query = new XiQuery();
			$query->select('*')
					->from('#__payplans_prodiscount')
				    ->where('coupon_code = "'.$discountCode.'"')
				    ->where('coupon_type="'.XiText::_("PLG_PAYPLANS_GIFT").'"')
                    ->where('published = 1');
					
            
			$discounts = $query->dbLoadQuery()->loadObjectList();
			
			$finalResult = false;
	  		$plan_id = array_shift($object->getPlans());
			foreach ($discounts as $discount){
				
				//if not a core discount then check for the applicable planids
				if(!$discount->core_discount){
					$subPlan	    = array_shift($object->getPlans());
					$discount_plans = explode(",",$discount->plans);
					
						if(!in_array($subPlan,$discount_plans)){
							unset($discounts[$discountId]);
							continue;
						}
			   }
							
				$result = PayplansHelperModifier::getTotalUsage($discountCode,XiText::_("PLG_PAYPLANS_GIFT"));
			
				if($result >= 1){
					return XiText::_('PLG_PAYPLANS_GIFT_ERROR_ALREADY_USED');
				}
				
			$modifiers = $object->getModifiers(array('type' => XiText::_("PLG_PAYPLANS_GIFT")));
			if(count($modifiers) > 0 ){
				return XiText::_('PLG_PAYPLANS_GIFT_CANT_USE_MULTIPLE_CODE');
			}
				
				$finalResult = $this->doApplyDiscount($object, $discountCode, $discount);
			}
			return $finalResult;	
		}	
	
	function doApplyDiscount($object, $discountCode, $discountObject)
		{
			$params = new stdClass();
			$plan_id = array_shift($object->getPlans());
			
			$params->message    = XiText::_('COM_PAYPLANS_APP_BASIC_DISCOUNT_MESSAGE');
			$params->type       = XiText::_("PLG_PAYPLANS_GIFT");
			$params->reference  = $discountCode;
			$params->frequency  = PayplansModifier::FREQUENCY_ONE_TIME; 
			$params->amount     = -100;
			$params->percentage = true;
			$params->serial     = PayplansModifier::PERCENT_DISCOUNT;
			
			//add modifier
		    $object->addModifier($params);
			$object->refresh();
			$object->save();
			//create log
			$message                  = XiText::_('PLG_PAYPLANS_GIFT_CODE_LOG_DISCOUNT_APPLIED');
			$error['Coupon Code']	  = 'Gift';
			$error['Invoice ID']      = $object->getId();
			$error['Prodiscount ID']  = $discountObject->prodiscount_id;
			$error['User ID']	 	  = $object->getBuyer();
			if(isset($amount)){
				$error['Discount Amount'] = $amount;
				$error['Percentage']      =  'Yes';
			}
		
			PayplansHelperLogger::log(XiLogger::LEVEL_INFO, $message, $discountObject,$error);	
			return true;
		}
	
	public function onPayplansGetDiscountType(&$args)
	{
		$args['gift'] = array( XiText::_("PLG_PAYPLANS_COUPON_TYPE_GIFT"), true);
		return true;

	}
	
}
