<?php

/**
* @copyright	Copyright (C) 2009 - 2009 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		Payplans
* @subpackage	Helpdesk
* @contact		payplans@readybytes.in
*/
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

/**
 * Payplans Helpdesk Plugin
 */
class plgPayplansHelpdesk extends XiPlugin
{
	const DO_NOTHING = -1;
	const ALLOWED 	 =  1;
	const BLOCKED    =  0;
     public function onPayplansSystemStart()
	{
		//add helpdesk app path to app loader
		$appPath = dirname(__FILE__).DS.'helpdesk'.DS.'app';
		PayplansHelperApp::addAppsPath($appPath);

		return true;
	}
	function onContentPrepare($context, &$row, &$params, $page = 0)
	{
		if(!is_a($row,'stdClass')){
			return false;
		}

		$option		 = JRequest::getVar('option',      false);
		$task		 = JRequest::getVar('task',        false);
		$id          = JRequest::getVar('id',        false);
				
		if($option=='com_maqmahelpdesk' && $task=='kb_view'){
			$userid 	= XiFactory::getUser()->id;
			$user = PayplansUser::getInstance($userid);
		    if($user->isAdmin()){
				return true;
			}
			if(array_key_exists($userid, $this->getSupportStaff())){
				return true;
			}
			$userSubs  = $user->getPlans();
			$knowledgebaseaclApp = PayplansHelperApp::getAvailableApps('knowledgebaseacl');
			foreach ($knowledgebaseaclApp as $app){
				$allowedkb=$app->getAppParam('knowledgebaseacl',0);
				if ($allowedkb=='0'){
						return  true;
				}
				$allowedkb = is_array($allowedkb) ? $allowedkb : array($allowedkb);		
				if(in_array($id,$allowedkb )){
					$allowedOrNot = self::_isUserAllowed($app,$userid,$userSubs);
					if($allowedOrNot == self::ALLOWED){
						return true;
				    }
					if($allowedOrNot == self::BLOCKED){
						$url  = XiRoute::_('index.php?option=com_payplans&view=plan');
						if(strpos($row->text,'<hr id='.'"system-readmore" />') == false){
							$row->text = "<a href='$url'>".XiText::_('COM_PAYPLANS_APP_KNOWLEDGEBASEACL_SUBSCRIBE_TO_READ')."</a>";
							return true;
						}
						$displaydata = explode('<hr id='.'"system-readmore" />', $row->text); 
						$row->text = $displaydata[0]."<a href='$url'>".XiText::_('COM_PAYPLANS_APP_KNOWLEDGEBASEACL_SUBSCRIBE_TO_READ_MORE')."</a>";
						return true;
					}	
				}	
		   	}
		}
		return true;
	}
	
	// checks whether user is allowed to access the content or not.
	static function _isUserAllowed($app,$userid,$userSubs)
	{	
		$plans 	    = $app->getPlans();
		if(!$userid){
			return false;
		}
				
		// return false when user is non-subscriber
		if(empty($userSubs)){
			return false;
		}
		
		// return true when app is core app,
		// no need to check whether plan is attached with this app or not
		if($app->getParam('applyAll',false) == true){
			return true;
		}
		
		// if user have an active subscription of the plan attached with the app then return true
			foreach($userSubs as $sub){
				if(in_array($sub, $plans)){
					return true;
				}
			}

		return false;
	}
	
   // Get user id of support staff
	function  getSupportStaff()
	{
		$query = new XiQuery();
		return $query->select('*')
					 ->from('`#__support_permission`')
					 ->dbLoadQuery()
					 ->loadObjectList('id_user');
	}
	function onAfterRoute()
	{
		$option			= 	JRequest::getVar('option',false);
		$id_workgroup	=	JRequest::getVar('id_workgroup',false);
		$task			=	JRequest::getVar('task',false);
		
		if($option=='com_maqmahelpdesk' && $task=='ticket_save'){	
			$userid 	= 	XiFactory::getUser()->id;
			$user 		= 	PayplansUser::getInstance($userid);
			$workgroup	=	self::getWorkgroup($id_workgroup);
		    if($user->isAdmin()){
				return true;
			}
			if(array_key_exists($userid, $this->getSupportStaff())){
				return true;
			}

			$allowedOrNot		= $this->allowedInApp($userid,$id_workgroup);
			if(!in_array(self::ALLOWED, $allowedOrNot)) {
				$message = XiText::_('COM_PAYPLANS_APP_HELPDESKTICKETS_NO_TICKETS_AVAILABLE_SUBSCRIBE_A_PLAN');
				$url     = XiRoute::_('index.php?option=com_payplans&view=plan');
				XiFactory::getApplication()->redirect(XiRoute::_('index.php?option=com_payplans&view=plan'),$message);
			}
			
			return true;
		}
		return true;
	}
	
	function allowedInApp($userid,$id_workgroup)
	{
		$user 				= PayplansUser::getInstance($userid);
		$userSubs  			= $user->getPlans();
		$resource_model		= PayplansApp::getResourceModel();
		$title		 	    = "com_maqmahelpdesk.tickets";
		$appResult  		= array();
		$helpdesktickets	= PayplansHelperApp::getAvailableApps('helpdesktickets');
		
		foreach ($helpdesktickets as $app)
		{
			$AddTicketsIn 		= $app->getAppParam('add_ticket_in', 'any_department');
			$allowedwg          = $app->getAppParam('helpdeskworkgroup',0);
			//it will check user is allowed or not
			$allowedOrNot 		= self::_isUserAllowed($app,$userid,$userSubs);
			
			//firstly i need to check weather app is applicable on it or not
			//here i need to fetch all app departs on which app will restrict
			$allowedwg = is_array($allowedwg) ? $allowedwg : array($allowedwg);
			
			if($AddTicketsIn == 'any_department'){
				if($allowedOrNot == self::BLOCKED){
					$appResult[] = self::BLOCKED;
					continue;
				}				
				$tickets = $resource_model->loadRecords(array('user_id'=>$userid, 'title'=>$title,'value'=>0));
				$allowed = $this->isAllowedInDept($tickets,'0',$userid);
		
				if($allowed == self::ALLOWED){
					$appResult[]    = self::ALLOWED;
	 				continue;
				}
				$appResult[]    = self::BLOCKED;
				continue;
			}
			
			if(in_array($id_workgroup, $allowedwg)){
				if($allowedOrNot == self::BLOCKED){
					$appResult[] = self::BLOCKED;
					continue;
				}	

				$tickets = $resource_model->loadRecords(array('user_id'=>$userid, 'title'=>$title,'value'=>$id_workgroup));
				$allowed = $this->isAllowedInDept($tickets,$id_workgroup,$userid);
				if($allowed == self::ALLOWED){
					$appResult[]    = self::ALLOWED;
	 				continue;
					}
				$appResult[]    = self::BLOCKED;
				continue;
			}
			
		}
		return $appResult;
	}
	
	function isAllowedInDept($tickets,$workgroupid,$userid)
	{
		if(!empty($tickets)){
			$tickets			  = array_shift($tickets);
			$numberoftickets 	  = $tickets->count;
			$ticketsSubscription  = $tickets->subscription_ids;
			$subscriptions        = explode(',', $ticketsSubscription);
			$subscriptionDate     = array();
			foreach ($subscriptions as $subscription){
				if($subscription != ''){
					$subscriptionInstance = PayplansSubscription::getInstance($subscription);
					$subscriptionDate[]   = $subscriptionInstance->getSubscriptionDate()->toMySQL();
				}
			}
			$ticketsCreatedByUser = self::ticketsCreated($userid,$workgroupid,$subscriptionDate);
			$countTickets 	      = count($ticketsCreatedByUser);
			if($countTickets < $numberoftickets){
				return true;
			}
			return false;
		}
		return true;	
	}
	
	static function getWorkgroup($workgoupid)
	{		
		$query = new XiQuery();
		return $query->select('wkdesc')
					 ->from('`#__support_workgroup`')
					 ->where('id = '.$workgoupid)
					 ->dbLoadQuery()
					 ->loadResult('wkdesc');
	}	
	
	public static function ticketsCreated($userid,$workgoupid,$subscriptionDate)
	{
		$str1 = '';
		foreach($subscriptionDate as $newDate){
			$str1 .= ' date > \''.$newDate.'\' OR';
		}
		$str1 = preg_replace('/OR$/', '', $str1);
		if($workgoupid == 0){
			$str = 'id_user = '.$userid.' AND ('.$str1.')';
		}
		else {
			$str = 'id_user = '.$userid.' AND id_workgroup = '.$workgoupid.' AND ('.$str1.')';
		}
		$query = new XiQuery();
		return $query->select('*')
					 ->from('`#__support_ticket`')
					 ->where($str)
					 ->dbLoadQuery()
					 ->loadObjectList('id');
	}
	
	
}
