<?php

/**
* @copyright	Copyright (C) 2009 - 2009 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		Payplans
* @subpackage	IMaqma Helpdesk 
* @contact		payplans@readybytes.in
*/
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

/**
 * Payplans Helpdesk Plugin
 */
class PayplansAppHelpdesk extends PayplansApp
{
	protected $_location	= __FILE__;
	protected $_resource	= 'com_maqmahelpdesk.clients';

	public function onPayplansSubscriptionAfterSave($prev, $new)
	{
		// no need to trigger if previous and current state is same
		if($prev != null && $prev->getStatus() == $new->getStatus()){
			return true;
		}		
		$subid  = $new->getId();		
		$userid = $new->getBuyer();
		
		//when subscription status is active
		if($new->getStatus() == PayplansStatus::SUBSCRIPTION_ACTIVE)
		{
			$hold		 = $this->getAppParam('addToClientonHold');
			$expire		 = $this->getAppParam('addToClientonExpire');
			$active 	 = $this->getAppParam('addToClientonActive');
			
			$this->_RemoveFromHelpdeskClient($userid, $hold, $subid);
			$this->_RemoveFromHelpdeskClient($userid, $expire, $subid);
			return $this->_AddToHelpdeskClient($userid, $active, $subid);		
		}

		//when subscription status is hold
		if($new->getStatus() == PayplansStatus::SUBSCRIPTION_HOLD)
		{
			$hold		 = $this->getAppParam('addToClientonHold');
			$expire		 = $this->getAppParam('addToClientonExpire');
			$active 	 = $this->getAppParam('addToClientonActive');

			$this->_RemoveFromHelpdeskClient($userid, $active, $subid);
			$this->_RemoveFromHelpdeskClient($userid, $expire, $subid);
			return $this->_AddToHelpdeskClient($userid, $hold, $subid);
		}
		
		//when subscription status is expire
		if($new->getStatus() == PayplansStatus::SUBSCRIPTION_EXPIRED)
		{
			$hold		 = $this->getAppParam('addToClientonHold');
			$expire		 = $this->getAppParam('addToClientonExpire');
			$active 	 = $this->getAppParam('addToClientonActive');

			$this->_RemoveFromHelpdeskClient($userid, $hold, $subid);
			$this->_RemoveFromHelpdeskClient($userid, $active, $subid);
			return $this->_AddToHelpdeskClient($userid, $expire, $subid);
		}
	}
	
	function _RemoveFromHelpdeskClient($userid, $clientids, $subid)
	{
		if(!is_array($clientids)){
			$clientids = array($clientids);
		}
		
		foreach($clientids as $clientid){
			
			//nothing to do when client array is empty.
			if(empty($clientid)){
				continue;
			}		
			
			$this->_removeFromResource($subid, $userid, $this->getClientName($clientid), $this->_resource);
			$this->_removeFromClient($clientid, $userid);
		}
		return true;
	}
	
	function _AddToHelpdeskClient($userid, $clientids, $subid)
	{			
		if(!is_array($clientids)){
			$clientids = array($clientids);
		}
		
		foreach($clientids as $clientid){

			//nothing to do when client array is empty.
			if(empty($clientid)){
				continue;
			}

			$query = new XiQuery();
			$users = $query->select('id_user')
					 ->from('`#__support_client_users`')
					 ->where('id_client = '.$clientid.' AND id_user = '.$userid)
					 ->dbLoadQuery()
					 ->loadResult();

			if(!count($users)){
				$this->_addToClient($clientid, $userid);
			}

			$this->_addToResource($subid, $userid, $this->getClientName($clientid), $this->_resource);
		}
	}

	function _removeFromClient($removeFromClient, $userid)
	{
		$query = new XiQuery();
		return $query->delete()
					 ->from('`#__support_client_users`')
					 ->where('id_client = '.$removeFromClient.' AND id_user = '.$userid)
					 ->dbLoadQuery()
					 ->loadResult();

	}

	function _addToClient($clientid, $userid)
	{
		$db    = XiFactory::getDbo();		
		$query = 'INSERT INTO `#__support_client_users`(id_client,id_user)'
				 .'values('.$clientid.','.$userid.')';
		$db->setQuery( $query );
		$db->query();
	}

	function getClientName($clientid)
	{		
		$query = new XiQuery();
		return $query->select('clientname')
					 ->from('`#__support_client`')
					 ->where('id = '.$clientid)
					 ->dbLoadQuery()
					 ->loadResult('clientname');
	}
	
}

class PayplansAppHelpdeskFormatter extends PayplansAppFormatter
{
	//get Rules 
	function getVarFormatter()
	{
		$rules = array();
		return $rules;
	}
}