<?php
/**
* @copyright	Copyright (C) 2009 - 2009 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		PayPlans
* @subpackage	Imaqma Helpdesk
* @contact 		payplans@readybytes.in
* 
* 
*/
if(defined('_JEXEC')===false) die();

class PayplansApphelpdesktickets extends PayplansApp
{
	protected $_location	= __FILE__;
	protected $_resource	= 'com_maqmahelpdesk.tickets';
	const ALLOWED 	 		=  1;
	const BLOCKED    		=  0;

	public function _isApplicable(PayplansIfaceApptriggerable $refObject, $eventName='')
	{
		return JFolder::exists(JPATH_SITE .DS.'components'.DS.'com_maqmahelpdesk');
	}

	public function onPayplansSubscriptionAfterSave($prev, $new)
	{
		// no need to trigger if previous and current state is same
		if($prev == null || $prev != null && $prev->getStatus() == $new->getStatus()){
			return true;
		}	
	
		$subid        = $new->getId();		
		$userid       = $new->getBuyer();
		$user         = PayplansUser::getInstance($userid);
		$plan_title   = $new->getTitle();
		$buyer_name   = $new->getBuyerName();
		$AddTicketsIn = $this->getAppParam('add_ticket_in', 'any_department');
		$allowedwg	  = $this->getAppParam('helpdeskworkgroup',0);
		$numberoftickets = $this->getAppParam('numberoftickets',0);
		//when subscription status is active
		if($new->getStatus() == PayplansStatus::SUBSCRIPTION_ACTIVE){
			if($AddTicketsIn != 'on_specific_department'){ 
				$this->_addToResource($subid, $userid,0, $this->_resource,$numberoftickets);
				return true;	
			}
			$allowedwg = is_array($allowedwg) ? $allowedwg : array($allowedwg);	
			foreach ($allowedwg as $workgoupid){
				$this->_addToResource($subid, $userid,$workgoupid, $this->_resource,$numberoftickets);
			}
			return true;
		}	

		if ( $prev->getStatus() == PayplansStatus::SUBSCRIPTION_ACTIVE  && $new->getStatus() != PayplansStatus::SUBSCRIPTION_ACTIVE ){
			if($AddTicketsIn !='on_specific_department'){ 
				$this->changeStatus($numberoftickets,'0',$userid);
				$this->_removeFromResource($subid, $userid,0, $this->_resource);
				return true;
			}
			$allowedwg = is_array($allowedwg) ? $allowedwg : array($allowedwg);	
			foreach ($allowedwg as $workgoupid){
				$this->changeStatus($numberoftickets,$workgoupid,$userid);
				$this->_removeFromResource($subid, $userid, $workgoupid, $this->_resource);
			}
		}
		return true;
	}
	
	function changeStatus($numberoftickets,$workgoupid,$userid)
	{
		if($workgoupid == 0){
			$str = 'id_user = '.$userid.' AND id_status = 1 ';
		}
		else{ 
			$str = 'id_user = '.$userid.' AND id_workgroup = '.$workgoupid.' AND id_status = 1 ';
		}

		$db 	= JFactory::getDBO();
		$query  = 'update `#__support_ticket`'
				. ' set `id_status` = 4'
				. ' where '.$str
				. 'order by `last_update` limit '.$numberoftickets;
	 	$db->setQuery( $query );
	 	$db->query();
	}
	
	//render Widget
	public function renderWidgetHtml()
	{   
		//get user id
		$userid = XiFactory::getUser()->id;
		if(!$userid){
			return true;
		}

		$resourceRecords = $this->getallowedtickets($userid);
	    if(empty($resourceRecords)){
	    	return true;
	    }
	
		$dept_id		 = '';
		$total			 = 0;
		$any_dept_count	 = 0;
		$render_data	 = array(array());
		$index			 = 0;

		// first calculate the sum of all consumed post in total variable 
        // then subtract from consumed of additional category.
		foreach($resourceRecords as $resourceRecord){
			if($resourceRecord->value == 0){
				$any_dept_count	= $resourceRecord->count;
			}
			else
			{
				$dept_id							 = $resourceRecord->value;
 			    $ticketingRecords				     = count(plgPayplansHelpdesk::ticketsCreated($userid,$dept_id,array(0)));
	 			$render_data[$index]['title']	 	 = plgPayplansHelpdesk::getWorkgroup($resourceRecord->value);
	 		 	$render_data[$index]['allowed']		 = $resourceRecord->count;
				
				//here is some need to calculate the total, beacause consumed, in case, it may be more than allowed
				//user then allowed should be handel properly 
	 		 	if($ticketingRecords > $resourceRecord->count && $resourceRecord->count!=0){
						$total 			 = $ticketingRecords - $resourceRecord->count;
		 		 		$ticketingdata 	 = $resourceRecord->count;
				}else{
						$ticketingdata 	 = $ticketingRecords;
				}

				$render_data[$index]['consumed'] = $ticketingdata;
				$index++;
			}
		}
		
		$render_data[$index]['title']	 = XiText::_("COM_PAYPLANS_APP_HELPDESKTICKETS_ANY_DEPT");
		$render_data[$index]['allowed']	 = $any_dept_count;
		$value							 = count(plgPayplansHelpdesk::ticketsCreated($userid,0,array(0)));
		
		//now adjust that exceeded total to the any category
		$render_data[$index]['consumed'] = ($value + $total);
	  
	    $this->assign('render_data', $render_data);		    
        $data = $this->_render('widgethtml');
        return $data;
	}
	
	function getallowedtickets($userid)
	{
		$resource_model	= PayplansApp::getResourceModel();
		return $resource_model->loadRecords(array('user_id'=>$userid, 'title'=>"com_maqmahelpdesk.tickets"));	
	}
		
	
}

class PayplansApphelpdeskticketsFormatter extends PayplansAppFormatter
{
	//get Rules 
	function getVarFormatter()
	{
		$rules = array();
		return $rules;
	}
}

