<?php
/**
* @copyright	Copyright (C) 2009 - 2009 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		PayPlans
* @subpackage	Frontend
* @contact 		payplans@readybytes.in
* 
* 
*/
if(defined('_JEXEC')===false) die();

class PayplansAppknowledgebaseacl extends PayplansApp
{
	protected $_location = __FILE__;
	const ALLOWED 	 =  1;
	const BLOCKED    =  0;
	const DO_NOTHING = -1;

	public function isApplicable($refObject = null, $eventName=''){
		
		if($eventName == 'onPayplansAccessCheck'){
			return true;
		}
		
		return false;
	}
	
	public function renderWidgetHtml()
	{   
		//get user id
		$userid     = XiFactory::getUser()->id;
		if(!$userid){
			return '';
		}
		$user 		= PayplansUser::getInstance($userid);
		if($user->isAdmin()){
			return '';
		}
		if(array_key_exists($userid, $this->getSupportStaff()))
		{
			return '';
		}

		$dataToRender = array();
		$kb = self::isAllowed($user);
		
	   foreach ($kb as &$id){
	   		$title = $this->getkbtitle($id);
		   	if(empty($title))
		   	continue;
		    $workgroup = $this->getWorkGroup($id);
			$dataToRender[$workgroup][]=$id;
			$dataToRender[$workgroup][]=$title;
	    }
	   
	    $this->assign('dataToRender', $dataToRender);
        return $this->_render('widgethtml');
	}

	function isAllowed(PayplansUser $user)
	{
		$subs = $user->getPlans();
		$kb   = array();
		$knowledgebaseaclapp = PayplansHelperApp::getAvailableApps('knowledgebaseacl');
		
		// For each app check whether knowledge bases attached with the app, to be shown in the dashboard widget or not.
		foreach ($knowledgebaseaclapp as $app)
		{
			$allowedkb = $app->getAppParam('knowledgebaseacl',array());
			$allowedkb = is_array($allowedkb) ? $allowedkb : array($allowedkb);
			if(empty($allowedkb)){
				continue;
			}
			$applyall= $app->getParam('applyAll',false);
			if($applyall != false && !empty($subs))
			{
				foreach ($allowedkb as &$value){
					$kb[]=$value;
					}
					continue;
			}
			if($applyall == false){
				$plans = $app->getPlans();
				if(empty($plans)){
					foreach ($allowedkb as &$value){
					$kb[]=$value;
					}
					continue;
				}
				if(array_intersect($subs, $plans) != false){
				 foreach ($allowedkb as &$value){
					$kb[]=$value;
					}
					continue;
				}
				
			}
		}
		
		return $kb;
	}
	
	function  getSupportStaff()
	{
		$query = new XiQuery();
		return $query->select('*')
					 ->from('`#__support_permission`')
					 ->dbLoadQuery()
					 ->loadObjectList('id_user');
	}

	//Get title of Knowledgebases
	function getkbtitle($id)
	{	
		$query = new XiQuery();
		return  $query->select('kbtitle')
					 ->from('`#__support_kb`')
					 ->where('id = '.$id)
					 ->where("`anonymous_access` != 2")
					 ->dbLoadQuery()
					 ->loadResult();
   	}

	function getWorkGroup($id)
	{
			$db 	= JFactory::getDBO();
			$query  = 'SELECT `id_workgroup`'
				 	. ' FROM `#__support_category` AS a '
				 	. 'LEFT JOIN `#__support_kb_category` AS b ON a.id = b.id_category '
				 	. 'WHERE b.id_kb ='.$id;
				 	
		 	$db->setQuery( $query );
		 	$workgroup = $db->loadResult();
		 	return $workgroup;

	}
	
	public function onPayplansAccessCheck(PayplansUser $user)
	{
		$option = JRequest::getVar('option');
		if($option == 'com_maqmahelpdesk')
		{
			$task 	= JRequest::getVar('task');
			if($task == 'kb_view')
			{
				$kb_id 	= JRequest::getVar('id');
				$allowedKb = self::isAllowed($user);
				if(in_array($kb_id,$allowedKb))
				{
					return true;
				}

				$message = XiText::_('COM_PAYPLANS_APP_HELPDESK_KNOWLEDGEBASE_NOT_ALLOWED_TO_VIEW');
				$url     = XiRoute::_('index.php?option=com_payplans&view=plan');
				XiFactory::getApplication()->redirect($url,$message);
				return true;
			}
		}
	}

}

class PayplansAppknwledgebaseaclFormatter extends PayplansAppFormatter
{
	//get Rules 
	function getVarFormatter()
	{
		$rules = array();
		return $rules;
	}
}
