<?php
/**
* @copyright	Copyright (C) 2009 - 2009 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		PayPlans
* @subpackage	HTTP query
* @contact 		shyam@readybytes.in
* 
*/
if(defined('_JEXEC')===false) die();

class PayplansAppHttpquery extends PayplansApp
{
	protected $_location	= __FILE__;

	public function onPayplansSubscriptionAfterSave($prev, $new)
	{
		// no need to trigger if previous and current state is same
		if($prev != null && $prev->getStatus() == $new->getStatus()){
			return true;
		}
		
		$newStatus  = $new->getStatus();
		
		$urlOnActive 	= $this->getAppParam('urlOnActive','');
		$urlOnHold 		= $this->getAppParam('urlOnHold','');
		$urlOnExpire 	= $this->getAppParam('urlOnExpire','');	
		$queryOnActive 	= $this->getAppParam('queryOnActive','');
		$queryOnHold   	= $this->getAppParam('queryOnHold','');
		$queryOnExpire 	= $this->getAppParam('queryOnExpire','');
				

		// if subscription is active
		if($newStatus == PayplansStatus::SUBSCRIPTION_ACTIVE){	
			return $this->_executeHttpQuery($urlOnActive,$queryOnActive,$new);
		}
		
		//if subscription is hold
		if($newStatus == PayplansStatus::SUBSCRIPTION_HOLD){		
			return $this->_executeHttpQuery($urlOnHold,$queryOnHold,$new);
		}
		// if subscription is active
		if($newStatus == PayplansStatus::SUBSCRIPTION_EXPIRED){
			return $this->_executeHttpQuery($urlOnExpire,$queryOnExpire,$new);
		}

		return true;
		
	}
	protected function _executeHttpQuery($url,$query,$object)
	{
		$full_url = $this->_createUrl($url, $query,$object);

		// generate curl request		
		$curl_request = curl_init($full_url);
		curl_setopt($curl_request,CURLOPT_RETURNTRANSFER,true);
		curl_setopt($curl_request,CURLOPT_HTTPHEADER,array( 'Content-Type: text/xml' ));
		curl_setopt($curl_request,CURLOPT_HEADER,false);
		curl_setopt($curl_request,CURLOPT_SSL_VERIFYPEER,false);
		$response = curl_exec( $curl_request);
      	$content  = array('response'=>$response,'body'=>'');
		$message  = XiText::_('COM_PAYPLANS_HTTP_QUERY_EXECUTE_SUCCESSFULLY');

		if ( $response === false ) {
			$event	= XiText::_('COM_PAYPLANS_HTTP_QUERY_EXECUTE_UNSUCCESSFULLY_MESSAGE1'). $url . XiText::_('COM_PAYPLANS_HTTP_QUERY_EXECUTE_UNSUCCESSFULLY_MESSAGE2') . curl_errno( $ch ) . ' ( "' . curl_error( $ch ) . '" ) '.XiText::_('COM_PAYPLANS_HTTP_QUERY_EXECUTE_UNSUCCESSFULLY_MESSAGE3');
			$content  = array('response'=>$response,'body'=>$event);
			$message  = XiText::_('COM_PAYPLANS_HTTP_QUERY_EXECUTE_UNSUCCESSFULLY');
		}
		PayplansHelperLogger::log(XiLogger::LEVEL_INFO, $message, $this, $content, 'PayplansAppHttpqueryFormatter');
		
		curl_close( $curl_request );

	}
	
	protected function _createUrl($url, $query, $object)
	{
		$query1 = XiFactory::getRewriter()->rewrite($query, $object);
		$urlsplit = explode( '?', $url );

		$p = explode( "\n", $query1 );

		if ( !empty( $urlsplit[1] ) ) {
			$p2 = explode( '&', $urlsplit[1] );

			if ( !empty( $p2 ) ) {
				$p = array_merge( $p2, $p );
			}
		}

		$fullp = array();
		foreach ( $p as $entry ) {
			$e = explode( '=', $entry );

			if ( !empty( $e[0] ) && !empty( $e[1] ) ) {
				$fullp[] = urlencode( trim($e[0]) ) . '=' . urlencode( trim($e[1]) );
			}
		}

		return $urlsplit[0] . '?' . implode( '&', $fullp );
	}
}

class PayplansAppHttpqueryFormatter extends PayplansAppFormatter
{
	public $template	= 'view_log';
	
	// get Ignore data 
	function getIgnoredata()
	{
		$ignore = array('_trigger', '_tplVars', '_mailer', '_location', '_errors', '_component');
		return $ignore;
	}
	
	// get rules
	function getVarFormatter()
	{
		$rules = array('_appplans'       => array('formatter'=> 'PayplansAppFormatter',
										       'function' => 'getAppPlans'),
					   'app_params'      => array('formatter'=> 'PayplansAppHttpqueryFormatter',
										       'function' => 'getFormattedContent'));
		return $rules;
	}

	// format email app content,status, expiration time 
	function getFormattedContent($key, $value, $data)
	{	
		$this->template = 'view';
	}
}
