<?php

/**
* @copyright	Copyright (C) 2009 - 2015 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		Payplans
* @subpackage	Idev Affiliate
* @contact		support+payplans@readybytes.in
*/
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

class plgPayplansidevaffiliate extends XiPlugin
{

	public function onAfterRoute()
	{
		$inputs = JFactory::getApplication()->input; 
		$idev = $inputs->get('idev_id');  
		if($inputs->get('option') == 'com_payplans' && $inputs->get('view') == 'plan' 
		   				&& $inputs->get('task') == 'subscribe' && isset($idev)) {
			  		$session = JFactory::getSession();
			  		$session->set('idev_id',$idev);
			} 
	   
	}

	public function onPayplansGetPlugin()
	{
		        $xml = dirname(__FILE__).DS.'idevaffiliate.xml';
		        if (file_exists($xml)) {
		                $xmlContent = simplexml_load_file($xml);
		        }
		        else {
		               $xmlContent = null;
		        }
		        return array('name'   => 'idevaffiliate', 
		              	  'value' =>$xmlContent);
	}
	
	//For Tracking "Upgrade" "Invoice Paid","refund"
	public function onPayplansInvoiceAfterSave($prev, $new)
	{
		if(!isset($prev) || !isset($new)){
			return true;			
		}
		
		// Before save and after save, Invoice status should not be same.
		if ($prev->getStatus() == $new->getStatus()){
			return true;
		}
		
		//Status of Invoice
		$status = $new->getStatus();

		//Which Event to track, Decision made on status of invoice from $new
		switch ($status)
		{
			
			// Invoice checkout
			case PayplansStatus::INVOICE_CONFIRMED :
					$isIdev = $new->getParam('idev_id');
					if (!isset($isIdev)) {
						$session 	= JFactory::getSession();
						$idev_id	= $session->get('idev_id'); 
						$new->setParam('idev_id',$idev_id);
						$new->save();
					}
					
					$order = $new->getReferenceObject(PAYPLANS_INSTANCE_REQUIRE);
					$user  = $new->getBuyer(PAYPLANS_INSTANCE_REQUIRE);
					if ($order instanceof PayplansOrder){
						$userIdevParam  = $user->getParams()->get('idevaffiliate'.$new->getId(), '');
				
						if (empty($userIdevParam)){
							$user->setParam('idevaffiliate'.$new->getId(), $this->_getClientIP());
							$user->save();
						}
					}
				 	break ;
			// Invoice paid
			case PayplansStatus::INVOICE_PAID : 
					$upgrade = $this->_checkForUpgrade($prev, $new);
					$args = $this->_invoicePaidDetails($new, $upgrade);
				 	break ;

			// Invoice Refund
			case PayplansStatus::INVOICE_REFUNDED:
					if($this->params->get('track_refund',0))
					{
						$event = 'refund';
						$args  = $this->_refund($new, $event);
						break;
					}

			// for all non-tracking cases.
			default:
					return true;
		}
		
		return	$this->_track($args);
		
	}
	
	//Check For Upgrade and then Collect Details for tracking
	protected function _checkForUpgrade($oldInvoice, $newInvoice)
	{	
		$newInvoiceKey		= $newInvoice->getKey();
		$newOrder			= PayplansOrder::getInstance($newInvoice->getObjectId());		
		$newSubscriptionId  = $newOrder->getParam('upgrading_from',null);
		
		if(($newOrder)	&& isset($newSubscriptionId) && !empty($newSubscriptionId)){
			
			if(isset($newSubscriptionId)){
				
				$oldInvoiceKey  	= PayplansHelperUtils::getKeyFromId($oldInvoice->getObjectId());
				$oldOrder			= PayplansOrder::getInstance($oldInvoiceKey);
				$oldSubscription 	= $oldOrder->getSubscription(PAYPLANS_INSTANCE_REQUIRE);
				//collects details of upgarade and return them.
				$this->_upgradeDetails($oldSubscription, $oldInvoiceKey, $newSubscriptionId,$newInvoice);
				return true;
			}
		}
		return false;
	}
	
	protected function _upgradeDetails($oldSubscription, $oldInvoiceKey, $newSubscriptionId, $newInvoice)
	{
		//Data from old subscription from which we are going to upgrade.
		$oldplanName	  	= $oldSubscription->getTitle();
							
		//Data From new subscription to which we are going to upgrade.
		$newSubscription	= PayplansSubscription::getInstance($newSubscriptionId);
		
		$newTotal	  	    = $newInvoice->getTotal();
		$newPlanName       	= $newInvoice->getTitle();
		$userId				= $oldSubscription->getBuyer();
		//$session 			= JFactory::getSession();
		$affiliateId 		= $newInvoice->getParam('idev_id');//$this->getAppParam('affiliate_id');
		//remove idev param from session
		//$session->clear('idev_id');
		if (isset($affiliateId)) {
		$args				= "idevaffiliate.php?id=$affiliateId"."&tid1=Upgraded_from_$oldplanName"."&tid2=Upgraded_To_$newPlanName"."&tid3=Old_invoice_$oldInvoiceKey";
		$this->_track($args);
		}
		
	}
	
	
	// To Find Details When an Invoice Gets Paid
	protected function _invoicePaidDetails($invoice, $upgrade)
	{
		//Gets Details of invoice
		$data = $this->_getDetails($invoice);
				
		//If Subscription is Not Upgraded then make an entry for Traffic Log on IDevAffiliates Otherwise
		if(true != $upgrade)
		{
			if (isset($data['Affiliate Id'])) {
			$args ='idevaffiliate.php?id='.$data['Affiliate Id']."&tid1=".$data['User Id']."&tid2=".$data['User Name'];
			$this->_track($args);
			}
		}
		
		return "sale.php?profile=72198&idev_saleamt=".$data['Price']."&idev_ordernum=".$data['Invoice Key']."&ip_address=".$data['Visitor IP']."&idev_option_1=".$data['User Name']."&idev_option_2=".$data['Email']."&idev_option_3=".$data['Plan Name'];
	}
	
	//	//To Find Refund Details
	protected function _refund($invoice, $event=null)
	{
		$data 	= $this->_getDetails($invoice);
		if (isset($data['Affiliate Id'])) {
		$this->_track("idevaffiliate.php?id=".$data['Affiliate Id']."&tid1=invoice&tid2=refund&tid3=successful");
		}
		return "sale.php?profile=72198&idev_saleamt=".$data['Price']."&idev_ordernum=".$data['Invoice Key']."&ip_address=".$data['Visitor IP']."&idev_option_1=".$data['User Name']."&idev_option_2=".$data['Email']."&idev_option_3=".$data['Plan Name'];
		
	}

	protected function _getDetails($invoice)
	{
		$invoiceId 				= $invoice->getId();
		$data					= array();
		$data['Invoice Key']	= $invoice->getKey();
		$data['Price']			= $invoice->getPrice();
		$data['Plan Name']		= str_replace(' ','-',$invoice->getTitle());
		
//		$data['Visitor IP']		= isset($_SERVER['HTTP_X_FORWARDED_FOR']) ? $_SERVER['HTTP_X_FORWARDED_FOR'] : $_SERVER['REMOTE_ADDR'];
		$data['Visitor IP']		= $this->_getClientIP();
		//$session 				= JFactory::getSession();
		$data['Affiliate Id']	= $invoice->getParam('idev_id');//$this->getAppParam('affiliate_id');
		//remove idev param from session
		//$session->clear('idev_id');
		$data['User Id']		= $invoice->getBuyer();
		
		$user					= PayplansUser::getInstance($data['User Id']);
		$data['User Name']		= $user->getRealname();
		$data['Email']			= $user->getEmail();
		
		$order = $invoice->getReferenceObject(PAYPLANS_INSTANCE_REQUIRE);
		if ($order instanceof PayplansOrder){
			$lastMaster 	= $order->getLastMasterInvoice();
			$userIdevParam  = $user->getParams()->get('idevaffiliate'.$invoiceId, '');
			
			if ($lastMaster == $invoiceId && !empty($userIdevParam)){
				$data['Visitor IP'] = $userIdevParam;
			}
		}
		
		return $data;
	}

	
	/*
	If REMOTE_ADDR is producing the server IP or wrong IP in general,
	adjust it to match the customer's IP address. You can check the
	IP address being received in the Incoming Traffic Log in your
	admin center.
	*/
	
	protected function _track($args){
		if (!empty($args)) {
		$url = $this->params->get('url');
		$ch = curl_init();
		$url="$url"."$args";
		$b = curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		$a = curl_exec($ch);
		$result['http_code'] = curl_getinfo($ch,CURLINFO_HTTP_CODE);
		$error = curl_error($ch);
		curl_close($ch);

		$data = $args.'===================='.$a.'========================='.$result['http_code'];
		file_put_contents(JPATH_SITE.DS.'tmp'.DS.time(), var_export($data,true), FILE_APPEND);
		}
	}

	protected static function _getClientIP()
    {
       $ip = "";
       $server = JFactory::getApplication()->input->server;
       if (!empty($server) ) {
           // get IP from HTTP Proxy or load-balancer
           $xfrwd = $server->get('HTTP_X_FORWARDED_FOR');
           $clientIp = $server->get('HTTP_CLIENT_IP');
           if (isset($xfrwd)) {
               $ip = $xfrwd;
           } elseif (isset($clientIp)) {
               $ip = $clientIp;
           } else {
               $ip = $server->get('REMOTE_ADDR');
           }
       } else {
           if (getenv('HTTP_X_FORWARDED_FOR')) {
               $ip = getenv('HTTP_X_FORWARDED_FOR' );
           } elseif (getenv('HTTP_CLIENT_IP')) {
               $ip = getenv('HTTP_CLIENT_IP');
           } else {
               $ip = getenv('REMOTE_ADDR');
           }
        }
       
  	 return $ip;
  }
	
	
	
}



