<?php
/**
* @copyright	Copyright (C) 2009 - 2009 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		PayPlans
* @subpackage	Jdownloads
* @contact 		shyam@readybytes.in
* 
*/
if(defined('_JEXEC')===false) die();

class PayplansAppJdownloads extends PayplansApp
{
	protected $_location	= __FILE__;
	protected $_resource	= 'com_jdownloads.group';
	
	public function _isApplicable(PayplansIfaceApptriggerable $refObject, $eventname='')
	{
		return JFolder::exists(JPATH_SITE .DS.'components'.DS.'com_jdownloads');
	}

	public function onPayplansSubscriptionAfterSave($prev, $new)
	{
		// no need to trigger if previous and current state is same
		if($prev != null && $prev->getStatus() == $new->getStatus()){
			return true;
		}
		
		$newStatus  = $new->getStatus();
		
		$active = $this->getAppParam('addToGroupOnActive');
		$active	= (is_array($active)) ? $active : array($active);
		
		$hold 	= $this->getAppParam('addToGroupOnHold');
		$hold	= (is_array($hold)) ? $hold : array($hold);
		
		$expire = $this->getAppParam('addToGroupOnExpire');
		$expire	= (is_array($expire)) ? $expire : array($expire);
			
		$subid  = $new->getId();
		$userid = $new->getBuyer();
		
		// if subscription is active
		if($newStatus == PayPlansStatus::SUBSCRIPTION_ACTIVE){
			$this->_removeFromGroup($userid, $hold, $subid);
			$this->_removeFromGroup($userid, $expire, $subid);
			$this->_addToGroup($userid, $active, $subid);
			
			return true;
		}
		
		//if subscription is hold
		if($newStatus == PayPlansStatus::SUBSCRIPTION_HOLD){
			$this->_removeFromGroup($userid, $active, $subid);
			$this->_removeFromGroup($userid, $expire, $subid);
			$this->_addToGroup($userid, $hold, $subid);
			
			return true;
		}
		// if subscription is active
		if($newStatus == PayPlansStatus::SUBSCRIPTION_EXPIRED){
			$this->_removeFromGroup($userid, $active, $subid);
			$this->_removeFromGroup($userid, $hold, $subid);
			$this->_addToGroup($userid, $expire, $subid);
			
			return true;
		}
		
		return true;
	}
	
	protected function _addToGroup( $userid, $groupids, $subid )
	{
		if(!is_array($groupids)){
			return false;
		}		

		foreach($groupids as $groupid){
			if(empty($groupid)){
				continue;
			}
			
			$users = $this->_getGroupMembers($groupid);
			
			if(in_array($userid, $users)){
				$this->_addToResource($subid, $userid, $groupid, $this->_resource);
				continue;
			}
			
			
			if($this->_setGroupMember($groupid, $userid)){
				$this->_addToResource($subid, $userid, $groupid, $this->_resource);
				$message = sprintf(XiText::_('COM_PAYPLANS_LOGGER_JDOWNLOADS_LOG_ADDED_TO_GROUP'), $userid, $groupid);
				$content = array( 'added_user'=>$userid , 'jdownloads_user_group' => $groupid);
				PayplansHelperLogger::log(XiLogger::LEVEL_INFO, $message, $this, $content);
			}
		}
		
		return true;
	}
	
	protected function _removeFromGroup( $userid, $groupids, $subid )
	{
		if(!is_array($groupids)){
			return false;
		}
		
		foreach($groupids as $groupid){
			if(empty($groupid)){
				continue;
			}
			
			$users = $this->_getGroupMembers($groupid);
			
			if(!in_array($userid,$users)){
				continue;
			}
					
			if($this->_removeFromResource($subid, $userid, $groupid, $this->_resource) 
					&& $this->_removeGroupMember($groupid, $userid)){
				$message = sprintf(XiText::_('COM_PAYPLANS_LOGGER_JDOWNLOADS_LOG_REMOVED_FROM_GROUP'), $userid, $groupid);
				$content = array( 'removed_user'=>$userid , 'jdownloads_user_group' => $groupid);
				PayplansHelperLogger::log(XiLogger::LEVEL_INFO, $message, $this, $content);
			}
		}
		
		return true;
	}
	
	protected function _getGroupMembers($groupid)
	{
		$db = JFactory::getDBO();

		$query = 'SELECT `groups_members`'
			. ' FROM #__jdownloads_groups'
			. ' WHERE `id` = \'' . $groupid . '\''
			;
		$db->setQuery( $query );
		$users = $db->loadResult();
		
		if(!empty($users)){
			$users = explode(',', $users);
		}
		return $users;
	}
	
	protected function _setGroupMember($groupid, $userid)
	{	
		$users = $this->_getGroupMembers($groupid);
		
		//if its not 1st user in group table
		if(!empty($users)){
			$userid	= (is_array($userid)) ? $userid : array($userid);
			$total_users = array_merge($users, $userid);
			$total_users = implode(',', $total_users);
		}
		else{
			$total_users = $userid;
		}
		$db = JFactory::getDBO();
		
		$query = 'UPDATE `#__jdownloads_groups`'
			. ' SET `groups_members` = "'. $total_users . '"'
			. ' WHERE `id` = "' . $groupid.'"';

		$db->setQuery( $query );
		return $db->query();
	}
	
	protected function _removeGroupMember($groupid, $userid)
	{
		$users = $this->_getGroupMembers($groupid);
		$userid	= (is_array($userid)) ? $userid : array($userid);
		
		$remaining_users = array_diff($users, $userid);
		$remaining_users = implode(',', $remaining_users);
		
		$db = JFactory::getDBO();
		
		$query = 'UPDATE `#__jdownloads_groups`'
			. ' SET `groups_members` = "'. $remaining_users . '"'
			. ' WHERE `id` = "' . $groupid.'"';
		
		$db->setQuery( $query );
		return $db->query();
	}
	
	//render Widget
	public function renderWidgetHtml()
	{   
		//get user id
		$userid     = XiFactory::getUser()->id;
		if(!$userid){
			return '';
		}
		//get user's jdownloads groups
	    $jdownloads_groups = $this->_getUserJdownloadsGroup($userid);
	    if(empty($jdownloads_groups)){
	    	return '';
	    }
	    $this->assign('jdownloads_groups',$jdownloads_groups);
        $data = $this->_render('widgethtml');
        return $data;
	}	
	
	//get jdownloads user group
	protected function _getUserJdownloadsGroup($userid)
	{
		$db         	  = JFactory::getDBO();
		$query      	  = 'SELECT `groups_name`, `groups_members`'
			          . ' FROM #__jdownloads_groups';
		$db->setQuery( $query );	
        $groupData  = $db->loadObjectList(`groups_name`);
        
        $jdownloadsGroups = array();
        
        foreach($groupData as $data){
        	
        	$groupMembers	= explode(',', $data->groups_members);
        	
        	if(in_array($userid,$groupMembers)){
	        	$jdownloadsGroups[]  = $data->groups_name;
        	}
        }
        return $jdownloadsGroups;
	}
	
	function getNameFromResourceValue($resource, $value)
	{
		// if its a different resource
		if($resource != $this->_resource){
			return false;
		}
		$db         = XiFactory::getDBO();		
		$query      = 'SELECT `groups_name`'
			          . ' FROM #__jdownloads_groups'
			          . ' WHERE `id` = "'. $value.'"';
		$db->setQuery( $query );
		return $db->loadResult();	
	
	}
}
