<?php
/**
 * @copyright	Copyright (C) 2009 - 2009 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * @package		PayPlans
 * @subpackage	jNews
 * @contact 	payplans@readybytes.in
 *
 */
if(defined('_JEXEC')===false) die();

class PayplansAppJnews extends PayplansApp
{
	protected $_location	= __FILE__;
	protected $_resource	= 'com_jnews.list';

	public function _isApplicable(PayplansIfaceApptriggerable $refObject, $eventname='' )
	{
		return JFolder::exists(JPATH_SITE .DS.'components'.DS.'com_jnews');
	}

	public function onPayplansSubscriptionAfterSave($prev, $new)
	{
		// no need to trigger if previous and current state is same
		if($prev != null && $prev->getStatus() == $new->getStatus()){
			return true;
		}

		$userid			= $new->getBuyer();
		$subid  		= $new->getId();
		$removeFromList = array();
		
		//when subscription status is active
		if($new->getStatus() == PayplansStatus::SUBSCRIPTION_ACTIVE){
			$removeFromList[]   = $this->getAppParam('addToListonHold');
			$removeFromList[]	= $this->getAppParam('addToListonExpire');
			$addToList 	    	= $this->getAppParam('addToListonActive');
			return $this->_addOrRemoveFromList($subid, $userid, $addToList, $removeFromList);
		}

		//when subscription status is hold
		if($new->getStatus() == PayplansStatus::SUBSCRIPTION_HOLD){
			$removeFromList[]   = $this->getAppParam('addToListonActive');
			$removeFromList[]	= $this->getAppParam('addToListonExpire');
			$addToList 		= $this->getAppParam('addToListonHold');
			return $this->_addOrRemoveFromList($subid, $userid, $addToList, $removeFromList);
		}
		
		//when subscription status is expire
		if($new->getStatus() == PayplansStatus::SUBSCRIPTION_EXPIRED){
			$removeFromList[]   = $this->getAppParam('addToListonActive');
			$removeFromList[]	= $this->getAppParam('addToListonHold');
			$addToList 		= $this->getAppParam('addToListonExpire');
			return $this->_addOrRemoveFromList($subid, $userid, $addToList, $removeFromList);
		}

	}
	
	function _addOrRemoveFromList($subid, $userid, $addToList, $removeFromList)
	{
		$is_allowed = false;

		$subscriber = $this->getSubscriberID($userid);

		if (!$subscriber) {
			$this->createSubscriber( $userid );
			$subscriber = $this->getSubscriberID( $userid );
		}

		if ( !$subscriber ) {
			return null;
		}

		$this->deleteFromList( $subid, $subscriber, $removeFromList, $userid);
		$this->addToList( $subid, $subscriber, $addToList, $userid);
	}

	function createSubscriber( $userid )
	{
		$db = &JFactory::getDBO();
		$user = XiFactory::getUser($userid);

		$query  = 'INSERT INTO #__jnews_subscribers'
				. ' (user_id, name, email, receive_html, confirmed, blacklist, timezone, language_iso, subscribe_date, params)'
				. ' VALUES(\'' . $userid . '\', \'' . $user->name . '\', \'' . $user->email . '\', \'1\', \'1\', \'0\', \'00:00:00\', \'eng\', \'' . date( 'Y-m-d H:i:s' ) . '\', \'\' )'
				;
		$db->setQuery( $query );
		$db->query();
	}

	function getSubscriberID( $userid )
	{
		$query = new XiQuery();
		return $query->select('`id`')
				->from('`#__jnews_subscribers`')
				->where('`user_id` = \'' . $userid . '\'')
				->dbLoadQuery()
				->loadResult()
				;
	}

	function addToList($subid, $subscriber_id, $list_ids, $userid )
	{
		if(empty($list_ids)){
			return true;
		}
		
		$list_ids = is_array($list_ids) ? $list_ids : array($list_ids); 
		$db = XiFactory::getDBO();
				
		$values = array();	
		foreach($list_ids as $id){
			$subscribers = $this->_getSubscribersList($id);
			
			//if subscriber already exists then addToResource only 
			if(in_array($subscriber_id, $subscribers)){
				$this->_addToResource($subid, $userid, $id, $this->_resource);
				continue;
			}

			$query  = 'INSERT INTO #__jnews_listssubscribers'
				. ' (subscriber_id, list_id, subdate)'
				. ' VALUES';
			$values  = '(\'' . $subscriber_id . '\', \'' . $id . '\', \'' . date( 'Y-m-d H:i:s',  time() ) . '\')';
			$query  .=  $values;
			
			$db->setQuery( $query );
			$db->query();

			$this->_addToResource($subid, $userid, $id, $this->_resource);
		}

		return true;
	}

	function deleteFromList($subid, $subscriber_id, $list_ids, $userid )
	{
		if(empty($list_ids)){
			return true;
		}
		
		$list_ids = is_array($list_ids) ? $list_ids : array($list_ids); 

		foreach ($list_ids as $list_id){
			if(is_array($list_id)){
				$this->deleteFromList($subid, $subscriber_id, $list_id, $userid);
			}
			
			else {
				if($this->_removeFromResource($subid, $userid, $list_id, $this->_resource)){
					$query = new XiQuery();
					$query->delete()
						  ->from('`#__jnews_listssubscribers`')
						  ->where('`subscriber_id` = ' .$subscriber_id .' ', 'AND')
						  ->where('`list_id` = ' .$list_id)
						  ->dbLoadQuery()
						  ->query();
				}
			}
		}
		
		return true;
	}
	
	protected function _getSubscribersList($listid)
	{
		$db = XiFactory::getDBO();

		$query = 'SELECT `subscriber_id`'
			. ' FROM #__jnews_listssubscribers'
			. ' WHERE `list_id` = \'' . $listid . '\''
			;
		$db->setQuery( $query );
		return $db->loadColumn();
	}
	
	//render Widget
	public function renderWidgetHtml()
	{   
		//get user id
		$userid     = XiFactory::getUser()->id;
		//get user's jnews lists
		$subcriberid   = $this->getSubscriberID($userid);
		
	    $jnews_lists = $this->_getUserJnewsList($subcriberid);
	 
	  	if(empty($jnews_lists)){
	    	return '';
	    }
	    $this->assign('jnews_lists',$jnews_lists);
        $data = $this->_render('widgethtml');
        return $data;
	}	
	
	protected function _getUserJnewsList($subscriberid)
	{
		$db = JFactory::getDBO();
		$user_lists = array();
		
		//Add Jnews List
		$query      = 'SELECT `list_name`,`list_id`,`list_type`'
			          . ' FROM #__jnews_listssubscribers as ls, #__jnews_lists as l'
			          . ' WHERE ls.`subscriber_id` = \'' . $subscriberid . '\' AND ls.`list_id` = l.`id`';
			       
        $db->setQuery( $query );
        $user_lists = $db->loadObjectList();
	 	
		return $user_lists;
	}
	
	function getNameFromResourceValue($resource, $value)
	{
		// if its a different resource
		if($resource != $this->_resource){
			return false;
		}
		
		$db         = XiFactory::getDBO();		
		$query      = 'SELECT `list_name`'
			          . ' FROM #__jnews_lists'
			          . ' WHERE `id` = "'. $value.'"';
		$db->setQuery( $query );
		return $db->loadResult();
	}

}
