<?php
/**
* @copyright	Copyright (C) 2009 - 2015 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		PayPlans
* @subpackage	JReview
* @contact 		support+payplans@readybytes.in
*/
if(defined('_JEXEC')===false) die();

class JFormFieldJreviewcategory extends XiField
{
	/**
	 * JReview
	 *
	 * @access	protected
	 * @var		string
	 */
	var	$type = 'jreviewcategory';

	function getInput()
	{			
		$cats = self::_getCategories();		

		return XiHTML::_('autocomplete.edit', $cats, $this->name, array('multiple'=>true), 'cat_id', 'cat_title', $this->value);
	}

	protected static function _getCategories()
	{		
		$db = XiFactory::getDBO();
		
		$query = "	SELECT
					Category.id AS cat_id,
					CONCAT(REPEAT('- ', IF(Category.level>0,Category.level - 1,1)), Category.title) AS cat_title
					FROM
					#__categories AS Category
					LEFT OUTER JOIN
					#__categories AS ParentCategory ON Category.lft <= ParentCategory.lft AND Category.rgt >= ParentCategory.rgt
					INNER JOIN
					#__jreviews_categories AS JreviewCategory ON JreviewCategory.id = Category.id AND JreviewCategory.`option` = 'com_content'
					WHERE
					Category.extension = 'com_content'
					GROUP BY
					Category.id
					ORDER
					BY Category.lft";
				
		return $db->setQuery($query)->loadObjectList('cat_id');
	}
}