<?php
/**
 * @copyright	Copyright (C) 2009 - 2009 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * @package		PayPlans
 * @subpackage	jreview
 * @contact 	payplans@readybytes.in
 * 
 */
if(defined('_JEXEC')===false) die();

class PayplansAppJreview extends PayplansApp
{
		protected $_location			= __FILE__;
		protected $_resource			= 'com_jreview.category';
		protected $_resource_image		= 'com_jreview.image';
		protected $_resource_attachment	= 'com_jreview.attachment';
		protected $_resource_audio		= 'com_jreview.audio';
		protected $_resource_video		= 'com_jreview.video';
		
		
	function onPayplansSubscriptionAfterSave($prev,$new)
	{
		if($prev == null){
			return true;
		}		
		$newStatus  = $new->getStatus();
		$prevStatus = $prev->getStatus();
		if($prevStatus == $newStatus){
			return true;
		}

		//add to resource on subscription active
		if($newStatus == PayplansStatus::SUBSCRIPTION_ACTIVE){
			$entryToAddIn 	   = $this->getAppParam('add_entry_in','any_category');
			$no_of_submisssion = $this->getAppParam('no_of_submisssion',  0);
			$no_of_images	   = $this->getAppParam('no_of_images',0);	
			$no_of_audio	   = $this->getAppParam('no_of_audio',0);
			$no_of_video	   = $this->getAppParam('no_of_video',0);
			$no_of_attachment  = $this->getAppParam('no_of_attachment',0);	
			$subid			   = $new->getId();
			$userid			   = $new->getBuyer();
			
			//for any category
			if($entryToAddIn == 'any_category'){
				$action = 1;
				$this->_addToResource($subid, $userid,0, $this->_resource, $no_of_submisssion);
				$this->_addToResource($subid, $userid,0, $this->_resource_image, $no_of_images);
				$this->_addToResource($subid, $userid,0, $this->_resource_audio, $no_of_audio);
				$this->_addToResource($subid, $userid,0, $this->_resource_video, $no_of_video);
				$this->_addToResource($subid, $userid,0, $this->_resource_attachment, $no_of_attachment);
				$this->_publishOrUnpublishEntry($userid, $no_of_submisssion,$action,0);
			}
			
			//for specific categories
			else{
				$action 			= 1;
				$restrictedcategory = $this->getAppParam('add_entry_in_category', 0);
				$restrictedcategory = (!is_array($restrictedcategory))? array($restrictedcategory) : $restrictedcategory;
				foreach ($restrictedcategory as $category){
					$this->_addToResource($subid, $userid, $category, $this->_resource, $no_of_submisssion);
					$this->_addToResource($subid, $userid, $category, $this->_resource_image, $no_of_images);
					$this->_addToResource($subid, $userid, $category, $this->_resource_audio, $no_of_audio);
					$this->_addToResource($subid, $userid, $category, $this->_resource_video, $no_of_video);
					$this->_addToResource($subid, $userid, $category, $this->_resource_attachment, $no_of_attachment);
					$this->_publishOrUnpublishEntry($userid, $no_of_submisssion,$action,$category);
				}
			}
		}
		
		//remove from resource on subscription expire/hold
		if( $prevStatus == PayplansStatus::SUBSCRIPTION_ACTIVE  && $newStatus != PayplansStatus::SUBSCRIPTION_ACTIVE ){ 
			$entryToAddIn 	   = $this->getAppParam('add_entry_in','any_category');
			$no_of_submisssion = $this->getAppParam('no_of_submisssion',  0);
			$no_of_images	   = $this->getAppParam('no_of_images',0);	
			$no_of_audio	   = $this->getAppParam('no_of_audio',0);
			$no_of_video	   = $this->getAppParam('no_of_video',0);
			$no_of_attachment  = $this->getAppParam('no_of_attachment',0);		
			$subid			   = $new->getId();
			$userid			   = $new->getBuyer();
			
			//for any category
			if($entryToAddIn == 'any_category'){
				$action = 0;
				$this->_removeFromResource($subid, $userid, 0, $this->_resource, $no_of_submisssion);
				$this->_removeFromResource($subid, $userid, 0, $this->_resource_image, $no_of_images);
				$this->_removeFromResource($subid, $userid, 0, $this->_resource_audio, $no_of_audio);
				$this->_removeFromResource($subid, $userid, 0, $this->_resource_video, $no_of_video);
				$this->_removeFromResource($subid, $userid, 0, $this->_resource_attachment, $no_of_attachment);
				$this->_publishOrUnpublishEntry($userid, $no_of_submisssion, $action,0);
				
			}
			
			//for specific categories
			else{
				$action 			= 0;
				$restrictedcategory = $this->getAppParam('add_entry_in_category', 0);
				$restrictedcategory = (!is_array($restrictedcategory))? array($restrictedcategory) : $restrictedcategory;
				foreach ($restrictedcategory as $category){
					$this->_removeFromResource($subid, $userid, $category, $this->_resource, $no_of_submisssion);
					$this->_removeFromResource($subid, $userid, $category, $this->_resource_image, $no_of_images);
					$this->_removeFromResource($subid, $userid, $category, $this->_resource_audio, $no_of_audio);
					$this->_removeFromResource($subid, $userid, $category, $this->_resource_video, $no_of_video);
					$this->_removeFromResource($subid, $userid, $category, $this->_resource_attachment, $no_of_attachment);
					$this->_publishOrUnpublishEntry($userid, $no_of_submisssion, $action,$category);					
				}
			}
		}
		return true;		
	}
		
	protected function _publishOrUnpublishEntry($userid, $publishCount, $action, $category)
	{
		// publish only those entries which are not currently published
		//and vice versa
		$complement = 1 - $action;
		$db    		= XiFactory::getDBO();
		
		
		if($category == '0'){
		//change enable state of all the fields related with the entry
		$query1 = ' UPDATE `#__content`'
				 .' SET `state`='.$action 
				 .' WHERE `created_by`='.$userid.' AND `state`='.$complement
				 .' ORDER BY `publish_up`'
				 .' LIMIT '.$publishCount;
				
		$db->setQuery( $query1 );
		$db->query();
		}
		else{
			$query2 = ' UPDATE `#__content`'
				 	 .' SET `state`='.$action 
				     .' WHERE `created_by`='.$userid.' AND `state`='.$complement
				 	 .' ORDER BY `publish_up`'
				 	 .' LIMIT '.$publishCount;

		$db->setQuery( $query2 );
		$db->query();
		}
	}
	
	
	
	//render Widget
	public function renderWidgetHtml()
	{   
		//get user id
		$userid = XiFactory::getUser()->id;
		if(!$userid){
			return true;
		}

		$data = array(	'listing'		=> array()	
						,'image' 		=> array()
						,'attachment' 	=> array()
						,'audio' 		=> array()
						,'video' 		=> array()	
				);

		$restrictedcategory = $this->getallowedsubmission($userid);
		
		if(empty($restrictedcategory)){
			return true;
		}
		
		$categoryRecords 	= $this->getcategory($restrictedcategory);
		
		$categoryRecords[0] = (object)array('title' => 'Total' , 'id'=>0); 
		
		foreach ($restrictedcategory as $category )
		{
			$data['listing'][$categoryRecords[$category]->title]['allowed'] 	= plgPayplansJreview::getUserResourceOfCategory($category, $userid);
			$data['image'][$categoryRecords[$category]->title]['allowed'] 		= plgPayplansJreview::getUserResourceOfCategory($category, $userid, true ,'photo');
			$data['attachment'][$categoryRecords[$category]->title]['allowed']	= plgPayplansJreview::getUserResourceOfCategory($category, $userid, true ,'attachment');
			$data['audio'][$categoryRecords[$category]->title]['allowed']		= plgPayplansJreview::getUserResourceOfCategory($category, $userid, true ,'audio');
			$data['video'][$categoryRecords[$category]->title]['allowed']		= plgPayplansJreview::getUserResourceOfCategory($category, $userid, true ,'video');
			
			$data['listing'][$categoryRecords[$category]->title]['consumed'] 	= plgPayplansJreview::getUserEntriesInCategory($category,$userid);
			$data['image'][$categoryRecords[$category]->title]['consumed'] 		= plgPayplansJreview::getUserMediaEntries($category,$userid,false,'photo');
			$data['attachment'][$categoryRecords[$category]->title]['consumed']	= plgPayplansJreview::getUserMediaEntries($category,$userid,false,'attachment');
			$data['audio'][$categoryRecords[$category]->title]['consumed']		= plgPayplansJreview::getUserMediaEntries($category,$userid,false,'audio');
			$data['video'][$categoryRecords[$category]->title]['consumed']		= plgPayplansJreview::getUserMediaEntries($category,$userid,false,'video');
		}
		
		$this->assign('render_data', $data);
		return  $this->_render('widgethtml');
		

	}
	
	//get category recoeds for categories in app
	function getcategory($catergories)
	{            
		if(empty($catergories)){
			return array();
		}
		$query 		     = new XiQuery();
		$cat_in			 = implode(",", $catergories);
		return $query->select('title,id')
						     ->from('`#__categories`')
						     ->where('`id` IN('.$cat_in.')')
						     ->dbLoadQuery()
						     ->loadObjectList('id');
	}
	
	function getallowedsubmission($userId)
	{
		$query = new XiQuery();
		return $query->select('value')
						->from('`#__payplans_resource`')
						->where("`title` = 'com_jreview.category'")
						->where('`user_id` ='.$userId)
						->dbLoadQuery()
						->loadColumn();
	}
}

class PayplansAppJreviewFormatter extends PayplansAppFormatter
{
	//get Rules 
	function getVarFormatter()
	{
		$rules = array();		
		return $rules;
	}
}