<?php
/**
* @copyright	Copyright (C) 2009 - 2009 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		PayPlans
* @subpackage	JUGA
* @contact 		shyam@readybytes.in
* 
*/
if(defined('_JEXEC')===false) die();

class PayplansAppJuga extends PayplansApp
{
	protected $_location	= __FILE__;
	protected $_resource	= 'com_juga.group';
	
	public function _isApplicable(PayplansIfaceApptriggerable $refObject, $eventname='')
	{
		return JFolder::exists(JPATH_SITE .DS.'components'.DS.'com_juga');
	}
	
	public function onPayplansSubscriptionAfterSave($prev, $new)
	{
		// no need to trigger if previous and current state is same
		if($prev != null && $prev->getStatus() == $new->getStatus()){
			return true;
		}
		
		$newStatus  = $new->getStatus();
		
		$active = $this->getAppParam('addToGroupOnActive');
		$active	= (is_array($active)) ? $active : array($active);
		
		$hold 	= $this->getAppParam('addToGroupOnHold');
		$hold	= (is_array($hold)) ? $hold : array($hold);
		
		$expire = $this->getAppParam('addToGroupOnExpire');
		$expire	= (is_array($expire)) ? $expire : array($expire);
			
		$subid  = $new->getId();
		$userid = $new->getBuyer();
		
		// if subscription is active
		if($newStatus == PayplansStatus::SUBSCRIPTION_ACTIVE){
			$this->_removeFromGroup($userid, $hold, $subid);
			$this->_removeFromGroup($userid, $expire, $subid);
			$this->_addToGroup($userid, $active, $subid);
			
			return true;
		}
		
		//if subscription is hold
		if($newStatus == PayplansStatus::SUBSCRIPTION_HOLD){
			$this->_removeFromGroup($userid, $active, $subid);
			$this->_removeFromGroup($userid, $expire, $subid);
			$this->_addToGroup($userid, $hold, $subid);
			
			return true;
		}
		// if subscription is active
		if($newStatus == PayplansStatus::SUBSCRIPTION_EXPIRED){
			$this->_removeFromGroup($userid, $active, $subid);
			$this->_removeFromGroup($userid, $hold, $subid);
			$this->_addToGroup($userid, $expire, $subid);
			
			return true;
		}
		
		return true;
	}
	
	protected function _addToGroup( $userid, $groupids, $subid )
	{
		if(!is_array($groupids)){
			return false;
		}		

		foreach($groupids as $groupid){
			if(empty($groupid)){
				continue;
			}
			
			$users = $this->_getGroupMembers($groupid);
			
			if(in_array($userid, $users)){
				$this->_addToResource($subid, $userid, $groupid, $this->_resource);
				continue;
			}
			
			
			if($this->_setGroupMember($groupid, $userid)){
				$this->_addToResource($subid, $userid, $groupid, $this->_resource);
			}
		}
		
		return true;
	}
	
	protected function _removeFromGroup( $userid, $groupids, $subid )
	{
		if(!is_array($groupids)){
			return false;
		}
		
		foreach($groupids as $groupid){
			if(empty($groupid)){
				continue;
			}
			
			$users = $this->_getGroupMembers($groupid);

			if(!in_array($userid,$users)){
				continue;
			}
					
			$this->_removeFromResource($subid, $userid, $groupid, $this->_resource);
			$this->_removeGroupMember($groupid, $userid);
		}
		
		return true;
	}
	
	protected function _getGroupMembers($groupid)
	{
		$db = JFactory::getDBO();

		$query = 'SELECT `user_id`'
			. ' FROM #__juga_u2g'
			. ' WHERE `group_id` = \'' . $groupid . '\''
			;
		$db->setQuery( $query );
		return $db->loadColumn();
	}
	
	protected function _setGroupMember($groupid, $userid)
	{
		$db = JFactory::getDBO();
		
		$now = new XiDate();
		$createdDate = $now-> toMySQL();

		$query = 'INSERT INTO `#__juga_u2g`'
			. ' (`user_id`, `group_id`, `created_datetime`)'
			. ' VALUES ( "' . $userid . '", "' . $groupid. '", "'. $createdDate.'")';

		$db->setQuery( $query );
		return $db->query();
	}
	
	protected function _removeGroupMember($groupid, $userid)
	{
		$db = JFactory::getDBO();

		$user = XiFactory::getUser($userid);
		
		$query = 'DELETE FROM `#__juga_u2g` '
				.' WHERE `user_id` = "' . $userid.'" '
				.' AND `group_id` = "' . $groupid.'"';
		
		$db->setQuery( $query );
		return $db->query();
	}
	
	//render Widget
	public function renderWidgetHtml()
	{   
		//get user id
		$userid     = XiFactory::getUser()->id;
		if(!$userid){
			return '';
		}
		//get user's juga groups
	    $juga_groups = $this->_getUserJugaGroup($userid);
	    if(empty($juga_groups)){
	    	return '';
	    }
	    $this->assign('juga_groups',$juga_groups);
        $data = $this->_render('widgethtml');
        return $data;
	}	
	
	//get juga user group
	protected function _getUserJugaGroup($userid)
	{
		$db         = JFactory::getDBO();
		$jugaGroups = array();
		$query      = 'SELECT `title`'
			          . ' FROM #__juga_u2g, #__juga_groups'
			          . ' WHERE `user_id` = \'' . $userid . '\' AND `group_id` = `id`';
		$db->setQuery( $query );	
        $jugaGroups  = $db->loadColumn();
        return $jugaGroups;
	}
	
	function getNameFromResourceValue($resource, $value)
	{
		// if its a different resource
		if($resource != $this->_resource){
			return false;
		}
		$db         = XiFactory::getDBO();		
		$query      = 'SELECT `title`'
			          . ' FROM #__juga_groups'
			          . ' WHERE `id` = "'. $value.'"';
		$db->setQuery( $query );
		return $db->loadResult();	
	
	}
	
	public static function getJugaGroups()
	{
		$query = new XiQuery();
		return $query->select(' `id` as group_id, `title` ')
		             ->from('`#__juga_groups`')
		             ->dbLoadQuery()
		             ->loadObjectList('group_id');
	}
}


class PayplansAppJugaFormatter extends PayplansAppFormatter
{
	//get Rules 
	function getVarFormatter()
	{
		$rules = array('_appplans'       => array('formatter'=> 'PayplansAppFormatter',
										       'function' => 'getAppPlans'),
					   'app_params'      => array('formatter'=> 'PayplansAppJugaFormatter',
										       'function' => 'getFormattedParams'));
		
		return $rules;
	}
	
	function getFormattedParams($key, $value, $data)
	{
		//do nothing if component is not installed
		if(!JFolder::exists(JPATH_SITE .DS.'components'.DS.'com_juga')){
				return false;
		}
		
		$value['addToGroupOnActive']	= $this->getGroupName($value['addToGroupOnActive']);
		$value['addToGroupOnHold']  	= $this->getGroupName($value['addToGroupOnHold']);
		$value['addToGroupOnExpire']	= $this->getGroupName($value['addToGroupOnExpire']);
	
	}
	
	function getGroupName($values)
	{
		$groups  = PayplansAppJuga::getJugaGroups();
		foreach ($values as $value)
		{
			$group[]	= $groups[$value]->title;
		}
		
		return implode(',', $group);
	}
}