<?php

/**
* @copyright	Copyright (C) 2009 - 2015 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		Payplans
* @subpackage	K2
* @contact		support+payplans@readybytes.in
*/
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

/**
 * Payplans K2 Plugin
 *
 */
class plgPayplansK2 extends XiPlugin
{
	const DO_NOTHING = -1;
	const ALLOWED 	 =  1;
	const BLOCKED    =  0;

	public function onPayplansSystemStart()
	{
		//add discount app path to app loader
		$appPath = dirname(__FILE__).DS.'k2'.DS.'app';
		PayplansHelperApp::addAppsPath($appPath);

		return true;
	}

	function onK2PrepareContent($item, $params, $limitstart)
	{
		$args = array(&$item, &$params, $limitstart);
		return PayplansHelperApp::trigger('onK2PrepareContent', $args);
	}
	
	static function isUserAllowed($item,$appName, $appParmeter)
	{
		    $k2Apps = PayplansHelperApp::getAvailableApps($appName);
  	 	    $appResult  = array();
            $userid = XiFactory::getUser()->id;
			$user = PayplansUser::getInstance($userid);
	  	    //check which app allow category, which not allow and which app do nothing
		    foreach($k2Apps as $app)
		    {

				$allowedItemByApp =  $app->getAppParam($appParmeter, 0);
	
				if(!is_array($allowedItemByApp)){
					$allowedItemByApp   = array($allowedItemByApp);
				}
	
			 	//if app is not applicable on that category 
			 	if(count(array_intersect($item, $allowedItemByApp)) == 0){
			 		$appResult[]    = self::DO_NOTHING;
			 		continue;
			 	}

			 	if(!$user->getId()){
			 		$appResult[] = self::BLOCKED;
			 		continue;
			 	}

	  	 	 	$subs       = $user->getPlans();
	  	 	 	//if user has no plans
	         	if(empty($subs)){
	           		$appResult[]  = self::BLOCKED;
	           		continue;
	          	}
	         
				// if user has plans and app is core app 
			 	if(!empty($subs) && $app->getParam('applyAll',false) != false){
			 		$appResult[]  = self::ALLOWED;
	           		continue;
			 	}
	
				//if user has app plans
				$appPlans = $app->getPlans();
				if(array_intersect($subs, $appPlans) != false){
					 $appResult[]  = self::ALLOWED;
	        	  	 continue;
				}
				else {
				   $appResult[]  = self::BLOCKED;
				}
		   }
	       return $appResult;
	}
}

