<?php
/**
* @copyright	Copyright (C) 2009 - 2016 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		PayPlans
* @subpackage	MailChimp
* @contact 		support+payplans@readybytes.in
*/
if(defined('_JEXEC')===false) die();

class JFormFieldXimailchimplist extends XiField
{
    	public $type = 'Ximailchimplist'; 
        function getInput()
	{			
		$lists = self::_getMailchimpList();
		if(empty($lists)){
			return XiText::_('COM_PAYPLANS_APP_MAILCHIMP_NO_LIST_EXISTS_FOR_API_KEY');
		}
        $value = is_array($this->value) ? $this->value : array($this->value);
		return XiHTML::_('autocomplete.edit',$lists, $this->name, array('multiple'=>true), 'id', 'name', $value);
	}

	protected static function _getMailchimpList()
	{  
		$lists = array();
		$appId = JRequest::getVar('id',0);
		if($appId == 0){
			return $lists;
		}
		$mailChimpApp = PayplansApp::getInstance($appId);
		$apiKey = $mailChimpApp->getAppParam('mailchimpApiKey');
        	$DataCenter = substr($apiKey, strrpos($apiKey, '-') + 1);
		if(empty($apiKey)){
			return  $lists;
		}

		$merchantemail =$mailChimpApp->getAppParam('mailchimpMerchantEmail');
		$header = array(
			"Authorization: Basic " . base64_encode($merchantemail.':'. $apiKey),

		);
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, 'https://'.$DataCenter.'.api.mailchimp.com/3.0/lists');
		curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
		curl_setopt($ch, CURLOPT_HEADER, 0);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		$output = curl_exec($ch);

		$retval = (array)json_decode($output);
		if($retval != false){
			foreach($retval['lists'] as $data){
				$id = $data->id;
				$lists[$id] = array('id'=>$data->id,
					'name'=>$data->name);
			}
		}
		return $lists;
	}
}
