<?php

/**
* @copyright	Copyright (C) 2009 - 2009 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		Payplans
* @subpackage	Mailster Newaletter
* @contact		payplans@readybytes.in
*/
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

/**
 * Payplans Mailster Plugin
 */
class PayplansAppMailster extends PayplansApp
{
	protected $_location	= __FILE__;
	protected $_resource	= 'com_mailster.group';

	public function _isApplicable(PayplansIfaceApptriggerable $refObject, $eventname='')
	{
		return JFolder::exists(JPATH_SITE .DS.'components'.DS.'com_mailster');
	}

	public function onPayplansSubscriptionAfterSave($prev, $new)
	{
		// no need to trigger if previous and current state is same
		if($prev != null && $prev->getStatus() == $new->getStatus()){
			return true;
		}		
		$subid  = $new->getId();		
		$userid = $new->getBuyer();
		
		//when subscription status is active
		if($new->getStatus() == PayplansStatus::SUBSCRIPTION_ACTIVE)
		{
			$hold		 = $this->getAppParam('addToGrouponHold');
			$expire		 = $this->getAppParam('addToGrouponExpire');
			$active 	 = $this->getAppParam('addToGrouponActive');
			
			$this->_RemoveFromMailsterGroup($userid, $hold, $subid);
			$this->_RemoveFromMailsterGroup($userid, $expire, $subid);
			return $this->_AddToMailsterGroup($userid, $active, $subid);		
		}

		//when subscription status is hold
		if($new->getStatus() == PayplansStatus::SUBSCRIPTION_HOLD)
		{
			$hold		 = $this->getAppParam('addToGrouponHold');
			$expire		 = $this->getAppParam('addToGrouponExpire');
			$active 	 = $this->getAppParam('addToGrouponActive');

			$this->_RemoveFromMailsterGroup($userid, $active, $subid);
			$this->_RemoveFromMailsterGroup($userid, $expire, $subid);
			return $this->_AddToMailsterGroup($userid, $hold, $subid);
		}
		
		//when subscription status is expire
		if($new->getStatus() == PayplansStatus::SUBSCRIPTION_EXPIRED)
		{
			$hold		 = $this->getAppParam('addToGrouponHold');
			$expire		 = $this->getAppParam('addToGrouponExpire');
			$active 	 = $this->getAppParam('addToGrouponActive');

			$this->_RemoveFromMailsterGroup($userid, $hold, $subid);
			$this->_RemoveFromMailsterGroup($userid, $active, $subid);
			return $this->_AddToMailsterGroup($userid, $expire, $subid);
		}
	}
	
	function _RemoveFromMailsterGroup($userid, $groupids, $subid)
	{
		if(!is_array($groupids)){
			$groupids = array($groupids);
		}
		
		foreach($groupids as $groupid){
			
			//nothing to do when group array is empty.
			if(empty($groupid)){
				continue;
			}		
			
			$this->_removeFromResource($subid, $userid, $this->getGroupName($groupid), $this->_resource);
			$this->_removeFromGroup($groupid, $userid);
		}
		return true;
	}
	
	function _AddToMailsterGroup($userid, $groupids, $subid)
	{			
		if(!is_array($groupids)){
			$groupids = array($groupids);
		}
		
		foreach($groupids as $groupid){

			//nothing to do when group array is empty.
			if(empty($groupid)){
				continue;
			}

			$db = XiFactory::getDBO();
			$db->setQuery('SELECT `user_id`'
						.' FROM #__mailster_group_users'
						.' WHERE `group_id` = "'.$groupid.'" AND `user_id`="'.$userid.'"');
					
			$users 		= $db->loadResult();
			if(!count($users)){
				$this->_addToGroup($groupid, $userid);
			}

			$this->_addToResource($subid, $userid, $this->getGroupName($groupid), $this->_resource);
		}
	}

	function _removeFromGroup($removeFromGruop, $userid)
	{
		$db = XiFactory::getDbo();
		$query = 'DELETE FROM `#__mailster_group_users`'
				 .' WHERE `user_id`='.$userid.' AND `group_id`='.$removeFromGruop.'';
		$db->setQuery( $query );
		return $db->query();
	}

	function _addToGroup($groupid, $userid)
	{
		$db    = XiFactory::getDbo();		
		$query = 'INSERT INTO `#__mailster_group_users`'
				 .'values('.$groupid.','.$userid.',1)';
		$db->setQuery( $query );
		$db->query();
	}

	function getGroupName($groupid)
	{		
		$query = new XiQuery();
		return $query->select('name')
					 ->from('`#__mailster_groups`')
					 ->where('id = '.$groupid)
					 ->dbLoadQuery()
					 ->loadResult('name');
	}
}

class PayplansAppMailsterFormatter extends PayplansAppFormatter
{
	//get Rules 
	function getVarFormatter()
	{
		$rules = array();
		return $rules;
	}
}
