<?php

/**
* @copyright	Copyright (C) 2009 - 2015 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		Payplans
* @subpackage	Module Access
* @contact		support+payplans@readybytes.in
*/
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

/**
 * Payplans Module Access Plugin
 *
 * @author support+payplans
 */
class plgPayplansModuleAccess extends XiPlugin
{
	public function onPayplansSystemStart()
	{
		$dir = dirname(__FILE__).DS.'moduleaccess'.DS.'app';
		PayplansHelperApp::addAppsPath($dir);
		return true;
	}
	
	public function onAfterModuleList(&$modules)
	{
		//Step 1:- Select user plan
		$user	= XiFactory::getUser();
		$userPlans = PayplansUser::getInstance($user->id)->getPlans(PayPlansStatus::SUBSCRIPTION_ACTIVE);
		
		//step 2:- select all module-access type apps
		$moduleAccessApp = PayplansHelperApp::getAvailableApps('moduleaccess');
		
		//step 3:- select those modules which we want to display or hide according to app
		$display = $hide = array();
		foreach($moduleAccessApp as $moduleAccessAppId=>$app)
		{
			$applyAll = $app->getParam('applyAll', 0);
			$app_modules = $app->getAppParam('AllowedModules');
			$app_modules	= (is_array($app_modules)) ? $app_modules : array($app_modules);
			
			if($applyAll){
				if(!empty($userPlans)){
					$display = array_merge($display, $app_modules);
				}else {
					$hide = array_merge($hide, $app_modules);
				}
			}
			else {
				$app_plans = $app->getPlans();
				
				if(array_intersect($userPlans, $app_plans)){
					$display = array_merge($display, $app_modules);
				}else{
					$hide = array_merge($hide, $app_modules);
				}
			}
		}
		
		//step 4:- remove allowed modules from hide list
		$hide = array_diff($hide, $display);	
		
        //step 5:- remove modules which are in hide list 
		foreach ($modules as $key => $module)
		{
			if(in_array($module->id, $hide))
			{
				unset($modules[$key]);
			}
		}
		$modules = array_values($modules);	
	}
	
}

