<?php
/**
* @copyright	Copyright (C) 2009 - 2009 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		Payplans
* @subpackage	Discount
* @contact 		shyam@readybytes.in
*/
if(defined('_JEXEC')===false) die();


/**
 * Module Access System
 * @author Puneet
 */
class PayplansAppModuleAccess extends PayplansApp
{
	//inherited properties
	protected $_location	= __FILE__;
	
	public static function getmodules()
	{
		static $modules;

		if (isset($modules)) {
			return $modules;
		}

		$user	= XiFactory::getUser();
		$db		= XiFactory::getDBO();

		$aid	= $user->get('aid', 0);

		$modules	= array();

		$wheremenu = isset( $Itemid ) ? ' AND ( mm.menuid = '. (int) $Itemid .' OR mm.menuid = 0 )' : '';

		static $clean;

		if (isset($clean)) {
			return $clean;
		}

		$Itemid 	= JRequest::getInt('Itemid');
		$app		= JFactory::getApplication();
		$user		= JFactory::getUser();
		$groups		= implode(',', $user->getAuthorisedViewLevels());
		$lang 		= JFactory::getLanguage()->getTag();
		$clientId 	= (int) $app->getClientId();

		$db	= XiFactory::getDbo();

		$query = $db->getQuery(true);
		$query->select('m.id, m.title');
		$query->from('#__modules AS m');
		$query->where('m.published = 1');

		$query->join('LEFT', '#__extensions AS e ON e.element = m.module AND e.client_id = m.client_id');
		$query->where('e.enabled = 1');

		$date = new Xidate();
		$now  = $date->toMySQL();
		$nullDate = $db->getNullDate();
		$query->where('(m.publish_up = '.$db->Quote($nullDate).' OR m.publish_up <= '.$db->Quote($now).')');
		$query->where('(m.publish_down = '.$db->Quote($nullDate).' OR m.publish_down >= '.$db->Quote($now).')');

		$query->where('m.access IN ('.$groups.')');
		$query->where('m.client_id = 0');

		// Filter by language
		if ($app->isSite() && $app->getLanguageFilter()) {
			$query->where('m.language IN (' . $db->Quote($lang) . ',' . $db->Quote('*') . ')');
		}

		$query->order('m.title');

		$db->setQuery( $query );
		
		//XITODO: use Xi Error
		if (null === ($modules = $db->loadObjectList('id'))) {
			JError::raiseWarning( 'SOME_ERROR_CODE', JText::_( 'Error Loading Modules' ) . $db->getErrorMsg());
			return false;
		}

		return $modules;
	}

	function collectAppParams(array $data)
	{
		if(!isset($data['app_params']['AllowedModules'])){
			$data['app_params']['AllowedModules'] = array();
		}
		
		return parent::collectAppParams($data);
	}
}

