<?php
/**
 * monetaweb
 * this app is payment gateway for monetaweb.
 * @copyright Copyright (C) 2009 - 2016 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
 * @license GNU/GPL, see LICENSE.php
 * @package payplans
 * @version 1.0.0
 * @author Team Readybytes <support+payplans@readybytes.in>
 */

if(defined( '_JEXEC' )==false) {
	die( 'Restricted access' );
}

class PayplansAppmonetaweb extends PayplansAppPayment
{

	//inherited properties
	protected $_location = __FILE__;

	public function isApplicable($refObject = null, $eventName = '')
	{
		if ($eventName == 'onPayplansControllerCreation') {
			return true;
		}
		return parent::isApplicable($refObject, $eventName);
	}

	function onPayplansPaymentForm(PayplansPayment $payment, $data = null)
	{

		$invoice 		= $payment->getInvoice(PAYPLANS_INSTANCE_REQUIRE);
		$id 			= $this->getAppParams()->get('id', '');
		$password 		= $this->getAppParams()->get('password', '');
		$sandbox 		= $this->getAppParams()->get('sandbox', false);
		if($sandbox){
			$requestUrl = 'https://test.monetaonline.it/monetaweb/payment/2/xml';
		}
		else{
			$requestUrl = 'https://www.monetaonline.it/monetaweb/payment/2/xml';
		}
		$amount 		= $invoice->getTotal();

		$lang 			= XiHelperJoomla::getLanguageCode();

		$notification_url 	= urlencode(JURI::root().'index.php?option=com_payplans&gateway=monetaweb&view=payment&task=notify&payment_key='.$payment->getKey());
		$merchantOrderId 	= $payment->getKey();
		$operationType 		= 'initialize';
		$recoveryUrl 		= urlencode(JURI::root().'index.php?option=com_payplans&view=payment&task=complete&action=cancel&payment_key='.$payment->getKey());
		$user 				= $payment->getBuyer(PAYPLANS_INSTANCE_REQUIRE);
		$email 				= $user->getEmail();

		$requestData = "id=$id&password=$password&operationType=$operationType&amount=$amount&language=$lang[language]&responseToMerchantUrl=$notification_url&recoveryUrl=$recoveryUrl&merchantOrderId=$merchantOrderId&cardHolderEmail=$email";

		$link 			= new JURI($requestUrl);
		$curl 			= new JHttpTransportCurl(new JRegistry());
		$curl_result 		= $curl->request('POST', $link,$requestData);

		$response = (array)simplexml_load_string($curl_result->body);
		if(isset($response['paymentid'])) {
			$this->assign('post_url', $response['hostedpageurl'].'?PaymentID='.$response['paymentid']);
			return $this->_render('form_standard');
		}
		else{
			$this->assign('code', $response['errorcode']);
			$this->assign('errormessage', $response['errormessage']);
			return $this->_render('error');
		}

	}
	function onPayplansPaymentAfter(PayplansPayment $payment, &$action, &$data, $controller)
	{
		if($action == 'cancel'){
			$error_status 	= $payment->getGatewayParam('error_status');
			$error_code 	= $payment->getGatewayParams('errorcode');
			if($error_status != 'CANCELED') {

				$this->assign('code', $error_code);
				$this->assign('errormessage', $error_status);
				$action = 'error';
			}
		}
		return parent::onPayplansPaymentAfter($payment, $action, $data, $controller);
	}


	public function onPayplansPaymentNotify(PayplansPayment $payment, $data, $controller)
	{
		$validation    	= $this->_validateResponse($data, $payment);
		$response 		= $data;
		if($validation) {

			$resultPageUrl= JURI::root().'index.php?option=com_payplans&gateway=monetaweb&view=payment&task=complete&action=success&payment_key='.$payment->getKey();
			ob_end_clean();
			ob_start();
			// Send your response.
			echo $resultPageUrl;
			// Get the size of the output.
			$size = ob_get_length();
			// Disable compression (in case content length is compressed).
			header("Content-Encoding: none");
			// Set the content length of the response.
			header("Content-Length: {$size}");
			// Close the connection.
			header("Connection: close");
			// Flush all output.
			ob_end_flush();
			ob_flush();
			flush();

			$invoice = $payment->getInvoice(PAYPLANS_INSTANCE_REQUIRE);
			// if same notification came more than one time
			// Check if transaction already exists,if yes then do nothing and return
			$txn_id = isset($response['paymentid']) ? $response['paymentid'] : 0;
			$subscr_id = isset($response['subscriptionid']) ? $response['subscriptionid'] : 0;
			$parent_id = isset($response['subscriptionid']) ? $response['subscriptionid'] : 0;
			$transactions = $this->_getExistingTransaction($invoice->getId(), $txn_id, $subscr_id, $parent_id);
			if (!empty($transactions)) {
				foreach ($transactions as $transaction) {
					$transaction = PayplansTransaction::getInstance($transaction->transaction_id, null, $transaction);
					if ($transaction->getParam('result', '') == $response['result']) {
						return true;
					}
				}
			}
			// get the transaction instace of lib
			$transaction = PayplansTransaction::getInstance();
			$transaction->set('user_id', $payment->getBuyer())
				->set('invoice_id', $invoice->getId())
				->set('payment_id', $payment->getId())
				->set('gateway_txn_id', $txn_id)
				->set('gateway_subscr_id', $subscr_id)
				->set('gateway_parent_txn', $parent_id)
				->set('params', PayplansHelperParam::arrayToIni($response));

			//set the transaction message as per status

			if ($response['result'] == 'CAPTURED' && $response['responsecode'] == '000') {
				$transaction->set('amount', $invoice->getTotal())
					->set('message', 'COM_PAYPLANS_APP_MONETAWEB_TRANSACTION_COMPLETED');

				return $transaction->save();

			}

		}
		else{
		$resultPageUrl= JURI::root().'index.php?option=com_payplans&view=payment&task=complete&action=cancel&payment_key='.$payment->getKey();
		ob_end_clean();
		ob_start();
		// Send your response.
		echo $resultPageUrl;
		// Get the size of the output.
		$size = ob_get_length();
		// Disable compression (in case content length is compressed).
		header("Content-Encoding: none");
		// Set the content length of the response.
		header("Content-Length: {$size}");
		// Close the connection.
		header("Connection: close");
		// Flush all output.
		ob_end_flush();
		ob_flush();
		flush();
		return false;
		}
	}
	protected function _validateResponse($response, $payment)
	{
		if($response['result'] == 'CAPTURED' && $response['responsecode'] == '000'){
			return true;
		}
		else {
			$message = XiText::_('COM_PAYPLANS_LOGGER_MONETAWEB_ERROR_OCCURED_IN_PAYMENT_CREATION');
			$error = $response;
			PayplansHelperLogger::log(XiLogger::LEVEL_ERROR, $message, $payment, array($error), 'PayplansPaymentFormatter', '', true);
			$payment->getGatewayParams()->set('error_status', isset($response['result']) ? $response['result'] : $response['errormessage']);
			$payment->getGatewayParams()->set('error_code', isset($response['errorcode']) ? $response['errorcode'] : 0);
			$payment->save();
		}

		return false;
	}
}
