<?php
/**
* @copyright	Copyright (C) 2009 - 2009 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @contact		payplans@readybytes.in
*/
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );


/**
 * Payplans Mosets Tree Plugin
 * PayPlans
 */

jimport('joomla.filesystem.path');
jimport( 'joomla.plugin.plugin' );

class plgSystemMtreepayplans extends JPlugin
{
	const ALLOWED 	 =  1;
	const BLOCKED    =  0;
	
	function __construct(& $subject, $config = array())
	{
		parent::__construct($subject, $config);
	}
	
	public function onPayplansSystemStart()
	{
		//add app path to app loader
		$appPath = dirname(__FILE__).DS.'mtreepayplans'.DS.'app';
		PayplansHelperApp::addAppsPath($appPath);
		
		return true;
	}

	function onContentAfterSave($resourceName, $link, $isNew)
	{
		$option = JRequest::getVar('option');
		$view 		= JRequest::getVar('view', null);
		$task 		= JRequest::getVar('task', null);

		if(($option == 'com_mtree' && $view == 'addlisting') || ($option == 'com_mtree' && $task == 'approve_publish_links')){
			$link_id = $link->get('link_id');
			self::onSaveMTreeListing($link_id);
		}
	}
	
	function onSaveMTreeListing($link_id)
		{
			$args = array($link_id);
			PayplansHelperEvent::trigger('onPayplansUpdateFeaturing', $args);
			return true;	
		}
		
	
	function onPayplansAccessCheck(PayplansUser $user)
	{
		$factoryApp = XiFactory::getApplication();
		$component 	= JRequest::getVar('option');
		$view 		= JRequest::getVar('view', null);
		$task 		= JRequest::getVar('task', null);
		// block user to add  new list only
		if($component != 'com_mtree'){
			return false;
		}
 		// in moset2.x series task is addlisting and in moset3.x series view is addlisting
        if(($view == 'addlisting') || $task == 'addlisting'){
			$userPlans = $user->getPlans();

			// when user does not have the required plan(plan attached with the app)
			if(empty($userPlans)){
				$msg = XiText::_('COM_PAYPLANS_APP_MTREE_SELECT_PLAN');
				$factoryApp->redirect(XiRoute::_('index.php?option=com_payplans&view=plan'), $msg);
			}

			$resource  	   =  $this->_getResource($user->getId());
			$count 		   =  (!empty($resource)) ? $resource->count : 0 ;
			$allowedOrNot  =  $this->_isUserAllowed($user);
		
			if(empty($allowedOrNot)){
				return false;
			}

			if(in_array(self::ALLOWED, $allowedOrNot))
			{
				$mtreeApp  = PayplansHelperApp::getAvailableApps('mtree');
				foreach ($mtreeApp as $app)
				{
					$allowedIn	  = $app->getAppParam('category_to_restrict', false);
					if($allowedIn == 'any')
					{
						$existingLists = $this->_getUserMtreeListing($user->getId());
						if(count($existingLists) >= $count)
						{
							$msg = XiText::_('COM_PAYPLANS_APP_MTREE_YOU_ARE_NOT_ALLOWED_TO_ADD_MORE_LISTING');
							$factoryApp->redirect(XiRoute::_('index.php?option=com_mtree&task=mypage'), $msg);
						}
					}
					else
					{
						if($task != 'savelisting'){
							return false;
						}
						
						$restrictedCat	  = $app->getAppParam('restrict_specific', false);
						$restrictedCat	  = is_array($restrictedCat) ? $restrictedCat : array($restrictedCat); 
						$childCategory    = $this->getChildCategory($restrictedCat);
						$restrictedCat    = array_merge($childCategory, $restrictedCat);
						$mtreeCatId		  = array(JRequest::getVar('cat_id', false));
					
						if(empty($mtreeCatId)){
							return false;
						}
						
						if(array_intersect($restrictedCat, $mtreeCatId)){
							if(($this->_getUserMtreeCatListing($this->_getUserMtreeListing($user->getId()), $restrictedCat)) >= ($app->getAppParam('publish_listings_on_active', false))) {
									$msg = XiText::_('COM_PAYPLANS_APP_MTREE_YOU_ARE_NOT_ALLOWED_TO_ADD_MORE_LISTING');
									$factoryApp->redirect(XiRoute::_('index.php?option=com_mtree&task=mypage'), $msg);										 	
							}
						}
					}
				}
			}
			else{
				$msg = XiText::_('COM_PAYPLANS_APP_MTREE_SELECT_PLAN');
				XiFactory::getApplication()->redirect(XiRoute::_('index.php?option=com_payplans&view=plan'), $msg);
			}
		}
	}
	
	
	protected function getChildCategory($category)
	{
		$db = XiFactory::getDBO();
		$query =  ' SELECT `cat_id` as cat_id'
				 .' FROM `#__mt_cats`'
				 .' WHERE `cat_parent` IN ( '.implode(',', $category).' ) AND `cat_published`=1';

		$db->setQuery( $query );
		return $db->loadColumn();
	}
	
	protected function _isUserAllowed($user)
	{
		$mtreeApp  = PayplansHelperApp::getAvailableApps('mtree');
		$appResult = array();
		
		foreach ($mtreeApp as $app){
			if($app->getParam('applyAll',false) != false){
				$appResult[]  = self::ALLOWED;
           		continue;
			}
			
			$appPlans = $app->getPlans();
			if(array_intersect($user->getPlans(), $appPlans) != false){
				 $appResult[]  = self::ALLOWED;
	          	 continue;
			}
			else {
			   $appResult[]  = self::BLOCKED;
			}
		}
		
		return $appResult;
	}
	
	protected function _getResource($userId)
	{
		$rmodel = PayplansApp::getResourceModel();
			$record = $rmodel->loadRecords(array('user_id'  => $userId,
											'title' => 'com_mtree.publish'));
		$record = array_shift($record);
		
		if(empty($record) || !$record){
			return false;
		}
		return $record;
	}
	
	protected function _getUserMtreeListing($userId)
	{
		$db = XiFactory::getDBO();
		$query =  ' SELECT `link_id` as link_id'
				 .' FROM `#__mt_links`'
				 .' WHERE `user_id`= '.$userId.' AND `link_published`=1';

		$db->setQuery( $query );
		return $db->loadColumn();
	}
	
	//Gets submission related to the current category of post.
	protected function _getUserMtreeCatListing($existingUserLinks, $mtreeCatId)
	{
		$db = XiFactory::getDBO();
		$query =  ' SELECT count(*)'
				 .' FROM `#__mt_cl`'
				 .' WHERE `cat_id` IN ('.implode(',', $mtreeCatId).") AND `link_id` IN ('".implode("', '", $existingUserLinks)."')";
		
		$db->setQuery( $query );
		return $db->loadResult();
	}
}
