<?php
/**
* @copyright	Copyright (C) 2009 - 2013 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		PayPlans
* @subpackage	PayPlans-Moset-Tree
* @author		Jitendra Khatri
* @contact 		payplans@readybytes.in
*/


class JFormFieldXimtcategories extends XiField
{
	public $type = 'Ximtcategories'; 
	
	public function getInput()
		{
			if(!JFolder::exists(JPATH_SITE .DS.'components'.DS.'com_mtree')){
				return XiText::_('COM_PAYPLANS_PLEASE_INSTALL_MTREE_BEFORE_USING_THIS_APPLICATION');
			}
			
		
			$categories = self::_getMtCategories();
			return PayPlansHtml::_('autocomplete.edit',  $categories,  $this->name, array('multiple'=>true), 'category_id', 'title', $this->value);
		
			
		}
	
	
	//Gets all categories of mtree, which have no parent category.  
	protected static function _getMtCategories()
	{
		$query = new XiQuery();
		return $query->select(' `cat_id` as category_id, `cat_name` as title ')
		             ->from('`#__mt_cats`')
			         ->where('`cat_published` = 1 AND `cat_parent` = 0')
		             ->dbLoadQuery()
		             ->loadObjectList('category_id');
	}
}
