<?php
/**
* @copyright	Copyright (C) 2009 - 2009 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		PayPlans
* @subpackage	Frontend
* @contact 		shyam@readybytes.in
* 
*/
if(defined('_JEXEC')===false) die();

class PayplansAppMtree extends PayplansApp
{
	protected $_location	= __FILE__;
	protected $_resource1    = 'com_mtree.publish';
	protected $_resource2    = 'com_mtree.feature';
	
	public function isApplicable($refObject = null, $eventName='')
	{
		if($eventName === 'onPayplansAccessCheck' || $eventName === 'onPayplansUpdateFeaturing'){
			return true;
		}
		return parent::isApplicable($refObject, $eventName);
	}
	
	// applicable only if mosets tree exist
	public function _isApplicable(PayplansIfaceApptriggerable $refObject, $eventname='')
	{
		return JFolder::exists(JPATH_SITE .DS.'components'.DS.'com_mtree');
	}

	function onPayplansUpdateFeaturing($link_id)
	{
		$user_id = XiFactory::getUser()->get('id');

		$db = XiFactory::getDBO();

		$query =  ' SELECT COUNT(*)'
				 .' FROM `#__mt_links`'
				 .' WHERE `user_id`= '.$user_id.' AND `link_featured`=1'
				 ;

		$db->setQuery( $query );
		$existingFeaturedLists = $db->loadResult();

		$resource = $this->_getResource($user_id, 0, $this->_resource2);
		$count = 0;
		if(!empty($resource)){
			$count = $resource->count;
		}
		
		//mark list as featured only when allowed
		if($existingFeaturedLists < $count){
			$query =  ' UPDATE #__mt_links'
						. ' SET `link_featured` = 1'
						. ' WHERE `link_id` ='. $link_id
						;
		
			$db->setQuery( $query );
			$db->query();
		}

		return true;	
	}
	
	public function onPayplansSubscriptionAfterSave($prev, $new)
	{
		$userid = $new->getBuyer();
		$subid  = $new->getId();
		

		
		if($prev == null){
			return true;
		}		
		$newStatus  = $new->getStatus();
		$prevStatus = $prev->getStatus();
		if($prevStatus == $newStatus){
			return true;
		}
				
		$restriction_on	    = $this->getAppParam('category_to_restrict','any');
		$restrictedcategories = $this->getAppParam('restrict_specific', null);
		
		$restrictedcategories = is_array($restrictedcategories) ? $restrictedcategories : array($restrictedcategories);

		$publishCount = $this->getAppParam('publish_listings_on_active', 0);
		$featureCount = $this->getAppParam('featured_listings_on_active', 0);
		

		if($newStatus == PayplansStatus::SUBSCRIPTION_ACTIVE)
		{
			$action = 1;//action is publish/feature
			if($restriction_on != 'specific'){
				$this->_addToResource($subid, $userid, 0, $this->_resource1, $publishCount);
				$this->_addToResource($subid, $userid, 0, $this->_resource2, $featureCount);
				$this->_publishUnpublishList($userid, $publishCount, $featureCount, $action, $new);
			}
			else{
				foreach ($restrictedcategories as $category){
						$this->_addToResource($subid, $userid, $category, $this->_resource1, $publishCount);
						$this->_addToResource($subid, $userid, $category, $this->_resource2, $featureCount);
						$this->_publishUnpublishList($userid, $publishCount, $featureCount, $action, $new);						
				}
			}	
			
			return true;
		}

		if(($prevStatus == PayplansStatus::SUBSCRIPTION_ACTIVE) 
					&&	($newStatus == PayplansStatus::SUBSCRIPTION_HOLD )){
			$action = 0;//action is unpublish/unfeature
			
			//$unpublishCount = $this->getAppParam('unpublish_listings_on_hold', 0);
			//$unfeatureCount = $this->getAppParam('unfeatured_listings_on_hold', 0);
			
			
			if($restriction_on != 'specific'){
				$this->_removeFromResource($subid, $userid, 0, $this->_resource1, $publishCount);
				$this->_removeFromResource($subid, $userid, 0, $this->_resource2, $featureCount);
				$this->_publishUnpublishList($userid, $publishCount, $featureCount, $action, $new);
			}
			else{
				foreach ($restrictedcategories as $category){
					$this->_removeFromResource($subid, $userid, $category, $this->_resource1, $publishCount);
					$this->_removeFromResource($subid, $userid, $category, $this->_resource2, $featureCount);
					$this->_publishUnpublishList($userid, $publishCount, $featureCount, $action, $new);
				}
			}
			
			return true;			
		}
		
		if($prevStatus == PayplansStatus::SUBSCRIPTION_ACTIVE  && $newStatus != PayplansStatus::SUBSCRIPTION_ACTIVE){
			
			$action = 0;//action is unpublish/unfeature
			
			//$unpublishCount = $this->getAppParam('unpublish_listings_on_expire', 0);
			//$unfeatureCount = $this->getAppParam('unfeatured_listings_on_expire', 0);
			if($restriction_on != 'specific'){
				$this->_removeFromResource($subid, $userid, 0, $this->_resource1, $publishCount);
				$this->_removeFromResource($subid, $userid, 0, $this->_resource2, $featureCount);
				$this->_publishUnpublishList($userid, $publishCount, $featureCount, $action, $new);
			}
			else{
				foreach ($restrictedcategories as $category){
					$this->_removeFromResource($subid, $userid, $category, $this->_resource1, $publishCount);
					$this->_removeFromResource($subid, $userid, $category, $this->_resource2, $featureCount);
					$this->_publishUnpublishList($userid, $publishCount, $featureCount, $action, $new);
					
				}
			}
			
			return true;			
		}
	}
	
	public function _publishUnpublishList($userid, $publishCount, $featureCount, $action, $subscription)
	{
		$db = XiFactory::getDBO();
		
		$sql =  ' SELECT COUNT(*)'
				 .' FROM `#__mt_links`'
				 .' WHERE `user_id`= '.$userid
				 ;
		$db->setQuery( $sql );
		$presult = $db->loadResult(); 
		if(empty($presult)){
			return ;
		}
		
		$sql1 =  ' SELECT COUNT(*)'
				 .' FROM `#__mt_links`'
				 .' WHERE `user_id`= '.$userid.' AND `link_featured`= 1'
				 ;
		$db->setQuery( $sql1 );
		$fresult = $db->loadResult(); 
		
		$resource1 = $this->_getResource($userid, 0, $this->_resource1);
		$pcount    = $resource1->count;
		
		$resource2 = $this->_getResource($userid, 0, $this->_resource2);
		$fcount    = $resource2->count;
		
		$subStatus = $subscription->getStatus();
		
		if($subStatus == PayplansStatus::SUBSCRIPTION_EXPIRED || $subStatus == PayplansStatus::SUBSCRIPTION_HOLD){
			//if allowed list is equals or greater then existing then dont unpublish the existing list
			if($presult <= $pcount && $fresult <= $fcount){
				return true;
			}
			$publishCount = $presult - $pcount;
			$featureCount = $fresult - $fcount;
		}
		
		$complement = 1 - $action;
		
		// NOTE: only published lists can be marked as featured
		// and a featured list can not be unpublished, list must be 
		//unfeatured first and then it can be unpublished 
		$query1 =  ' UPDATE #__mt_links'
						. ' SET link_featured = '.$action
						. ' WHERE `user_id` ='. $userid.' AND `link_published` = 1 AND `link_featured` = '.$complement
						. ' LIMIT '.$featureCount
						;
								
		$query2 =  ' UPDATE #__mt_links'
							. ' SET link_published  = '. $action
							. ' WHERE `user_id` ='. $userid . ' AND `link_published` = '.$complement. ' AND `link_featured` = 0'
							. ' LIMIT '.$publishCount
							;
		//in case of active status we need to run query 
		//for featuring after executing query for publishing list
		// as an unpublished list can not be marked as featured			
		if($subscription->getStatus() == PayplansStatus::SUBSCRIPTION_ACTIVE){
			$query   =  $query1;
			$query1  =  $query2;
			$query2  =  $query;
		}
		
		$db->setQuery( $query1 );
		$db->query();
		
		$db->setQuery( $query2 );
		$db->query();
		
		return true;
	}
	
	public function renderWidgetHtml()
	{   
		//get user id
		$userid     = XiFactory::getUser()->id;
		if(!$userid){
			return '';
		}

		//get user's mosett tree entries
	    $mtree_listing = $this->_getUserMtreelisting($userid);
	    if(empty($mtree_listing))
	    	return '';

	    $this->assign('mtree_listing',$mtree_listing);
        $data = $this->_render('widgethtml');
        return $data;
	}
	
	protected function _getUserMtreeListing($userid)
	{
		$db    = XiFactory::getDBO();
		$query =  ' SELECT `link_id` as id, `link_name` as name'
				 .' FROM `#__mt_links`'
				 .' WHERE `user_id`= '.$userid.' AND `link_published`=1'
				 ;

		$db->setQuery( $query );
		return $db->loadObjectList('id');
	}
}
