<?php
/**
* @copyright	Copyright (C) 2009 - 2011 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
* @package		PayPlans
* @subpackage	Prodiscount
* @contact 		payplans@readybytes.in
* website		http://www.jpayplans.com
* Technical Support : Forum -	http://www.jpayplans.com/support/support-forum.html
*/
if(defined('_JEXEC')===false) die();

class PayplanssiteControllerOneclickcheckout_invoice extends PayplanssiteControllerInvoice
{
	function getName()
	{
		return 'invoice';
	}
	
	
	public function confirm($invoiceId = null, $userId = null, $appId = null)
    {
		// clicked on checkout
		if(JRequest::getVar('payplans_invoice_confirm', 'BLANK', 'POST') !== 'BLANK'){
			//XITODO : Is it a dummy user ? Yes, then try to register him
			$invoiceId = $this->getModel()->getId();
            $invoice   = PayplansInvoice::getInstance($invoiceId);
            $user    = $invoice->getBuyer(PAYPLANS_INSTANCE_REQUIRE);

            if((int)$user->getId() === (int)PayplanssiteControllerOneclickcheckout_invoice::getDummyUserId()){
            	$nonRegisteredPreference = $user->getPreference();
				// save user data for auto plugin
				$userId = $this->_autoRegister();
				// Error happened, redirect to registration
				if(!$userId ){
					// XITODO : append error message	
					$this->setTemplate(__FUNCTION__);
	            	return true;
				}
			// vat information(purpose and VAt no. get stored on non-registered user, so in order to move data to original user,below work is done)
			$nonRegisteredPreference = $nonRegisteredPreference->toArray();
			$newUser = PayplansUser::getInstance($userId);
			foreach ($nonRegisteredPreference as $key => $value){
			    $newUser->setPreference($key, $value);
			    $user->setPreference($key, '');
			}
				$user->save();
				$newUser->save();
				$this->_updateUserId($userId);
            }
		}
		
		$fromOneClickCheckOut = JRequest::getVar('fromOneClickCheckout',0);
		$newUserId = XiFactory::getUser()->get('id');	

		if($fromOneClickCheckOut && $newUserId)
		{
			$this->_updateUserId($newUserId);
			JRequest::setVar('fromOneClickCheckout',null);
		}
		return parent::confirm();
	}
	
	//override this function to allow user to see invoice whether logged in user is not same as buyer
	public function _allowedViewInvoice($loggedInUser = 0,PayplansUser $buyer)
       {
               $dummyId  = PayplanssiteControllerOneclickcheckout_invoice::getDummyUserId();
               if ($buyer != $dummyId){
                       return parent::_allowedViewInvoice($loggedInUser,$buyer);
               }
               return true;
       }

	// Collect and save user registration
	protected function _autoRegister()
	{
		$email 	  = JRequest::getVar('payplansRegisterAutoEmail', false);
		$username = JRequest::getVar('payplansRegisterAutoUsername', false);
		$password = JRequest::getVar('payplansRegisterAutoPassword', false);

        $oneclick      = JPluginHelper::getPlugin('payplans','oneclickcheckout');
		$captchaParam  = json_decode($oneclick->params);
		$showCaptcha   = $captchaParam->show_captcha;
		
		// if $username is not post then redirect to login page again
		if(!$username || !$email || !$password || JString::strlen(Jstring::trim($password)) === 0){
			// error
			return false;
		}
		
        // if captcha not matched then redirect to login page	    
		if($showCaptcha){
            $post       = JRequest::get('post');      
			JPluginHelper::importPlugin('captcha');
			$dispatcher = JDispatcher::getInstance();
			$res        = $dispatcher->trigger('onCheckAnswer',$post['recaptcha_response_field']);

		    if(isset($res[0]) && !$res[0]){
				XiFactory::getApplication()->enqueueMessage(XiText::_('PLG_PAYPLANSREGISTRATION_AUTO_REGISTRATION_SAVE_FAILED_16'));	
				return false;
			}
         }
        
		$registrationPlugin = 'auto';
        if(PayplansFactory::getConfig()->registrationType == 'activateafterpayment')
        {
            $registrationPlugin = 'activateafterpayment';
        }

        // register user
        $userId = XiHelperPlugin::getPluginInstance('payplansregistration', $registrationPlugin)->_autoRegister($username, $email, $password,$username);		 //fullname is equal to username.
		// update session data
		XiFactory::getSession()->set('REGISTRATION_NEW_USER_ID', $userId);
		
		return $userId;
	}
	
	static $userId = null;
 	static public function getDummyUserId()
    {    
        $registrationPlugin = 'auto';
        if(PayplansFactory::getConfig()->registrationType == 'activateafterpayment')
        {
            $registrationPlugin = 'activateafterpayment';
        }
        if(self::$userId != null){
            return self::$userId;
        }
        
        // find the dummy user
        $query = new XiQuery();
        self::$userId = $query->select(' `id`')
                     ->from('`#__users`')
                     ->where("`username`='Not_Registered'")
                     ->dbLoadQuery()
                     ->loadResult();

        // register a dummy user
        if(!self::$userId){
            jimport('joomla.user.helper');
            self::$userId = XiHelperPlugin::getPluginInstance('payplansregistration',$registrationPlugin)
                            ->_autoRegister(
                                'Not_Registered', 
                                'not@registered.com', 
                                JUserHelper::genRandomPassword()
                            );
        }        
        
        return self::$userId;
    }
}
