<?php
/**
* @copyright	Copyright (C) 2009 - 2009 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		PayPlans
* @subpackage	Frontend
* @contact 		payplans@readybytes.in
*/
if(defined('_JEXEC')===false) die();

class PayplansAppPayfast extends PayplansAppPayment
{
	protected $_location	= __FILE__;
	
	public function onPayplansPaymentForm(PayplansPayment $payment, $data = null)
	{
		if(is_object($data)){
			$data = (array)$data;
		}
		
		$post_url = ($this->getAppParam('sandbox', false) == false) ? "https://www.payfast.co.za/eng/process" : "https://sandbox.payfast.co.za/eng/process" ;
		
		$invoice = $payment->getInvoice(PAYPLANS_INSTANCE_REQUIRE);
		
		// basic setup
		$this->assign('post_url', $post_url);
		
		$root = JURI::root();
    	if(XiFactory::getConfig()->https == true){
    		$root = JString::str_ireplace("http:", "https:", $root);
    	}
		
		$data['merchant_id']		= '10000103';
		$data['merchant_key'] 		= '479f49451e829';
		if($this->getAppParam('sandbox', false) == false)
		{
			$data['merchant_id']		= $this->getAppParam('merchantid', 0);
			$data['merchant_key'] 		= $this->getAppParam('merchantkey', 0);
		}
		
		$data['return_url']			= $root.'index.php?option=com_payplans&gateway=payfast&view=payment&task=complete&action=success&payment_key='.$payment->getKey();
		$data['cancel_url']			= $root.'index.php?option=com_payplans&gateway=payfast&view=payment&task=complete&action=cancel&payment_key='.$payment->getKey();
		$data['notify_url']			= $root.'index.php?option=com_payplans&gateway=payfast&view=payment&task=notify&payment_key='.$payment->getKey();
		$data['m_payment_id']		= $invoice->getKey();
		$data['amount']				= $invoice->getTotal();
		$data['item_name']			= $invoice->getTitle();
	
	 	$sigString = '';
        foreach( $data as $key => $val )
        {
            if(!empty($val))
            {
              $sigString .= $key .'='. urlencode( $val  ) .'&';
            }
        }
        // Remove last ampersand
        $getString 					= substr( $sigString, 0, -1 );
        $data['signature'] 			= md5( $getString );
		
		$this->assign('merchant_id',  	$data['merchant_id']);
		$this->assign('merchant_key', 	$data['merchant_key']);		
    	$this->assign('return_url', 	$data['return_url']);
    	$this->assign('cancel_url', 	$data['cancel_url']);
    	$this->assign('notify_url', 	$data['notify_url']);
    	$this->assign('item_name',		$data['item_name']);
    	$this->assign('amount',			$data['amount']);
    	$this->assign('m_payment_id',	$data['m_payment_id']); 
		$this->assign('signature', 		$data['signature']);
    	
    	return $this->_render('form_standard');    	
    }
	
	public function onPayplansPaymentAfter(PayplansPayment $payment, &$action, &$data, $controller)
	{
		$logs	= PayplansHelperLogger::getLog($payment, XiLogger::LEVEL_ERROR);
		$record = array_pop($logs);		
		if($record && !empty($record)){
			$action = 'error';
		}
		
		return parent::onPayplansPaymentAfter($payment, $action, $data, $controller);
	}
	
	public function onPayplansPaymentNotify(PayplansPayment $payment, $data, $controller)
	{
		$invoice = $payment->getInvoice(PAYPLANS_INSTANCE_REQUIRE);
		
		$errors = array();		
		
		$validationData = JRequest::get('POST');
		// is it a valid records, ask to payfast
    	if($this->isValidIPN($validationData) == false){
    		$errors[] = XiText::_('COM_PAYPLANS_INVALID_IPN');
    		$message = XiText::_('COM_PAYPLANS_LOGGER_PAYMENT_INVALID_IPN');
    		PayplansHelperLogger::log(XiLogger::LEVEL_ERROR, $message, $payment, $validationData, 'PayplansPaymentFormatter', '', true);
    		return "INVALID IPN";
    	}
    	
    	// if same notification came more than one time
    	// check if transaction already exists
    	// if yes then do nothing and return
    	$txn_id 	= isset($data['pf_payment_id']) ? $data['pf_payment_id'] : 0;
    	$subscr_id  = isset($data['subscr_id'])     ? $data['subscr_id']     : 0;
    	$parent_txn = isset($data['parent_txn_id']) ? $data['parent_txn_id'] : 0;
    	
    	$transactions = $this->_getExistingTransaction($invoice->getId(), $txn_id, $subscr_id, $parent_txn);
    	
    	if($transactions !== false){
    		foreach($transactions as $transaction){
    			$transaction = PayplansTransaction::getInstance($transaction->transaction_id, null, $transaction);
    			$par = $transaction->getParam('payment_status', '');
    			if($transaction->getParam('payment_status', '') == $data['payment_status']){
    				return true;
    			}
    		}
    	}
    	
    	// get the transaction instace of lib
		$transaction = PayplansTransaction::getInstance();
		$transaction->set('user_id', $payment->getBuyer())
					->set('invoice_id', $invoice->getId())
					->set('payment_id', $payment->getId())
					->set('pf_payment_id', $txn_id)
					->set('gateway_subscr_id', $subscr_id)
					->set('gateway_parent_txn', $parent_txn)
					->set('params', PayplansHelperParam::arrayToIni($data));
		
		$func_name 	= isset($data['payment_status']) ? '_on_payment_'.JString::strtolower($data['payment_status']) : 'EMPTY';
		
		if(method_exists($this, $func_name)){
			$errors = $this->$func_name($payment, $data, $transaction);
		}
		else{
			$errors[] = XiText::_('COM_PAYPLANS_APP_PAYFAST_INVALID_TRANSACTION_TYPE_OR_PAYMENT_STATUS');
		}
		
    	//if error present in the transaction then redirect to error page
		if(!empty($errors)){
			$message = XiText::_('COM_PAYPLANS_LOGGER_ERROR_IN_PAYFAST_PAYMENT_PROCESS');
			$log_id = PayplansHelperLogger::log(XiLogger::LEVEL_ERROR, $message, $payment, $errors, 'PayplansPaymentFormatter', '', true);
		}
	
		//store the response in the payment AND save the payment
		if(!$transaction->save()){
			$message = XiText::_('COM_PAYPLANS_LOGGER_ERROR_TRANSACTION_SAVE_FAILED');
			$log_id = PayplansHelperLogger::log(XiLogger::LEVEL_ERROR, $message, $payment, $data, 'PayplansPaymentFormatter', '', true);
		}
		
		$payment->save();
		
		return count($errors) ? implode("\n", $errors) : ' No Errors';
	}
	
	protected function _on_payment_complete($payment, $data, $transaction)
	{
		//		Completed: The payment has been completed, and the funds have been
		//		added successfully to your account balance.
		$errors = $this->_validateNotification($payment, $data);
        
		if(empty($errors)){
			$transaction->set('amount', $data['amount_gross'])
						->set('message', 'COM_PAYPLANS_APP_PAYFAST_TRANSACTION_COMPLETED');
		}

		return $errors;
	}
	
	function _validateNotification(PayplansPayment $payment, array $data)
    {
    	$errors = array();

    	// find the required data from post-data, and match with payment
    	// check reciever email must be same.
    	$merchant_id  = '10000103';
    	if($this->getAppParam('sandbox',false) == false){
    		$merchant_id = $this->getAppParam('merchantid',0);
    	}
    		
    	if($merchant_id != $data['merchant_id']) {
            $errors[] = XiText::_('COM_PAYPLANS_INVALID_PAYFAST_MERCHANT_ID');
        }
	            	
        return $errors;
    }
    
	protected function _on_payment_failed($payment, $data, $transaction)
	{
		$transaction->set('message', 'COM_PAYPLANS_APP_PAYFAST_TRANSACTION_FAILED');
	}
	
	/**
	 * Validates the incoming data.
	 */
	private function isValidIPN($data)
	{				
	 	if($this->getAppParam('proxy_server'))
        {
	        // Variable initialization
	        $validHosts = array(
	            'www.payfast.co.za',
	            'sandbox.payfast.co.za',
	            'w1w.payfast.co.za',
	            'w2w.payfast.co.za',
	         );
	
	        $validIps = array();
	
	        foreach( $validHosts as $pfHostname )
	        {
	            $ips = gethostbynamel( $pfHostname );
	
	            if( $ips !== false )
	                $validIps = array_merge( $validIps, $ips );
	        }
	
	        // Remove duplicates
	        $validIps = array_unique( $validIps );
	     
	        if( !in_array( $_SERVER['REMOTE_ADDR'], $validIps ) )
	        {
	            return false;
	        }
        }

        foreach($data as $key => $val ) 
        {
            if($key == 'm_payment_id') $returnString = '';
            if(! isset($returnString)) continue;
            if($key == 'signature') continue;
            $returnString .= $key . '=' . urlencode($val) . '&';
        }

        $returnString = substr($returnString, 0, -1);
        
        if(md5($returnString) != $data['signature']) {
            return false;
        }
    
       	$host		 = $this->getValidationUrl();
        $header      = "POST /eng/query/validate HTTP/1.0\r\n";
        $header 	.= 'Host: '. $host ."\r\n";
        $header     .= "Content-Type: application/x-www-form-urlencoded\r\n";
        $header     .= "Content-Length: " . strlen($returnString) . "\r\n\r\n";
        
        $fp          = fsockopen('ssl://'.$this->getValidationUrl(), 443, $errno, $errstr, 10);
        
        if (!$fp) {
            // HTTP ERROR
            return false;
        } else {
            fputs($fp, $header . $returnString);
            while(! feof($fp)) 
            {
                $res = fgets($fp, 1024);
                if (strcmp($res, "VALID") == 0) {
                    fclose($fp);
                    return true;
                }
            }
        }
        
        fclose($fp);
        return false;
	}

	private function getValidationUrl()
	{
		$sandbox = $this->getAppParam('sandbox', 0);
		if($sandbox) {
			return 'sandbox.payfast.co.za';
		} else {
			return 'www.payfast.co.za';
		}
	}
}
