<?php
/**
 * paypaladaptive
 *
 * @copyright Copyright (C) 2009 - 2014 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
 * @license GNU/GPL, see LICENSE.php
 * @package payplans
 * @version 1.0.0
 * @author Team Payplans <support+payplans@readybytes.in>
 */

if (defined('_JEXEC') == false) {
    die('Restricted access');
}

class PayplansApppaypaladaptive extends PayplansAppPayment
{
    //inherited properties
    protected $_location = __FILE__;

    public function isApplicable($refObject = null, $eventName = '')
    {

        if ($eventName == 'onPayplansControllerCreation') {
            return true;
        }

        return parent::isApplicable($refObject, $eventName);

    }

    function onPayplansControllerCreation(&$view, &$controller, &$task, &$format)
    {
        if ($view != 'payment' || ($task != 'notify')) {
            return true;
        }
        $input = JFactory::getApplication()->input;
        $paymentKey = $input->get('memo');
        if (!empty($paymentKey)) {
            JRequest::setVar('payment_key', $paymentKey, 'POST');
            return true;
        }
        return true;
    }

    public function onPayplansPaymentForm(PayplansPayment $payment, $data = null)
    {
        $invoice = $payment->getInvoice(PAYPLANS_INSTANCE_REQUIRE);
        $root = JURI::root();
        $date =& JFactory::getDate();
        $current_date = $date->format("Y-m-d");

        /*if ($invoice->isRecurring()) {
            $frequency_type = ltrim(preg_replace('/[0-9]+/', '', PayplansHelperFormat::planTime($invoice->getExpiration())));

            switch($frequency_type){
                case 'day':
                    $paymentPeriod = 'DAILY';
                    break;
                case 'month':
                    $paymentPeriod = 'MONTHLY';
                    break;
                case 'year':
                    $paymentPeriod = 'ANNUALLY';
                    break;
                case 'months and  days':
                    $paymentPeriod = 'MONTHLY';
                    $dateOfMonth = $date->format("d");
                    break;
                case 'year and  months and  days':
                    $paymentPeriod = 'ANNUALLY';
                    $dateOfMonth = $date->format('d');
                default;
                    $paymentPeriod = 'NO_PERIOD_SPECIFIED';
            }

            $expiration = $invoice->getExpiration(PAYPLANS_RECURRING, true);
            $endDate = $this->_calculateEndDate($invoice, $expiration);
            $numberofPayment = $invoice->getRecurrenceCount();
            $request = 'returnUrl=' . urlencode($root . 'index.php?option=com_payplans&gateway=paypaladaptive&view=payment&task=notify&payment_key=' . $payment->getKey()) .
                    '&cancelUrl=' . urlencode($root . 'index.php?option=com_payplans&gateway=paypaladaptive&view=payment&task=complete&action=cancel&payment_key=' . $payment->getKey()) .
                    '&startingDate=' . $current_date .'&paymentPeriod='.$paymentPeriod.'&dateOfMonth='.$dateOfMonth. '&maxAmountPerPayment=' . $invoice->getTotal() . '&maxNumberOfPayments=' . $numberofPayment . '&maxTotalAmountOfAllPayments=' . $numberofPayment * $invoice->getTotal() . '&currencyCode=' . $invoice->getCurrency('isocode', 'USD') . '&requestEnvelope.errorLanguage=en_US';

        }
        else {*/
        $endDate = $current_date;
        $numberofPayment = '1';
        $request = 'returnUrl=' . urlencode($root . 'index.php?option=com_payplans&gateway=paypaladaptive&view=payment&task=notify&payment_key=' . $payment->getKey()) .
            '&cancelUrl=' . urlencode($root . 'index.php?option=com_payplans&gateway=paypaladaptive&view=payment&task=complete&action=cancel&payment_key=' . $payment->getKey()) .
            '&startingDate=' . $current_date . '&maxAmountPerPayment=' . $invoice->getTotal() . '&maxNumberOfPayments=' . $numberofPayment . '&maxTotalAmountOfAllPayments=' . $invoice->getTotal() . '&currencyCode=' . $invoice->getCurrency('isocode', 'USD') . '&requestEnvelope.errorLanguage=en_US';

        //}
        // Build a request for a pre-approval key


        $url = $this->getAppParam('sandbox') ? "https://svcs.sandbox.paypal.com/AdaptivePayments/Preapproval" : "https://svcs.paypal.com/AdaptivePayments/Preapproval";
        // Request for Pre-Approval Key.
        $response = $this->_paypalSend($request, $url);

        if ($response->preapprovalKey) {
            $payment->getGatewayParams()->set('preapprovalkey', $response->preapprovalKey);
            $payment->save();
            $post_URL = $this->getAppParam('sandbox') ? 'https://www.sandbox.paypal.com/cgi-bin/webscr?cmd=_ap-preapproval&preapprovalkey=' : 'https://www.paypal.com/cgi-bin/webscr?cmd=_ap-preapproval&preapprovalkey=';
            $this->assign('post_url', $post_URL . $response->preapprovalKey);
            return $this->_render('form_buynow');
        } else {
            $response = (array)$response;
            $error = $response['error'];
            $this->assign('errormessage', $error[0]->message);
            $this->assign('errorcode', $error[0]->errorId);
            return $this->_render('error');
        }
    }

    public function onPayplansPaymentNotify(PayplansPayment $payment, $data, $controller)
    {

       // file_put_contents(JPATH_SITE . DS . 'tmp' . DS . time(), var_export($data, true), FILE_APPEND);
        $invoice = $payment->getInvoice(PAYPLANS_INSTANCE_REQUIRE);
        $root = JURI::root();
        if ($data['payment_status'] == 'Completed') {

            $transaction = PayplansTransaction::getInstance();
            $transaction->set('user_id', $payment->getBuyer())
                ->set('invoice_id', $invoice->getId())
                ->set('payment_id', $payment->getId())
                ->set('gateway_txn_id', $data['txn_id'])
                ->set('gateway_subscr_id', $data['payer_id'])
                ->set('gateway_parent_txn', $data['reciever_id'])
                ->set('params', PayplansHelperParam::arrayToIni($data))
                ->set('amount', $data['payment_gross'])
                ->set('message', XiText::_('COM_PAYPLANS_APP_PAYPAL_PAYPAL_PAYMENT_SUCCESS'));
            return $transaction->save();

        }

        $request = "preapprovalKey=" . $payment->getGatewayParam('preapprovalkey') . "&requestEnvelope.errorLanguage=en_US";
        //$url = "https://svcs.sandbox.paypal.com/AdaptivePayments/PreapprovalDetails";
        $post_URL= $this->getAppParam('sandbox') ? 'https://svcs.sandbox.paypal.com/AdaptivePayments/PreapprovalDetails' : 'https://svcs.paypal.com/AdaptivePayments/PreapprovalDetails';
        $response = $this->_paypalSend($request, $post_URL);
        if ($response->approved) {
            $createPacket = array(
                "actionType" => "PAY",    // Specify the payment action
                "currencyCode" => $invoice->getCurrency('isocode', 'USD'),  // The currency of the payment
                "receiverList" => array(
                    "receiver" => array(
                        array(
                            "amount" => $invoice->getTotal(),
                            "email" => $this->getAppParam('merchant_email')
                        )
                    )

                ),
                "memo" => $payment->getKey(),
                "returnUrl" => $root . 'index.php?option=com_payplans&gateway=paypaladaptive&view=payment&task=complete&action=success&payment_key=' . $payment->getKey(),
                "cancelUrl" => $root . 'index.php?option=com_payplans&gateway=paypaladaptive&view=payment&task=complete&action=cancel&payment_key=' . $payment->getKey(),
                "requestEnvelope" => array(
                    "errorLanguage" => "en_US",
                    "detailLevel" => "ReturnAll"
                ));
            $URL= $this->getAppParam('sandbox') ? 'https://svcs.sandbox.paypal.com/AdaptivePayments/' : 'https://svcs.paypal.com/AdaptivePayments/';
            $response = $this->_paypalPay($createPacket, "Pay", $URL);
            $post_URL= $this->getAppParam('sandbox') ? 'https://www.sandbox.paypal.com/cgi-bin/webscr?cmd=_ap-payment&paykey=' : 'https://www.paypal.com/cgi-bin/webscr?cmd=_ap-payment&paykey=';
            //$this->assign('post_url', $post_URL . $response['payKey']);
            //return $this->_render('form_buynow');
            header('Location: ' . $post_URL . $response['payKey']);
        }

    }

    public function onPayplansPaymentAfter(PayplansPayment $payment, &$action, &$data, $controller)
    {
        return true;
    }

    function _paypalPay($data, $call, $url)
    {
        $header = array(
            // Sandbox API credentials for the API Caller account
            "X-PAYPAL-SECURITY-USERID :".$this->getAppParam('paypal-user-id'),
            "X-PAYPAL-SECURITY-PASSWORD :".$this->getAppParam('paypal-password'),
            "X-PAYPAL-SECURITY-SIGNATURE :".$this->getAppParam('paypal-signature'),
            "X-PAYPAL-APPLICATION-ID : 	APP-80W284485P519543T",
            "X-PAYPAL-REQUEST-DATA-FORMAT : JSON"
        );

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url . $call);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);;
        curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($data));
        curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
        return json_decode(curl_exec($ch), true);
    }

    protected function _calculateEndDate($invoice, $expiration)
    {
        $startDate = new XiDate('now');
        $endDate = $startDate;

        $recurrence_count = $invoice->getRecurrenceCount();
        // IMP : add 10 years when recurrence count is 0
        if (intval($recurrence_count) === 0) {
            $endDate = $endDate->addExpiration('100000000000');
            return $endDate->toFormat('%Y-%m-%d');
        }

        for ($i = 0; $i < $recurrence_count; $i++) {
            $endDate = $endDate->addExpiration($expiration);
        }

        return $endDate->toFormat('%Y-%m-%d');
    }


    function _paypalSend($data, $url)
    {
        $header = array(
            // Sandbox API credentials for the API Caller account
            "X-PAYPAL-SECURITY-USERID :".$this->getAppParam('paypal-user-id'),
            "X-PAYPAL-SECURITY-PASSWORD :".$this->getAppParam('paypal-password'),
            "X-PAYPAL-SECURITY-SIGNATURE :".$this->getAppParam('paypal-signature'),
            "X-PAYPAL-APPLICATION-ID : APP-80W284485P519543T",
            "X-PAYPAL-REQUEST-DATA-FORMAT : NV",
            "X-PAYPAL-RESPONSE-DATA-FORMAT : JSON"
        );

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);;
        curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
        return json_decode(curl_exec($ch));
    }

}
 
