<?php
/**
* @copyright	Copyright (C) 2009 - 2009 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		PayPlans
* @subpackage	Frontend
* @contact 		payplans@readybytes.in
*/
if(defined('_JEXEC')===false) die();


class PayplansAppPayseal extends PayplansAppPayment
{
	protected $_location	= __FILE__;
	protected $motoURL		= "https://payseal.icicibank.com/mpi/Moto.jsp";
	protected $sslURL 		= "https://payseal.icicibank.com/mpi/Ssl.jsp";
	protected $verbose 		= true;
	protected $mstrOSType	= "NT";
	protected $epgURL		= "https://payseal.icicibank.com/mpi/PGServSFA";
	
	function isApplicable($refObject = null, $eventName='')
	{
		// return true for event onPayplansPaymentForm
			
		return parent::isApplicable($refObject, $eventName);
	}

    function onPayplansPaymentForm(PayplansPayment $payment, $data = null)
	{		

		if(is_object($data)){
			$data = (array)$data;
		}
		
		$action = JRequest::getVar('action',false);
		if($action == 'process')
		{
			$this->paysealProcessPayment($payment,$data);
		}
		
		$root = JURI::root();
    	if(XiFactory::getConfig()->https == true){
    		$root = JString::str_ireplace("http:", "https:", $root);
    	}
    	
    	$invoice  = $payment->getInvoice(PAYPLANS_INSTANCE_REQUIRE);
    	
    	//if some error occured when click on buy but response is not successful then show error msg
    	$error_code = JRequest::getVar('error_code');
    	$error_msg  = JRequest::getVar('error_msg');
    	if(isset($error_code) && isset($error_msg)){
    		$this->assign('error_code', $error_code);
    		$this->assign('error_msg',  $error_msg);
    		$this->assign('invoice',  	$invoice);
    		return $this->_render('buying_error');
    	}
    	
    	$orderKey 		= PayplansHelperUtils::getKeyFromId($invoice->getObjectId());
		$invoice_key 	= $invoice->getKey();
		
		$user = $this->_replaceToken($payment,$invoice_key);

		$this->assign('currency_code', 	$invoice->getCurrency('isocode'));
		$this->assign('customer_ip', 	$_SERVER['REMOTE_ADDR']);
    	$this->assign('response_url', 	$root.'index.php?option=com_payplans');
    	$this->assign('order_id', 		$orderKey);
    	$this->assign('invoice_id',		$invoice_key);
    	$this->assign('amount',			number_format($invoice->getTotal(),2));
		$this->assign('payment', 		$payment);
		$this->assign('user', 			$user);
		$this->assign('showBuyerDetail',	$this->getAppParam('show_buyer_detail',false));
		$this->assign('showShippingDetail',	$this->getAppParam('show_shipping_detail',false));
		$this->assign('post_url', XiRoute::_("index.php?option=com_payplans&view=payment&task=pay&action=process&payment_key=".$payment->getKey()));

		return $this->_render('buyer_details');
	}
	
	//replaces the token of app params
	public function _replaceToken($object,$invoice_key)
	{
		$rewriter = PayplansFactory::getRewriter();
		
		$user = new stdClass();
		
		$details = array('buyer_id','buyer_name','buyer_email','buyer_address_line1',
						 'buyer_address_line2','buyer_address_line3','buyer_state','buyer_city'
						,'buyer_zip','buyer_country_alpha','shipping_email','shipping_address_line1'
						,'shipping_address_line2','shipping_address_line3','shipping_state'
						,'shipping_city','shipping_zip','shipping_country_alpha');
		
		foreach ($details as $detail){
			$data = $this->getAppParam($detail);
			
		
			$replacedData = $rewriter->rewrite($data, $object);
			
//			//if anyone doesn't fill information completely then he redirect it to invoice confirm page
//			if(empty($replacedData) || $replacedData==false){
//					$message = XiText::_('COM_PAYPLANS_APP_PAYSEAL_DETAILS_ARE_NOT_FILLED');
//					$url = XiRoute::_('index.php?option=com_payplans&view=invoice&task=confirm&invoice_key='.$invoice_key); 
//					XiFactory::getApplication()->redirect($url,$message,'warning');	
//			}
		
			//country show it number only then convert it to it's isocode3
			if(!empty($replacedData) && ($detail == 'shipping_country_alpha' || $detail == 'buyer_country_alpha'))
			{
				$countryModel 	=  PayplansFactory::getInstance('country','model');
				$record 		= $countryModel->loadRecords(array('country_id'=>$replacedData));
				$record 		= array_pop($record);
				$replacedData 	= $record->isocode3;
			}
			
			$user->$detail = $replacedData; 
			
		}

		return $user; 
	} 
	
	public function paysealProcessPayment($payment,$data)
	{
		//all variables are handeled here
		self::loadSfaLibrary();
		
		$oMPI 			= new MPIData();
		$oCI			= new CardInfo();
		$oPostLibphp	= new PostLibPHP($this->epgURL,$this->sslURL,$this->motoURL,$this->getAppParam('secret_key',false),$this->mstrOSType,$this->verbose);
		$oMerchant		= new Merchant();
		$oBTA			= new BillToAddress();
		$oSTA			= new ShipToAddress();
		$oPGResp		= new PGResponse();
		$oPGReserveData = new PGReserveData();
		$merchantId		= $this->getAppParam('merchant_id',false);
		$uniqueTransactionId =$data['payment_key'].'sfx'.time();
			
		//Buyer Details 
		$data['paysealCustomerId']	= (empty($data['paysealCustomerId']))?$payment->getBuyer():$data['paysealCustomerId'];
		
		$data['paysealAddrLine2']	= (empty($data['paysealAddrLine2']))?'not_applicable':$data['paysealAddrLine2'];
		$data['paysealAddrLine3']	= (empty($data['paysealAddrLine3']))?'not_applicable':$data['paysealAddrLine3'];
		
		//shipping Details
		$data['paysealShippingAddrLine2']	= (empty($data['paysealShippingAddrLine2']))?'not_applicable':$data['paysealShippingAddrLine2'];
		$data['paysealShippingAddrLine3']	= (empty($data['paysealShippingAddrLine3']))?'not_applicable':$data['paysealShippingAddrLine3'];

		$oMerchant->setMerchantDetails($merchantId,$merchantId,$merchantId,$data['customer_ip'],$uniqueTransactionId,$data['order_id'],$data['response_url'],"POST",$data['currency_code'],$data['invoice_id'],'req.Sale',$data['amount'],"","Ext1","true","Ext3","Ext4","New PHP");
		
		$oBTA->setAddressDetails($data['paysealCustomerId'],$data['paysealCustomerName'],$data['paysealAddrLine1'],$data['paysealAddrLine2'],$data['paysealAddrLine3'],$data['paysealCity'],$data['paysealState'],$data['paysealZip'],$data['paysealCountryAlpha'],$data['paysealEmail']);
		
		$oSTA->setAddressDetails($data['paysealShippingAddrLine1'],$data['paysealShippingAddrLine2'],$data['paysealShippingAddrLine3'],$data['paysealShippingCity'],$data['paysealShippingState'],$data['paysealShippingZip'],$data['paysealShippingCountryAlpha'],$data['paysealShippingEmail']);
		
		$oPGResp = $oPostLibphp->postSSL($oBTA,$oSTA,$oMerchant,$oMPI,$oPGReserveData);
		
		if($oPGResp->getRespCode() == '000'){
			$url	=$oPGResp->getRedirectionUrl();
//			$url =~ s/http/https/;
//			print "Location: ".$url."\n\n";
//			header("Location: ".$url);
			
		}else{
			
			$error_code = $oPGResp->getRespCode();
			$error_msg 	= $oPGResp->getRespMessage();
			
			$url = XiRoute::_('index.php?option=com_payplans&view=payment&task=pay&error_code='.$error_code.'&error_msg='.$error_msg.'&payment_key='.$payment->getKey()); 
							
		}	
		XiFactory::getApplication()->redirect($url);
	}
	
	public function loadSfaLibrary()
	{
		
		$path = dirname(__FILE__).DS.'Sfa'.DS;

		include_once ($path."BillToAddress.php");
		include_once ($path."CardInfo.php");
		include_once ($path."Merchant.php");
		include_once ($path."MPIData.php");
		include_once ($path."ShipToAddress.php");
		include_once ($path."PGResponse.php");
		include_once ($path."PostLibPHP.php");
		include_once ($path."PGReserveData.php");
		include_once ($path."EncryptionUtil.php");
		include_once ($path."PGSearchResponse.php");
			
	}
	
	public function onPayplansPaymentNotify(PayplansPayment $payment, $data, $controller)
	{
		
		//data need to trimed to saved to transaction param
		$dataToTxnParam = $data;
		unset($dataToTxnParam['option']);
		unset($dataToTxnParam['view']);
		unset($dataToTxnParam['task']);
		unset($dataToTxnParam['Itemid']);
		
		//check the response is a valid response or modified
		$payseal_data = PayplansFactory::getSession()->get('payseal_data');
		if(isset($payseal_data) && !PayplansAppPayseal::validateSFAResponse($payseal_data))
		{
			//It is needed to create a log for wrong response
			$message = XiText::_('COM_PAYPLANS_APP_PAYSEAL_LOGGER_ERROR_IN_PAYSEAL_RESPONSE_INVALID');
			PayplansHelperLogger::log(XiLogger::LEVEL_ERROR, $message, $payment, $payseal_data, 'PayplansPaymentFormatter', '', true);
			
			return XiText::_('COM_PAYPLANS_APP_PAYSEAL_LOGGER_ERROR_IN_PAYSEAL_RESPONSE_INVALID');
		}
		
		$invoice = $payment->getInvoice(PAYPLANS_INSTANCE_REQUIRE);
		
		$gatewayTxn_id 	= isset($data['ePGTxnID']) ? $data['ePGTxnID'] : 0;
    	$responseCode 	= strtok($data['DATA'],'RespCode=');
    	

    	// if same notification then epg gatewat id is same as previous one then
    	// check if transaction already exists
    	// if yes then do nothing and return
    	$transactions = $this->_getExistingTransaction($invoice->getId(), $gatewayTxn_id, 0, 0);
    	if(!empty($transactions)){
    				return true;
    	}
    	
    	$user		= $payment->getBuyer(PAYPLANS_INSTANCE_REQUIRE);
    	$username	= $user->getUsername();
    	$userId		= $user->getId();
    	$invoiceId 	= $invoice->getId();
    	
		// get the transaction instace of lib
		$transaction = PayplansTransaction::getInstance();
		$transaction->set('user_id',$userId)
					->set('invoice_id',$invoiceId)
					->set('payment_id', $payment->getId())
					->set('gateway_txn_id', $gatewayTxn_id)
					->set('gateway_subscr_id', 0)
					->set('gateway_parent_txn', 0)
					->set('params', PayplansHelperParam::arrayToIni($dataToTxnParam));
		
		// if response code is 0 then transaction is successful		
	    if($responseCode == '0'){
	    	$transaction->set('amount',$invoice->getTotal())
	    				->set('message', 'COM_PAYPLANS_APP_PAYSEAL_TRANSACTION_COMPLETED')
	    				->save();
	    	XiFactory::getApplication()->redirect(XiRoute::_('index.php?option=com_payplans&view=payment&task=complete&payment_key='.$payment->getKey()));
		}		
		else
		{
			$transaction->set('amount',0)
						->set('message', 'COM_PAYPLANS_APP_PAYSEAL_TRANSACTION_NOT_COMPLETED')
	    				->save();
	    			
	    	$transactionKey = PayplansHelperUtils::getKeyFromId($transaction->getId());
	    	$invoiceKey		= PayplansHelperUtils::getKeyFromId($invoice->getId());
	    	
			$errors['response_code']	 = $responseCode;
			$errors['response_message']  = sprintf(XiText::_('COM_PAYPLANS_APP_PAYSEAL_LOGGER_ERROR_IN_PAYSEAL_PAYMENT_PROCESS_DETAILS'),$data['Message'],$username,$userId,$transactionKey,$invoiceKey);
			$errors['response']			 = $data;
			
			$message = XiText::_('COM_PAYPLANS_APP_PAYSEAL_LOGGER_ERROR_IN_PAYSEAL_PAYMENT_PROCESS');
			PayplansHelperLogger::log(XiLogger::LEVEL_ERROR, $message, $payment, $errors, 'PayplansPaymentFormatter', '', true);
			
			$errors['response_message']  = $data['Message'];
			
			$url = XiRoute::_('index.php?option=com_payplans&view=payment&task=pay&error_code='.$errors['response_code'].'&error_msg='.$errors['response_message'].'&payment_key='.$payment->getKey()); 
			XiFactory::getApplication()->redirect($url);			
		}
		
	}
	
	//validate the reponse with key provided
	public function validateSFAResponse($data)
	{	   
		include_once (dirname(__FILE__).'/Sfa/'."EncryptionUtil.php");

		$strMerchantId			= $this->getAppParam('merchant_id','');
		$secretKey 				= $this->getAppParam('secret_key','');
		$astrResponseData		= $data['DATA'];
		$astrDigest 			= $data['EncryptedData'];
		$oEncryptionUtilenc 	= new EncryptionUtil();
		$astrsfaDigest  		= $oEncryptionUtilenc->getHMAC($astrResponseData,$secretKey,$strMerchantId);

		PayplansFactory::getSession()->clear('payseal_data');
		 
		if (strcasecmp($astrDigest, $astrsfaDigest) == 0) {
			return true;
		}	 
		
		return false;
	} 
	
	//function after payment is done
	public function refundRequest(PayplansTransaction $transaction, $refund_amount)
	{
		self::loadSfaLibrary();
		
		$uniquePaymentKey 	= $transaction->getParam('TxnID', '');
		$epgPaymentkey 	= $transaction->getParam('ePGTxnID', '');
		$rrnNumber		= $transaction->getParam('RRN', '');
		$authCode		= $transaction->getParam('AuthIdCode', '');
		$currencyCode	= $transaction->getCurrency('isocode');
		$amount			= $refund_amount;
		
		$oPostLibphp	=	new	PostLibPHP($this->epgURL,$this->sslURL,$this->motoURL,$this->getAppParam('secret_key',false),$this->mstrOSType,$this->verbose);
		
		$oMerchant		=	new	Merchant();
		
		$oPGResp		=	new	PGResponse();
		
		$merchant_id 	=  $this->getAppParam('merchant_id',false);
		
		
		$root = JURI::root();
    	if(XiFactory::getConfig()->https == true){
    		$root = JString::str_ireplace("http:", "https:", $root);
    	}
    	
    	$response_url = $root.'index.php?option=com_payplans';
    	
		$oMerchant->setMerchantRelatedTxnDetails($merchant_id,$merchant_id,$merchant_id,$uniquePaymentKey,$epgPaymentkey,$rrnNumber,$authCode,$response_url,"POST",$currencyCode,"req.Refund",$amount,"","Ext1","Ext2","Ext3","Ext4","Ext5");
		
		$oPgResp=$oPostLibphp->postRelatedTxn($oMerchant);
		
		//refund response code is zero then terminate the order
		if($oPgResp->getRespCode() == 0){
						
			$paymentKey	= strtok($uniquePaymentKey,'sfx');
			$paymentId 	= PayplansHelperUtils::getIdFromKey($paymentKey);
    		$payment 	= PayplansPayment::getInstance($paymentId);
    		
    		if($payment != false || !empty($payment)){
    			
    			 $dataToTxnParam = explode("\n",$oPgResp->toString());
    			 $newtransaction = PayplansTransaction::getInstance();
				 $newtransaction->set('user_id', 			$transaction->getBuyer())
								->set('invoice_id', 		$transaction->getInvoice())
								->set('payment_id',		 	$oPgResp->getTxnId())
								->set('gateway_txn_id',	 	$oPgResp->getEpgTxnId())
								->set('gateway_subscr_id', 	0)
								->set('gateway_parent_txn', 0)
								->set('params', 			PayplansHelperParam::arrayToIni($dataToTxnParam));

				$negativeAmt = -($amount);
		    	$newtransaction->set('amount',$negativeAmt)
		    				->set('message', 'COM_PAYPLANS_APP_PAYSEAL_TRANSACTION_COMPLETED')
		    				->save();
    		}
		    		
    		return true; 
		}
		
		return false;
	}
	
	public function supportForRefund()
	{
		return true;
	}
}
