<?php
/**
  * @copyright Copyright (C) 2009 - 2015 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
 * @license GNU/GPL, see LICENSE.php
 * @package payplans
 * @version 1.0.0
 * @author support+payplans <support+payplans@readybytes.in>
 */

if(defined( '_JEXEC' )==false) {
	die( 'Restricted access' );
}

class PayplansApppayu extends PayplansAppPayment
{
	protected $_location	= __FILE__;
    
    function onPayplansPaymentForm(PayplansPayment $payment, $data = null)
	{
		$invoice 			 = $payment->getInvoice(PAYPLANS_INSTANCE_REQUIRE);
		$this->assign('post_url','https://secure.payu.com/api/v2_1/orders');				
		
		$second_key =$this->getAppParam('sandbox','1')?'13a980d4f851f3d9a1cfc792fb1f5e50':$this->getAppParam('second_key', '');
		
		$input 		 		 = JFactory::getApplication()->input->server;
		$customerIp			 = $input->get('REMOTE_ADDR');        									    
		$this->assign('customerIp',$customerIp);
		
		$description 		 = $invoice->getTitle();
		$this->assign('description',$description);											
		$this->assign('product_name',$description);											
		
		$pos_id				 = $this->getAppParam('sandbox','1')?'145227':$this->getAppParam('pos_id', '');								
		$this->assign('pos_id',$pos_id);
		
		$currency			 = $invoice->getCurrency('isocode','PLN');									
		$this->assign('currency',$currency);
		
		// TO DO : Add comment 
		$totalAmount		 = $invoice->getTotal()*100;    										
		$this->assign('totalAmount',$totalAmount);
		
		$continue_url		 = JURI::root().'index.php?option=com_payplans&gateway=payu&view=payment&task=complete&action=success&payment_key='.$payment->getKey();
		$this->assign('continueUrl',$continue_url);											
		
		$notify_url  		 = JURI::root().'index.php?option=com_payplans&view=payment&task=notify&payment_key='.$payment->getKey();
		$this->assign('notify_url',$notify_url);											
		
		$md5Hash			 = md5($continue_url.$currency.$customerIp.$description.$pos_id.$notify_url.$description.'1'.$totalAmount.$totalAmount.$second_key);  													// Signature
		$open_signature 	 = "signature=".$md5Hash.";"."algorithm=MD5".";"."sender=".$pos_id;		
		$this->assign('signature',$open_signature);
		
		return $this->_render('form_buynow');
	}
	
	function onPayplansPaymentAfter(PayplansPayment $payment, &$action, &$data, $controller) {
	
		return parent::onPayplansPaymentAfter($payment, $action, $data, $controller);
	}
	
	public function onPayplansPaymentNotify(PayplansPayment $payment, $data, $controller)
	 {
		$invoice 		= $payment->getInvoice(PAYPLANS_INSTANCE_REQUIRE);
		$dataDirect 	= file_get_contents("php://input");
		// When debug mode is on dump in file
		if(JDEBUG){
						file_put_contents(JPATH_SITE.DS.'tmp'.DS.time(), var_export($dataDirect,true), FILE_APPEND);
		}
		$result 		= $this->validateNotification($dataDirect,$payment);
		if(in_array(false,$result)){
			$message 	= XiText::_('COM_PAYPLANS_APP_PAYU_NOTIFICATION_NOT_VALID');
			$error		= $result;
			PayplansHelperLogger::log(XiLogger::LEVEL_ERROR, $message, $payment, $error, 'PayplansPaymentFormatter', '', true);
			return false;
		}
		return $result;
	} 
	
	public function validateNotification($data,PayplansPayment $payment)
	  {
		$invoice 						= $payment->getInvoice(PAYPLANS_INSTANCE_REQUIRE);
		$postData 	    				= json_decode($data, true);
		if (!is_array($postData)){
			return array(false,XiText::_('COM_PAYPLANS_APP_PAYU_NOTIFICATION_NOT_VALID'));
		}
		$total							= $postData['order']['totalAmount'];
		$input						    = JFactory::getApplication()->input->server;
		$signature					    = $input->getString('HTTP_OPENPAYU_SIGNATURE'); 
		$merchant_pos_id				= $this->getAppParam('sandbox','1')?'145227':$this->getAppParam('pos_id', '');
		$merchantsecondKey				= $this->getAppParam('sandbox','1')?'13a980d4f851f3d9a1cfc792fb1f5e50':$this->getAppParam('second_key', '');
		
		if($postData['order']['merchantPosId']!== $merchant_pos_id){
			return array(false, XiText::_('COM_PAYPLANS_APP_PAYU_POS_ID_ERROR'));
		}
		if (empty($signature)){
			return array(false, XiText::_('COM_PAYPLANS_APP_PAYU_SIGNATURE_ERROR'));
		}
		$list = explode(';', rtrim($signature, ';'));
		if (empty($list)){
			return array(false, XiText::_('COM_PAYPLANS_APP_PAYU_SIGNATURE_ERROR'));
		}
		$signatureData = array();
		foreach ($list as $value) {
			$explode = explode('=', $value);
			$signatureData[$explode[0]] = $explode[1];
		}
		
		$concatenatedJson = $data.$merchantsecondKey;
		$expected_signature=md5($concatenatedJson);
		if($expected_signature !== $signatureData['signature']){
			       return array(false, XiText::_('COM_PAYPLANS_APP_PAYU_SIGNATURE_MISMATCH_ERROR'));
	    	}
		
		$transactions = $this->_getExistingTransaction($invoice->getId(),$postData['order']['orderId'], '0','0');    
    		if($transactions !== false){
    			foreach($transactions as $transaction){
    				$transaction = PayplansTransaction::getInstance($transaction->transaction_id, null, $transaction);
    					if($transaction->getParam('status','') == $postData['order']['status']){
   							return true;
    			}
    		}
    	}
		
    	$transaction = PayplansTransaction::getInstance();
    	$transaction ->set('user_id', $payment->getBuyer())
    				 ->set('invoice_id', $invoice->getId())
    				 ->set('payment_id', $payment->getId())
    	             ->set('gateway_txn_id', $postData['order']['orderId'])  
    				 ->set('gateway_subscr_id','0' )
    				 ->set('gateway_parent_txn','0' )
    				 ->set('params', PayplansHelperParam::arrayToIni($postData[order]));
        
        if($postData['order']['status']=='PENDING'){
    		$transaction->set('message', 'COM_PAYPLANS_APP_PAYU_TRANSACTION_PENDING_STATE');
    	}
    	
    	if($postData['order']['status']=='CANCELLED'){
    		$transaction->set('message', 'COM_PAYPLANS_APP_PAYU_TRANSACTION_CANCELLED_STATE');
    	}
    	
    	if($postData['order']['status']=='WAITING_FOR_CONFIRMATION')
    	{
    		$transaction->set('message', 'COM_PAYPLANS_APP_PAYU_TRANSACTION_WAITING_FOR_CONFIRMATION_STATE');
    	}
    	if($postData['order']['status']=='COMPLETED')
    	{
    		$transaction->set('amount', $total/100)
						->set('message', 'COM_PAYPLANS_APP_PAYU_TRANSACTION_COMPLETED');
    	}
    	$transaction->save();
    	return array(true, XiText::_('COM_PAYPLANS_APP_PAYU_TRANSACTION_SUCCESSFUL'));
	}
		}

?>