<?php
/**
 * 
 * @copyright 		Copyright (C) 2009 - 2015 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
 * @license 		GNU/GPL, see LICENSE.php
 * @package 		payplans
 * @version 		1.0.0
 * @author 			support+payplans <support+payplans@readybytes.in>
 */

if(defined( '_JEXEC' )==false) {
	die( 'Restricted access' );
}

class PayplansAppPayUMoney extends PayplansAppPayment
{
	
	//inherited properties
	protected $_location	= __FILE__;

	function onPayplansPaymentForm(PayplansPayment $payment, $data = null)
	{
		$invoice 			= $payment->getInvoice(PAYPLANS_INSTANCE_REQUIRE);
		$post_url 			= $this->getAppParam('sandbox', '1')?'https://test.payu.in/_payment':'https://secure.payu.in/_payment';
		$salt 				= $this->getAppParam('salt', 0);
		$key				= $this->getAppParam('merchant_key', '');
		$user				= $invoice->getBuyer(PAYPLANS_INSTANCE_REQUIRE);
		$userId				= $user->get('user_id');
		$email				= $user->getEmail();
		$userName			= $user->getUserName();
		$txnKey				= $payment->getKey();
		$amount				= $invoice->getTotal();
		$productInfo		= $invoice->getTitle();
		$hash_string		= $key.'|'.$txnKey.'|'.number_format($amount , 2).'|'.$productInfo.'|'.$userName.'|'.$email.'|'.$userId.'||||||||||'.$salt;
		$hash               = strtolower(hash('sha512', $hash_string));

		$this->assign('post_url', 		$post_url);
		$this->assign('key', 			$key);
		$this->assign('txnid', 			$txnKey);
		$this->assign('productinfo', 	$productInfo);
		$this->assign('amount', 		number_format($amount , 2));
		$this->assign('firstname', 		$userName);
		$this->assign('email', 			$email);
		$this->assign('surl',			JURI::root().'index.php?&option=com_payplans&payment_key='.$payment->getKey().'&gateway=payumoney&view=payment&task=complete&action=success');
		$this->assign('furl', 			JURI::root().'index.php?&option=com_payplans&payment_key='.$payment->getKey().'&gateway=payumoney&view=payment&task=complete&action=cancel');
		$this->assign('curl', 			JURI::root().'index.php?&option=com_payplans&payment_key='.$payment->getKey().'&gateway=payumoney&view=payment&task=complete&action=cancel');
		$this->assign('provider',		'payu_paisa');
		$this->assign('udf1',			$userId);
		$this->assign('hash', 			$hash);

		return $this->_render('form_buynow');
	}

	function onPayplansPaymentAfter(PayplansPayment $payment, &$action, &$data, $controller) {

		if($action == 'cancel'){
			return true;
		}

		if($data['status'] != 'success')
		{
			$message 	= XiText::_('COM_PAYPLANS_APP_PAYUMONEY_ERROR');
			PayplansHelperLogger::log(XiLogger::LEVEL_ERROR, $message, $payment, $data, 'PayplansPaymentFormatter');

			$action		= 'error';
			return parent::onPayplansPaymentAfter($payment, $action, $data, $controller);

		}

		$invoice 						= $payment->getInvoice(PAYPLANS_INSTANCE_REQUIRE);
		list($isValidResp, $message) 	= $this->validateResponse($data,$invoice);
		if (!$isValidResp) {
			PayplansHelperLogger::log(XiLogger::LEVEL_ERROR, $message, $payment, $data, 'PayplansPaymentFormatter');

			$action	= 'error';
			return parent::onPayplansPaymentAfter($payment, $action, $data, $controller);
		}

		//Duplicate Transactions Checking
		$transactions 					= $this->_getExistingTransaction($invoice->getId(), $data['payuMoneyId'], 0, 0);
		if($transactions !== false){
			foreach($transactions as $transaction){
				$transaction 			= PayplansTransaction::getInstance($transaction->transaction_id, null, $transaction);
				if($transaction->getParam('mihpayid', '') == $data['mihpayid']){
					return true;
				}
			}
		}

		$transaction 	= PayplansTransaction::getInstance();
		$transaction->set('user_id', 			$invoice->getBuyer())
			->set('invoice_id', 		$invoice->getId())
			->set('payment_id', 		$payment->getId())
			->set('amount',				$data['amount'])
			->set('message',            XiText::_('COM_PAYPLANS_APP_PAYUMONEY_PAYMENT_COMPLETED_SUCCESSFULLY'))
			->set('gateway_txn_id', 	isset($data['payuMoneyId']) 	? $data['payuMoneyId'] : 0)
			->set('gateway_subscr_id', 	0)
			->set('gateway_parent_txn', 0)
			->set('params', 			PayplansHelperParam::arrayToIni($data))
			->save();

		return parent::onPayplansPaymentAfter($payment, $action, $data, $controller);
	}


	function validateResponse(array $data,PayplansInvoice $invoice)
	{
		if (!isset($data)) {
			return array(false, XiText::_('COM_PAYPLANS_APP_PAYUMONEY_RESPONSE_ERROR'));
		} else {
			$salt 		 	 	 = $this->getAppParam('salt', 0);
			$key 		 		 = $data['key'];
			$txnId 			 	 = $data['txnid'];
			$amount 	 		 = $data['amount'];
			$productInfo  		 = $data['productinfo'];
			$userName 			 = $data['firstname'];
			$email   	 		 = $data['email'];
			$userId 			 = $data['udf1'];
			$hash_string	     = $salt.'|'.$data['status'].'||||||||||'.$userId.'|'.$email.'|'.$userName.'|'.$productInfo.'|'.$amount.'|'.$txnId.'|'.$key;
			$generatedHash       = strtolower(hash('sha512', $hash_string));

			$hash 				 = $data['hash'];

			if ($hash !== $generatedHash) {
				// signature hash does not matched
				return array(false,XiText::_('COM_PAYPLANS_APP_PAYUMONEY_SIGNATURE_INVALID'));
			}

			return array(true, XiText::_('COM_PAYPLANS_APP_PAYUMONEY_NO_ERROR'));
		}
	}
}
