<?php
/**
 * payunity
 * this app is the payment gateway integration for PayUnity payment gateway.
 * @copyright Copyright (C) 2009 - 2014 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
 * @license GNU/GPL, see LICENSE.php
 * @package payplans
 * @version 1.0.0
 * @author Team ReadyBytes <support+payplans@readybytes.in>
 */

if(defined( '_JEXEC' )==false) {
	die( 'Restricted access' );
}

class PayplansAppPayUnity extends PayplansAppPayment
{
	
	//inherited properties
	protected $_location	= __FILE__;

    function onPayplansPaymentForm(PayplansPayment $payment, $data = null)
    {
        $checkoutId = $this->requestCheckout($payment);
        $this->assign('checkoutId',$checkoutId);
        $scriptUrl = $this->getAppParam('sandbox', '1')?'https://test.oppwa.com/':'https://oppwa.com/';
        $this->assign('src',$scriptUrl);
        $root = JURI::root();
        $this->assign('post_url',$root.'index.php?option=com_payplans&gateway=payunity&view=payment&task=complete&action=success&payment_key='.$payment->getKey());
        return $this->_render('form_buynow');
    }

    private function requestCheckout(PayplansPayment $payment) {
        $invoice 			= $payment->getInvoice(PAYPLANS_INSTANCE_REQUIRE);
        $req_url 			= $this->getAppParam('sandbox', '1')?'https://test.oppwa.com/':'https://oppwa.com/';
        $merchantId      	= $this->getAppParam('user_id', 0);
        $merchantPwd		= $this->getAppParam('user_pwd', '');
        $channelId			= $this->getAppParam('channel_id', '');
        $user				= $invoice->getBuyer(PAYPLANS_INSTANCE_REQUIRE);
        $email				= $user->getEmail();
        $userName			= $user->getUserName();
        $txnKey				= $payment->getKey();
        $amount				= $invoice->getTotal();
        $productInfo		= $invoice->getTitle();
        $currency			= $invoice->getCurrency('isocode','EUR');

        $req_url            = $req_url."v1/checkouts";
        $data               = "authentication.userId=".$merchantId.
                                "&authentication.password=".$merchantPwd.
                                "&authentication.entityId=".$channelId.
                                "&amount=".$amount.
                                "&currency=".$currency.
                                "&paymentType=DB".
                                "&merchantTransactionId=".$txnKey.
                                "&customer.email=".$email.
                                "&customer.givenName=".$userName.
                                "&descriptor=".$productInfo;
        if($invoice->isRecurring()) {
            $data           = $data."&recurringType=INITIAL&createRegistration=true";
        }

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $req_url);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
        if($this->getAppParam('sandbox', '1')){
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        } else {
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, true);
        }
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        $responseData = curl_exec($ch);
        if(curl_errno($ch)) {
            return curl_error($ch);
        }
        curl_close($ch);
        return json_decode($responseData)->id;

    }


    function onPayplansPaymentAfter(PayplansPayment $payment, &$action, &$data, $controller)
    {
        if($action == 'cancel'){
            return true;
        }

        if($action == 'success'){
            $invoice                = $payment->getInvoice(PAYPLANS_INSTANCE_REQUIRE);
            $resourcePath           = $data['resourcePath'];
            $merchantId      	    = $this->getAppParam('user_id', 0);
            $merchantPwd		    = $this->getAppParam('user_pwd', '');
            $channelId			    = $this->getAppParam('channel_id', '');
            $url                    = $this->getAppParam('sandbox', '1')?'https://test.oppwa.com':'https://oppwa.com';
            $url                    .= $resourcePath;
            $url                    .= "?authentication.userId=".$merchantId.
                                    "&authentication.password=".$merchantPwd.
                                    "&authentication.entityId=".$channelId;

            $ch                     = curl_init();
            curl_setopt($ch, CURLOPT_URL, $url);
            curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'GET');
            if($this->getAppParam('sandbox', '1')) {
                curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
            } else {
                curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, true);
            }
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            $responseData           = curl_exec($ch);
            if(curl_errno($ch)) {
                return curl_error($ch);
            }
            curl_close($ch);
            $responseData           = json_decode($responseData);
            $pattern                = '/^(000\.000\.|000\.100\.1|000\.[36])/';
            if (!preg_match($pattern, $responseData->result->code)) {
                $message 					= XiText::_('COM_PAYPLANS_APP_PAYUNITY_ERROR');
                $action						= 'error';
                PayplansHelperLogger::log(XiLogger::LEVEL_ERROR, $message, $payment, $responseData, 'PayplansPaymentFormatter');

                return parent::onPayplansPaymentAfter($payment, $action, $responseData, $controller);
            } else {

                //do check for valid payments.
            list($isValidResp, $message)	= $this->checkResponse($payment,$responseData);
            if (!$isValidResp) {
                PayplansHelperLogger::log(XiLogger::LEVEL_ERROR, $message, $payment, $responseData, 'PayplansPaymentFormatter');
                $action	= 'error';
                return parent::onPayplansPaymentAfter($payment, $action, $responseData, $controller);
            }

            if(JDEBUG){
                // When debug mode is on dump in file
                file_put_contents(JPATH_SITE.DS.'tmp'.DS.time().$invoice->getKey(), var_export($responseData,true), FILE_APPEND);
            }
            //Duplicate Transactions Checking
            $transactions 					= $this->_getExistingTransaction($invoice->getId(), $responseData->id, $responseData->registrationId,0);
            if($transactions !== false){
                foreach($transactions as $transaction){
                    $transaction 			= PayplansTransaction::getInstance($transaction->transaction_id, null, $transaction);
                    $statusCode 			= $transaction->getParam('result', '')->code;

                    if($statusCode == $responseData->result->code){
                        return true;
                    }
                }
            }

            $transaction 					        = PayplansTransaction::getInstance();
            $transaction->set('user_id', 			$invoice->getBuyer())
                        ->set('invoice_id', 		$invoice->getId())
                        ->set('payment_id', 		$payment->getId())
                        ->set('amount',				$responseData->amount)
                        ->set('message',            XiText::_('COM_PAYPLANS_APP_PAYUNITY_PAYMENT_COMPLETED_SUCCESSFULLY'))
                        ->set('gateway_txn_id', 	isset($responseData->id) 	? $responseData->id : 0)
                        ->set('gateway_subscr_id', 	isset($responseData->registrationId) ? $responseData->registrationId :0)
                        ->set('gateway_parent_txn', 0)
                        ->set('params', 			PayplansHelperParam::arrayToIni($responseData))
                        ->save();

            if ($invoice->isRecurring()) {
                $recurrence_count			= $this->_getRecurrenceCount($invoice);
                $payment->getGatewayParams()->set('pending_recur_count',$recurrence_count);
                $payment->getGatewayParams()->set('reference_id',$responseData->registrationId);
                $payment->save();
            }
            return parent::onPayplansPaymentAfter($payment, $action, $data, $controller);

        }
        }
    }

    public function processPayment(PayplansPayment $payment, $invoiceCount)
    {
        $invoice 						= $payment->getInvoice(PAYPLANS_INSTANCE_REQUIRE);
        $sourceOrder 					= $payment->getGatewayParam('reference_id');
        $merchantId      	            = $this->getAppParam('user_id', 0);
        $merchantPwd		            = $this->getAppParam('user_pwd', '');
        $channelId			            = $this->getAppParam('channel_id', '');
        $amount							= $invoice->getTotal();
        $currency						= $invoice->getCurrency('isocode','EUR');

        $lifetime 						= ($invoice->getRecurrenceCount() == 0)? true : false;
        $invoice_count 					= $invoiceCount +1;

        if($invoice->isRecurring())
        {
            $recurrence_count 			= $payment->getGatewayParam('pending_recur_count');

            if($recurrence_count > 0 || $lifetime) {
                $url = $this->getAppParam('sandbox', '1') ? 'https://test.oppwa.com/' : 'https://oppwa.com/';
                $url = $url . "v1/registrations/" .$sourceOrder."/payments";
                $data = "authentication.userId=".$merchantId .
                        "&authentication.password=".$merchantPwd.
                        "&authentication.entityId=".$channelId.
                        "&amount=".$amount.
                        "&currency=".$currency.
                        "&paymentType=DB".
                        "&recurringType=REPEATED";

                $ch = curl_init();
                curl_setopt($ch, CURLOPT_URL, $url);
                curl_setopt($ch, CURLOPT_POST, 1);
                curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
                if ($this->getAppParam('sandbox', '1')) {
                    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
                } else {
                    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, true);
                }
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                $responseData = curl_exec($ch);
                if (curl_errno($ch)) {
                    return curl_error($ch);
                }
                curl_close($ch);
                $responseData = json_decode($responseData);
                $pattern = '/^(000\.000\.|000\.100\.1|000\.[36])/';
                if (!preg_match($pattern, $responseData->result->code)) {
                    $message = XiText::_('COM_PAYPLANS_APP_PAYUNITY_ERROR_RECURRING_PAYMENT');
                    $action = 'error';
                    PayplansHelperLogger::log(XiLogger::LEVEL_ERROR, $message, $payment, $responseData, 'PayplansPaymentFormatter');
                    return false;
                } else {
                    $transaction    = PayplansTransaction::getInstance();
                    $transaction->set('user_id', $invoice->getBuyer())
                                ->set('invoice_id', $invoice->getId())
                                ->set('payment_id', $payment->getId())
                                ->set('amount', $responseData->amount)
                                ->set('message', XiText::_('COM_PAYPLANS_APP_PAYUNITY_PAYMENT_COMPLETED_SUCCESSFULLY'))
                                ->set('gateway_txn_id', $responseData->id)
                                ->set('gateway_subscr_id', 0)
                                ->set('gateway_parent_txn', $sourceOrder)
                                ->set('params',	PayplansHelperParam::arrayToIni($responseData))
                                ->save();

                    $recurrence_count = $recurrence_count - 1;
                    $payment->getGatewayParams()->set('pending_recur_count', $recurrence_count);
                    $payment->save();
                }
            }
        }
    }


    private function _getRecurrenceCount(PayplansInvoice $invoice)
    {
        $count = $invoice->getRecurrenceCount();
        if(intval($count) === 0){
            return 9999;
        }

        $recurring = $invoice->isRecurring();
        if($recurring){

            // Recurrence Count For Regular Recurring Plan
            if($recurring == PAYPLANS_RECURRING){
                $recurrence_count = $invoice->getRecurrenceCount();
            }
            // Recurrence Count For Recurring + Trial 1 Plan
            if($recurring == PAYPLANS_RECURRING_TRIAL_1){
                $recurrence_count = $invoice->getRecurrenceCount() + 1;
            }
            // Recurrence Count For Recurring + Trial 2 Plan
            if($recurring == PAYPLANS_RECURRING_TRIAL_2){
                $recurrence_count = $invoice->getRecurrenceCount() + 2;
            }
        }
        return $recurrence_count;
    }

    /**
     * Validates the response from payment gateway.
     *
     */
    private function checkResponse(PayplansPayment $payment, $resParams) {

        $invoice                = $payment->getInvoice(PAYPLANS_INSTANCE_REQUIRE);
        $amount                 = $invoice->getTotal();
        if($amount == $resParams->amount && $payment->getKey()== $resParams->merchantTransactionId && $resParams->paymentType=='DB') {
            return array(true, XiText::_('COM_PAYPLANS_APP_PAYUNITY_NO_ERROR'));
        } else {
            return array(false, XiText::_('COM_PAYPLANS_APP_PAYUNITY_RESPONSE_ERROR'));
        }
    }
}
 
