<?php 
/**
* @copyright	Copyright (C) 2009 - 2015 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license	    GNU/GPL, see LICENSE.php
* @package	    PayPlans
* @subpackage	pdfInvoice
* @contact 	    support+payplans@readybytes.in
*/
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport( 'joomla.filesystem.archive' );
jimport( 'joomla.document.document' );

class plgPayplansPdfinvoice extends XiPlugin
{
	var $_name = 'pdfinvoice';	
	
	/**
	 * load plugin's view and controller
	 */
	public function onPayplansSystemStart()
	{
		//autoload view and controller
        $dir = dirname(__FILE__).DS.'pdfinvoice';
//      PayplansHelperLoader::addAutoLoadFile($dir.DS.'pdfinvoiceadminview.php', 'PayplansadminViewReports');
//		PayplansHelperLoader::addAutoLoadFile($dir.DS.'pdfinvoicecontroller.php', 'PayplansadminControllerReports');
        return true;
	}

	/**
	 * set plugin template for backend and front end
	 */
	public function onPayplansViewBeforeRender(XiView $view, $task)
	{
		//add submenu when plugin in enabled
		if(XiHelperJoomla::getPluginStatus('pdfinvoice','payplans')){
			//need to add reports submenu if it's not there
			$submenus = XiAbstractView::addSubmenus();
			if(!in_array('reports',$submenus)){
				XiAbstractView::addSubmenus('reports');
			}
			
			if(($view instanceof PayplansadminViewReports) && ($task == 'display')){
				$layout  	=  'default_admin';
				$templates 	= $this->_getTemplatePath($this->_name);
				foreach($templates as $tmpl)
					$view->addTemplatePath($tmpl);
					
				return self::renderTemplate($view, $layout);
			}
			
			if(($view instanceof PayplanssiteViewInvoice) && ($task == 'thanks' || $task == 'display')){
				$invoiceId 	= $view->getModel()->getId();
				$invoice 	= PayplansInvoice::getInstance($invoiceId);
				$this->_assign('invoice', $invoice);
				$html 	  	= $this->_render("download_pdfhtml",null,'default');
				return array("pp-invoice-thanks-action" => $html);
			}
		}
		return true;
	}	

	function onAfterRoute()
	{
		$mainframe = PayplansFactory::getApplication();
		$option    = JRequest::getCmd('option');
		$action    = JRequest::getcmd('action');
		if(!( $option == 'com_payplans' && 
			( isset($action) && ($action == 'adminPdfInvoice' || $action == 'sitePdfInvoice')))){
			return;
		}		

		//for backend
		if($action == 'adminPdfInvoice' )
		{
			$userid 	= XiFactory::getUser()->id;
			if(!$userid){
				return; //Do nothing is user not logged in
			}

			$user = PayplansUser::getInstance($userid);
		    	if(!$user->isAdmin()){
				return; // do nothing if user is not admin
			}

			if(!$this->doAdminAction())
				return ;
			if(!$this->createZipOfFiles()){
				PayplansFactory::getApplication()->enqueueMessage(XiText::_('PLG_PAYPLANS_PDFINVOICE_NO_RESULT_FOUND'), 'warning');
			}
			return;
		}
		//for frontend with action sitePdfInvoice
		else{
			
			//need to check we are allowing guest user to download invoice
			$allowGuestDownload = $this->params->get('allowGuestDownload', 0);
			
			if(PayplansFactory::getUser()->get('id') || $allowGuestDownload){
				$invoice_key   	= PayplansFactory::getApplication()->input->get('invoice_key',0);
				$invoiceId      = XiHelperUtils::getIdFromKey($invoice_key);
				$invoice 		= PayplansInvoice::getInstance($invoiceId);
       			 if(!$invoice){
        			PayplansFactory::getApplication()->enqueueMessage(XiText::_('PLG_PAYPLANS_PDFINVOICE_NO_RESULT_FOUND'), 'warning');
        			return true;
       			}

			    $this->_streamPdf($this->doSiteAction($invoice), $invoice_key);
			}
			else {
				PayplansFactory::getApplication()->enqueueMessage(XiText::_('PLG_PAYPLANS_PDFINVOICE_ACTIVATE_YOUR_ACCOUNT_FIRST'),'error');
				return true;
			}
		}
		return true;
	}
	
	/**
	 * delete all files and folders used in pdf generation
	 */
	function onPayplansCron()
	{
		if(!PayplansFactory::getSession()->get('pdfinvoice_lock',0)){
			$folders = JFolder::folders(dirname(__FILE__).DS.'pdfinvoice','pdfinvoices');
			foreach ($folders as $folder){
				$this->deleteFolder(JPATH_ROOT.DS.'media'.DS.'payplans'.DS.'app'.DS.'pdfinvoice'.DS.$folder);
			}
		}
		return true;
	}
	
	/**
	 * Start processing invoice for front end
	 */
	function doSiteAction($invoice)
	{	
		$record 				= new stdClass();
		$record->invoice_id   	= $invoice->getId();
		$record->created_date 	= $invoice->getCreatedDate();        
		$record->paid_date 		= $invoice->getPaidDate();
		
		$pdf = $this->getContentForPdf($result = array($record) , 1);
		return $pdf;
	}
	
	/**
	 * stream the pdf
	 */
	protected function _streamPdf($pdf, $invoice_key)
	{
		$pdf->stream('invoice_'.$invoice_key.'.pdf');
		exit;
	}
	
	/**
	 * start processing for invoices
	 */
	function doAdminAction()
	{
		$mysess      = PayplansFactory::getSession();
		$count	     = $mysess->get('pdfinvoice_count',1);
		$deleteFiles = PayplansFactory::getApplication()->input->get('pdfinvoice_deleteFiles',0,'GET');
		$limitStart  = $mysess->get('pdfinvoice_start',0);
		//delete folders related to the login user,if exist
		if($deleteFiles){
			$this->deleteUserFiles();
			$this->clearSessionVariables();
		}
		
		//if invoice key is given then use site side's function
		$invoiceKey = PayplansFactory::getApplication()->input->get('pdfinvoice_invoiceKey',0);
		if($invoiceKey){
			$invoiceId	= XiHelperUtils::getIdFromKey($invoiceKey);
			if(!$invoiceId){
				PayplansFactory::getApplication()->enqueueMessage(XiText::_('PLG_PAYPLANS_PDFINVOICE_INVALID_INVOICE_KEY'), 'warning');
			}else {
				$invoice = PayplansInvoice::getInstance($invoiceId);
       			 if(!$invoice){
        			PayplansFactory::getApplication()->enqueueMessage(XiText::_('PLG_PAYPLANS_PDFINVOICE_NO_RESULT_FOUND'), 'warning');
        			return;
       			}
				$this->_streamPdf($this->doSiteAction($invoice), $invoiceKey);
			}
			return;
		}
		
		//else get result for in between given dates
		$result 	= $this->getResultForInvoices();
		if(isset($result['result']) && !empty($result['result'])){
			$this->createFolder($this->getContentForPdf($result['result']), $count);
		}else {
			PayplansFactory::getApplication()->enqueueMessage(XiText::_('PLG_PAYPLANS_PDFINVOICE_NO_RESULT_FOUND'), 'warning');
			return;
		}

		//if total result is greater than processed result then set next limit and refresh the page 
		if(isset($result['totalResult']) && 
		         $result['totalResult']   >  ($limitStart + count($result['result']))){
			$mysess->set('pdfinvoice_count',++$count);
			$mysess->set('pdfinvoice_start', ($limitStart + count($result['result'])));
			$this->doRefresh();
			exit;
		}
		return true;
	}
	
	/**
	 * get the result invoices to be generated
	 */
	function getResultForInvoices()
	{
		$mysess  	  = PayplansFactory::getSession();
		$txnDateFrm   = $mysess->get('pdfinvoice_txnDateFrm',null);
		$txnDateTo    = $mysess->get('pdfinvoice_txnDateTo',null);
		$invoiceKey   = 0;
		//get variables from URL 
		if( empty($txnDateFrm) || empty($txnDateTo )){
			$txnDateFrm  = JRequest::getVar('pdfinvoice_txnDateFrm','00-00-0000');
			$txnDateTo  = JRequest::getVar('pdfinvoice_txnDateTo','00-00-0000');
			//if all fields are blank then return false
			if(empty($txnDateFrm) && empty($txnDateTo))
				return false;
			elseif (empty($txnDateFrm) && !empty($txnDateTo)){
				$txnDateFrm = $txnDateTo;
			}
			elseif (empty($txnDateTo) && !empty($txnDateFrm))
				$txnDateTo  = $txnDateFrm; 
				
			//also set in session for future use
			$mysess->set('pdfinvoice_txnDateFrm',$txnDateFrm);
			$mysess->set('pdfinvoice_txnDateTo',$txnDateTo);
		}
		
	    $result['totalResult'] = $mysess->get('pdfinvoice_total',null);		
		//get total result only for the first time,deciding it through variable 'pdfinvoice_deleteFiles'
		if(JRequest::getVar('pdfinvoice_deleteFiles',0)){
			$result['totalResult'] = $this->getTotalResults($txnDateFrm,$txnDateTo);
			$mysess->set('pdfinvoice_total',$result['totalResult']);			
		}
		
		$result['result'] = $this->_getResultInvoices($txnDateFrm,$txnDateTo);
		return $result;
	}
	
	/**
	 * build condition to be applied in query
	 */
	function _getResultInvoices($txnDateFrm,$txnDateTo)
	{
		$mysess  	= PayplansFactory::getSession();
		$limit 	    = $this->params->get('invoice_limit');
		$limitStart = $mysess->get('pdfinvoice_start',0);
		$records    = PayplansHelperInvoice::getInvoiceWithinDates($txnDateFrm , $txnDateTo, $limitStart, $limit);
		return $records;
	}
	
	/**
	 * set content in a pdf file and save it in a folder
	 */
	function getContentForPdf($result)
	{
	    $this->loadRequiredClasses();
		$contents = $this->includeHeader();
		if($result){
			foreach($result as $row){
				$content = $this->getTemplate($row);
				if(!$content){
					continue;
				}
				$contents .= $content;
			}
		}
		//create pdf file
		$contents.= "</body></html>";
		$pdf      = new DOMPDF();
		$pdf->set_paper("a4", "portrait");
		$pdf->load_html($contents);
		$pdf->render();
		return $pdf;
	}
	
	/**
	 *  Creating folder of given pdf files
	 */
	function createFolder($pdf, $count = 0 , $userId = null)
	{
		$user	  = PayplansFactory::getUser($userId);
		$dir_path = JPATH_ROOT.DS.'media'.DS.'payplans'.DS.'app'.DS.'pdfinvoice'.DS.'pdfinvoices'.$user->id;
		if(!is_dir($dir_path)){
		    mkdir($dir_path, 0777, true);
		}
		file_put_contents($dir_path.DS.'invoice'.$count.'.pdf', $pdf->output());
		return ;
	}	
	
	/**
	 * get template for pdf file
	 */
	function getTemplate($record)
	{	
		//get instances
		$invoice        = PayplansInvoice::getInstance($record->invoice_id);
		if(!$invoice)
			return false; 
		$user    		= PayplansUser::getInstance($invoice->getBuyer());
		if(!is_null($record->created_date)){
			$record->created_date   = is_object($record->created_date)?$record->created_date:(new XiDate($record->created_date));
		}
	
		$this->_assign('invoice', $invoice);
		$this->_assign('record', $record);	
		$this->_assign('user', $user);
		//trim otherwise it will generate next empty page while generating pdf
		return trim($this->_render('pdfcontent',null,'default'));
	}
	
	/**
	 * delete folder and contained files
	 */
	function deleteFolder($dirPath)
	{
		if(is_dir($dirPath)){	
			$files = JFolder::files($dirPath);
			foreach ($files as $file){
				unlink($dirPath.DS.$file);
			}
			JFolder::delete($dirPath);
		}
		return true;	
	}
	
	/**
	 * Delete all existing files in invoices folder
	 */
	function deleteUserFiles($userId = null)
	{   
		$user 	= PayplansFactory::getUser($userId);
		//delete files and folder before and after processing
		$this->deleteFolder(JPATH_ROOT.DS.'media'.DS.'payplans'.DS.'app'.DS.'pdfinvoice'.DS.'pdfinvoices'.$user->id);
		return true;
	}
	
	/**
	 * clear all session variables
	 */
	function clearSessionVariables()
	{
		$mysess   = PayplansFactory::getSession();
		$sessVars = array('pdfinvoice_start','pdfinvoice_count','pdfinvoice_deleteFiles',
						  'pdfinvoice_txnDateFrm','pdfinvoice_txnDateTo','pdfinvoice_total');
		foreach ($sessVars as $var){
			$mysess->clear($var);
		}
		return true;	
	}
	
	/**
	 * get total result exist in between the given dates
	 */
	function getTotalResults($txn_from , $txn_to)
	{	
		//set lock variable so that files/folders can be restricted to delete through cron  
	    PayplansFactory::getSession()->set('pdfinvoice_lock',PayplansFactory::getSession()->get('pdfinvoice_lock',0)+1);
		$query  = new XiQuery();
		return  count($query->select('DISTINCT `invoice_id`')
		                ->from('`#__payplans_invoice`')
		                ->where('Date(`paid_date`) >= "'.$txn_from.'"')
		                ->where('Date(`paid_date`) <= "'.$txn_to.'"')
		                ->where("`status` ='".PayplansStatus::INVOICE_PAID."'")
		                ->dbLoadQuery()
		                ->loadAssocList());
	}
	
	/**
	 * Create zip of pdf files 
	 */
	function createZipOfFiles()
	{
		$user 			   = PayplansFactory::getUser();
		$dir_path 		   = JPATH_ROOT.DS.'media'.DS.'payplans'.DS.'app'.DS.'pdfinvoice'.DS.'pdfinvoices'.$user->id.DS;
		$archive_file_name = $dir_path."pdfinvoices".$user->id.".zip";
		$files             = JFolder::files($dir_path);
		$zip 			   = new JArchive();
		$zip_adapter       = JArchive::getAdapter('zip'); // compression type
		
		$filesToZip 	   = array();
		//create file data required for zip_adapter
		foreach ($files as $file){
			$data 		   = JFile::read($dir_path.DS.$file);
			$filesToZip[]  = array('name'=> $file, 'data'=>$data);
		}
		
		//create the file and throw the error if unsuccessful
		if (!$zip_adapter->create($archive_file_name,$filesToZip)) {
          exit('Error creating zip file');
        }
		
	    //then send the headers to force download the zip file
	    if(file_exists($archive_file_name)){
		    header("Content-type: application/zip");
		    header("Content-Disposition: attachment; filename=pdfInvoices.zip");
		    header("Pragma: no-cache");
		    header("Expires: 0");
		    readfile("$archive_file_name");
		    $this->deleteUserFiles();
		    $this->clearSessionVariables();
		    
		    //unset lock variable so that cron can dekete the dummy folders if any
			PayplansFactory::getSession()->set('pdfinvoice_lock',PayplansFactory::getSession()->get('pdfinvoice_lock',0)-1);
		    exit;
	    }
	    return false;
	}	
	
	/**
	 * Refresh page for processing properly 
	 */
	function doRefresh()
	{
		$app 		 = PayplansFactory::getApplication();
		$currentUrl  = JURI::getInstance();
		//remove delete_files variable from url
		$currentUrl->delVar('pdfinvoice_deleteFiles');
		$redirectUrl = $currentUrl->toString();
       	$app->redirect($redirectUrl);
	}
	
	/**
	 * set header of pdf file 
	 */
	function includeHeader()
	{
		return $this->_render('pdfheader',null,'default');
	}
		
	/**
	 * load required classes of dompdf
	 */
	function loadRequiredClasses()
	{
		require_once dirname(__FILE__).DS.'pdfinvoice'.DS.'dompdf0.6'.DS."dompdf_config.inc.php";
	    $files = JFolder::files(DOMPDF_INC_DIR);
	    foreach ($files as $file){
			$class = JFile::stripExt($file);
			$class = JFile::stripExt($class);
			$frags = explode('_',$class);
		
			for($i=0; $i < count($frags); $i++)
				$frags[$i] = JString::ucfirst($frags[$i]);
				
			$class = implode ('_',$frags);
			XiHelperLoader::addAutoLoadFile(DOMPDF_INC_DIR.DS."$file",$class);
		}
		return;
	}
	
	public function renderTemplate(&$view, $layout)
	{
		$tabcontent  = "<li><a href='#pdfinvoice' data-toggle='tab'>".XiText::_('COM_PAYPLANS_REPORTS_PDF')." </a></li>";
		$content     = $this->_loadTemplate($layout);
		
		return array('payplans-admin-reports-tabs'=> $tabcontent, 'payplans-admin-reports-contents'=> $content);
	}
}

