<?php

/**
* @copyright	Copyright (C) 2009 - 2009 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license	GNU/GPL, see LICENSE.php
* @package	Payplans
* @subpackage	Phoca
* @contact	payplans@readybytes.in
*/
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

/**
 * Payplans Phoca Component
 *
 */
class plgPayplansPhoca extends XiPlugin
{

	public function onPayplansSystemStart()
	{
		//add acymailing app path to app loader
		$appPath = dirname(__FILE__).DS.'phoca'.DS.'app';
		PayplansHelperApp::addAppsPath($appPath);

		return true;
	}
	
	public static function onPayplansAccessCheck(PayplansUser $user)
	{
		
		//*retriction on direct access, if admin create menu link of phoda
		// access then it is needed to restrict the user to access
		
		$option = JRequest::getVar('option', false);
		
		$view 	= JRequest::getVar('view', false);
		
		if($option == 'com_phocadownload' && $view == 'category')
		{
			$userId = $user->getId();
			
			if(!$userId){
				$userId = -1;
			}
			
			//category id come as 1:phoca-cat-1 
			$categoryId 	= JRequest::getVar('id',false);
			$categoryId 	= strtok($categoryId,":");
			
			$parentCats = self::getParentCategories($categoryId);

			$apps = PayplansHelperApp::getAvailableApps('phocadownload');
			
			$accessibleCategories = array(); 
			$result = array();

			foreach ($apps as $app) {
				$appCateogries = $app->getAppParam('accessToCatOnActive');
				$appCateogries = (is_array($appCateogries))? $appCateogries : array($appCateogries);
				
				$restrictedCategories = array_intersect($parentCats, $appCateogries);
				if (!empty($restrictedCategories)) 
				{
					$accessibleCategories = $app->_getUserAccessPhocaCategories($userId);
					
					foreach ($restrictedCategories as $cat) {
						if (! array_key_exists($cat, $accessibleCategories))
						{
							$result[] = false;
							break;
						}
					}
				}
				else {
					$result[] = true;
				}
			}
			
			if (in_array(false, $result) )
			{
				$msg = XiText::_('COM_PAYPLANS_APP_PHOCADOWNLOAD_ACCESS_RIGHTS_DENIAL');
				XiFactory::getApplication()->redirect(XiRoute::_('index.php?option=com_payplans&view=plan&task=subscribe'), $msg);
			}
			return true;
			
		}
		
		return true;
	}
	
	public static function getParentCategories($catId, $parent = array())
	{
		$parent[] = $catId;
		
		$categories = PayplansAppPhocadownload::getCategories();
	
		if($categories[$catId]->parent_id == 0) {
			return $parent;
		}
	
		return self::getParentCategories($categories[$catId]->parent_id, $parent);
	}

}
