<?php
/**
 * @copyright	Copyright (C) 2009 - 2013 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * @package		PayPlans
 * @subpackage	Frontend
 * @contact 	payplans@readybytes.in
 * @author		Puneet Singhal
 */
if(defined('_JEXEC')===false) die();?>

<div class="row-fluid">
	<form method="post" action="<?php echo $post_url;?>" name="pin-payment-form" id="checkout_form">

		<b>
			<?php echo $this->_render('partial_amount', compact('currency', 'amount'), 'default'). XiText::_('COM_PAYPLANS_PAYMENT_APP_PIN_PAYMENT_AMOUNT');?>
       </b>

		<fieldset class="form-horizontal">
			<legend><?php echo XiText::_('COM_PAYPLANS_PAYMENT_APP_PIN_CREDIT_CARD_DETAIL')?></legend>

			<div class="control-group">
				<div class="control-label"><?php echo XiText::_('COM_PAYPLANS_PAYMENT_APP_PIN_CREDIT_CARD_NUMBER');?> </div>
				<div class="controls">
					<input type="number" class="required pp-validate-creditcard" data-validation-creditcard-message= "<?php echo XiText::_("COM_PAYPLANS_PAYMENT_GATEWAY_INVALID_CREDIT_CARD")?>" name="card-number" id=card-number >
				</div>
			</div>
			
			<div class="control-group">	
				<div class="control-label"><?php echo XiText::_('COM_PAYPLANS_PAYMENT_APP_PIN_CREDIT_CARD_CVC');?></div>
				<div class="controls">
					<input type="number" class="required pp-validate-cvclength" id=card-cvc  data-validation-cvclength-message= "<?php echo XiText::_("COM_PAYPLANS_PAYMENT_GATEWAY_INVALID_CVC_LENGTH")?>" data-pp-validate='#card-number' name="card-cvc">
				</div>
			</div>
			
			<div class="control-group">
				<div class="control-label"><?php echo XiText::_('COM_PAYPLANS_PAYMENT_APP_PIN_CREDIT_CARD_EXPIRATION');?></div>
				
				<div class="controls">
				<?php 
					/*** array of months ***/
					$months = array(
					1=>XiText::_('JANUARY'),
					2=>XiText::_('FEBRUARY'),
					3=>XiText::_('MARCH'),
					4=>XiText::_('APRIL'),
					5=>XiText::_('MAY'),
					6=>XiText::_('JUNE'),
					7=>XiText::_('JULY'),
					8=>XiText::_('AUGUST'),
					9=>XiText::_('SEPTEMBER'),
					10=>XiText::_('OCTOBER'),
					11=>XiText::_('NOVEMBER'),
					12=>XiText::_('DECEMBER'));
	
					/*** current month ***/
					$select = '<select name="card-expiry-month" style="width:93px;">'."\n";
					foreach($months as $key=>$mon)
					{
						$select .= "<option value=".$key;
						$select .= ">$mon</option>\n";
					}
					$select .= '</select>';
					echo $select;
	
					/*** the current year ***/
					$start_year = date('Y');
					$end_year = $start_year + 20;
	
					/*** range of years ***/
					$rangeOfYear = range($start_year, $end_year);
	
					/*** create the select ***/
					$select = '<select name="card-expiry-year" style="width:93px;">';
					foreach( $rangeOfYear as $year )
					{
						$select .= "<option value=".$year;
						$select .= ">$year</option>\n";
					}
					$select .= '</select>';
	
					echo $select;

				?>
				</div>
			</div>
		</fieldset>
		
		<fieldset class="form-horizontal pp-secondary pp-color pp-border pp-background pp-small">
	      	<legend><?php echo XiText::_('COM_PAYPLANS_PAYMENT_APP_PIN_PERSONAL_DETAILS'); ?></legend>
	        <div class="control-group">
	          <div class="control-label"><?php echo XiText::_('COM_PAYPLANS_PAYMENT_APP_PIN_NAME')?></div>
	          <div class="controls">
	          		<input type="text" class="required" name="card-name" value="" /><br/>
	          		<span style="font-size:0.85em;"><?php echo XiText::_('COM_PAYPLANS_PAYMENT_APP_PIN_NAME_MSZ');?></span>
	          </div>
	        </div>
	        
	         <div class="control-group">
	          <div class="control-label"><?php echo XiText::_('COM_PAYPLANS_PAYMENT_APP_PIN_EMAIL')?></div>
	          <div class="controls"><input type="text" class="required email" name="email" value="<?php echo $email;?>" /></div>
	        </div>
	        
	        <div class="control-group">
	          <div class="control-label"><?php echo XiText::_('COM_PAYPLANS_PAYMENT_APP_PIN_ADDRESS_LINE_ONE')?></div>
	          <div class="controls"><textarea name="address" cols="27"  rows="5"  class="required"></textarea></div>
	        </div>
	        
	        <div class="control-group">
	          <div class="control-label"><?php echo XiText::_('COM_PAYPLANS_PAYMENT_APP_PIN_CITY')?></div>
	          <div class="controls"><input type="text" class="required" name="city" value="" /></div>
	        </div>
	
	        <div class="control-group">
	          <div class="control-label"><?php echo XiText::_('COM_PAYPLANS_PAYMENT_APP_PIN_STATE')?></div>
	          <div class="controls"><input type="text" name="state" value="" /></div>
	        </div>
	        
	        <div class="control-group">
	          <div class="control-label"><?php echo XiText::_('COM_PAYPLANS_PAYMENT_APP_PIN_COUNTRY')?></div>
	          <div class="controls"><input type="text" class="required" name="country" value="Australia" /></div>
	        </div>
	
	        <div class="control-group">
	          <div class="control-label"><?php echo XiText::_('COM_PAYPLANS_PAYMENT_APP_PIN_ZIP_CODE')?></div>
	          <div class="controls"><input type="text" name="zip" value="" /></div>
	        </div>
        
      </fieldset>
      
	  <fieldset class="form-horizontal">
	  	<div class="row-fluid">
	  		<div class="offset3 span9 ">
				<button id="pp-payment-app-buy" class="btn btn-primary btn-large"><?php echo XiText::_('COM_PAYPLANS_PAYMENT_APP_PIN_PAYMENT_BUY');?></button>&nbsp;&nbsp;&nbsp;&nbsp;
				<a class="btn btn-large" href="<?php echo XiRoute::_("index.php?option=com_payplans&view=payment&task=complete&action=cancel&payment_key=$paymentKey"); ?>"><?php echo XiText::_('COM_PAYPLANS_APP_STRIPE_PAYMENT_CANCEL')?>
				</a>
			</div>
	  	</div>
	</fieldset>
	</form>
</div>



<?php 
