<?php
/**
 * Add On as a Services
 * @copyright Copyright (C) 2009 - 2014 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
 * @license GNU/GPL, see LICENSE.php
 * @package Payplans
 * @subpackage	PlanAddons
 * @version 3.2
 * @author Mohit Agrawal <mohit@readybytes.in>
 */

if(defined('_JEXEC')===false) die();

class PayplansModelPlanaddons extends XiModel
{
	public $filterMatchOpeartor = array(
										'published'	    => array('='),
										'price' => array('>=', '<='),
										'title'			=> array('LIKE'),
										'start_date' 	=> array('>=', '<='),
										'end_date'		=> array('>=', '<=')
										);
	
	//return the applicable services on particular plan
	//filter the out of stock services also
	public function loadAvailableServices(Array $plans = array())
	{
		static $results = array();

		if ( ! empty($results) ) {
			return $results;
		}
		
		$currentDate = new XiDate('now');
		$allServices = $this->loadRecords(array( 'published' => 1 , 'start_date' => array(array("<=", "'$currentDate'")) , 'end_date' => array(array(">=", "'$currentDate'" ) ) ));
		
		if (empty($plans)) {
			return $allServices;
		}
		
		foreach ( $allServices as $service ) {
			
			$params 	= new XiParameter($service->params);
			$isLimited 	= $params->get('availability', 0);
			
			if ($isLimited) {
			
				$stock 		= $params->get('stock', 0);
				$remaining 	= $stock - $service->consumed;
				
				//calulate remaing stock
				if( $remaining <= 0 ) {
					//do not count-in  if out of stock
					continue;
				}
			}
			
			if ( $service->apply_on == 1 ) {
				$results[] = $service;
				continue;
			}

			$servicePlans =  json_decode($service->plans);
			
			if ( array_intersect($plans, $servicePlans) ) {
				$results[] = $service;
			}
		}

		return $results;
	}
}

class PayplansModelformPlanaddons extends XiModelform
{
}
