<?php
/**
 * Add On as a Services view
 * @copyright Copyright (C) 2009 - 2014 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
 * @license GNU/GPL, see LICENSE.php
 * @package Payplans
 * @subpackage	PlanAddons
 * @version 3.2
 * @author Mohit Agrawal <mohit@readybytes.in>
 */

if(defined('_JEXEC')===false) die();

class PayplansadminViewPlanaddons extends XiView
{
	protected function _adminGridToolbar()
	{
		XiHelperToolbar::addNew('new');
		XiHelperToolbar::editList();
		XiHelperToolbar::divider();
		XiHelperToolbar::publish();
		XiHelperToolbar::unpublish();
		XiHelperToolbar::divider();
		XiHelperToolbar::delete();
		XiHelperToolbar::divider();
		XiHelperToolbar::openPopup('searchRecords', 'search', 'search.png', 'COM_PAYPLANS_TOOLBAR_SEARCH', true );
	}

	public function _getTemplatePath($layout = 'default')
	{
		return array_merge(parent::_getTemplatePath($layout),array(dirname(__DIR__).DS.'templates'.DS.'planaddons'));
	}

	public function _displayGrid($records)
	{

		$plugin 		= JPluginHelper::getPlugin('payplans', 'planaddons');
		$pluginParams 	= new XiParameter($plugin->params);
		$showAdvance 	= $pluginParams->get('show_advance', 0);

		$this->assign('showAdvance',$showAdvance);

		return parent::_displayGrid($records);
	}

	public function edit($tpl=null, $itemId=null)
	{
		$itemId     = ($itemId === null) ? $this->getModel()->getState('id') : $itemId;
		$service   	= PayplansPlanaddons::getInstance($itemId);
		$logRecords	= XiFactory::getInstance('log', 'model')
								->loadRecords(array('object_id'=>$itemId, 'class'=>'PayplansPlanaddons'));

		//needed to add path of this xml
		JForm::addFormPath(dirname(__FILE__));

		$form     		= $service->getModelform()->getForm($service);

		$plugin 		= JPluginHelper::getPlugin('payplans', 'planaddons');
		$pluginParams 	= new XiParameter($plugin->params);

		$showAdvance 	= $pluginParams->get('show_advance', 0);

		$this->assign('showAdvance', $showAdvance);
		$this->assign('form', $form);
		$this->assign('log_records', $logRecords);
		$this->assign('service', $service);
		return true;
	}
}
