<?php
/**
* @copyright	Copyright (C) 2009 - 2009 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		PayPlans
* @subpackage	Prodiscount
* @contact 		shyam@readybytes.in
*/
if(defined('_JEXEC')===false) die();

class PayplansTableProdiscount extends XiTable
{
	public function __construct($tblFullName=null, $tblPrimaryKey='prodiscount_id', $db=null)
	{
		static $isTableExist = false;
		// if discount table does not exist, and static variable is not true then create table
		if(!$isTableExist && XiHelperTable::isTableExist('#__payplans_prodiscount')==false)
		{
			$sql = 'CREATE TABLE IF NOT EXISTS `#__payplans_prodiscount` (
						  `prodiscount_id` INT NOT NULL AUTO_INCREMENT,
						  `title`		   VARCHAR(255) ,
						  `coupon_code`	   VARCHAR(255) ,
						  `coupon_type`	   VARCHAR(255) ,
						  `core_discount`  TINYINT(1) ,
						  `coupon_amount`  DECIMAL(15,5) DEFAULT 0.00000 ,
						  `plans`		   VARCHAR(255) ,
						  `start_date`     DATETIME , 
						  `end_date`       DATETIME ,
						  `published`	   TINYINT(1) ,
						  `params`         TEXT ,
  						   PRIMARY KEY (`prodiscount_id`)
						)
						ENGINE = MyISAM
						DEFAULT CHARACTER SET = utf8 
						AUTO_INCREMENT=1;';
			$dbo = XiFactory::getDBO();
			$dbo->setQuery($sql);
			$dbo->query();
			
			// For resolving caching issue of tables:
			// if this work is not done then the new table is not 
			// added to the cached table list even after successfully 
			// creation of the table and sometimes generate error
			if($dbo->query()){
				XiFactory::cleanStaticCache(true);
				XiHelperTable::isTableExist('#__payplans_prodiscount');
				XiFactory::cleanStaticCache(false);
				$isTableExist = true;
			}
		}
	
		return parent::__construct($tblFullName, 'prodiscount_id', $db);
	}
 }