<?php
/**
* @copyright	Copyright (C) 2009 - 2009 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		PayPlans
* @subpackage	Prodiscount
* @contact 		payplans@readybytes.in
*/
if(defined('_JEXEC')===false) die();


class PayplansadminViewProdiscount extends XiView
{
	
	protected function _adminToolbar()
	{
		$this->_adminToolbarTitle();

		if($this->getTask() == 'bulkCodes' ) {
			XiHelperToolbar::custom('generateBulkDiscount', 'cog.png', 'cog.png', 'COM_PAYPLANS_APP_PRODISCOUNT_GENERATE',false);
			XiHelperToolbar::cancel();
		}
		else {
			parent::_adminToolbar();
		}
	}
	
	
 	public function getJSValidActions()
    {
    	$actions = parent::getJSValidActions();
    	
    	return array_merge($actions, array('generateBulkDiscount'));
    	
    }	

	protected function _adminGridToolbar()
	{
		XiHelperToolbar::addNew('new');
		XiHelperToolbar::custom('bulkCodes', 'cog.png', 'cog.png', 'COM_PAYPANS_APP_PRODISCOUNT_GENERATE_MASS_CODES',false);
		XiHelperToolbar::editList();
		XiHelperToolbar::divider();
		XiHelperToolbar::publish();
		XiHelperToolbar::unpublish();
		XiHelperToolbar::divider();
		XiHelperToolbar::delete();
		XiHelperToolbar::divider();
		XiHelperToolbar::openPopup('searchRecords', 'search', 'search.png', 'COM_PAYPLANS_TOOLBAR_SEARCH', true );
	}

	function _getTemplatePath($layout = 'default')
	{
		return array_merge(parent::_getTemplatePath($layout),$this->_path['template']);
	}
	
	function _displayGrid($records)
	{
		// for plans caching
		$planIds = array();
		$plans   = array();
		foreach ($records as $record){
			if(!empty($record->plans)){
				$planIds[] = $record->plans;
			}
		}
		if(!empty($planIds)){
			$filter = array('plan_id' => array(array('IN', "(".implode(",", $planIds).")")));
			$plans = PayplansHelperPlan::get($filter);
		}
		
		$this->assign('plans', $plans);
		return parent::_displayGrid($records);
	}
	
	function edit($tpl=null, $itemId=null)
	{
		$itemId     = ($itemId === null) ? $this->getModel()->getState('id') : $itemId;
		$discount   = PayplansProdiscount::getInstance($itemId);
		$logRecords	= XiFactory::getInstance('log', 'model')
								->loadRecords(array('object_id'=>$itemId, 'class'=>'PayplansProdiscount'));
		
		//needed to add path of this xml
		JForm::addFormPath(dirname(__FILE__));
								
		$form        = $discount->getModelform()->getForm($discount);

		$coupon_type =  array();
		$arg = array(&$coupon_type);
		PayplansHelperEvent::trigger('onPayplansGetDiscountType', $arg );
		$this->assign('coupon_type', $coupon_type);
		$this->assign('form',$form);
		$this->assign('log_records',$logRecords);
		$this->assign('discount', $discount);
		return true;
	}
	
	function bulkCodes()
	{

		$discount   = PayplansProdiscount::getInstance(0);
		
		//needed to add path of this xml
		JForm::addFormPath(dirname(__FILE__));
								
		$form        = $discount->getModelform()->getForm($discount);

		$this->assign('form',$form);
		$this->assign('discount', $discount);
		$this->setTpl('generateBulkDiscount');
		return true;
	}
	
	public function _getDynamicJavaScript()
	{
	  ob_start(); ?>

        payplansAdmin.prodiscount_generateBulkDiscount = function()
        {
           
            var e = document.getElementById("core_discount");
            var applyAll = e.options[e.selectedIndex].value;
            if(applyAll == "1")
            {
                return true;
            }
           
            var eles = payplans.jQuery('input[name="Payplans_form[plans][]"]');
   
            for(var i =0; i < eles.length; i++){
                if(eles.hasOwnProperty(i) && eles[i].value != undefined && eles[i].value !=0 && eles[i].value.length > 0){
                    return true;
                }
            }
            
            // this is done inorder to find the parent div.
            var eles = payplans.jQuery('input[name="Payplans_form[plans]"]');
            parent = eles.closest(".control-group").first();
            help   = parent.find('div[class="help-block"]');
            help.html("<ul><li class='text-error'>This is required</li></ul>");
 			return false;          

        }
	
        <?php
        $js = ob_get_contents();
        ob_end_clean();
        return $js;
	}
	
	public function discountHelp()
	{
	 	$this->_setAjaxWinTitle(XiText::_('COM_PAYPLANS_PRODISCOUNT_COUPON_TYPE'));
    	$this->_setAjaxWinAction();
    	return true;
	}
}

