<?php
/**
* @copyright	Copyright (C) 2009 - 2016 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		PayPlans
* @subpackage		QuickPay
* @contact 		support+payplans@readybytes.in
*/
if(defined('_JEXEC')===false) die();

class PayplansAppQuickpay extends PayplansAppPayment
{
	protected $_location	= __FILE__;


	function isApplicable($refObject = null, $eventName='')
	{
		// return true for event onPayplansControllerCreation
		if($eventName == 'onPayplansControllerCreation'){
			return true;
		}
		
		return parent::isApplicable($refObject, $eventName);
	}

	function onPayplansControllerCreation(&$view, &$controller, &$task, &$format)
      {
         if($view != 'payment' || ($task != 'notify') ){
            return true;
         }
		  $request_body = file_get_contents("php://input");
		  /*$checksum     = $this->sign($request_body, $this->getAppParam('private_key') );
		  if ($checksum == $_SERVER["HTTP_QUICKPAY_CHECKSUM_SHA256"]) {
			  // Request is authenticated
		  } else {
			  // Request is NOT authenticated
		  }*/
		  $resultData = (array)json_decode($request_body);
		  $order_id = $resultData['order_id'];
		  $values = explode('_',$order_id,2);
		  $paymentId = $values['0'];
		  $paymentKey = XiHelperUtils::getKeyFromId($paymentId);
        if(!empty($paymentKey)){
            JRequest::setVar('payment_key', $paymentKey, 'POST');
            return true;
        }
        
        return true;
    }
	
	public function onPayplansPaymentForm(PayplansPayment $payment, $data = null)
	{
		if(is_object($data)){
			$data = (array)$data;
		}
		$invoice = $payment->getInvoice(PAYPLANS_INSTANCE_REQUIRE);
		//IMP: transaction amount must be in its smallest unit
		$amount  = number_format($invoice->getTotal(),2,'.','')*100;
		
		// setup urls
		$root = JURI::root();
    	if(XiFactory::getConfig()->https == true){
    		$root = JString::str_ireplace("http:", "https:", $root);
    	}
		$time = new XiDate();
		$order_id = $time->toUnix();

    	$params = array();
    	$params['version'] = 'v10';
    	$params['merchant_id'] =$this->getAppParam('merchant_id');
    	$params['agreement_id'] = $this->getAppParam('agreement_id');
    	$params['order_id'] = $payment->getId().'_'.$order_id;
    	$params['amount'] = $amount;
    	$params['autocapture'] = '1';
    	$params['currency'] = $invoice->getCurrency('isocode');
    	$params['continueurl'] = $root.'index.php?option=com_payplans&gateway=quickpay&view=payment&task=complete&action=success&payment_key='.$payment->getKey();
    	$params['cancelurl'] =   $root.'index.php?option=com_payplans&gateway=quickpay&view=payment&task=complete&action=cancel&payment_key='.$payment->getKey();
    	$params['callbackurl'] = $root.'index.php?option=com_payplans&gateway=quickpay&view=payment&task=notify';
    	$checksum = $this->__generateChecksum($params,$this->getAppParam('payment_key'));
		// basic setup
		$this->assign('version', "v10");
		$this->assign('merchant_id', $this->getAppParam('merchant_id'));
		$this->assign('agreement_id', $this->getAppParam('agreement_id'));
		$this->assign('order_id', $payment->getId().'_'.$order_id);
		$this->assign('amount', $amount);
		$this->assign('autocapture', '1');
		$this->assign('currency', $invoice->getCurrency('isocode'));
		$this->assign('continueurl', $root.'index.php?option=com_payplans&gateway=quickpay&view=payment&task=complete&action=success&payment_key='.$payment->getKey());
		$this->assign('cancelurl', 	 $root.'index.php?option=com_payplans&gateway=quickpay&view=payment&task=complete&action=cancel&payment_key='.$payment->getKey());
		$this->assign('callbackurl', $root.'index.php?option=com_payplans&gateway=quickpay&view=payment&task=notify');
		$this->assign('invoice', $invoice);
		$this->assign('checksum', $checksum);
		$this->assign('post_url', "https://payment.quickpay.net");

		if($invoice->isRecurring()) {
		$params1 = array();
		$params1['type'] = 'subscription';
		$params1['description'] = $invoice->getId();
	    	$params1['version'] = 'v10';
	    	$params1['merchant_id'] = $this->getAppParam('merchant_id');
	    	$params1['agreement_id'] = $this->getAppParam('agreement_id');
	    	$params1['order_id'] = $payment->getId().'_'.$order_id;
	    	$params1['amount'] = $amount;
	    	$params1['autocapture'] = '1';
	    	$params1['currency_code'] = $invoice->getCurrency('isocode');
	    	$params1['continueurl'] = $root.'index.php?option=com_payplans&gateway=quickpay&view=payment&task=complete&action=success&payment_key='.$payment->getKey();
	    	$params1['cancelurl'] = $root.'index.php?option=com_payplans&gateway=quickpay&view=payment&task=complete&action=cancel&payment_key='.$payment->getKey();
	    	$params1['callbackurl'] = $root.'index.php?option=com_payplans&gateway=quickpay&view=payment&task=notify';
	    	$checksum = $this->__generateChecksum($params1,$this->getAppParam('payment_key'));
		$this->assign('type',  'subscription');
		$this->assign('description',  $invoice->getId());
		$this->assign('version', "v10");
		$this->assign('merchant_id', $this->getAppParam('merchant_id'));
		$this->assign('agreement_id', $this->getAppParam('agreement_id'));
		$this->assign('order_id', $payment->getId().'_'.$order_id);
		$this->assign('amount',      $amount);
		$this->assign('invoice',     $invoice);
		$this->assign('autocapture', 1);
		$this->assign('currency_code',  $invoice->getCurrency('isocode'));
		$this->assign('continueurl', $root.'index.php?option=com_payplans&gateway=quickpay&view=payment&task=complete&action=success&payment_key='.$payment->getKey());
		$this->assign('cancelurl', 	$root.'index.php?option=com_payplans&gateway=quickpay&view=payment&task=complete&action=cancel&payment_key='.$payment->getKey());
		$this->assign('callbackurl', $root.'index.php?option=com_payplans&gateway=quickpay&view=payment&task=notify');
		$this->assign('checksum',  $checksum);
		}

		return $this->_render('form_standard');
	}

	/**
	 * Generates  A MD5 checksum to ensure data integrity. 
	 * See http://tech.quickpay.net/payments/form/ for more information.
	 * 
	 * @return String : checksum hash
	 */
	private function __generateChecksum($params,$api_key)
	{	
		ksort($params);

		$string = implode(" ", $params);

		return hash_hmac("sha256", $string, $api_key);

	}
	
	public function onPayplansPaymentAfter(PayplansPayment $payment, &$action, &$data, $controller)
	{
			return parent::onPayplansPaymentAfter($payment, $action, $data, $controller);
	}
	
	protected function _validateResponse($response, $payment)
	{
		if($response['state'] == 'active' || $response['state'] == 'processed'){
			return true;
		}
		else {
			if ($response['state'] == 'pending') {
				return false;
			} else {
				$message = XiText::_('COM_PAYPLANS_LOGGER_QUICKPAY_ERROR_OCCURED_IN_PROFILE_CREATION');
				$error = $response;
				PayplansHelperLogger::log(XiLogger::LEVEL_ERROR, $message, $payment, array($error), 'PayplansPaymentFormatter', '', true);
				}
			}

		return false;
 	}
	
	function withdrawalFromSubscription($payment, $invoice, $amount)
	{ 
		$params = $payment->getGatewayParams()->toArray();
		$root = JURI::root();
		if(XiFactory::getConfig()->https == true){
			$root = JString::str_ireplace("http:", "https:", $root);
		}
		$headerParameter = array(
			'callbackurl' => $root.'index.php?option=com_payplans&gateway=quickpay&view=payment&task=notify',
			'version' => 'v10',
			'api_user_key' => $this->getAppParam('apiuserkey')
		);
		$time = new XiDate();
		$order_id = $time->toUnix();
		$subscriptionParameter = array(
			'order_id' => $payment->getId().'_'.$order_id,
			'amount' => $amount,
			'id' => $params['transaction_id'],
			'auto_capture' => '1'
		);

   		$checksum = $this->__generateChecksum($subscriptionParameter,$this->getAppParam('apiuserkey'));

		$subscriptionParameter['checksum'] = $checksum;

		return $this->curlRequest($subscriptionParameter, $headerParameter, "https://api.quickpay.net//subscriptions/".$params['transaction_id']."/recurring");
	}
	
	private function _processRecurringPayment(PayplansPayment $payment, $invoice, $amount)
	{
		$deductCount	= 1 ;
		$gatewayParams	= $payment->getGatewayParams();

		//send request to quickpay to make a withdrawal from subscription
		$quickpayResponse = $this->withdrawalFromSubscription($payment, $invoice, $amount);


		$responsedata  = json_decode($quickpayResponse);
		if(is_object($responsedata)){
			$responsedata = (array)$responsedata;
		}
		if(JDEBUG) {
			file_put_contents(JPATH_SITE . DS . 'tmp' . DS . time(), var_export($responsedata, true), FILE_APPEND);
		}

			//as one payment has been made so update pending_recur_count parameter of the payment
		$gatewayParams->set('pending_recur_count', $gatewayParams->get('pending_recur_count') - $deductCount);
		$payment->set('gateway_params', $gatewayParams)
				->save();
	}
	
	public function processPayment(PayplansPayment $payment, $invoiceCount)
	{
		$invoice = $payment->getInvoice(PAYPLANS_INSTANCE_REQUIRE);
		$invoice_count = $invoiceCount + 1;
		
		if($invoice->isRecurring())
		{
			$recurrence_count 	= $payment->getGatewayParam('pending_recur_count');

			if($recurrence_count > 0) {
				$amount = number_format($invoice->getTotal($invoice_count),2,'.','') * 100; // amount must be in its smallest unit
				$this->_processRecurringPayment($payment, $invoice, $amount);
			}
		}
	}

	function sign($base, $private_key) {
		return hash_hmac("sha256", $base, $private_key);
	}
	
	public function onPayplansPaymentNotify(PayplansPayment $payment, $data, $controller)
	{
		$rawData = file_get_contents("php://input");
		$responsedata = json_decode($rawData);
		if(is_object($responsedata)){
			$responsedata = (array)$responsedata;
		}
	$validation    = $this->_validateResponse($responsedata, $payment);
	if($validation)
	{
		if($responsedata['type'] == 'Subscription'){
				return $this->processFirstSubscription($responsedata,$payment);
		}

		$invoice = $payment->getInvoice(PAYPLANS_INSTANCE_REQUIRE);
		$gatewayParams = $payment->getGatewayParams();
		$subcription_id = $gatewayParams->get('transaction_id');
		$operations = $responsedata['operations'];
		foreach ($operations as $key) {
			if ($key->type == 'refund') {
				$transaction = PayplansTransaction::getInstance();
				$transaction->set('user_id', 			$payment->getBuyer())
					->set('invoice_id', 		$invoice->getId())
					->set('payment_id', 		$payment->getId())
					->set('gateway_txn_id',		$responsedata['id'])
					->set('gateway_subscr_id', 	$subcription_id)
					->set('gateway_parent_txn', $responsedata['id'])
					->set('params', 			PayplansHelperParam::arrayToIni($responsedata))
					->set('amount', -$key->amount / 100)
					->set('message', 'COM_PAYPLANS_PAYMENT_APP_QUICKPAY_REFUND_SUCCESS');
					return $transaction->save();
					}
				}

		// if same notification came more than one time
		// Check if transaction already exists,if yes then do nothing and return
	    $txn_id         = isset($responsedata['id']) ? $responsedata['id'] : 0;
	    $subscr_id 		= isset($subcription_id) ? $subcription_id : 0;
	    $parent_id 		= isset($responsedata['parent_txn_id']) ? $responsedata['parent_txn_id'] : 0;
	    $transactions 	= $this->_getExistingTransaction($invoice->getId(), $txn_id, $subscr_id, $parent_id);
    	if (!empty($transactions)) {
    		foreach ($transactions as $transaction) {
    			$transaction = PayplansTransaction::getInstance($transaction->transaction_id, null, $transaction);
    			if($transaction->getParam('type','') == $responsedata['type'] &&
					$transaction->getParam('state','') == $responsedata['state']){
    					return true;
				}
    		}
    	}
		// get the transaction instace of lib
		$transaction = PayplansTransaction::getInstance();
		$transaction->set('user_id', 			$payment->getBuyer())
					->set('invoice_id', 		$invoice->getId())
					->set('payment_id', 		$payment->getId())
					->set('gateway_txn_id',		$txn_id)
					->set('gateway_subscr_id', 	$subscr_id)
					->set('gateway_parent_txn', $parent_id)
					->set('params', 	     PayplansHelperParam::arrayToIni($responsedata));
		$operations = $responsedata['operations'];
		//set the transaction message as per status
		foreach ($operations as $key) {
			if ($key->type == 'capture' && $key->qp_status_code == '20000') {
					$transaction->set('message', "COM_PAYPLANS_APP_QUICKPAY_TRANSACTION_COMPLETED");
					$transaction->set('amount', $key->amount / 100);
				} else {
					$transaction->set('message', 'COM_PAYPLANS_APP_QUICKPAY_TRANSACTION_NO_STATUS');
				}
			}
		return $transaction->save();
	}
	return false;
	}
	function processFirstSubscription($response, $payment){
		$invoice = $payment->getInvoice(PAYPLANS_INSTANCE_REQUIRE);
		// if same notification came more than one time
			// Check if transaction already exists,if yes then do nothing and return
			$txn_id         = 0;
		    $subscr_id 		= isset($response['id']) ? $response['id'] : 0;
		    $parent_id 		= isset($response['id']) ? $response['id'] : 0;
			$transactions 	= $this->_getExistingTransaction($invoice->getId(), $txn_id, $subscr_id, $parent_id);
	    	if (!empty($transactions)) {
	    		foreach ($transactions as $transaction) {
	    			$transaction = PayplansTransaction::getInstance($transaction->transaction_id, null, $transaction);
	    			if($transaction->getParam('qpstat','') == $response['qpstat'] &&
	  					$transaction->getParam('state','') == $response['state']){
	    					return true;
    				}
	    		}
	    	}

				$transaction = PayplansTransaction::getInstance();
				$transaction->set('user_id', $invoice->getBuyer())
							->set('invoice_id', $invoice->getId())
							->set('payment_id', $payment->getId())
							->set('gateway_subscr_id', $subscr_id ? $subscr_id : 0)
							->set('message', 'COM_PAYPLANS_PAYMENT_APP_QUICKPAY_PROFILE_CREATED')
							->set('params', PayplansHelperParam::arrayToIni($response))
							->set('amount', 0)
							->save();

				$params = new XiParameter();
				$params->set('transaction_id', $response['id']);
				$params->set('pending_recur_count', $this->_getRecurrenceCount($invoice));

				$payment->set('gateway_params', $params)
						->save();

				$this->_processRecurringPayment($payment, $invoice, number_format($invoice->getTotal(),2,'.','') * 100);
		return true;
			}
	private function _getRecurrenceCount(PayplansInvoice $invoice)
	{
		$count = $invoice->getRecurrenceCount();
		if(intval($count) === 0){
			return 9999;
		}
		
		$recurring = $invoice->isRecurring();
		if($recurring){
			
			// Recurrence Count For Regular Recurring Plan
       		if($recurring == PAYPLANS_RECURRING){
	       		$recurrence_count = $invoice->getRecurrenceCount();
       		}
       		// Recurrence Count For Recurring + Trial 1 Plan
       		if($recurring == PAYPLANS_RECURRING_TRIAL_1){
				$recurrence_count = $invoice->getRecurrenceCount() + 1;
       		}
       		// Recurrence Count For Recurring + Trial 2 Plan
       		if($recurring == PAYPLANS_RECURRING_TRIAL_2){
	       		$recurrence_count = $invoice->getRecurrenceCount() + 2;
       		}
		}
		return $recurrence_count;
	}
	
	public function isSupportPaymentCancellation($invoice)
	{
		if($invoice->isRecurring()){
			return true;
		}
		return false;
	}
	
	public function onPayplansPaymentTerminate(PayplansPayment $payment, $controller)
	{
		$invoice   		= $payment->getInvoice(PAYPLANS_INSTANCE_REQUIRE);	
		$gatewayParams  = $payment->getGatewayParams();
		$transaction_id = $gatewayParams->get('transaction_id',0);

		$cancelResponse = $this->_cancelRecurring($invoice, $transaction_id);

		$responsedata = json_decode($cancelResponse);
		if(is_object($responsedata)){
			$responsedata = (array)$responsedata;
		}
		
		$transaction = PayplansTransaction::getInstance();
		$transaction->set('user_id', $invoice->getBuyer())
					->set('invoice_id', $invoice->getId())
					->set('payment_id', $payment->getId())
					->set('gateway_txn_id', $transaction_id)
					->set('params', PayplansHelperParam::arrayToIni($responsedata));

		if(($responsedata['state'] == 'cancelled') ){
			$transaction->set('message', 'COM_PAYPLANS_APP_QUICKPAY_CANCEL_SUCCESS')
						->save();
						
			$gatewayParams->set('pending_recur_count', 0);

			$payment->set('gateway_params', $gatewayParams)
					->save();	
			parent::onPayplansPaymentTerminate($payment, $controller);		
			return $this->_render('cancel_success');	
		}
		
		$transaction->set('message', 'COM_PAYPLANS_PAYMENT_APP_QUICKPAY_CANCEL_ERROR')
					->save();
					
		$message 	= XiText::_('COM_PAYPLANS_LOGGER_QUICKPAY_ERROR_OCCURED_IN_CANCEL');
		$error 		= $responsedata;
		$log_id 	= PayplansHelperLogger::log(XiLogger::LEVEL_ERROR, $message, $payment, array($error));
		return $this->_render('cancel_error');
		
	}
	
	protected function _cancelRecurring($invoice, $transaction_id)
	{
		$root = JURI::root();
		if(XiFactory::getConfig()->https == true){
			$root = JString::str_ireplace("http:", "https:", $root);
		}
		$headerParameter = array(
			'callbackurl' => $root.'index.php?option=com_payplans&gateway=quickpay&view=payment&task=notify',
			'version' => 'v10',
			'api_user_key' => $this->getAppParam('apiuserkey')
		);

		$subscriptionParameter = array(
			'id' => $transaction_id
			);

		$checksum = $this->__generateChecksum($subscriptionParameter,$this->getAppParam('apiuserkey'));

		$subscriptionParameter['checksum'] = $checksum;

		return $this->curlRequest($subscriptionParameter, $headerParameter, "https://api.quickpay.net//subscriptions/".$transaction_id."/cancel?synchronized");
	}


	public function refundRequest(PayplansTransaction $transaction, $refund_amount)
	{

		$transaction_id 		= $transaction->getGatewayTxnId();
		$amount 				= $refund_amount*100;
		$params 				= $transaction->getParams();
		$refundResponse = $this->_refundpayment($transaction_id, $amount,$params->get('type'));

		$responsedata = json_decode($refundResponse);
		if(is_object($responsedata)){
			$responsedata = (array)$responsedata;
		}
		if($responsedata['state'] == 'pending' && $responsedata['accepted'] == true ){
			return $this->_render('refund_success');
		}

		$message 	= XiText::_('COM_PAYPLANS_PAYMENT_APP_QUICKPAY_REFUND_ERROR');
		$error 		= $responsedata;
		$log_id 	= PayplansHelperLogger::log(XiLogger::LEVEL_ERROR, $message, array($error));
		return $this->_render('cancel_error');
	}

	public function supportForRefund()
	{
		return true;
	}
	protected function _refundpayment($transaction_id, $amount, $type)
	{
		$root = JURI::root();
		if(XiFactory::getConfig()->https == true){
			$root = JString::str_ireplace("http:", "https:", $root);
		}
		$headerParameter = array(
			'callbackurl' => $root.'index.php?option=com_payplans&gateway=quickpay&view=payment&task=notify',
			'version' => 'v10',
			'api_user_key' => $this->getAppParam('apiuserkey')
		);

		$subscriptionParameter = array(
			'id' => $transaction_id,
			'amount' => $amount
		);

		$checksum = $this->__generateChecksum($subscriptionParameter,$this->getAppParam('apiuserkey'));
		$subscriptionParameter['checksum'] = $checksum;
		return $this->curlRequest($subscriptionParameter, $headerParameter, "https://api.quickpay.net//payments/".$transaction_id."/refund");
	}


	public function curlRequest($requestString = null, $headerParameter= null, $requestUrl)
	{
		$header= array(
			"Authorization: Basic ".base64_encode(":".$headerParameter['api_user_key']),
			"Accept-Version:".$headerParameter['version']
		);
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $requestUrl);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $requestString);
		$httpResponse = curl_exec($ch);
		return $httpResponse;
	}
}

