<?php

/**
* @copyright	Copyright (C) 2009 - 2009 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		Payplans
* @subpackage	Rokfeaturetable
* @contact		shyam@joomlaxi.com
*/
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

/**
 * Payplans Rokfeaturetable Plugin
 *
 */
class plgPayplansRokfeaturetable extends XiPlugin
{
	const PPOSITION = 'payplans-rokfeature';
	
	public function onPayplansSystemStart()
	{
		$payplansTmpl = JPATH_ROOT.DS.'modules'.DS.'mod_rokfeaturetable'.DS.'templates'.DS.'payplans.txt';
		$moduleExist  = JPATH_ROOT.DS.'modules'.DS.'mod_rokfeaturetable'.DS.'mod_rokfeaturetable.php';
		
		$mainframe 	  = XiFactory::getApplication();
		
		if($mainframe->isAdmin() == false)
			return true;

		$plugin = JRequest::getVar('plugin',false);
		$task   = JRequest::getVar('task',false);
		
		if($plugin != 'rokfeaturetable')
			return true;

		//check if module exists or not
		if(!JFile::exists($moduleExist)){
			XiFactory::getApplication()->enqueueMessage(XiText::_('PLG_PAYPLANS_ROKFEATURETABLE_ROKFEATURETABLE_MODULE_DOES_NOT_EXIST'));
			return true;
		}
		
		//check if user wants to update template or not
		if($task != 'update'){
			//check if file is present or not 
			if(JFile::exists($payplansTmpl))
				return true;
		}
		
		$sitename 		= $mainframe->getCfg( 'sitename' );
		
		//get all plans published & visible plan
		$plans      = PayplansApi::getPlans(array('published'=> 1, 'visible'=> 1));
		
		$finalArray = array();
		$html  		= '';
		
		foreach($plans as $plan){
			$plan = PayplansApi::getPlan($plan->plan_id);
			
			$currency = $plan->getCurrency();
			$amount   = $plan->getPrice();
			
			$config = XiFactory::getconfig();
			$fractionDigitCount = $config->fractionDigitCount;
			$separator = $config->price_decimal_separator;
			$amount = number_format(round($amount, $fractionDigitCount), $fractionDigitCount, $separator, '');
			 
			if($config->show_currency_at == "before")
				$price = $currency.' '.$amount;
			else
				$price = $amount.' '.$currency;
			
			if(floatval(0) == floatval($plan->getPrice()))
				$price = XiText::_('COM_PAYPLANS_PLAN_PRICE_FREE');
					
			//get time seperator
			$timeseperator = ($plan->isRecurring() !== false)? XiText::_('COM_PAYPLANS_PLAN_PRICE_TIME_SEPERATOR') : XiText::_('COM_PAYPLANS_PLAN_PRICE_TIME_SEPERATOR_FOR');
			$description = trim($plan->getDescription());
			$description = preg_replace('/\n/',"<br>", preg_replace('/\r/', '',$description));
			$finalArray[] = 'name::'.$plan->getTitle();
			$finalArray[] = 'name-sub::'.JString::ucfirst($plan->getTeasertext());
			$finalArray[] = 'price::'.$price;
			$finalArray[] = 'price-sub::'.$timeseperator.' '.ltrim(PayplansHelperFormat::planTime($plan->getExpiration()));
			$finalArray[] = 'row-3::'.$description;
			$finalArray[] = 'button-text::'.XiText::_('PLG_PAYPLANS_ROKFEATURETABLE_SUBSCRIBE_NOW');
		    //Don't use Juri::base() b'coz it returns the url to the side(admin/site) we are using
            $finalArray[] = 'button-text-link::'.Juri::root().'index.php?option=com_payplans&view=plan&task=subscribe&plan_id='.$plan->getId();
			$finalArray[] = '---';
				
		}
		
		//to remove last ---, as it will create new col
		$temp = array_pop($finalArray);
		
		ob_start();
		$html .= implode("\n", $finalArray);
		$html .= ob_get_contents();
		ob_clean();
			
		$msg = self::_copyTemplate($html);
		
		$document = JFactory::getDocument();
		$document->setBuffer($msg, 'component');
		echo $msg;
		exit;
	}

	public function onPayplansGetPlugin()
	    {
	        $xml = dirname(__FILE__).DS.'rokfeaturetable.xml';
	        if (file_exists($xml)) {
	                    $xmlContent = simplexml_load_file($xml);
	                }
	                else {
	                    $xmlContent = null;
	                }
	         return array('name'   => 'rokfeaturetable', 
	                	  'value' =>$xmlContent);
	    }

	public function onPayplansViewAfterRender(XiView $view, $task, &$output)
	{
		$option = JRequest::getVar('option');
		
		if($option == 'com_payplans' && ($view instanceof XiView ) && ($task == 'subscribe' || $task == '')){

			// if any module doesn't exist with this setting, then return
			$db = XiFactory::getDBO();
		
			$sql = " SELECT `id` "
					." FROM ".$db->quoteName('#__modules')
					." WHERE (`position` = 'payplans-rokfeature' AND `published`=1 AND `module` = 'mod_rokfeaturetable')";
			$db->setQuery($sql);
			$result	= $db->loadResult();
			
			if($result == null)
				return;

			$output = '';
			$module = PayplansHelperTemplate::_renderModules(self::PPOSITION);
			
			foreach($module as $title => $data){
			 $output .= $data;	
			}
		}
	}
	
	protected function _copyTemplate($html)
	{		
		$filePath   = dirname(__FILE__).DS.'rokfeaturetable'.DS.'payplans.txt';
		$payplansTmpl = JPATH_ROOT.DS.'modules'.DS.'mod_rokfeaturetable'.DS.'templates'.DS.'payplans.txt';
		
		//if existing file is not writable 
		if ( file_exists($filePath) && !is_writable($filePath)){
		  XiError::raiseError (500, XiText::_("PLG_PAYPLANS_ROKFEATURETABLE_PERMISSION_DENIED"));
		}
		
		//open a file which contain the data fetched from the database
		$fp     = fopen($filePath,"w");
		fwrite($fp,$html);
		fclose($fp);
		
		if(JFile::copy($filePath , $payplansTmpl))
			return XiText::_('PLG_PAYPLANS_ROKFEATURETABLE_TEMPLATE_COPIED_SUCCESSFULLY');
        
        return XiText::_('PLG_PAYPLANS_ROKFEATURETABLE_TEMPLATE_COPY_FAILED');
	}
}
