<?php
/**
* @copyright	Copyright (C) 2009 - 2011 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license	GNU/GPL, see LICENSE.php
* @package	PayPlans
* @subpackage	Frontend
* @contact	payplans@readybytes.in
*/
if(defined('_JEXEC')===false) die();

class PayplansAppSetcom extends PayplansAppPayment
{
	//inherited properties
	protected $_location	= __FILE__;
	
	function isApplicable($refObject = null, $eventName='')
	{
		// return true for event onPayplansControllerCreation
		if($eventName == 'onPayplansControllerCreation'){
			return true;
		}
		
		return parent::isApplicable($refObject, $eventName);
	}
	
	protected function _removeQuestionMark($array)
	{
		foreach(array_key_exists($array) as $value){
			$key = JString::str_ireplace('?', '', $value);
			$array[$value] = $key;
		}
		
		return $array;
	}
	
	public function onPayplansControllerCreation(&$view, &$controller, &$task, &$format)
	{
		$gateway = JRequest::getVar('gateway', '');
		if($view != 'payment' || ($task != 'notify' && $task != 'complete') || $gateway != $this->getType() ){
			return true;
		}
		
		$reference = JRequest::getVar('Reference', null);
		if($task == 'complete'){
			$reference = JRequest::getVar('reference', null);
		}
		
    	if(!$reference){
    		return true;
    	}
    	
 		// V IMP : there are possibility that GET variables may have a ? 
 		// so need to remove it 
		$reference = explode('-', $reference);
	
		// we will get order and payment key from apc_1 and apc_2
		$invoiceKey 	= $reference['0'];
		$paymentKey 	= $reference['1'];
		
		if($invoiceKey == false || $paymentKey == false){
			return true;
		}
			
		JRequest::setVar('invoice_key', $invoiceKey, 'POST');
		JRequest::setVar('payment_key', $paymentKey, 'POST');
		
		return true;
	}
	
	public function onPayplansPaymentForm(PayplansPayment $payment, $data=null)
	{
		$invoice = $payment->getInvoice(PAYPLANS_INSTANCE_REQUIRE);
		
		$this->assign('post_url', 'https://secure.setcom.co.za/creditcard.cfm');
		$this->assign('co_id', $this->getAppParam('co_id', ''));
		$this->assign('outlet', $this->getAppParam('outlet', ''));
		$this->assign('reference', $invoice->getKey().'-'.$payment->getKey());
		$this->assign('amount', $invoice->getTotal());
		
		$consistentKey = md5($this->getAppParam('co_id', '').$this->getAppParam('outlet', '')
						 .$invoice->getKey().'-'.$payment->getKey().$invoice->getTotal()
						 .$this->getAppParam('secret', ''));
			
		return $this->_render('form');
	}
	
	public function onPayplansPaymentNotify(PayplansPayment $payment, $data, $controller)
	{	
		$invoice = $payment->getInvoice(PAYPLANS_INSTANCE_REQUIRE);
		
		// If same notification came more than one time
    	// Check if transaction already exist then do nothing and return
		$txn_id			= isset($data['OrderNumber']) ? $data['OrderNumber'] : 0;
		$transactions	= $this->_getExistingTransaction($invoice->getId(), $txn_id, 0, 0);
    	if($transactions !== false){
    		foreach($transactions as $transaction){
    			$transaction = PayplansTransaction::getInstance($transaction->transaction_id, null, $transaction);
    			if(strtolower($transaction->getParam('Outcome','')) == strtolower($data['Outcome'])){
    				return true;
    			}
    		}
    	}
    	
		// get the transaction instace of lib
		$transaction = PayplansTransaction::getInstance();
		$transaction->set('user_id', $payment->getBuyer())
					->set('invoice_id', $invoice->getId())
					->set('payment_id', $payment->getId())
					->set('gateway_txn_id', isset($data['OrderNumber']) ? $data['OrderNumber'] : 0)
					->set('params', PayplansHelperParam::arrayToIni($data));
					
			
		$transaction->set('amount', $data['Amount']);
		
		// XITODO : use constant instead of number
		
		if('DECLINED' === JString::strtoupper($data['Outcome'])){
			$error = XiText::_('COM_PAYPLANS_APP_SETCOM_PAYMENT_DECLINED');
			$transaction->set('message', 'COM_PAYPLANS_APP_SETCOM_TRANSACTION_DECLINED');
		}
		
		if('ERROR' === JString::strtoupper($data['Outcome'])){
			$error = XiText::_('COM_PAYPLANS_APP_SETCOM_ERROR_IN_PAYMENT');
			$transaction->set('message', 'COM_PAYPLANS_APP_SETCOM_ERROR_IN_PAYMENT');
		}

		if('APPROVED' === JString::strtoupper($data['Outcome'])){
			$transaction->set('message', 'COM_PAYPLANS_APP_SETCOM_TRANSACTION_COMPLETED');
		}
	
		if($error){
			$message = XiText::_('COM_PAYPLANS_APP_SETCOM_LOGGER_ERROR_IN_PAYMENT');
			$errors						= array();			
			$errors['error_message'] 	= $error;
			$errors['response']			= $data;
			$log_id = PayplansHelperLogger::log(XiLogger::LEVEL_ERROR, $message, $payment, $errors, 'PayplansPaymentFormatter', '', true);
		}		
		
		$transaction->save();
					
		return true;
	}
}
