<?php
/**
* @copyright	Copyright (C) 2009 - 2009 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		PayPlans
* @subpackage	Frontend
* @contact 		shyam@readybytes.in
* 
*/
if(defined('_JEXEC')===false) die();

class PayplansAppSobi2 extends PayplansApp
{
	protected $_location	= __FILE__;
	protected $_resource	= 'com_sobi2.entry';
	const ALLOWED 	 =  1;
	const BLOCKED    =  0;
	
	public function isApplicable($refObject = null, $eventName='')
	{
		if($eventName === 'onPayplansAccessCheck'){
			return true;
		}

		return parent::isApplicable($refObject, $eventName);
	}

	// applicable only if sobi2 exist
	public function _isApplicable(PayplansIfaceApptriggerable $refObject, $eventName='')
	{
		return JFolder::exists(JPATH_SITE .DS.'components'.DS.'com_sobi2');
	}
	
	public function onPayplansSubscriptionAfterSave($prev, $new)
	{
		// no need to trigger if previous and current state is same
		if($prev != null && $prev->getStatus() == $new->getStatus()){
			return true;
		}

		$newStatus  = $new->getStatus();
		
		$allowedEntries   = $this->getAppParam('allowedEntries');
			
		$subid  = $new->getId();
		$userid = $new->getBuyer();
		if($newStatus != 0){
			$this->_countAllowedEntries($subid, $userid,$allowedEntries,$newStatus,$prev);
		}

		return true;	
	}
		
	function onPayplansAccessCheck(PayplansUser $user)
	{		
		$option 	= JRequest::getVar('option');
		$task 		= JRequest::getVar('sobi2Task', null);

		// block user to add  new list only
		if($option != 'com_sobi2' ){
			return false;
		}

        $resource = $this->_getResource($user->getId(),0, $this->_resource);
		//if empty resource set $count to 0
		$count = 0;
		if(!empty($resource)){
			$count = $resource->count;
		}
		
		$userPlans     = $user->getPlans();
        // if no user plans then return		
		if(empty($userPlans))
		{
			$msg = XiText::_('COM_PAYPLANS_APP_SOBI2_SELECT_PLAN');
			XiFactory::getApplication()->redirect(XiRoute::_('index.php?option=com_payplans&view=plan'), $msg);
		}

        $allowedOrNot = $this->_isUserAllowed($user);
        if(in_array(self::ALLOWED, $allowedOrNot))
		{
		    // get User Entries
			$userEntries = $this->_getUserEntries($user->getId());
			//if task is add new and user entried are greater than allowed entries
			if($task == 'addNew' && $userEntries['all'] >= $count)
			{
				$msg = XiText::_('COM_PAYPLANS_APP_SOBI2_YOU_ARE_NOT_ALLOWED_TO_ADD_MORE_ENTRY');
				XiFactory::getApplication()->redirect(XiRoute::_('index.php?option=com_payplans&view=dashboard'), $msg);
			}
//		
//		// set a 'newEntry' variable in session when add user save a new 
//		// entry
//	    if($task == 'saveSobi')
//		{	
//			$itemId  	= JRequest::getVar('sobi2Id',0);
//		    //set variable in session only if new entry
//		    if($itemId == 0){
//		 	   XiFactory::getSession()->set('newEntry', true);
//		    }
//			return true;
//	    }
//
//		if($task == 'sobi2Details')
//		{  
//		    //get value from session
//	    	$isnewEntry = XiFactory::getSession()->get('newEntry', false);
//	    	$itemId  	= JRequest::getVar('sobi2Id',0);
//	    	if(isset($isnewEntry) && $isnewEntry == true)
//			{
//				//get user allowed published categories
//				$allowedPublishCategories = $this->_getAllowedPublishedCategories($user);
//				
//				// 	if user published categories is greater than allowed categories the
//                // unpublished that newly added entry		
//				if($userEntries['published'] > $allowedPublishCategories)
//				{
//					$db    = XiFactory::getDBO();
//		
//					$query = ' UPDATE #__sobi2_item'
//							. ' SET `published`  = 0'
//							. ' WHERE `owner`='. $user->getId(). ' AND `itemid`='.$itemId
//							;
//					$db->setQuery( $query );
//					$db->query();
//					// clear variable from session and redirect
//					XiFactory::getSession()->clear('newEntry');
//					$msg = XiText::_('COM_PAYPLANS_APP_SOBI2_YOU_ARE_NOT_ALLOWED_TO_ADD_MORE_PUBLISHED_ENTRY');
//					XiFactory::getApplication()->redirect(XiRoute::_('index.php?option=com_payplans&view=dashboard'), $msg);
//		   		 }
//
//	    		XiFactory::getSession()->clear('newEntry');
//	  		 }
//	    }
	}
	else
	{   if($task == 'addNew')
		{
			$msg = XiText::_('COM_PAYPLANS_APP_SOBI2_SELECT_PLAN');
			XiFactory::getApplication()->redirect(XiRoute::_('index.php?option=com_payplans&view=plan'), $msg);
	     }
	 }
}


	protected function _getUserEntries($userId){
		$UserEntries = array();
		$db    = XiFactory::getDBO();
		$query =  ' SELECT COUNT(*)'
				 .' FROM `#__sobi2_item`'
				 .' WHERE `owner`= '.$userId.' AND `published`=1'
				 ;
		$db->setQuery( $query );
		$UserEntries['published'] = $db->loadResult();

		$query =  ' SELECT COUNT(*)'
				 .' FROM `#__sobi2_item`'
				 .' WHERE `owner`= '.$userId.' AND `published`=0'
				 ;
		$db->setQuery( $query );
		$UserEntries['unpublished'] = $db->loadResult();

		$UserEntries['all'] = $UserEntries['published'] + $UserEntries['unpublished'];
		return $UserEntries;
	}
	
	protected function _countAllowedEntries($subid, $userid,$allowedEntries,$newStatus,$prev)
	{
		$resource = $this->_getResource($userid,0, $this->_resource);
		$count = 0;
		//if empty resource set $count to 0
		if(!empty($resource)){
			$count = $resource->count;
		}
		
		//get user's Sobi2 published and unpublished entries
		$userEntries = $this->_getUserEntries($userid);
		//if active subscription
		if($newStatus == PayplansStatus::SUBSCRIPTION_ACTIVE){
			$count =  $allowedEntries;
            // if any unpublish then publish them
			if($userEntries['unpublished'] > 0){
				$this->_publishOrUnpublishEntry($userid, $allowedEntries, 1);
			}
			$this->_addToResource($subid, $userid,0, $this->_resource,$count);
			return;		
		}
		if(($prev != null && $prev->getStatus() == PayplansStatus::SUBSCRIPTION_ACTIVE) && 
				($newStatus == PayplansStatus::SUBSCRIPTION_EXPIRED || $newStatus == PayplansStatus::SUBSCRIPTION_HOLD))
		{
			$count = $allowedEntries;
	        //if publish then unpublish entries
	        
			if($userEntries['published']>0){
				$this->_publishOrUnpublishEntry($userid, $allowedEntries, 0);
			}
			$this->_removeFromResource($subid, $userid,0, $this->_resource,$count);
		}
		
	}
	
	protected function _publishOrUnpublishEntry($userid,$limit,$publish)
	{
		// publish only those entries which are not currently published
		//and vice versa
		$complement = 1 - $publish;
		$db    = XiFactory::getDBO();
		
		$query = ' UPDATE #__sobi2_item'
						. ' SET `published`  = '.$publish
						. ' WHERE `owner`='. $userid.' AND `published`='.$complement
						. ' LIMIT '.$limit
						;
		$db->setQuery( $query );
		$db->query();
	}
	
	//render Widget
	public function renderWidgetHtml()
	{   
		//get user id
		$userid     = XiFactory::getUser()->id;
		if(!$userid){
			return '';
		}

		//get user's sobi2 entries
	    $sobi2_entries = $this->_getUserSobi2Entries($userid);
	    if(empty($sobi2_entries))
	    	return '';

	    $this->assign('sobi2_entries',$sobi2_entries);
        $data = $this->_render('widgethtml');
        return $data;
	}	
	
	protected function _getUserSobi2Entries($userid)
	{
		$UserEntries = array();
		$db    = XiFactory::getDBO();
		$query =  ' SELECT `itemid`, `title`'
				 .' FROM `#__sobi2_item`'
				 .' WHERE `owner`= '.$userid.' AND `published`=1'
				 ;

		$db->setQuery( $query );
		return $db->loadObjectList('itemid');
	}
	
//	protected function _getAllowedPublishedCategories($user){
//		$sobi2Apps = PayplansHelperApp::getApplicableApps('sobi2',$user);
//		$publishCategories = 0;
//		foreach ($sobi2Apps as $app)
//		{
//			$categoriesToPublish = $app->getAppParam('entriesToPublish',0);
//			$publishCategories = $publishCategories + $categoriesToPublish;
//		}
//		return $publishCategories;
//	}
	
	protected function _isUserAllowed($user)
	{
		$sobi2Apps = PayplansHelperApp::getAvailableApps('sobi2');
  	 	$appResult  = array();

	  	//check which app allow category, which not allow and which app do nothing
		foreach($sobi2Apps as $app)
		{
			if($app->getParam('applyAll',false) != false)
			{
				$appResult[]  = self::ALLOWED;
           		continue;
			}
			//if user has app plans
			$appPlans = $app->getPlans();
			if(array_intersect($user->getPlans(), $appPlans) != false){
				 $appResult[]  = self::ALLOWED;
        	  	 continue;
			}
			else {
			   $appResult[]  = self::BLOCKED;
			}
			
		}
		return $appResult;
	}
}
