<?php

/**
* @copyright	Copyright (C) 2009 - 2009 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		Payplans
* @subpackage	Subscription-Detail
* @contact		shyam@joomlaxi.com
*/
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

/**
 * Payplans Subscription Detail Plugin
 */
class plgPayplansSubscriptiondetail extends XiPlugin
{
	public function onPayplansSystemStart()
	{
		// add subscriptiondetail app path to app loader
		$appPath = dirname(__FILE__).DS.'subscriptiondetail'.DS.'app';
		PayplansHelperApp::addAppsPath($appPath);

		return true;
	}
	
	public function onPayplansViewBeforeRender(XiView $view, $task) //On fornt-end subscription screen 
	{
		//render widget on order-display page 
		if($view instanceof PayplanssiteViewSubscription && ( $task == 'display'  || $task == 'getDetails' ) ) {
			$itemid  	      = $view->getModel()->getId();
			$layout           = 'orderdisplay';
			$subscription 	  = PayplansSubscription::getInstance($itemid);
			$subscriptionApp  = new PayplansAppSubscriptiondetail();
			return $subscriptionApp->renderWidget($subscription, $layout);
		}
	}
	
	public function onPayplansAppAfterSave($prev, $new)
	{
		if(false == ($new instanceof PayplansAppSubscriptiondetail)){
			return true;
		}

		$appid = $new->getId();
		//XITODO : in future write it to media folder
		$location = $new->getLocation();
		$path     = $location.DS.'xmldata'.DS."subscriptiondetail_app_$appid.xml";
		
		$param = base64_decode($new->getAppParam('subscriptiondetailparams'));	
	
		//delete the existing file if any
		if(JFile::exists($path)){
			JFile::delete($path);	
		}

		JFile::write($path, $param);
		return true;
	}
	
	public function onPayplansSubscriptiondetailSaveRequest($fields)
	{
		if(empty($fields)){
			return true;
			//XITODO : Test it
			$response = XiFactory::getAjaxResponse();
			return $response->sendResponse();
		}
		
		$userid = XiFactory::getUser()->id;
		if(!$userid){
			// show error message
			return true;
		}
		
		$data = array();
		foreach($fields as $field){
			if(strncmp($field->name, 'subscription_detail',18)==0){
				$data[$field->name] = $field->value;
			}
			elseif($field->name == 'subscriptionKey'){
				$subscriptionKey  = $field->value;
			}
		}
		$subscription = PayplansSubscription::getInstance(XiHelperUtils::getIdFromKey($subscriptionKey));
		$args         = array(&$subscription, &$data);
		$result       = PayplansHelperEvent::trigger('onPayplansSubscriptiondetailSave', $args, '', $subscription);
				
		$subscription->save();

		//XITODO : Send success or error message
		$response = XiFactory::getAjaxResponse();
		$response->sendResponse();
	}
	
	function onPayplansRewriterDisplayTokens()
	{
		$subscriptionDetailApp  = PayplansHelperApp::getAvailableApps('subscriptiondetail');

		//if no app exists then don't create tab 
		if(empty($subscriptionDetailApp)){
			return ;
		}
		

		$rewriterToken   = array();
		$subscriptionparams = '';
		//set the tokens
		foreach ($subscriptionDetailApp as $app){
			$name     = $app->getName(); 
			$appid    = $app->getId();
			$location = $app->getLocation();
			$path     = $location.DS.'xmldata'.DS."subscriptiondetail_app_$appid.xml";
			$xml      = file_get_contents($path);
            if (trim($xml) == '') {
                  return true;
             }
			$form = JForm::getInstance('subscription.subscriptionDetail'.$appid, $path ,array(),true);
			foreach ($form->getFieldset('subscription_detail') as $field)
			{
				$subscriptionparams[$field->fieldname] = $field->value;
			}		

			if(!is_array($subscriptionparams) || empty($subscriptionparams)){
				continue ;
			}
			
			foreach($subscriptionparams as $key => $value){
				$rewriterToken[JString::strtoupper($name.'_'.$key)] = 0 ;
			}
		}
		
		$contentLi = '<li><a href="#Subscription_detail" data-toggle="tab">Subscription Detail</a></li>';
		$contentsTab = '<div class="tab-pane" id="Subscription_detail">';
		foreach($rewriterToken as $key => $val){			
			$contentsTab .= '[['.$key.']]<br/>';			
		}
		$contentsTab .= "</div>"; 
		return array($contentLi, $contentsTab);
	}
	
	//For saving subscription details app params from back-end 
	function onPayplansSubscriptionBeforeSave($prev, $subscription)
	{
		$subscription_detail = JRequest::getVar('subscription_detail');
		if(JFactory::getApplication()->isAdmin() && JRequest::getVar('subscription_detail') && isset($subscription_detail)){
			foreach ($subscription_detail as $key=>$value){
				$subscription->setParam($key,$value);
			}
		}
		return true;
	}
	
}
