<?php
/**
* @copyright	Copyright (C) 2009 - 2015 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		Payplans
* @subpackage	Subscriptionstartdate
* @contact		support+payplans@readybytes.in
*/
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

/**
 * Payplans Subscription Start-Date
 * @author Manisha Ranawat
 */

define('PAYPLANS_CRON_SUBSTAR_COUNT', 100);

class plgPayplansSubscriptionstartdate extends XiPlugin
{	
	public function onPayplansSystemStart()
	{
		$appPath = dirname(__FILE__).DS.'subscriptionstartdate'.DS.'app';
		PayplansHelperApp::addAppsPath($appPath);
		return true;
	}
	
	public function onPayplansViewBeforeRender(XiView $view, $task)
	{
		if($view instanceof PayplanssiteViewPlan){
			if($task == 'subscribe'){
				$plans = $view->get('plans');
				$this->_newDateMapping($plans, $view);
			}
			
			if($task == 'login'){
				$plan = $view->get('plan');
				$plans[$plan->getId()] = $plan;
				$this->_newDateMapping($plans, $view);
			}
		}

		if(($view instanceof PayplanssiteViewInvoice) && $task == 'confirm'){
			$invoice = $view->get('invoice');
			if($invoice->isRecurring()){
				return true;
			}
			
            $getplans 				= $invoice->getPlans(PAYPLANS_INSTANCE_REQUIRE);
			$plan 					= array_shift($getplans);
			$plans[$plan->getId()] 	= $plan;
			$newdates 				= $this->_newDateMapping($plans, $view);
		}
	}
	
	function _newDateMapping($plans, $view)
	{
		if(empty($plans)){
			return true;
		}
		
		$apps  = PayplansHelperApp::getAvailableApps('subscriptionstartdate');
		if(empty($apps))
		{
			return array();
		}
		$newDates = array();
		
		foreach ($apps as $app) {
			$stratDate = $app->getAppParam('start_date', 0);
			if(empty($stratDate)){
				continue;
			}

			$app_plans  = is_array($app->_appplans) ? $app->_appplans : array($app->_appplans);

			foreach ($plans as $id => $plan){
				if($app->getParam('applyAll', false) || in_array($id, $app_plans)){		 			
					$date          = new XiDate($stratDate);
		 			$newDates[$id] = PayplansHelperFormat::date($date);
				}
			}
		}
		
		//if not applicable then do nothing
		if(!isset($newDates)){
			return array();
		}
		
		foreach ($plans as $id => $plan){
			if (array_key_exists($id, $newDates)) {
				$Plan  		= PayplansPlan::getInstance($id);
				$details 	= $Plan->getDetails();
				if($details->get('expirationtype') == 'fixed'){
					$tmp   		= $Plan->getParams()->get('teasertext', '');
					$tmp        = $tmp."<br/><Strong>".XiText::_('COM_PAYPLANS_APP_SUBSCRIPTIONSTARTDATE_JS_SEPARATOR')."</strong><br/>".$newDates[$id];
					$Plan->setParam('teasertext', $tmp);
				}
			}
		}
		
		return $newDates;
	}
	
	public function onPayplansCron()
	{		
		$currentDate	= new XiDate('now');

		$query			= new XiQuery();
		$totalRecords	= 	$query->select('s.subscription_id')
	                			  ->from('`#__payplans_subscription` as s ')
	                		      ->innerJoin('`#__payplans_order` as o ON o.order_id = s.order_id AND o.status = '.PayplansStatus::ORDER_COMPLETE)
	                		      ->where('s.status = '.PayplansStatus::NONE)
	                		      ->where('s.subscription_date <= '."'".$currentDate->toMySQL()."'")
								  ->dbLoadQuery()
		  						  ->loadColumn();
	                        
		if(empty($totalRecords)){
			return true;
		}
		
		if(count($totalRecords) > PAYPLANS_CRON_SUBSTAR_COUNT){
			$subRecords	= array_chunk($totalRecords, 2);
			foreach ($subRecords as $records){
				foreach ($records as $record){
					$this->_activateSubscriptions($record);
				}
			}
		}else {
			foreach ($totalRecords as $record){
				$this->_activateSubscriptions($record);
			}
		}
		
		return true;
	}
	
	// Activate Subscription on desired start date
	public function _activateSubscriptions($subscriptionId)
	{
		$subscription = PayplansSubscription::getInstance($subscriptionId);
		if($subscription->getParams()->get('is_scheduled_activation', 0)){
			$subscription->set('status', PayplansStatus::SUBSCRIPTION_ACTIVE);
			$subscription->save();	
		}
	}
	
}
