<?php
/**
* @copyright	Copyright (C) 2009 - 2009 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		Payplans
* @subpackage	Discount
* @contact 		shyam@readybytes.in
*/
if(defined('_JEXEC')===false) die();


/**
 * Tienda System
 * @author Puneet
 */
class PayplansAppTienda extends PayplansApp
{
	//inherited properties
	protected $_location	= __FILE__;
	protected $_resource	= 'com_tienda.group';
	
	public function onPayplansSubscriptionAfterSave($prev, $new)
	{
		// no need to trigger if previous and current state is same
		if($prev != null && $prev->getStatus() == $new->getStatus()){
			return true;
		}

		$newStatus  = $new->getStatus();
		
		$active = $this->getAppParam('addToGroupOnActive');
		$active	= (is_array($active)) ? $active : array($active);
		
		$hold 	= $this->getAppParam('addToGroupOnHold');
		$hold	= (is_array($hold)) ? $hold : array($hold);
		
		$expire = $this->getAppParam('addToGroupOnExpire');
		$expire	= (is_array($expire)) ? $expire : array($expire);
		
		$subid  = $new->getId();
		$userid = $new->getBuyer();
		 
		// #1 : remove from groups assigned from other status (if applicable)
		// #2 : add to group and add resource for current status 
		
		// if subscription is active
		if($newStatus == PayplansStatus::SUBSCRIPTION_ACTIVE){
			$this->_removeFromTiendaGroup($userid, $hold, $subid);
			$this->_removeFromTiendaGroup($userid, $expire, $subid);
			$this->_addToTiendaGroup($userid, $active, $subid);
			
			return true;
		}
		
		if($newStatus == PayplansStatus::SUBSCRIPTION_HOLD){
			$this->_removeFromTiendaGroup($userid, $active, $subid);
			$this->_removeFromTiendaGroup($userid, $expire, $subid);
			$this->_addToTiendaGroup($userid, $hold, $subid);
			
			return true;
		}
		
		if($newStatus == PayplansStatus::SUBSCRIPTION_EXPIRED){
			$this->_removeFromTiendaGroup($userid, $active, $subid);
			$this->_removeFromTiendaGroup($userid, $hold, $subid);
			$this->_addToTiendaGroup($userid, $expire, $subid);
			
			return true;
		}
	
		return true;
	}


	protected function _addToTiendaGroup($userid, $groupsid, $subid)
	{
		$usergroupid = $this->_getUserGroup($userid);
		
		foreach ($groupsid as $groupid)
		{
			if(empty($groupid)){
				continue;
			}
			if(!in_array($groupid, $usergroupid) ){
				$this->_insertUserToGroup($userid, $groupid);
			}
			
				$this->_addToResource($subid, $userid, $groupid, $this->_resource);
		}
		
		return true;
	}

	protected function _removeFromTiendaGroup($userid, $groupsid, $subid)
	{
		$usergroupid = $this->_getUserGroup($userid);
		
		foreach ($groupsid as $groupid)
		{
			if(empty($groupid)){
				continue;
			}
			
			if(in_array($groupid, $usergroupid) )
			{
				$this->_removeFromResource($subid, $userid, $groupid, $this->_resource);
				$this->_deleteUserFromGroup($userid, $groupid);
			}
		}
		
		return true;
	}
	
	protected function _getUserGroup($userid)
	{
		$db = JFactory::getDBO();

		$query = 'SELECT `group_id`'
			. ' FROM #__tienda_usergroupxref'
			. ' WHERE `user_id` = ' . $userid;
		$db->setQuery( $query );
		
		return $db->loadColumn();
	}
	
	protected function _insertUserToGroup($userid, $groupid)
	{
		$db = JFactory::getDBO();
		
		$query = 'INSERT INTO #__tienda_usergroupxref (`user_id`, `group_id`) VALUES ('
				. $userid . ','. $groupid . ')';
		
		$db->setQuery( $query );
		return $db->query();
	}
	
	protected function _deleteUserFromGroup($userid, $groupid)
	{
		$db = JFactory::getDBO();
		$query = 'DELETE FROM #__tienda_usergroupxref'
			. ' WHERE `user_id` = ' . $db->Quote($userid)
			. ' AND `group_id` = ' .$db->Quote($groupid);
			
		$db->setQuery( $query );
		return $db->query();
	}
	
	public static function getTiendaGroups()
	{
		$db = JFactory::getDBO();
		$query = 'SELECT group_id, group_name'
			 	. ' FROM #__tienda_groups'
			 	;
	 	$db->setQuery( $query );
	 	return $db->loadObjectList('group_id'); 
	}

	//render Widget
	public function renderWidgetHtml()
	{   
		//get user id
		$userid     = XiFactory::getUser()->id;
		if(!$userid){
			return '';
		}
		//get user's tienda groups
	    $tienda_groups = $this->_getUserTiendaGroup($userid);
	    if(empty($tienda_groups)){
	    	return '';
	    }
	    $this->assign('tienda_groups',$tienda_groups);
        $data = $this->_render('widgethtml');
        return $data;
	}
	
	protected function _getUserTiendaGroup($userid)
	{
		$tiendaGroupIds = $this->_getUserGroup($userid);
		
		$db = XiFactory::getDBO();
		$tiendaGroupIds = implode(',', $tiendaGroupIds);
		
		$query = 'SELECT `group_name`'
			. ' FROM #__tienda_groups'
			. ' WHERE `group_id` IN (' . $tiendaGroupIds .')';
		$db->setQuery( $query );
		
		$tiendaGroupNames = $db->loadColumn();
		
        return $tiendaGroupNames;
	}
}
