<?php
/**
* @copyright	Copyright (C) 2009 - 2015 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		PayPlans
* @subpackage	Upgrade
* @contact 		support+payplans@readybytes.in
* 
*/
if(defined('_JEXEC')===false) die();

class PayplansAppUpgrade extends PayplansApp
{
	protected $_location	= __FILE__;	
	const ALL_PLAN   =  'ALL_PLAN';
	
	public function onPayplansUpgradeTo()
	{
		// only published and visible plans
		$plans = PayplansHelperPlan::getPlans(array('published' => 1));
		
		$upgradeTo = $this->getAppParam('upgrade_to', array());
		$upgradeTo = is_array($upgradeTo) ? $upgradeTo : array($upgradeTo);
		
		$return  = array();
		foreach($upgradeTo as $pid){
			if(isset($plans[$pid])){
				$return[$pid] = $plans[$pid];
			}
		}
		
		return $return;
	}
	
	
	//render the widget for an susbcription
	function renderWidget($subscriptionId)
	{
		$subscription = PayplansSubscription::getInstance($subscriptionId);
		
		$plans = PayplansHelperUpgrade::findAvailableUpgrades($subscription->getKey());
		
		If (empty($plans)) {
			return false;
		}
		
		$this->assign('subscription', $subscription);
	
		$html = $this->_render('widgethtml');
	
		return $html;
	}
}

class PayplansAppUpgradeFormatter extends PayplansAppFormatter
{
	public $template = 'view_log';
	// get rules to apply
	function getVarFormatter()
	{
		$rules = array( '_appplans'       => array('formatter'=> 'PayplansAppFormatter',
										       'function' => 'getAppPlans'),
						'app_params'      => array('formatter'=> 'PayplansAppUpgradeFormatter',
										       	   'function' => 'getFormattedParams')
						);
		return $rules;
	}
	
	function getFormattedParams($key, $value, $data)
	{
		if(is_array($value['upgrade_to']))
		{
			foreach ($value['upgrade_to'] as $param){
				$planName 			= PayplansHelperPlan::getName($param);				
				$plans[] 			= PayplansHtml::link(XiRoute::_("index.php?option=com_payplans&view=plan&task=edit&id=".$param, false), $param.'('.$planName.')');
			}
			$value['upgrade_to']	= implode(', ', $plans);
		}
		else{
			$planName 				= PayplansHelperPlan::getName($value['upgrade_to']);			
			$value['upgrade_to'] 	=  PayplansHtml::link(XiRoute::_("index.php?option=com_payplans&view=plan&task=edit&id=".$value['upgrade_to'], false), $value['upgrade_to'].'('.$planName.')');
		}

		$this->template		= 'view';
	}
}
