<?php
/**
* @copyright	Copyright (C) 2009 - 2015 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		Payplans
* @subpackage	UsedTimeMonitor
* @contact		support+payplans@readybytes.in
*/
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

class plgPayplansUsedtimemonitor extends XiPlugin
{

	var $_name = 'usedtimemonitor';

	public function onPayplansSystemStart()
	{
		//autoload app path and plugin files 
		$dir = dirname(__FILE__).DS.'usedtimemonitor'.DS;
		PayplansHelperApp::addAppsPath($dir.'app');
		PayplansHelperLoader::addAutoLoadFile($dir.'lib.php', 'PayplansUsedtimemonitor');
		PayplansHelperLoader::addAutoLoadFile($dir.'view.php', 'PayplansadminViewUsedtimemonitor');
		PayplansHelperLoader::addAutoLoadFile($dir.'controller.php', 'PayplansadminControllerUsedtimemonitor');
		PayplansHelperLoader::addAutoLoadFile($dir.'table.php', 'PayplansTableUsedtimemonitor');
		PayplansHelperLoader::addAutoLoadFile($dir.'model.php', 'PayplansModelUsedtimemonitor');
		PayplansHelperLoader::addAutoLoadFile($dir.'logout.php', 'PayplansUsedtimemonitorlogout');
		PayplansHelperLoader::addAutoLoadFile($dir.'cron.php','PayplansUsedtimemonitorcron');

		return true;
	}
	
	/**
	 * set plugin template for backend 
	 */
	public function onPayplansViewBeforeRender(XiView $view, $task)
	{
		//add admin-submenu when plugin in enabled
		if(XiFactory::getApplication()->isAdmin() && XiHelperJoomla::getPluginStatus('usedtimemonitor','payplans')){
			XiAbstractView::addSubmenus('usedtimemonitor');
		}
		
		//for admin side
		if(($view instanceof PayplansadminViewUsedtimemonitor) && ($task == 'display' || $task == 'edit')){
			// we need to add the normal template overriding paths
			$templatePaths = $this->_getTemplatePath($this->_name);
			$view->addPathToView($templatePaths);
		}

		//render widget on backend user-edit page 
		if($view instanceof PayplansadminViewUser && $task == 'edit'){
			$userid  	      = $view->getModel()->getId();
			$app  			  = new PayplansAppUsedtimemonitor();
			return array('pp-user-details'=>$app->_renderWidget('useredit',$userid));
		}

		return true;
	}
	
	public function onAfterRoute()
	{
		$userId = XiFactory::getuser()->id;
		if(!$userId || XiFactory::getApplication()->isAdmin()){
			return true;
		}
		
		//check for resource
		if(PayplansUsedtimemonitor::checkForResourceAvailabilty($userId)){
			//monitor user action
			PayplansUsedtimemonitor::monitorUsedTime($userId);
		}
	}
	
	public function onUserLogout($user, $options = array())
	{
		if(XiFactory::getApplication()->isSite()){
			$instance = PayplansUsedtimemonitor::getInstance('logout');
			
			//check for resource
			if(PayplansUsedtimemonitor::checkForResourceAvailabilty($user['id'])){
				$instance->doLogoutAction($user);
			}
		}
	}
	
	public function onPayplansCron()
	{
		//do work only if table exist
		if(XiHelperTable::isTableExist('#__payplans_usedtimemonitor')){
			if($this->params->get('when_to_end') == 'cron'){
				$instance = PayplansUsedtimemonitor::getInstance('cron');
				$instance->doCronAction();
			}
			//mark exceeded subscriptions
			PayplansUsedtimemonitor::expireSubscriptionsWhenTimeExceeded();
		}
	}

	// Delete related entries in used time monitor when user get deleted. 
	function onUserBeforeDelete($user)
	{
		$userId 		= $user['id'];
		$timemonitor    = XiFactory::getInstance('usedtimemonitor','model');
		$timemonitor->deleteMany(array('user_id' => $userId));

	}

	// Delete subscription related entries when subscription get deleted
	function onPayplansSubscriptionBeforeDelete($object)
	{
		$subscriptionId	= $object->getId();
		$timemonitor	= XiFactory::getInstance('usedtimemonitor', 'model');
		$timemonitor->deleteMany(array('subscription_id' => $subscriptionId));
	}

}
