<?php
/**
* @copyright	Copyright (C) 2009 - 2009 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		PayPlans
* @subpackage	Frontend
* @contact 		shyam@readybytes.in
*/
if(defined('_JEXEC')===false) die();

class PayplansAppWebmoney extends PayplansAppPayment
{
	protected $_location	= __FILE__;
	
	function isApplicable($refObject = null, $eventName='')
	{
		// return true for event onPayplansControllerCreation
		if($eventName == 'onPayplansControllerCreation'){
			return true;
		}
		
		return parent::isApplicable($refObject, $eventName);
	}
	
	function onPayplansControllerCreation(&$view, &$controller, &$task, &$format)
	{
		// LMI_PAYMENT_DESC should be present in data posted
		// explode it by , 
		// first will be plan name
		// second will be payment key
		if($view == 'payment' && $task == 'notify'){
			$keys = JRequest::getVar('LMI_PAYMENT_DESC', false);
			if($keys == false){
				return true;
			}
			
			$keys = explode(',', $keys);
			array_shift($keys);
			JRequest::setVar('payment_key', array_shift($keys), 'POST');
			return true;
		}
		
		return true;
	}
	
    function onPayplansPaymentForm(PayplansPayment $payment, $data = null)
	{
		if(is_object($data)){
			$data = (array)$data;
		}
		
		$invoice = $payment->getInvoice(PAYPLANS_INSTANCE_REQUIRE);
		
		$purse = $this->getAppParam('merchant_purse', false);
		$this->assign('purse',$purse);
		
		$this->assign('testmode',0);
		if ( $this->getAppParam('test_mode', false) ) {
			$this->assign('testmode',1);
		}

		$this->assign('payment_no',$payment->getId());
		// store payment key in payment_desc
		// so that order and payment can be found out at the time of notify
		// this will come as vendor_order_id
		$this->assign('payment_desc',$invoice->getTitle().','.$payment->getKey());
		$this->assign('amount',$invoice->getTotal());
	    $root = JURI::root();
    	if(XiFactory::getConfig()->https == true){
    		$root = JString::str_ireplace("http:", "https:", $root);
    	}
    	$this->assign('success_url',$root.'index.php?option=com_payplans&gateway=webmoney&view=payment&task=complete&action=success&payment_key='.$payment->getKey());
    	$this->assign('fail_url',$root.'index.php?option=com_payplans&gateway=webmoney&view=payment&task=complete&action=cancel&payment_key='.$payment->getKey());
    	$this->assign('result_url', $root.'index.php?option=com_payplans&view=payment&task=notify');
		
		$this->assign('post_url','https://merchant.webmoney.ru/lmi/payment.asp');
		return $this->_render('form_subscription');

	}
	
	// notification comes only if payment is successfull
   public function onPayplansPaymentNotify(PayplansPayment $payment, $data, $controller)
	{
		$invoice = $payment->getInvoice(PAYPLANS_INSTANCE_REQUIRE);
		
	    $txn_id = isset($data['LMI_SYS_TRANS_NO']) ? $data['LMI_SYS_TRANS_NO'] : 0;
		$parent_txn=0;
	    $transactions = $this->_getExistingTransaction($invoice->getId(), $txn_id, $subscr_id, $parent_txn);
		// if transactions are not false then 
		// transaction may have already created for successfull payment or same notification may come more 
		// than 1 time then do nothing
	    if($transactions !== false){
	    		foreach($transactions as $transaction){
	    			$transaction = PayplansTransaction::getInstance($transaction->transaction_id, null, $transaction);
	    			if($transaction->getParam('LMI_PAYMENT_NO','') == $data['LMI_PAYMENT_NO']){
	    				return true;
	    			}
	    		}
	    	}
		
		// get the transaction instace of lib
		$transaction = PayplansTransaction::getInstance();
		$transaction->set('user_id', $payment->getBuyer())
					->set('invoice_id', $invoice->getId())
					->set('payment_id', $payment->getId())
					->set('amount',isset($data['LMI_PAYMENT_AMOUNT']) ? $data['LMI_PAYMENT_AMOUNT'] : 0)
					->set('gateway_txn_id', isset($data['LMI_SYS_TRANS_NO']) ? $data['LMI_SYS_TRANS_NO'] : 0)
					->set('gateway_subscr_id', isset($data['LMI_SYS_INVS_NO']) ? $data['LMI_SYS_INVS_NO'] : 0)
					->set('params', PayplansHelperParam::arrayToIni($data));

		$transaction->save();
  		
	}
	
    public function onPayplansPaymentAfter(PayplansPayment $payment, &$action, &$data, $controller)
	{
				
		if($action == 'success'){
			return true;	
		}
			
		$action= 'error';
		$invoice 		= $payment->getInvoice(PAYPLANS_INSTANCE_REQUIRE);

		// get the transaction instace of lib
		$transaction = PayplansTransaction::getInstance();
		$transaction->set('user_id', $payment->getBuyer())
					->set('invoice_id', $invoice->getId())
					->set('payment_id', $payment->getId())
					->set('gateway_txn_id', isset($data['LMI_SYS_TRANS_NO']) ? $data['LMI_SYS_TRANS_NO'] : 0)
					->set('gateway_subscr_id', isset($data['LMI_SYS_INVS_NO']) ? $data['LMI_SYS_INVS_NO'] : 0)
					->set('params', PayplansHelperParam::arrayToIni($data));
			
		$errors						= array();		
		$errors['error_message']	= XiText::_('COM_PAYPLANS_APP_WEBMONEY_PAYMENT_FAIL');
		$errors['response']			= $data;
		$message = XiText::_('COM_PAYPLANS_APP_WEBMONEY_PAYMENT_FAIL_DESC');
		PayplansHelperLogger::log(XiLogger::LEVEL_ERROR, $message, $payment, $errors, 'PayplansPaymentFormatter', '', true);
		// XITODO:: Handle response properly		
		$transaction->set('message',$message);
		$transaction->save();
		// to display error template
		return parent::onPayplansPaymentAfter($payment, $action, $data, $controller);
	}
	
	
}
