<?php
/**
 * @copyright 	Copyright (C) 2009 - 2015 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
 * @license 	GNU/GPL, see LICENSE.php
 * @package 	wirecard
 * @version 	1.0.0
 * @author 		support+payplans <support+payplans@readybytes.in>
 */

if(defined( '_JEXEC' )==false) {
	die( 'Restricted access' );
}

class PayplansAppwirecard extends PayplansAppPayment
{
	
	//inherited properties
	protected $_location	= __FILE__;

	
	function onPayplansPaymentForm(PayplansPayment $payment, $data = null)
		{
			$invoice 							= $payment->getInvoice(PAYPLANS_INSTANCE_REQUIRE);
			$post_url 							= "https://checkout.wirecard.com/page/init.php";
			$customerId							= $this->getAppParam('customer_id', 0);
			$secretKey 							= $this->getAppParam('secret', 0);
			$toolkitPassword 					= $this->getAppParam('toolkit_password', 0);
			$orderDescription   				= $invoice->getTitle();
			$orderReference						= $payment->getKey();
			$amount								= $invoice->getTotal();
			$currency							= $invoice->getCurrency('isocode','USD');
			$successUrl							= JURI::root().'index.php?payment_key='.$payment->getKey().'&option=com_payplans&gateway=wirecard&view=payment&task=complete&action=success';
			$cancelUrl							= JURI::root().'index.php?payment_key='.$payment->getKey().'&option=com_payplans&gateway=wirecard&view=payment&task=complete&action=cancel';
			$failureUrl							= JURI::root().'index.php?payment_key='.$payment->getKey().'&option=com_payplans&gateway=wirecard&view=payment&task=complete&action=cancel';
			$serviceUrl							= JURI::root().'index.php?payment_key='.$payment->getKey().'&option=com_payplans&gateway=wirecard&view=payment&task=complete&action=cancel';
			$autoDeposit						= 'no';
			//currently wirecard supports english only need to change in future
			$language							= 'en';
			$transactionIdentifier 				= $invoice->isRecurring()?'INITIAL':'SINGLE';
			//$maxRetries							= '0';
				
			$this->assign('post_url', 			$post_url);
			$this->assign('customerId', 		$customerId);
			$this->assign('language', 			$language);
			$this->assign('orderDescription', 	$orderDescription);
			$this->assign('currency', 			$currency);
			$this->assign('amount', 			$amount);
			$this->assign('success_url',		$successUrl);
			$this->assign('cancel_url', 		$cancelUrl);
			$this->assign('failure_url', 		$failureUrl);
			$this->assign('service_url',		$serviceUrl);
			$this->assign('orderReference', 	$orderReference);
			$this->assign('customerStatement', 	$orderDescription);
			$this->assign('autoDeposit', 		$autoDeposit);
			//$this->assign('maxRetries', 		$maxRetries);
			$this->assign('transactionIdentifier',$transactionIdentifier);
			//parameter order can be anything.But we need to make sure that we pass the values same as parameter order.
			$requestFingerprintOrder			= 'secret,customerId,amount,currency,language,orderDescription,successUrl,orderReference,customerStatement,autoDeposit,transactionIdentifier,requestFingerprintOrder';	
			$this->assign('requestFingerprintOrder',$requestFingerprintOrder);
			//Here parameter values are as per the order above.
			$requestFingerprint = md5($secretKey.$customerId.$amount.$currency.$language.$orderDescription.$successUrl.$orderReference.$orderDescription.$autoDeposit.$transactionIdentifier.$requestFingerprintOrder);
			$this->assign('requestFingerprint' , $requestFingerprint);
			return $this->_render('form_buynow');
		}	
	
	
function onPayplansPaymentAfter(PayplansPayment $payment, &$action, &$data, $controller) {
		
		if($action == 'cancel'){
			return true;
		}
		
		if($data['paymentState'] != 'SUCCESS')
		{
			$message 					= XiText::_('COM_PAYPLANS_APP_WIRECARD_ERROR');
			$action						= 'error';
			PayplansHelperLogger::log(XiLogger::LEVEL_ERROR, $message, $payment, $data, 'PayplansPaymentFormatter');
			
		    return parent::onPayplansPaymentAfter($payment, $action, $data, $controller);
			
		}
		//do check for valid payments.
		list($isValidResp, $message)	= $this->checkResponse($payment,$data);
		if (!$isValidResp) {
			PayplansHelperLogger::log(XiLogger::LEVEL_ERROR, $message, $payment, $data, 'PayplansPaymentFormatter');
			$action	= 'error';
		    return parent::onPayplansPaymentAfter($payment, $action, $data, $controller);
		}
		
		$invoice 						= $payment->getInvoice(PAYPLANS_INSTANCE_REQUIRE);
		if(JDEBUG){
			// When debug mode is on dump in file
			file_put_contents(JPATH_SITE.DS.'tmp'.DS.time().$invoice->getKey(), var_export($data,true), FILE_APPEND);
		}
		//Duplicate Transactions Checking
		$transactions 					= $this->_getExistingTransaction($invoice->getId(), $data['gatewayReferenceNumber'], 0,$data['orderNumber']);
		if($transactions !== false){
    		foreach($transactions as $transaction){
    			$transaction 			= PayplansTransaction::getInstance($transaction->transaction_id, null, $transaction);
    			$txnRefNum 				= $transaction->getParam('orderNumber', '');
    			$txnStatus				= $transaction->getParam('paymentState','');
    			if($txnRefNum == $data['orderNumber'] && $txnStatus == $data['paymentState']){
    				return true;
    			}
    		}
    	}
		
		$transaction 					= PayplansTransaction::getInstance();
		$transaction->set('user_id', 			$invoice->getBuyer())
					->set('invoice_id', 		$invoice->getId())
					->set('payment_id', 		$payment->getId())
					->set('amount',				$data['amount'])
					->set('message',            XiText::_('COM_PAYPLANS_APP_WIRECARD_PAYMENT_COMPLETED_SUCCESSFULLY'))
					->set('gateway_txn_id', 	isset($data['gatewayReferenceNumber']) 	? $data['gatewayReferenceNumber'] : 0)
					->set('gateway_subscr_id', 	0)
					->set('gateway_parent_txn', isset($data['orderNumber']) 	? $data['orderNumber'] : 0)
					->set('params', 			PayplansHelperParam::arrayToIni($data))
					->save();	
					
		if ($invoice->isRecurring()) {
			$recurrence_count			= $this->_getRecurrenceCount($invoice);
			$payment->getGatewayParams()->set('pending_recur_count',$recurrence_count);
			$payment->getGatewayParams()->set('source_order_number',$data['orderNumber']);
			$payment->save();
		}
		return parent::onPayplansPaymentAfter($payment, $action, $data, $controller);
		
}


public function processPayment(PayplansPayment $payment, $invoiceCount)
	{
		$invoice 						= $payment->getInvoice(PAYPLANS_INSTANCE_REQUIRE);
		$sourceOrder 					= $payment->getGatewayParam('source_order_number');
		$url							= 'https://checkout.wirecard.com/page/toolkit.php';
		$customerId						= $this->getAppParam('customer_id', 0);
		$secretKey 						= $this->getAppParam('secret', 0);
		$toolkitPassword 				= $this->getAppParam('toolkit_password', 0);
		$orderDescription   			= $invoice->getTitle();
		$orderReference					= $payment->getKey();
		$autoDeposit					= 'no';
		$amount							= $invoice->getTotal();
		$currency						= $invoice->getCurrency('isocode','USD');
		$orderNumber					= $payment->getId();
		$language						= 'en';
		$requestOrder 					= 'customerId,toolkitPassword,secret,command,language,orderNumber,sourceOrderNumber,autoDeposit,orderDescription,amount,currency,orderReference,customerStatement';
		//Here parameter values are as per the order above.
		$requestFingerprint 			= md5($customerId.$toolkitPassword.$secretKey.'recurPayment'.$language.$orderNumber.$sourceOrder.$autoDeposit.$orderDescription.$amount.$currency.$orderReference.$orderDescription);
		$lifetime 						= ($invoice->getRecurrenceCount() == 0)? true : false;
		$invoice_count 					= $invoiceCount +1;
			
		if($invoice->isRecurring())
		{			
			$recurrence_count 			= $payment->getGatewayParam('pending_recur_count');
			
			if($recurrence_count > 0 || $lifetime)
			{
					$link 				= new JURI($url);	
					$curl 				= new JHttpTransportCurl(new JRegistry());
					$queryString 		= 'customerId='.$customerId.'&toolkitPassword='.$toolkitPassword.'&command=recurPayment&language='.$language.
										  '&requestFingerprint='.$requestFingerprint.'&orderNumber='.$orderNumber.'&sourceOrderNumber='.$sourceOrder.
										  '&orderDescription='.$orderDescription.'&amount='.$amount.'&autoDeposit='.$autoDeposit.'&currency='.$currency.
										  '&orderReference='.$orderReference.'&customerStatement='.$orderDescription;
					$response 			= $curl->request('POST', $link,$queryString);
					$response			= json_decode($response->body);
					if ($response['status']!=0) {
						$message 		= XiText::_('COM_PAYPLANS_APP_WIRECARD_ERROR_RECURRING_PAYMENT');
						PayplansHelperLogger::log(XiLogger::LEVEL_ERROR, $message, $payment, $response, 'PayplansPaymentFormatter');
						return false;
					}
					
					$transaction 		= PayplansTransaction::getInstance();
					$transaction->set('user_id', 			$invoice->getBuyer())
								->set('invoice_id', 		$invoice->getId())
								->set('payment_id', 		$payment->getId())
								->set('amount',				$amount)
								->set('message',            XiText::_('COM_PAYPLANS_APP_WIRECARD_PAYMENT_COMPLETED_SUCCESSFULLY'))
								->set('gateway_txn_id', 	$orderReference.'_recurrence_'.time())
								->set('gateway_subscr_id', 	0)
								->set('gateway_parent_txn', 0)
								->save();
					
					$recurrence_count 	= $recurrence_count -1;
					$payment->getGatewayParams()->set('pending_recur_count',$recurrence_count);
					$payment->save();
			}
		}
	}
	
	
	
private function _getRecurrenceCount(PayplansInvoice $invoice)
	{
		$count = $invoice->getRecurrenceCount();
		if(intval($count) === 0){
			return 9999;
		}
		
		$recurring = $invoice->isRecurring();
		if($recurring){
			
			// Recurrence Count For Regular Recurring Plan
       		if($recurring == PAYPLANS_RECURRING){
	       		$recurrence_count = $invoice->getRecurrenceCount();
       		}
       		// Recurrence Count For Recurring + Trial 1 Plan
       		if($recurring == PAYPLANS_RECURRING_TRIAL_1){
				$recurrence_count = $invoice->getRecurrenceCount() + 1;
       		}
       		// Recurrence Count For Recurring + Trial 2 Plan
       		if($recurring == PAYPLANS_RECURRING_TRIAL_2){
	       		$recurrence_count = $invoice->getRecurrenceCount() + 2;
       		}
		}
		return $recurrence_count;
	}
	
	
/**
 * Validates the response from payment gateway.
 * 
 */
private function checkResponse(PayplansPayment $payment, $resParams) {
	
	if (empty($resParams["responseFingerprint"]) || !isset($resParams["responseFingerprint"])) {
		return array(false, XiText::_('COM_PAYPLANS_APP_WIRECARD_RESPONSE_ERROR'));
	} else {
		
			$secretKey 				  	= $this->getAppParam('secret', 0);
			$responseFingerprintOrder 	= isset($resParams["responseFingerprintOrder"]) ? $resParams["responseFingerprintOrder"] : "";
			$responseFingerprint 		= isset($resParams["responseFingerprint"]) ? $resParams["responseFingerprint"] : "";
			$fingerprintSeed 			= ""; 
			$order 						= explode(",", $responseFingerprintOrder);
			if (in_array ("paymentState", $order) && in_array ("secret", $order) ) {
					for ($i = 0; $i < count($order); $i++) {
						$name 			= $order[$i];
						$value 			= isset($resParams[$name]) ? $resParams[$name] : "";
						$fingerprintSeed .= $value; 
						if (strcmp($name, "secret") == 0) {
							$fingerprintSeed .= $secretKey;
						} 
					}
					$fingerprint 		= md5($fingerprintSeed); 
					// checks if computed fingerprint and responseFingerprint are same
					if (strcmp($fingerprint, $responseFingerprint) == 0) {
						return array(true, XiText::_('COM_PAYPLANS_APP_WIRECARD_NO_ERROR'));
					} 
					 else {
						return array(false,XiText::_('COM_PAYPLANS_APP_WIRECARD_SIGNATURE_INVALID'));
					}
			}	
			
	}
	
}	
}
 
