<?php
/**
* @copyright	Copyright (C) 2009 - 2009 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license	GNU/GPL, see LICENSE.php
* @contact	payplans@readybytes.in
*/
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );


/**
 * Payplans Zoo Integration Plugin
 */

class plgPayplansZoo extends XiPlugin
{
	const DO_NOTHING = -1;
	const ALLOWED 	 =  1;
	const BLOCKED    =  0;
	const ALL_PLAN   =  'ALL_PLAN';
	const ANY_CAT	 = -1;
	
	public function onPayplansSystemStart()
	{
		//add app path to app loader
		$appPath = dirname(__FILE__).DS.'zoo'.DS.'app';
		PayplansHelperApp::addAppsPath($appPath);
		
		return true;
	}
	
	function onPayplansAccessCheck(PayplansUser $user)
	{
		$option 	= JRequest::getVar('option');
		$view 		= JRequest::getVar('view', null);
		$task       = JRequest::getVar('task',null);
        $itemId     = JRequest::getVar('Itemid',0);
        $layout     = JRequest::getVar('layout',null);
        $category_id= JRequest::getVar('category_id',null);
        $item_id    = JRequest::getVar('item_id',false);
        $flag         = 0;
        $edited     = false;
        if($item_id) {
            $edited = true;
        }

        // do not work in admin
        if(XiFactory::getApplication()->isAdmin()){
            return ;
        }
        
        // do nothing if admin
        if($user->isAdmin())
        {
            return false;
        }
        if($option != 'com_zoo')
        {
            return false;
        }
        
        // Now Restrictions apply on category also (Previously Only Items are restricted)
		if($task == 'category' || $task == 'item'){
			
			if(!isset($category_id)){
				if(isset($item_id)){
					$category_id = $this->getParentFromItemid($item_id);
				}
				else{
					$category_id = 0;
				}
			}
			$allowView 			= 0 ;
			$controlOn 			= array('on_view','on_both');
            $appPlans 			= array();
			$zooCategoryApps = PayplansHelperApp::getAvailableApps('zoo');
            $parentCategory = $this->_getParentCategories($category_id);   

			  foreach($zooCategoryApps as $app){
			    if(in_array($app->getAppParam('controlOn'),$controlOn)){
			    	$categoryOn      = $app->getAppParam('add_entry_in');
			    	$postInCategory  = $parentCategory;
			    	if($categoryOn == 'on_specific_category'){
						$postInCategory	 = $app->getAppParam('zoo_category',array());
						$postInCategory  = is_array($postInCategory) ? $postInCategory : array($postInCategory);
			    	}
					if(count(array_intersect($parentCategory,$postInCategory)) != 0){
						if(!$user->getId()){
							    $msg        = XiText::_('COM_PAYPLANS_APP_ZOO_SUBMISSION_NOT_LOGIN');
                                XiFactory::getApplication()->redirect(XiRoute::_('index.php?option=com_payplans&view=plan&task=subscribe'), $msg);
                                return true;
						}
						else {
								$plan 		  = $app->getPlans();
								$plan  	      = (empty($plan))? array(self::ANY_CAT) : $plan ;
								$appPlans 	  = array_merge($appPlans, $plan);
						}	
					}
			     }
			  }            
           
            $subscriptionRecords = XiFactory::getInstance('subscription','model')->loadRecords(array('user_id'=>$user->getId(),'status'=>PayplansStatus::SUBSCRIPTION_ACTIVE));
            if(!empty($subscriptionRecords) && !empty($appPlans)){
	            foreach ($subscriptionRecords as $subscriptionRecord){
	            	$plan = $subscriptionRecord->plan_id;
	            	if(in_array($plan, $appPlans)){
	            		$allowView = 1;
	            		break;
	            	}
	            	if(in_array(self::ANY_CAT,$appPlans)){
	            		$allowView = 1;
	            		break;
	            	}
	            }
            }

            if($allowView == 0 && !empty($appPlans)){
            	$msg = XiText::_('COM_PAYPLANS_APP_ZOO_CATEGORY_NOT_ALLOW_VIEW');
				XiFactory::getApplication()->redirect(XiRoute::_('index.php?option=com_payplans&view=plan&task=subscribe'), $msg);
            }
		}
		
		if($layout == 'submission' && $task == 'save')
		{
			//if no user is logged in						
			if(!$user->getId()){
				$msg        = XiText::_('COM_PAYPLANS_APP_ZOO_SUBMISSION_NOT_LOGIN');
				XiFactory::getApplication()->redirect(XiRoute::_('index.php?option=com_payplans&view=plan&task=subscribe'), $msg);
				return true;
			}
			$submissionId = JRequest::getVar('submission_id',null);
			$typeId       = JRequest::getVar('type_id',null);
			$elements     = JRequest::getVar('elements', array());
			if (array_key_exists('_itemcategory',$elements)) {
				$categories = array_values($elements['_itemcategory']['value']);
			}
			if(!isset($categories)){
				$query = new XiQuery();
				$submissionParams =  $query	->select('params')
					 						->from('#__zoo_submission')
					 						->where('`id` = '.$submissionId)
					 						->dbLoadQuery()
					 						->loadResult(); 	
				$params          = json_decode($submissionParams,true);
				$categories      = $params['form.'.$typeId]['category'];
			}
			if(!is_array($categories)){
				$categories = array($categories);
			}
			$parentCategory = array();

			foreach ($categories as $category)
			{
		 		$parent = $this->_getParentCategories($category);
				$parentCategory = array_merge($parentCategory, $parent);
            }
 
			$zooCategoryApps 	= PayplansHelperApp::getAvailableApps('zoo');           
			foreach ($parentCategory as $category)
			{
				
				$controlOn = array('on_submit','on_both');
				$isAllowedOrNot = $this->isZooCategoryAllowed($category, $user, $controlOn);
				if($isAllowedOrNot == self::DO_NOTHING){
					continue;
				}
                if($isAllowedOrNot == self::BLOCKED)
                {
                	$msg = XiText::_('COM_PAYPLANS_APP_ZOO_CATEGORY_SELECT_PLAN');
					XiFactory::getApplication()->redirect(XiRoute::_('index.php?option=com_payplans&view=plan&task=subscribe'), $msg);
				}
				
				//firstly check for specific category allowed then check for any category
				$category = array($category,$category);
				
				if($this->redirectDecision($zooCategoryApps, $controlOn,$category, $flag, $user,$edited) == false){
					$category = array(self::ANY_CAT,0);
					if($this->redirectDecision($zooCategoryApps, $controlOn,$category, $flag, $user,$edited) == true){
						$msg = XiText::_('COM_PAYPLANS_APP_ZOO_CATEGORY_YOU_ARE_NOT_ALLOWED_TO_ADD_MORE_SUBMISSIONS');	
						XiFactory::getApplication()->redirect(XiRoute::_('index.php?option=com_payplans&view=dashboard'), $msg);							
					}
				}
				else{
					$msg = XiText::_('COM_PAYPLANS_APP_ZOO_CATEGORY_YOU_ARE_NOT_ALLOWED_TO_ADD_MORE_SUBMISSIONS');	
					XiFactory::getApplication()->redirect(XiRoute::_('index.php?option=com_payplans&view=dashboard'), $msg);
				}
			}
		}
	  }

	protected function redirectDecision($zooCategoryApps,$controlOn,$category,$flag,$user,$edited = false)
	{
				$userEntries = self::getUserEntries($user->getId(), $category[0]);

				if($edited) {
					$userEntries--;
				}

				$record 	 = $this-> _getZooResource($user->getId(),$category[1]);
				$count 	     = ($record!=false) ? $record->count : 0 ;
					
				// if user not record of category in which he/she want to post
				// then check available app for that category
				// if app is created then not allowed to post otherwise ok
				if($count == 0){
			        // check which plan is required for this category/app
				    foreach($zooCategoryApps as $app){
					    if(in_array($app->getAppParam('controlOn'),$controlOn)){
							$postInCategory		= $app->getAppParam('zoo_category',array());
							if($postInCategory == $category){
								$flag = 1; break;	
							}					
					    }
				    }
				    	
				}
				if($count == 0){
					if($flag == 1)
					{ return true;
					}
				}				
                elseif( $userEntries >= $count || $flag == 1)
				{ return true;
				}
				return false;
	}
	
	protected function getParentFromItemid($item_id)
	{
		$db     = XiFactory::getDBO();
		$query =  ' SELECT `category_id`'
			         .' FROM `#__zoo_category_item`'
			         .' WHERE `item_id`= '.$item_id
			         ;
		$db->setQuery( $query );
		return $db->loadResult();
	}
	
	public static function getUserEntries($userId,$category)
	{
		$db     = XiFactory::getDBO();
		if($category == 0)
		{
			$query =  ' SELECT COUNT(*)'
			         .' FROM `#__zoo_item`'
			         .' WHERE `created_by`= '.$userId.' AND `id` NOT IN (SELECT `item_id` FROM `#__zoo_category_item`)'
			         ;
			$db->setQuery( $query );
			return $db->loadResult();
		}
		elseif($category == self::ANY_CAT)
		{
			$query =  ' SELECT COUNT(*)'
			         .' FROM `#__zoo_item`'
			         .' WHERE `created_by`= '.$userId;
			$db->setQuery( $query );
			return $db->loadResult();
		}
		else
		{
			$query         =  ' SELECT COUNT(*)'
			                 .' FROM `#__zoo_item`'
		      	             .' WHERE `created_by`= '.$userId.' AND `id` IN (SELECT `item_id` FROM `#__zoo_category_item` WHERE `category_id` ='.$category. ')'
			                 ;
		$db->setQuery( $query );
		return $db->loadResult();
			
		}
		
	}

	protected function _getZooResource($userId,$category)
    {
		$rmodel = PayplansApp::getResourceModel();
		$record = $rmodel->loadRecords(array('user_id'  => $userId,
											'title' => 'com_zoo.submission'.$category));
		
		$record = array_shift($record);
		if(empty($record) || !$record)
		{
			return false;
		}
		return $record;
	}

	
	/**
	 * Handling of zoo Category app starts from here 
	 *
	 */
	
	// for joomla 1.5
	function onPrepareContent($article, $params, $limitstart )
	{  
		return $this->_prepareContent($article,$params);
	}
	
	// for joomla 1.7
	function onContentPrepare($context,$article, $params, $limitstart)
	{
		return $this->_prepareContent($article,$params);
	}
	
	protected function _prepareContent($article,$params)
	{
		// if option is not zoo the return
		if(JRequest::getVar('option',null) !== 'com_zoo'){
			return false;
		}
        // if params is null then create registry object
		if(!is_object($params)){
 			$params = new JRegistry();
         }

		$userid = XiFactory::getUser()->id;
		$user = PayplansUser::getInstance($userid);
		// don't block if admin
		if($user->isAdmin()){
			return true;
		}
		
		// get the category and app which is being accessed
		$item_id 	= $params->get('item_id',0);
		if(!$item_id){
		 	return false;
		}

		$categories 	= $this->_getCategory($item_id);

		$parentCategory = array();
		foreach ($categories as $category)
		{
	 		$parent = $this->_getParentCategories($category);
			$parentCategory = array_merge($parentCategory, $parent);
         }

		$controlOn = array('on_view','on_both');

		foreach ($parentCategory as $category)
		{
			$isAllowedOrNot = self::isZooCategoryAllowed($category, $user,$controlOn);
			if($isAllowedOrNot==self::ALLOWED || $isAllowedOrNot == self::DO_NOTHING)
			{
				continue;
			}
			else
			{
				$url = XiRoute::_('index.php?option=com_payplans&view=plan&task=subscribe');
		    	$article->text ='<a href="'.$url.'">'.XiText::_('COM_PAYPLANS_APP_ZOO_CATEGORY_SUBSCRIBE_PLAN').'</a>';
				return true;
			}
		}
		
	}
	
	static function isZooCategoryAllowed($category,$user,$controlOn)
	{
		$zooCategoryApps 	= PayplansHelperApp::getAvailableApps('zoo');
        // check which plan is required for this category/app
        $applicablePlans = array();
	    foreach($zooCategoryApps as $app){
	   	 	
		    $postInCategory		= $app->getAppParam('add_entry_in','any_category');
			$appCategory		= array();
			if($postInCategory == 'any_category'){
				$appCategory[]  = 0;
			}
			else{	
				$appCategory        = $app->getAppParam('zoo_category', $appCategory);
			}

			$restrictionOn = $app->getAppParam('controlOn','on_view');
			$appCategory   = is_array($appCategory) ? $appCategory : array($appCategory);
	    	if(!in_array($restrictionOn, $controlOn)){
		 		continue;
		 	}
			//if app is not applicable on that category 
		 	if(in_array($category, $appCategory) || in_array('0', $appCategory)){
		 		// if apply to all then break
		 		//else mearge all the plans
		 		if($app->getParam('applyAll')){
		 			$applicablePlans = array(self::ALL_PLAN);
		 			break;
		 		}
		 		else{
		 			$applicablePlans = array_merge($applicablePlans, $app->getPlans()) ;
		 		}
		 	}
	    }
	    
	    // applicable plans is empty
	    if(count($applicablePlans) <= 0){
	    	return self::DO_NOTHING;
	    }
	    
	   
		// if user is not logged in or does not have any plan, ask him to subscribe
		if(!$user->getId() || count($user->getPlans()) <= 0){
			return self::BLOCKED;	
		}
		
		// user has any plan
		
		$userplans = $user->getPlans();
		// if cat/app is available to any plans, return treu because user has any plan
		if(in_array(self::ALL_PLAN, $applicablePlans)){
			return self::ALLOWED;
		}
		
		// if no allowed but any one blocked then block
      	if(count(array_intersect($applicablePlans, $userplans)) >= 1){
        	return self::ALLOWED;
		}
			return self::BLOCKED;
	}
	
	protected function _getCategory($itemId)
	{
		$query = new XiQuery();
		return  $query->select('`category_id`')
					 ->from('#__zoo_category_item')
					 ->where('`category_id`<> 0 AND `item_id`= '.$itemId)
					 ->dbLoadQuery()
  					 ->loadColumn();
	}
	
	
	 function _getParentCategories($catId)
	{
		$allCat   = array();
		while($catId)
		{
			$allCat[] = $catId;
			
			$db 	= XiFactory::getDBO();
			$query = 'SELECT `parent`'
				 	. ' FROM #__zoo_category'
				 	. ' WHERE `published` = 1 AND `id` = '.$catId;
				 	;
		 	$db->setQuery( $query );
		 	$catId = $db->loadResult();
		}
		return $allCat;
	}
}
