<?php
/**
* @copyright	Copyright (C) 2009 - 2009 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		PayPlans
* @subpackage	Frontend
* @contact 		shyam@readybytes.in
* 
*/
if(defined('_JEXEC')===false) die();

class PayplansAppZoo extends PayplansApp
{
	protected $_location	= __FILE__;
	protected $_resource	= 'com_zoo.submission';
	const ALLOWED 	        =  1;
	const BLOCKED           =  0;
    const DO_NOTHING        = -1;

	public function _isApplicable(PayplansIfaceApptriggerable $refObject, $eventname='')
	{
		if(!JFolder::exists(JPATH_SITE .DS.'components'.DS.'com_zoo')){
			return false;
		}
		return true;
	}
	
	public function onPayplansSubscriptionAfterSave($prev, $new)
	{
		// no need to trigger if previous and current state is same
		if($prev != null && $prev->getStatus() == $new->getStatus()){
			return true;
		}

		$newStatus  = $new->getStatus();
		
		$restrictionOn = $this->getAppParam('controlOn','on_view');
		if($restrictionOn != 'on_submit' && $restrictionOn != 'on_both')
        {
			return true;
		}

		$zooCategory	= array();
		$postInCategory	= $this->getAppParam('add_entry_in','any_category');

		if($postInCategory == 'any_category'){
			$zooCategory[]  = 0;
		}
		else{	
			$zooCategory        = $this->getAppParam('zoo_category', $zooCategory);
		}
		$allowedEntries     = $this->getAppParam('allowedSubmissions',0);
		$allowedSubmissions = explode(',', $allowedEntries);
		$subid              = $new->getId();
		$userid             = $new->getBuyer();
		
		if($newStatus == PayPlansStatus::SUBSCRIPTION_ACTIVE)
		{
			$action = 1;//action is publish/feature
            
			for($i=0;$i<sizeof($zooCategory);$i++)
			{   
				if(!isset($allowedSubmissions[$i]))
				{
					$allowedSubmissions[$i]= $allowedSubmissions[sizeof($allowedSubmissions)-1];
		     	}
				$this->_addToResource($subid, $userid, $zooCategory[$i], $this->_resource.$zooCategory[$i], $allowedSubmissions[$i]);
			    $this->_publishOrUnpublishEntry($userid, $allowedSubmissions[$i], $action,$zooCategory[$i]);
			}
		}
			
		
		if(($prev != null && $prev->getStatus() == PayPlansStatus::SUBSCRIPTION_ACTIVE) && 
				($newStatus == PayPlansStatus::SUBSCRIPTION_EXPIRED || $newStatus == PayPlansStatus::SUBSCRIPTION_HOLD))
		{
			$action = 0;
			for($i=0;$i<sizeof($zooCategory);$i++)
			{   if(!isset($allowedSubmissions[$i]))
				{
					$allowedSubmissions[$i]= $allowedSubmissions[sizeof($allowedSubmissions)-1];
		     	}
				$this->_removeFromResource($subid, $userid, $zooCategory[$i], $this->_resource.$zooCategory[$i], $allowedSubmissions[$i]);
			    $this->_publishOrUnpublishEntry($userid, $allowedSubmissions[$i], $action,$zooCategory[$i]);
			}
		}

		return true;	
	}
	
	protected function _publishOrUnpublishEntry($userid, $publishCount, $action, $zooCategory)
	{
		// publish only those entries which are not currently published
		//and vice versa
		$complement = 1 - $action;
		$db    = XiFactory::getDBO();
		
		
		if($zooCategory == '0'){
		//change enable state of all the fields related with the entry
		$query1 = ' UPDATE `#__zoo_item`'
				 .' SET `state`='.$action 
				 .' WHERE `created_by`='.$userid.' AND `state`='.$complement.' AND `id` NOT IN (SELECT `item_id` FROM `#__zoo_category_item`)'
				 . ' LIMIT '.$publishCount;
				
		$db->setQuery( $query1 );
		$db->query();
		}
		else{
			$query2 = ' UPDATE `#__zoo_item`'
				 .' SET `state`='.$action 
				 .' WHERE `created_by`='.$userid.' AND `state`='.$complement.' AND `id` IN (SELECT `item_id` FROM `#__zoo_category_item` WHERE `category_id` ='.$zooCategory. ')'
				 . ' LIMIT '.$publishCount;
				
		$db->setQuery( $query2 );
		$db->query();
		}
	}

 	//render Widget
	public function renderWidgetHtml()
	{   
		$userid         = XiFactory::getUser()->id;
		if(!$userid){
			return '';
		}

		$resourceRecords = $this->getallowedsubmission($userid);
	    if(empty($resourceRecords)){
	    	return true;
	    }
		
		$total			= 0;
		$any_cat_count	= 0;

		// first calculate the sum of all consumed post in total variable 
        // then subtract from consumed of additional category.
		foreach($resourceRecords as $resourceRecord){
			if(key($resourceRecord) == 0){
				continue;
			}
			else{				
	 		 	if($resourceRecord['cosumed'] > $resourceRecord['allowed']){
						$total 			 		  += $resourceRecord['cosumed'] - $resourceRecord['allowed'];
		 		 		$resourceRecord['cosumed'] = $resourceRecord['allowed'];
				}				
			}			
		}
		if(isset($resourceRecord[0])){	
			$resourceRecord[0]['consumed']  = ($resourceRecord[0]['consumed'] + $total);
		}
		

	    $this->assign('render_data', $resourceRecords);
        return $this->_render('widgethtml');
	}
	
	
	function getallowedsubmission($userId)
	{
		$catgoryTitleRecords = array();
		$rmodel = PayplansApp::getResourceModel();
		$value 	= "'".'com_zoo.submission%'."'";
		$record = $rmodel->loadRecords(array('user_id'  => $userId,'title' => array(array('LIKE',$value))));

		if(empty($record) || !$record)
		{
			return null;
		}
		
		foreach ($record as $resourceRecord)
		{
			if($resourceRecord->value == 0){
				$catgoryTitleRecords[$resourceRecord->value]['title']= XiText::_("COM_PAYPLANS_APP_ZOO_SUBMISSION_TOTAL_CAT");
				$catgoryTitleRecords[$resourceRecord->value]['allowed'] = $resourceRecord->count;
				$catgoryTitleRecords[$resourceRecord->value]['consumed'] = plgPayplansZoo::getUserEntries($userId,-1);
				continue;
			}
			$catgoryTitleRecords[$resourceRecord->value]['title']= $this->getCatTitle($resourceRecord->value);
			$catgoryTitleRecords[$resourceRecord->value]['allowed'] = $resourceRecord->count;
			$catgoryTitleRecords[$resourceRecord->value]['consumed'] = plgPayplansZoo::getUserEntries($userId,$resourceRecord->value);
			
		}
		return $catgoryTitleRecords;
	}
	
	function getCatTitle($catId)
	{
			$db 	= XiFactory::getDBO();
			$query = 'SELECT `name`'
				 	.' FROM #__zoo_category'
				 	.' WHERE `published` = 1 AND `id` = '.$catId;
		 	$db->setQuery( $query );
		 	return $db->loadResult();
	}
}
