<?php
/**
* @copyright	Copyright (C) 2009 - 2009 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license	GNU/GPL, see LICENSE.php
* @contact	payplans@readybytes.in
*/
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );


/**
 * Payplans Zoo Element Integration Plugin
 */

class plgPayplansZooelement extends XiPlugin
{	
	const NONE  = -1;
	
	public function onZooItemSaved($event)
	{
		$use = JRequest::getVar('use_payplans_with_zoo_item', false);
		
		if(!$use){
			return true;
		}
			
		$item = $event->getSubject();
		$new = $event['new'];
		
		$ppplans = JRequest::getVar('ppplans', array());
		
//		if(!count($ppplans)){
//			return true;
//		}
		
		$data['itemid'] = $item->id;		
		$data['params'] = serialize($ppplans);
		
		require_once dirname(__FILE__).DS.'zooelement'.DS.'model.php';
		require_once dirname(__FILE__).DS.'zooelement'.DS.'table.php';
		
		$model = XiFactory::getInstance('zooitemelement', 'model');
		$model->delete($data['itemid']);
		$model->save($data, $data['itemid'], true);
	}
	
	protected static function _getItemParams($itemid)
	{
		require_once dirname(__FILE__).DS.'zooelement'.DS.'model.php';
		require_once dirname(__FILE__).DS.'zooelement'.DS.'table.php';
		
		static $params = array();
		if(!isset($param[$itemid])){
			$model = XiFactory::getInstance('zooitemelement', 'model');
			$records = $model->loadRecords(array('itemid' => $itemid));
			if(count($records)){
				$record = array_shift($records);				
				$params[$itemid] = unserialize($record->params);
			}
			else{
				$params[$itemid] = array();
			}
		}
		
		return $params[$itemid];
	}
	
	public static function onZooElementAfterEdit($event)
	{
		$element = $event->getSubject();
		$config  = json_decode($element->config);
		
		$itemid = $element->getItem()->id;
		$selected = array();
		if($itemid){
			$selected = self::_getItemParams($itemid);
		}
		
		if(!isset($selected[$element->identifier])){
			$selected[$element->identifier] = array('plans' => '', 'action' => 'show');
		}
		
		if(!isset($selected[$element->identifier]['plans'])){
			$selected[$element->identifier]['plans'] = array();
		}

		if(!isset($selected[$element->identifier]['action'])){
			$selected[$element->identifier]['action'] = 'show';
		}		
		
		// if ppplans is not set or does not contain any value
		// it means it is available to all users, then do nothing 
		if(!isset($config->enableppplans) || !$config->enableppplans){
			return true;
		}
		
		// html of actions
		$actionOptions = array(array('value' => 'show', 'text' => XiText::_('COM_PAYPLANS_PLG_ZOO_ELEMENT_SELECT_ACTION_SHOW')),
							   array('value' => 'hide', 'text' => XiText::_('COM_PAYPLANS_PLG_ZOO_ELEMENT_SELECT_ACTION_HIDE'))
							   );
																	
		$plans = PayplansApi::getPlans();
		$plans[0]->plan_id = -1;
		$plans[0]->title = XiText::_('COM_PAYPLANS_PLG_ZOO_ELEMENT_PLANS_NONE');
		asort($plans);
		
		$html = $event['html'];
		$pop = array_pop($html);
		$html[] = '<strong>&nbsp;</strong>
					<div class="more-options">
						<div class="trigger">
							<div>
								<div class="advanced button hide">'.XiText::_('COM_PAYPLANS_PLG_ZOO_ELEMENT_HIDE_PLANS').'</div>
								<div class="advanced button">'.JText::_('COM_PAYPLANS_PLG_ZOO_ELEMENT_SHOW_PLANS').'</div>
							</div>
						</div>
				
						<div class="advanced options">'.
							XiText::_('COM_PAYPLANS_PLG_ZOO_ELEMENT_SELECT_PLAN').'
							<div class="row short pp-plans">'.
								$element->app->html->_('control.genericList', $plans, 'ppplans['.$element->identifier.'][plans][]', 'multiple="true"', 'plan_id', 'title', $selected[$element->identifier]['plans'])
							.'</div>						
							<div class="row short pp-plans">'.
								XiText::_('COM_PAYPLANS_PLG_ZOO_ELEMENT_SELECT_ACTION').
								$element->app->html->_('control.genericList', $actionOptions, 'ppplans['.$element->identifier.'][action]', '', 'value', 'text', $selected[$element->identifier]['action'])
							.'</div>
						</div>
					</div>';
		$html[] = $pop;
		
		static $hiddenfield = false;
		if($hiddenfield === false){
			$html[] = '<input type="hidden" name="use_payplans_with_zoo_item" value="1" />';
			$hiddenfield = true;
		}
		
		$event['html'] = $html;
	}
	
	public static function onZooElementBeforeDisplay($event)
	{
		$item 	 = $event->getSubject();
		$element = $event['element'];
		
		$event['render'] = plgPayplansZooelement::_checkRestrictions($item,$element);
		return true;
	}
	
	protected static function _getUserPlans($user)
	{
		// get the users plan
		static $userplans = null;
		if($userplans === null){
			$userplans = array();
			if($user !== null){
				$userplans = $user->getPlans();
			}
		}
		
		return $userplans;
	}
	
	public static function onZooElementDownload($event)
	{		
		$element = $event->getSubject();
		$item 	 = $element->getItem();
		
		$event['canDownload'] = plgPayplansZooelement::_checkRestrictions($item,$element);
		if(!$event['canDownload']){
			$msg        = XiText::_('COM_PAYPLANS_APP_ZOO_ELEMENT_NO_DIRECT_DOWNLOAD');
			XiFactory::getApplication()->redirect(XiRoute::_('index.php?option=com_payplans&view=plan&task=subscribe'), $msg);
			return true;
		}
		
		return true;
	}	
	public static function onZooElementConfigForm($event)
	{		
		$xmlString	= '<element type="element" group="Payplans" hidden="true">
							<params>
								<param 	name="action" 
										type="list" 
										label="COM_PAYPLANS_PLG_ZOO_ELEMENT_SELECT_ACTION_LABEL"
										description="COM_PAYPLANS_PLG_ZOO_ELEMENT_SELECT_ACTION_DESC">
										<option value="show">COM_PAYPLANS_PLG_ZOO_ELEMENT_SELECT_ACTION_OPTION_SHOW</option>
										<option value="hide">COM_PAYPLANS_PLG_ZOO_ELEMENT_SELECT_ACTION_OPTION_HIDE</option>
								</param>
								
								<param 	name="ppplans" 
										type="plans" 
										label="COM_PAYPLANS_PLG_ZOO_ELEMENT_SELECT_PLAN"
										description="COM_PAYPLANS_PLG_ZOO_ELEMENT_SELECT_PLAN_DESC"/>
										
								<param 	name="enableppplans" 
										type="radio" 
										default="0"
										label="COM_PAYPLANS_PLG_ZOO_ELEMENT_ENABLE_PLANS_SELECTION"
										description="COM_PAYPLANS_PLG_ZOO_ELEMENT_ENABLE_PLANS_SELECTION_DESC">
										<option value="0">COM_PAYPLANS_NO</option>
										<option value="1">COM_PAYPLANS_YES</option>
								</param>
							</params>
						</element>
				  	';
		
		$element = $event->getSubject();
		$element->app->path->register(dirname(__FILE__).DS.'zooelement'.DS.'fields', 'fields');
		$form = $event['form'];
		$form->addXml($xmlString);
	}
	
	public function onPayplansSystemStart()
	{
		// make sure ZOO exists
		//can not use Jcomponent helper to check whther extension is installed and enabled
		//since it displays warning message when extension is not installed
		$db 	= XiFactory::getDbo();
		$query 	= $db->getQuery(true)
					 ->select('extension_id AS id, enabled')
					 ->from('#__extensions')
					 ->where($db->quoteName('type') . ' = ' . $db->quote('component'))
					 ->where($db->quoteName('element') . ' = ' . $db->quote('com_zoo'));
					 
		$db->setQuery($query);
		$result = $db->loadObject();
		
		if(empty($result) || !$result->enabled){
			return ;
		}

		// load ZOO config
		if (!JFile::exists(JPATH_ADMINISTRATOR.'/components/com_zoo/config.php') || !JComponentHelper::getComponent('com_zoo', true)->enabled) {
			return;
		}

		require_once(JPATH_ADMINISTRATOR.'/components/com_zoo/config.php');

		// make sure App class exists
		if (!class_exists('App')) {
			return;
		}

		// Here are a number of events for demonstration purposes.
		// Have a look at administrator/components/com_zoo/config.php
		// and also at administrator/components/com_zoo/events/

		// Get the ZOO App instance
		$zoo = App::getInstance('zoo');

		$zoo->event->register('plgPayplansZoo');
		$zoo->event->dispatcher->connect('element:beforedisplay', array('plgPayplansZooelement', 'onZooElementBeforeDisplay'));
		$zoo->event->dispatcher->connect('element:afteredit', array('plgPayplansZooelement', 'onZooElementAfterEdit'));
		$zoo->event->dispatcher->connect('element:configform', array('plgPayplansZooelement', 'onZooElementConfigForm'));
		$zoo->event->dispatcher->connect('element:download',   array('plgPayplansZooelement', 'onZooElementDownload'));
		// item saved trigger
		$zoo->event->dispatcher->connect('item:saved', array('plgPayplansZooelement', 'onZooItemSaved'));
				
		return true;
	}
	
	public static function _checkRestrictions($item,$element)
	{
		static $user = null;
		if($user === null){
			$userid = XiFactory::getUser()->id;
			if($userid){
				$user = PayplansApi::getUser($userid);
			}
		}
			
		// if user is admin
		if($user !== null && $user->isAdmin()){
			return true;
		}
		
		
		$config = json_decode($element->config);
		
		// if ppplans is not set or does not contain any value
		// it means it is available to all users, then do nothing 
		if(!empty($config->ppplans)){
			// get the users plan
			$userplans 	= self::_getUserPlans($user);
			$plans 		= (array)$config->ppplans;
			
			if(!isset($config->action) || $config->action == 'show'){
				// if user do not have any plans then element should not be renderred
				if(!count($userplans)){
					return false;
					
				}			
				
				if(in_array(self::NONE, $plans) || count(array_intersect($userplans, $plans)) == 0){
					return false;
					
				}
			}
			else{
				// if user do not have any plans then element should not be renderred
				if(count($userplans) && count(array_intersect($userplans, $plans))){
					return false;
					
				}
			}
		}
		
		//  restriction atitem level is not enable then do nothing
		if(!isset($config->enableppplans) || $config->enableppplans == false){
			return true;
		}
		
		// check for individual item
		$itemid = $item->id;
		$plansConfig = self::_getItemParams($itemid);
				
		$identifier = $element->identifier ;
		if(!isset($plansConfig[$identifier])){
			return true;
		}
		
		$userplans = self::_getUserPlans($user);
		
		// if action is not set or its set to "show" then element should be shown to only subscriber
		// so action should be false
		$action = false;
		if(isset($plansConfig[$identifier]['action']) && $plansConfig[$identifier]['action'] == 'hide'){
			$action = true;
		}
		 
		// if user do not have any plans then element should not be renderred
		if(!count($userplans)){
			return $action;
			
		}		
		$plans = $plansConfig[$identifier]['plans'];
		$plans = is_array($plans) ? $plans : array($plans); 
		if(in_array(self::NONE, $plans) || count(array_intersect($userplans, $plans)) == 0){
			return $action;
			
		}
		
		// if above conditions are not true then return inverse action
		return !$action;
	}
	
	public function onPayplansGetPlugin()
    {
		$xml = dirname(__FILE__).DS.'zooelement.xml';
        if (file_exists($xml)) {
   			$xmlContent = simplexml_load_file($xml);
	    }
	    else {
			$xmlContent = null;
	    }
	    return array('name'   => 'zooelement', 
	              	  'value' =>$xmlContent);
	}
	
}
